-- 烟花狂欢
Lua_FireworksCarnivalPanel = class("Lua_FireworksCarnivalPanel", Lua_DisplayObject)
function Lua_FireworksCarnivalPanel:ctor(p)
	self:superCall("ctor", p, "FireworksCarnivalPanel_skin");
end

function Lua_FireworksCarnivalPanel:buildShowItem()
	self:superCall("buildShowItem");

	Lua_CommonUtil.addTimer("effect_Timer", 2, self, self.onEffectTimer);

	self.rewardList = Lua_DragList.new(self.content,1, Vector4(0, 0, 320, 196));
	self.rewardList:setListCell(Lua_fireworksCarnivalItem, 80, 80, 4);
	self.rewardList:setLocation(264, -121, 0);

	self.yanHuaEffect = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_qmsdyanhua", "gui_qmsdyanhua", -168, -189);
	self.yanHuaEffect:SetRenderQueue(self.yanHua, 5, 2, false);

	self.jianTouEffect = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_zhiyinjiantou_green", "gui_zhiyinjiantou_green", 58, -129);
	self.jianTouEffect:SetRenderQueue(self.yanHua, 5, 2);
	self.jianTouEffect:setRot(0, 0, 180);

	self.oneBuyBg:addClickFuntion(self, self.oneBuyBgClick);
	self.tenBuyBg:addClickFuntion(self, self.tenBuyBgClick);

	self:addLuaEvent("SET_NATIONAL_FESTIVAL_PANEL", self, self.setPanelData);
end

function Lua_FireworksCarnivalPanel:setData(data)
	self.data = data;
end

function Lua_FireworksCarnivalPanel:onEffectTimer()
	self.yanHuaEffect:setEnable(false);
	self.yanHuaEffect:setEnable(true);
end

function Lua_FireworksCarnivalPanel:setPanelData()
	local isShow;
	self.dataList = Array();
	for k,v in ipairs(self.data.reward_info[1].reward_set) do
		isShow = false;
		for _,p in ipairs(self.data.reward_info[1].spec_effect_item) do
			if v.id == tonumber(p) then
				isShow = true;
			end
		end
		self.dataList:add({data = v, isShow = isShow});
	end
	self.rewardList:setLuaArrayData(self.dataList, false);

	-- self.money_type = 209000004 - self.data.firework_info.money_type;
	-- local uiatlasName = Lua_MoneyData.getMoneyIconAtlas(self.money_type);
	-- local spriteName = Lua_MoneyData.getIconSpByMoneyType(self.money_type);
	-- self.goldBg:setAltas(uiatlasName, spriteName);
	-- self.goldTxt.text = self.data.firework_info.price;
	self.desTxt.text = self.data.content;
end

function Lua_FireworksCarnivalPanel:oneBuyBgClick()
	if self.clickTime and getTime() - self.clickTime < 0.3 then
		OperateAlert.show(LanUtil.getValue(121419));
		return;
	end
	self.clickTime = getTime();

	self:onBuy(1);
end

function Lua_FireworksCarnivalPanel:tenBuyBgClick()
	if self.clickTime and getTime() - self.clickTime < 0.3 then
		OperateAlert.show(LanUtil.getValue(121419));
		return;
	end
	self.clickTime = getTime();

	self:onBuy(10);
end

function Lua_FireworksCarnivalPanel:onBuy(needBuyNum)
	if self.data and needBuyNum > 0 then
		self.needBuyNum = needBuyNum;
		self.costGoldNum = self.data.firework_info.price * self.needBuyNum;
		local str;
		if DataCenter.moneyData:getMoney(self.data.firework_info.money_type) < self.costGoldNum then
			str = "["..Lua_ColorDefine.RED_STR.."]"..self.costGoldNum.."[-]";
			self.bEnoughGold = false;
		else
			str = "["..Lua_ColorDefine.GREEN_STR.."]"..self.costGoldNum.."[-]";
			self.bEnoughGold = true;
		end

		if DataCenter.neverTip:getNeverValue("Lua_FireworksCarnivalPanel") then
			if self.bEnoughGold == false then
				local costVo = Lua_ToolVo.new(self.data.firework_info.money_type);
				OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(121427), costVo.colorName));
			else
				Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sReceiveFireworks(self.needBuyNum);
			end
			return;
		end

		local tipData = {};
		tipData.des = LanUtil.formateStr(LanUtil.getValue(124516), str, tostring(self.needBuyNum));  
		tipData.neverTip = "Lua_FireworksCarnivalPanel";
		tipData.owner = self;
		tipData.type = 1;
		tipData.subFun = self.onSureFun;
		Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
	end
end

function Lua_FireworksCarnivalPanel:onSureFun()
	if self.bEnoughGold then
		Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sReceiveFireworks(self.needBuyNum);
	else
		DataCenter.moneyData:isMoneyEnough(self.data.firework_info.money_type, self.costGoldNum, true, true);
	end
end

function Lua_FireworksCarnivalPanel:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	if self.yanHuaEffect ~= nil then
		self.yanHuaEffect:dispose();
		self.yanHuaEffect = nil;
	end
	if self.jianTouEffect ~= nil then
		self.jianTouEffect:dispose();
		self.jianTouEffect = nil;
	end
	Lua_CommonUtil.removeTimer(self, self.onEffectTimer);
	
	self:superCall("dispose");
end





--------------------------------------------------





Lua_fireworksCarnivalItem = class("Lua_fireworksCarnivalItem", Lua_ListCell);
function Lua_fireworksCarnivalItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_fireworksCarnivalItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setDepth(5);
	self.itemImg:setCanClick(false);
	self.itemImg:setScale(0.8, 0.8);
end

function Lua_fireworksCarnivalItem:onPlayerSoundClick()
	if self._data ~= nil then
		Lua_PackUtil.showItemInfo(self.itemImg.data);
	end
end
function Lua_fireworksCarnivalItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local reward = Lua_ToolVo.createToolVo(data.data.id, data.data.amount, data.data.bind == 2 and 1 or data.data.bind);
	reward.star = data.data.equipment.star;
	self.itemImg.data = reward
	self.itemImg:showMaskSp(false);
	self.itemImg:showNotYetImg(false);
	self.itemImg:showRoundEff(data.isShow);
end

function Lua_fireworksCarnivalItem:checkOutBound(showRect)
	if self._data ~= nil then
		local rect = Lua_Rectangle.new(self.itemX - 35, self.itemY - 35, 70, 70);
		self.itemImg:showRoundEff(showRect:containeRect(rect));
	end
end

function Lua_fireworksCarnivalItem:dispose()
	if self.itemImg ~= nil then
		self.itemImg:dispose();
		self.itemImg = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end