-- 烟花狂欢购买结算界面
checkRequire("Lua_TreasureResultWindow");
Lua_FireworksCarnivalResultWindow = class("Lua_FireworksCarnivalResultWindow", Lua_TreasureResultWindow);
function Lua_FireworksCarnivalResultWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_FireworksCarnivalResultWindow";
	self.bShowRuneChips = false;
end

function Lua_FireworksCarnivalResultWindow:buildPanel(go)
	self:superCall("buildPanel", go);

	self:addLuaEvent("rReceiveFireworks", self, self.onReceiveFireworks);
end

function Lua_FireworksCarnivalResultWindow:onReceiveFireworks(msg)  
	if msg.reward_list ~= nil then
		self.len = #msg.reward_list;
		if self.len > 1 then
			self.againBtn.label = LanUtil.getValue(121433);
		else
			self.againBtn.label = LanUtil.getValue(121409);
		end

		local tvo;
		local arr = Array();
		for i = 1, self.len do 
			tvo = Lua_ToolVo.createToolVo(msg.reward_list[i].id);
			tvo:fromServer(msg.reward_list[i]);
			tvo.bShowQualityEff = true;
			arr:add(tvo);
		end
		self:setShowResultData(arr);
	end
end

function Lua_FireworksCarnivalResultWindow:onAgainBtnClick(go)
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.3 then
		OperateAlert.show(LanUtil.getValue(121419));
		return;
	end
	self.clickTime = getTime();

	self.needBuyNum = self.len > 1 and 10 or 1;
	if self.needBuyNum > 0 then
		local str;
		self.data = DataCenter.OperationalActivitiesData:getNationalFestivalData(1018);
		self.costGoldNum = self.data.firework_info.price * self.needBuyNum;
		if DataCenter.moneyData:getMoney(self.data.firework_info.money_type) < self.costGoldNum then
			str = "["..Lua_ColorDefine.RED_STR.."]"..tostring(self.costGoldNum).."[-]";
			self.bEnoughGold = false;
		else
			str = "["..Lua_ColorDefine.GREEN_STR.."]"..tostring(self.costGoldNum).."[-]";
			self.bEnoughGold = true;
		end

		if DataCenter.neverTip:getNeverValue("Lua_FireworksCarnivalPanel") == true then
			if self.bEnoughGold == false then
				local costVo = Lua_ToolVo.new(self.data.firework_info.money_type);
				OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(121427), costVo.colorName));
			else
				Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sReceiveFireworks(self.needBuyNum);
			end
			return;
		end

		local tipData = {};
		tipData.des = LanUtil.formateStr(LanUtil.getValue(124516), str, tostring(self.needBuyNum));  
		tipData.neverTip = "Lua_FireworksCarnivalPanel";
		tipData.owner = self;
		tipData.type = 1;
		tipData.subFun = self.onSureFun;
		Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
	end
end

function Lua_FireworksCarnivalResultWindow:onSureFun()
	if self.bEnoughGold then
		Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sReceiveFireworks(self.needBuyNum);
	else
		DataCenter.moneyData:isMoneyEnough(self.data.firework_info.money_type, self.costGoldNum, true, true);
	end
end