-- 全民盛典
checkRequire("Lua_FireworksCarnivalPanel");
-- checkRequire("Lua_RechargeRitualPanel");
-- checkRequire("Lua_HelloEveryonePanel");
-- checkRequire("Lua_KingComesPanel");
Lua_NationalFestivalWindow = class("Lua_NationalFestivalWindow", Lua_Window);
function Lua_NationalFestivalWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_NationalFestivalWindow";
	self.skinName = "NationalFestivalWindow_skin";
	self.showClose = false;
end

function Lua_NationalFestivalWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.role:setUrl("/images/common/ui_quanminshengdian.png");
	self.role:SetDimensions(427, 720);
	self.role:setLocation(-400, -2, 0);

	self.itemList = Array();
	self.itemList:add({id = 1018, panel = Lua_FireworksCarnivalPanel, showEventId = false});

	self.btnList = Lua_DragList.new(self.content, 2, Vector4(0, 0, 750, 64));
	self.btnList:setListCell(Lua_NationalFestivalItem, 64, 190, 4);
	self.btnList:setLocation(95, 139, 0);

	self:addLuaEvent("NATIONALFESTIVAL_BTNCLICK", self, self.updataClickInfo);
	self:addLuaEvent("SET_NATIONAL_FESTIVAL", self, self.updateNationalFestivalInfo); 
	sendMsg(11400021);
end

function Lua_NationalFestivalWindow:updateNationalFestivalInfo()
	local data;
	local arr = Array();
	for i = 1, self.itemList:getSize() do
		data = DataCenter.OperationalActivitiesData:getNationalFestivalData(self.itemList[i].id);
		if data ~= nil then
			arr:add({name = data.title, panel = self.itemList[i].panel, index = i,
				data = data, showEventId = self.itemList[i].showEventId});
		end
	end

	local curSelectIdx = 1;
	if self.selectIdx ~= nil then
		curSelectIdx = self.selectIdx;
		self.selectIdx = nil;
	end

	self.btnList:setLuaArrayData(arr, false);
	if arr:getSize() > 0 then
		self:updataClickInfo(arr[curSelectIdx], true);
		self.btnList:setSelected(curSelectIdx);
	end
end

function Lua_NationalFestivalWindow:updataClickInfo(itemInfo)
	if self.selectIdx == itemInfo.index then
		return;
	end
	self.selectIdx = itemInfo.index;

	self.eTimeNum = tonumber(tostring(itemInfo.data.stop_tick));
	self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(124507), TimeTransform.getInstance():transSeconds9(self.eTimeNum - tonumber(tostring(GlobalVar.cur_tick))));
	self:startTimer();
	self:onTimeStrTimer();

	if self.curPanel ~= nil then
		self.curPanel:dispose();
		self.curPanel = nil;
	end
	self.curPanel = itemInfo.panel.new(self.content);
	self.curPanel:setData(itemInfo.data);

	Lua_MsgUtil.callFunc("SET_NATIONAL_FESTIVAL_PANEL");
end

function Lua_NationalFestivalWindow:startTimer()
	if self.countDown ~= true then
		self.countDown = true;
		Lua_CommonUtil.addTimer("Lua_NationalFestivalWindow", 1, self, self.onTimeStrTimer);
	end
end

function Lua_NationalFestivalWindow:onTimeStrTimer()
	self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(124507), TimeTransform.getInstance():transSeconds9(self.eTimeNum - tonumber(tostring(GlobalVar.cur_tick))));
	if self.eTimeNum - tonumber(tostring(GlobalVar.cur_tick)) <= 0 then
		self:endTimer();
	end
end

function Lua_NationalFestivalWindow:endTimer()
	if self.countDown then
		self.countDown = false;
		Lua_CommonUtil.removeTimer(self, self.onTimeStrTimer);
	end
end

function Lua_NationalFestivalWindow:dispose()
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	self:endTimer();

	self:superCall("dispose");
end





--------------------------------------------------





Lua_NationalFestivalItem = class("Lua_NationalFestivalItem", Lua_ListCell);
function Lua_NationalFestivalItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_NationalFestivalItem:buildShowItem()
	self:superCall("buildShowItem");

	self.btnBg = UICreate.createUIAtlasImage(self.content, "operationalActivities_atlas", "ui_yhsd_an", 0, 0, 0, 0);
	self.btnBg:setDepth(8);

	self.btnTxt = UICreate.createLabel(self.content, "", 0, -1, 116, 28, 28);
	self.btnTxt.pivot = UIWidget.Pivot.Center;
	self.btnTxt.overflowMethod = UILabel.Overflow.ResizeFreely;
	self.btnTxt.colorStr = Lua_ColorDefine.transColor("493930");
	self.btnTxt:setDepth(15);

	self.redDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 90, 28, 0, 0);
	self.redDot.name = "redDot";
	self.redDot:setDepth(16);
end

function Lua_NationalFestivalItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.btnTxt.text = self._data.name;

	local needRed = false;
	if data.showEventId then
		for i = 1, #data.data.reward_info do
			if data.data.reward_info[i].draw_flag == 0 then
				-- self._eventIds[tostring(eventId)] = eventId;
				needRed = true;
			end
		end
	end
	self.redDot:setEnable(needRed);
end

function Lua_NationalFestivalItem:onPlayerSoundClick(go)
	Lua_MsgUtil.callFunc("NATIONALFESTIVAL_BTNCLICK", self._data);
end

-- function Lua_NationalFestivalItem:onSelectionChange(val)
-- 	self:superCall("onSelectionChange", val);

-- 	if val then
-- 		self.btnBg:setAltas("operationalActivities_atlas", "ui_yhsd_an");
-- 		self.btnTxt.colorStr = Lua_ColorDefine.transColor("493930");
-- 	else
-- 		self.btnBg:setAltas("operationalActivities_atlas", "ui_yhsd_an");
-- 		self.btnTxt.colorStr = Lua_ColorDefine.transColor("493930");
-- 	end
-- end