-- 集字送礼
Lua_OperationalActivitiesOnePanel = class("Lua_OperationalActivitiesOnePanel", Lua_DisplayObject)
function Lua_OperationalActivitiesOnePanel:ctor(p)
	self:superCall("ctor", p, "OperationalActivities_skin");
end

function Lua_OperationalActivitiesOnePanel:buildShowItem()
	self:superCall("buildShowItem");

	self.itemList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 980, 405));
	self.itemList:setListCell(Lua_ColletWordGiveGiftItem, 135, 990, 1);
	self.itemList:setLocation(92, -128, 0);

	self:addLuaEvent("UPDATE_ONEPANEL_DATA", self, self.updateColletWordPanelInfo);
end

function Lua_OperationalActivitiesOnePanel:updateColletWordPanelInfo(o)
	if self.first_type ~= o.act_detail.first_type then
		return;
	end

	local actData = DataCenter.OperationalActivitiesData;
	self.eTimeNum = actData.act_detail.stop_tick;

	local atimeStr1 = TimeTransform.getInstance():transSeconds8(actData.act_detail.start_tick, "yyyy-MM-dd HH:mm");
	local atimeStr2 = TimeTransform.getInstance():transSeconds8(self.eTimeNum, "yyyy-MM-dd HH:mm");
	self.aTime.text = LanUtil.formateStr("[FFDF05]"..LanUtil.getValue(122535).."[-]", atimeStr1, atimeStr2);

	local time = self.eTimeNum - actData.act_detail.times;
	self.eTimeLable.text = LanUtil.formateStr("[FFDF05]"..LanUtil.getValue(122536).."[-]", TimeTransform.getInstance():transSeconds1(time, true));
	Lua_CommonUtil.addTimer("Lua_OperationalActivitiesOnePanel", 1, self, self.onTimeStrTimer);

	self.aDes.text = LanUtil.formateStr("[FFDF05]"..LanUtil.getValue(122537).."[-]", "[FFFFFF]"..actData.act_detail.content.."[-]");

	local arr = Array();
	for i,v in ipairs(actData.act_detail.reward_info) do
		arr:add(v);
	end
	self.itemList:setLuaArrayData(arr, false);

	self:setRankingText();
end

function Lua_OperationalActivitiesOnePanel:setRankingText()
	local actData = DataCenter.OperationalActivitiesData;
	local secondType = actData.act_detail.second_type;
	local subValue = actData.act_detail.sub_value;
	if actData.act_detail.first_type == 1004 then
		if secondType == 1 then
			self.myFighting.text=LanUtil.formateStr("[FFDF05]"..LanUtil.getValue(122538).."[-]", "[00E125]"..subValue.."[-]");
		elseif secondType == 2 then
			self.myFighting.text = LanUtil.formateStr(LanUtil.getValue(122559), subValue);
		elseif secondType == 4 then
			local stageDic = DataCenter.servantData:lvlTrans(subValue);
			self.myFighting.text = LanUtil.formateStr(LanUtil.getValue(122560), tostring(stageDic.stage), tostring(stageDic.starLvl));
		elseif secondType == 5 then
			local stageDic = DataCenter.mountData:lvlTrans(subValue);
			self.myFighting.text = LanUtil.formateStr(LanUtil.getValue(122561), tostring(stageDic.stage), tostring(stageDic.starLvl));
		elseif secondType == 6 then
			local stageDic = DataCenter.servantWeaponData:lvlTrans(subValue);
			self.myFighting.text = LanUtil.formateStr(LanUtil.getValue(122563), tostring(stageDic.stage), tostring(stageDic.starLvl));
		elseif secondType == 7 then
			local stageDic = DataCenter.servantMountData:lvlTrans(subValue);
			self.myFighting.text = LanUtil.formateStr(LanUtil.getValue(122564), tostring(stageDic.stage), tostring(stageDic.starLvl));
		elseif secondType == 8 then
			local stageDic = DataCenter.servantWingData:lvlTrans(subValue);
			self.myFighting.text = LanUtil.formateStr(LanUtil.getValue(122565), tostring(stageDic.stage), tostring(stageDic.starLvl));
		elseif secondType == 10 then
			local stageDic = DataCenter.magicWeaponData:lvlTrans(subValue);
			self.myFighting.text = LanUtil.formateStr(LanUtil.getValue(122566), tostring(stage), tostring(starLvl));
		elseif secondType == 11 then
			local stageDic = DataCenter.talismanData:lvlTrans(subValue);
			self.myFighting.text = LanUtil.formateStr(LanUtil.getValue(122567), tostring(stage), tostring(starLvl));
		elseif secondType == 101 then
			self.myFighting.text = LanUtil.formateStr(LanUtil.getValue(122562), subValue);
		elseif secondType == 102 then
			self.myFighting.text = LanUtil.formateStr(LanUtil.getValue(122558), subValue);
		end

		if tonumber(actData.act_detail.second_sub) ~= 0 then
			self.myRanking.text = LanUtil.formateStr("[FFDF05]"..LanUtil.getValue(122539).."[-]", "[00E125]"..actData.act_detail.second_sub.."[-]");
		else
			self.myRanking.text = LanUtil.formateStr("[FFDF05]"..LanUtil.getValue(122539).."[-]", "[00E125]"..LanUtil.getValue(122557).."[-]");
		end
		self.myRanking:setLocation(self.myFighting.mainContent.transform.localPosition.x + self.myFighting.width + 20, 112, 0);
	end
	self.myFighting:setEnable(actData.act_detail.first_type == 1004);
	self.myRanking:setEnable(actData.act_detail.first_type == 1004);
end

function Lua_OperationalActivitiesOnePanel:onTimeStrTimer()
	self.eTimeNum = self.eTimeNum - 1;
	local time = self.eTimeNum - DataCenter.OperationalActivitiesData.act_detail.times;
	if time > 0 then
		self.eTimeLable.text = LanUtil.formateStr("[FFDF05]"..LanUtil.getValue(122536).."[-]", TimeTransform.getInstance():transSeconds1(time, true));
	else
		Lua_CommonUtil.removeTimer(self, self.onTimeStrTimer);
	end
end

function Lua_OperationalActivitiesOnePanel:dispose()
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	Lua_CommonUtil.removeTimer(self, self.onTimeStrTimer);
	
	self:superCall("dispose");
end





--------------------------------------------------





Lua_ColletWordGiveGiftItem = class("Lua_ColletWordGiveGiftItem", Lua_ListCell);
function Lua_ColletWordGiveGiftItem:ctor(p)
	self:superCall("ctor", p, "OperationalActivitiesItem_skin");
end

function Lua_ColletWordGiveGiftItem:buildShowItem()
	self:superCall("buildShowItem");
	
	self.arr = Array();
	self.effectArr = Array();
	self.condArr = Array();
	self.condSpArr = Array();

	self.redDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 446, 15, 0, 0);
	self.redDot.name = "redDot"
	self.redDot:setDepth(16);
	self.redDot:setEnable(false);

	self.receiveBtn:addClickFuntion(self, self.onReceiveClick);
end

function Lua_ColletWordGiveGiftItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.firstType = DataCenter.OperationalActivitiesData.act_detail.first_type;
	if self.firstType == 1002 or self.firstType == 1003 then
		self.moneyTxt.text = LanUtil.formateStr(data.content, DataCenter.OperationalActivitiesData.act_detail.sub_value);
	else
		self.moneyTxt.text = data.content;
	end

	self.receiveBtn:setBtnEnable(true);
	if self.firstType ~= 1004 then
		if data.draw_flag == 0 then
			self.receiveBtn:setBtnEnable(true);
			self.redDot:setEnable(true);
			if self.firstType ~= 1013 then
				self.receiveBtn.label = LanUtil.getValue(122527);
			else
				self.receiveBtn.label = LanUtil.getValue(122568);
			end
		elseif data.draw_flag == 1 then
			if self.firstType == 1001 or self.firstType == 1012 then
				self.receiveBtn:setBtnEnable(true);
				self.redDot:setEnable(false);
				self:setWinInfo()
			elseif self.firstType == 1013 then
				self.receiveBtn:setBtnEnable(true);
				self.redDot:setEnable(false);
				self.receiveBtn.label = LanUtil.getValue(122568);
			else
				self.receiveBtn:setBtnEnable(false);
				self.redDot:setEnable(false);
				self.receiveBtn.label = LanUtil.getValue(122528);
			end
		else
			self.receiveBtn:setBtnEnable(true);
			self.redDot:setEnable(false);
			self:setWinInfo()
		end
	else 
		self.receiveBtn:setBtnEnable(true);
		self.redDot:setEnable(false);
		self:setWinInfo()
	end

	self:setCond();
	
	if self.firstType == 1013 then
		if tonumber(data.cond[1]) == 0 then
			self.condTxt:setEnable(false);
		else
			self.condTxt:setEnable(true);
			if tonumber(data.cond[1]) == 1 then
				self.condTxt.text = LanUtil.formateStr(LanUtil.getValue(122570), data.sub_value)
			else
				self.condTxt.text = LanUtil.formateStr(LanUtil.getValue(122571), data.sub_value)
			end
		end
	else
		self.condTxt:setEnable(false);
	end

	-- 创建道具
	local len = #data.reward_set;
	local num = self.arr:getSize() - len;
	local itemImg;
	while(num > 0) do
		itemImg = self.arr:shift();
		itemImg:dispose();
		num = num - 1;
	end

	while(num < 0) do
		itemImg = Lua_ToolImage.new(self.content);
		itemImg:setDepth(5);
		itemImg:setScale(0.88, 0.88, 0.88);
		self.arr:add(itemImg);
		num = num + 1;
	end

	if self.effectArr:getSize() > 0 then
		self.effectArr:clear();
	end

	local obj;
	local tvo;
	for i = 1, len do
		obj = data.reward_set[i];

		tvo = Lua_ToolVo.createToolVo(obj.id, obj.amount, obj.bind == 2 and 1 or obj.bind);
		tvo.star = obj.equipment.star;
		tvo.bShowItemBg = true;

		itemImg = self.arr[i];
		for i = 1, #data.spec_effect_item do
			if obj.id == tonumber(data.spec_effect_item[i]) and tvo.color > 2 then
				tvo.roundEffect = true;
				self.effectArr:add(itemImg);
			end
		end

		itemImg.data = tvo;
		if self.firstType ~= 1013 then
			itemImg:showNum(obj.amount, true);
			itemImg:setLocation(-419 + (i - 1) * 85, -17, 0);
		else
			self.itemNumArr:sort("num", false)
			itemImg:showNum(self.itemNumArr[1].num, true);
			itemImg:setLocation(-419 + (i - 1 + self.condLen) * 120, -17, 0);
		end
	end
	self.moneyTxt:setLocation(-453, 39, 0);
end

function Lua_ColletWordGiveGiftItem:setWinInfo()
	local secondType = DataCenter.OperationalActivitiesData.act_detail.second_type;
	local dataList = DataCenter.OperationalActivitiesData:getDataList()
	if self.firstType ~= 1004 and self.firstType ~= 1013 then
		for i = 1, dataList:getSize() do
			if dataList[i].first_type == self.firstType then
				self.receiveBtn.label = LanUtil.getValue(dataList[i].btn_text);
				self.list = dataList[i].open_list
			end
		end
	elseif self.firstType == 1004 then
		for i = 1, dataList:getSize() do
			if dataList[i].second_type == secondType then
				self.receiveBtn.label = LanUtil.getValue(dataList[i].btn_text);
				self.list = dataList[i].open_list
			end
		end
	elseif self.firstType == 1013 then
		for i = 1, dataList:getSize() do
			if dataList[i].first_type == self.firstType then
				self.receiveBtn.label = LanUtil.getValue(dataList[i].btn_text);
			end
		end
	end
end

-- 集字送礼条件道具显示
function Lua_ColletWordGiveGiftItem:setCond()
	if self.firstType == 1013 then
		self.itemNumArr = Array();
		self.condLen = (#self._data.cond - 2) / 2;
		local condNum = self.condArr:getSize() - self.condLen;
		local condImg;
		local condSp;
		while(condNum > 0) do
			condImg = self.condArr:shift();
			condSp = self.condSpArr:shift();
			condImg:dispose();
			condSp:dispose();
			condNum = condNum - 1;
		end
	
		while(condNum < 0) do
			condImg = Lua_ToolImage.new(self.content);
			condImg:setDepth(5);
			condImg:setScale(0.88, 0.88, 0.88);
			self.condArr:add(condImg);

			condSp = UICreate.createUIAtlasImage(self.content, "", "", 0, 0, 0, 0);
			condSp:setDepth(6);
			self.condSpArr:add(condSp);

			condNum = condNum + 1;
		end

		local tvo;
		for i = 1, self.condLen do
			local itemNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(tonumber(self._data.cond[i * 2 + 1]));
			self.itemNumArr:add({num = itemNum / tonumber(self._data.cond[i * 2 + 2])});

			tvo = Lua_ToolVo.createToolVo(tonumber(self._data.cond[i * 2 + 1]), itemNum, 0);
			tvo.bShowItemBg = true;

			condImg = self.condArr[i];
			condImg.data = tvo;
			condImg:setLocation(-419 + (i - 1) * 120, -17, 0);
		end

		for i = 1, self.condSpArr:getSize() do
			if i < self.condSpArr:getSize() then
				self.condSpArr[i]:setAltas("iconantlas1", "tongyong_jiahao")
			else
				self.condSpArr[i]:setAltas("operationalActivities", "yyhd_denghao")
			end
			self.condSpArr[i]:setLocation(-360 + (i - 1) * 120, -17, 0);
		end
	else
		for i = 1, self.condArr:getSize() do
			self.condArr[i]:dispose();
		end

		for i = 1, self.condSpArr:getSize() do
			self.condSpArr[i]:setEnable(false);
		end
	end
end

function Lua_ColletWordGiveGiftItem:checkOutBound(showRect)
	if self.effectArr:getSize() <= 0 then
		return;
	end

	local width = self.effectArr[1].item_bg.width;
	local height = self.effectArr[1].item_bg.height;
	local rect = Lua_Rectangle.new(self.itemX - width / 2, self.itemY - 17 - height / 2, width, height);
	for i = 1, self.effectArr:getSize() do
		self.effectArr[i]:showRoundEff(showRect:containeRect(rect));
	end
end

function Lua_ColletWordGiveGiftItem:onReceiveClick()
	if self.firstType ~= 1004 then
		if self._data.draw_flag == 0 then
			self:receivingReward();
		elseif self._data.draw_flag == 1 then
			if self.firstType == 1001 or self.firstType == 1012 then
				self:onOpenWinClick();
			elseif self.firstType == 1013 then
				OperateAlert.show(LanUtil.getValue(122572));
			end
		else
			if self.firstType == 1013 then
				self:onHangUpClick();
			else
				self:onOpenWinClick();
			end
		end
	else
		self:onOpenWinClick();
	end
end

function Lua_ColletWordGiveGiftItem:receivingReward()
	DataCenter.OperationalActivitiesData:receivedReward({
		act_index = DataCenter.OperationalActivitiesData.act_detail.act_index,
		reward_index = self._data.index,
		reward_num = 1
	});
end

function Lua_ColletWordGiveGiftItem:onOpenWinClick()
	Lua_WindowUtil.openWin("Lua_OperationalActivitiesWindow",WinParam.ACTION_CLOSE, nil);
	Lua_PackUtil.openWinByList(self.list, nil, nil, true);
end

function Lua_ColletWordGiveGiftItem:onHangUpClick()
	sendMsg(10404305);
	Lua_WindowUtil.openWin("Lua_OperationalActivitiesWindow", WinParam.ACTION_CLOSE);
end