checkRequire("Lua_OperationalActivitiesOnePanel")
checkRequire("Lua_RechargeRebatePanel")
Lua_OperationalActivitiesWindow = class("Lua_OperationalActivitiesWindow", Lua_FullSizeWindow);
function Lua_OperationalActivitiesWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_OperationalActivitiesWindow";
	self.bgPath = "/images/common/special_bg.jpg";
	self.showTitle = false;
end

function Lua_OperationalActivitiesWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.operationalTitleSpOA = UICreate.createUIAtlasImage(self.content, "titleName_altas_1", "yunyinghuodong", -480, 330, 0, 0);
	self.operationalTitleSpOA:setDepth(6);

	self.leftBg = UICreate.createUIAtlasImage(self.content, "iconantlas4", "special_frst_yeqian_bg", -497, 0, 170, MainWinDefine.bgHeight);
	self.leftBg:setDepth(1);

	self.btnDragList = Lua_DragList.new(self.content, 1, Vector4(50, -256, 220, 600));
	self.btnDragList:setListCell(Lua_btnListOA, 80, 460, 1);
	self.btnDragList:setLocation(-556, 220, 0);

	self:addLuaEvent("ON_OPERATIONALACT_ITEM_CLICK", self, self.updateActPanelInfo);
	self:addLuaEvent("UPDATE_ACTIVITIES_DATA", self, self.creatBtnList);
	self:addLuaEvent("SET_ACTIVITIES_BTN_REDDOT", self, self.rSetBtnRedDot);

	-- DataCenter.OperationalActivitiesData:sGetBackAheadShow();
	DataCenter.OperationalActivitiesData:sGetActivitiesInfo();
end

function Lua_OperationalActivitiesWindow:showWin(param)
	self:superCall("showWin", param);
end

function Lua_OperationalActivitiesWindow:creatBtnList()
	local btnNameArr = DataCenter.OperationalActivitiesData:getActivitiesInfo(1, 2);
	local temp = 0;
	self.btnInfos = Array();
	for i = 1, btnNameArr:getSize() do
		if temp ~= btnNameArr[i].act_index then
			if btnNameArr[i].first_type ~= Lua_OperationalActivitiesData.ACT_RANK -- 屏蔽开服冲榜类型
				and btnNameArr[i].first_type ~= Lua_OperationalActivitiesData.ACT_RECHARGE -- 屏蔽累充类型
				and btnNameArr[i].first_type ~= Lua_OperationalActivitiesData.ACT_CHARCATER then -- 屏蔽集字冲榜类型
				
				temp = btnNameArr[i].act_index;
				self.btnInfos:add({act_index = btnNameArr[i].act_index, first_type = btnNameArr[i].first_type,
					second_type = btnNameArr[i].second_type, name = btnNameArr[i].title, index = i, isRedDot = false});
			end
		end
	end

	self.selectNum = 1;
	if self.showData == nil then
		self.selectNum = 1;
	elseif type(self.showData) == "table" and self.showData.opName ~= nil then
		for i = 1, self.btnInfos:getSize() do
			if self.showData.opName == self.btnInfos[i].name then
				self.selectNum = i;
			end
		end
	end

	if self.selectedIndex ~= nil and self.btnInfos[self.selectedIndex] ~= nil then
		self.selectNum = self.selectedIndex;
	end

	local btnInfo = self.btnInfos[self.selectNum];
	if btnInfo == nil then
		return;
	end
	self:updateActPanelInfo({act_index = btnInfo.act_index, first_type = btnInfo.first_type,
		second_type = btnInfo.second_type, name = btnInfo.name, index = self.selectNum}, true);
end

function Lua_OperationalActivitiesWindow:rSetBtnRedDot(isselect)
	for i = 1, self.btnInfos:getSize() do
		local isRedDot = false;
		if DataCenter.OperationalActivitiesData.notify_list:getSize() > 0 then
			for j = 1, #DataCenter.OperationalActivitiesData.notify_list[1] do
				if self.btnInfos[i].act_index == DataCenter.OperationalActivitiesData.notify_list[1][j] then
					isRedDot = true;
				end
			end
		end
		self.btnInfos[i].isRedDot = isRedDot;
	end
	self.btnDragList:setLuaArrayData(self.btnInfos, false);

	if isselect == nil or isselect == true then
		self.btnDragList:setSelected(self.selectNum);
	end
end

function Lua_OperationalActivitiesWindow:updateActPanelInfo(val)
	if self.selectedIndex == val.index then
		return;
	end
	self.selectedIndex = val.index;

	local openDayList = DataCenter.OperationalActivitiesData:getOpenDayList(1);
	for i = 1, openDayList:getSize() do
		if openDayList[i].show_flag == 1 then
			if val.first_type == openDayList[i].first_type and val.second_type == openDayList[i].second_type then
				OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(122574), tostring(openDayList[i].open_day)));
				return;
			end
		end
	end

	if self.curPanel ~= nil then
		self.curPanel:dispose();
		self.curPanel = nil;
	end

	if val.first_type == 1008 then
		self.curPanel = Lua_RechargeRebatePanel.new(self.content);
		self.curPanel.first_type = val.first_type;
	else
		self.curPanel = Lua_OperationalActivitiesOnePanel.new(self.content);
		self.curPanel.first_type = val.first_type;
	end
	DataCenter.OperationalActivitiesData:sGetOperationalActivities(val.act_index,val.first_type);
end

function Lua_OperationalActivitiesWindow:dispose()
	if self.btnInfos ~= nil then
		self.btnInfos:clear()
		self.btnInfos = nil;
	end
	if self.btnDragList ~= nil then
		self.btnDragList:dispose()
		self.btnDragList = nil;
	end
	if self.curPanel ~= nil then
		self.curPanel:dispose();
		self.curPanel = nil;
	end
	self:superCall("dispose");
end





--------------------------------------------------





Lua_btnListOA = class("Lua_btnListOA", Lua_ListCell);
function Lua_btnListOA:ctor(p)
	self:superCall("ctor", p);
end

function Lua_btnListOA:buildShowItem()
	self:superCall("buildShowItem");

	self.operationalBg = UICreate.createUIAtlasImage(self.content, "", "", -110, 0, 0, 0);
	self.operationalBg:setDepth(8);

	self.operationalTxt = UICreate.createLabel(self.content, "", -110, 0, 200, 30, 26);
	self.operationalTxt.pivot = UIWidget.Pivot.Center;
	self.operationalTxt:setDepth(15);

	self.redDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", -41, 22, 0, 0)
	self.redDot.clickScale = false;
	self.redDot.name = "redDot";
	self.redDot:setDepth(16);
	self.redDot:setEnable(false);
end

function Lua_btnListOA:setData(data)
	self._data = data;

	self.operationalTxt.text = data.name;
	self.redDot:setEnable(data.isRedDot);
end

function Lua_btnListOA:onPlayerSoundClick(go)
	Lua_MsgUtil.callFunc("ON_OPERATIONALACT_ITEM_CLICK", self._data);
end

function Lua_btnListOA:onSelectionChange(val)
	self:superCall("onSelectionChange", val);

	if val == true then
		self.operationalBg:setAltas("iconantlas1", "tab7_souchong_select");
		self.operationalTxt.color = Color.New(1, 1, 1, 1)
		self.operationalTxt.effectColorStr = Lua_ColorDefine.transColor("A02F08");
		self.operationalTxt.effectStyle = 3;
	else
		self.operationalBg:setAltas("iconantlas1", "tab7_souchong_normal");
		self.operationalTxt.color = Color.New(157 / 255, 62 / 255, 22 / 255, 1)
		self.operationalTxt.effectStyle = 0;
	end
end

function Lua_btnListOA:dispose()
    self:superCall("dispose");
end