Lua_CharmKingCharmRewardItem = class("Lua_CharmKingCharmRewardItem", Lua_ListCell);
function Lua_CharmKingCharmRewardItem:ctor(p)
	self:superCall("ctor", p, "CharmKingCharmRewardItem_skin");
end

function Lua_CharmKingCharmRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rItem = Lua_RewardItem.new(self.content);
	self.rItem:setLayout(76, 76, 4);
	self.rItem:setMaxShow(3);
	self.rItem:setDepth(10);
	self.rItem:setClickWin(false);
	self.rItem:setMouseEnble(false);
	self.rItem:setItemScale(0.8, 0.8);
	self.rItem:setLocation(-117, -11, 0);
end

function Lua_CharmKingCharmRewardItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local str;
	if data.aggregate_value < data.cond then
		str = "[FF1616]" .. data.aggregate_value .. "[-]";
	else
		str = "[00E125]" .. data.aggregate_value .. "[-]";
	end

	if data.flag == 0 then
		if data.settl_switch ~= 1 then
			self.desLab.text = LanUtil.formateStr(LanUtil.getValue(141216), str, tostring(data.cond));
		else
			self.desLab.text = LanUtil.formateStr(LanUtil.getValue(141219), str, tostring(data.cond));
		end
	elseif data.flag == 1 then
		self.desLab.text = LanUtil.formateStr(LanUtil.getValue(141210), str, tostring(data.cond));
	end

	if data.state ~= 1 then
		self.redDot:setEnable(false);

		self.getBtn:setGray(true);
		self.getBtn:removeClickFuntion(self, self.getClick);

		if data.state == 0 then
			self.getBtn.label = LanUtil.getValue(124511);
		elseif data.state == 2 then
			self.getBtn.label = LanUtil.getValue(124512);
		end
	else
		self.redDot:setEnable(true);

		self.getBtn.label = LanUtil.getValue(122527);
		self.getBtn:setGray(false);
		self.getBtn:addClickFuntion(self, self.getClick);
	end
	self.rItem:setRewardByToolVoList(data.rewardList);
end

function Lua_CharmKingCharmRewardItem:getClick()
	local cmd = ProtoPublic_pb.Proto10105602();
	cmd.index = self._data.index;
	cmd.first_type = self._data.first_type;
	sendMsg(10105602, cmd);
end

function Lua_CharmKingCharmRewardItem:checkOutBound(showRect)
	if self._data == nil then
		self.inViewEffect = false;
		return;
	end

	local rect = Lua_Rectangle.new(self.itemX - 25, self.itemY - 40, 75, 60);
	self.inViewEffect = showRect:containeRect(rect);
	self:updateEffectState();
end

function Lua_CharmKingCharmRewardItem:updateEffectState()
	if self.inViewEffect == true and self._data.state == 1 then
		if self.effect == nil then
			self.effect = UICreate.createUIEffect(self.content, nil, nil, 193, 1);
			self.effect:setUrl("/effects/scsEffects/anniutexiao", "anniutexiao");
			self.effect:setSacle(0.43, 0.56, 1);
			self.effect:setLocation(116, -11, 0);
			self.effect:SetRenderQueue(self.desLab, 2, 2, false);
		end
		self.effect:setEnable(true);
	else
		if self.effect ~= nil then
			self.effect:setEnable(false);
		end
	end

	local list = self.rItem.awords;
	if self.inViewEffect == true then
		for i, v in ipairs(list) do
			if v.data.show_effect == 1 and v.roundEff == nil then
				v:showRoundEff(true);
			end
		end
	else
		for i, v in ipairs(list) do
			if v.roundEff ~= nil then
				v:showRoundEff(false);
			end
		end
	end
end

function Lua_CharmKingCharmRewardItem:onPlayerSoundClick(go)
	local v = Vector3(UnityEngine.Input.mousePosition.x, UnityEngine.Input.mousePosition.y, 0);
	local screenpos = UICamera.mainCamera:ScreenToWorldPoint(v);
	local mousePosition = self.rItem.content.transform:InverseTransformPoint(screenpos);
	for i, v in ipairs(self.rItem.awords) do
		if self:checkMouseClick(v, mousePosition) then
			Lua_PackUtil.showItemInfo(self._data.rewardList[i], false);
			break;
		end
	end
end

function Lua_CharmKingCharmRewardItem:checkMouseClick(item, vec)
	local pos = item.content.transform.localPosition;
	if vec.x >= pos.x - 34 and vec.x <= pos.x + 34 and vec.y >= pos.y - 34 and vec.y <= pos.y + 34 then
		return true;
	end
	return false;
end

function Lua_CharmKingCharmRewardItem:dispose()
	if self.rItem ~= nil then
		self.rItem:dispose();
		self.rItem = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end