Lua_CharmKingRankItem = class("Lua_CharmKingRankItem", Lua_ListCell);
function Lua_CharmKingRankItem:ctor(p)
	self:superCall("ctor", p, "CharmKingRankItem_skin");
end

function Lua_CharmKingRankItem:buildShowItem()
	self:superCall("buildShowItem");

	self.sendFlowerBtn:addClickFuntion(self, self.sendFlowerClick);
end

function Lua_CharmKingRankItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.rankLab.text = LanUtil.formateStr(LanUtil.getValue(141211),tostring(self.data.rank));
	if self.data.isEmpty then
		self:updataRankInfoState(false)
	else
		self:updataRankInfoState(true)
		self:updatainfo(self.data.rankList);
	end
end

function Lua_CharmKingRankItem:updataRankInfoState(state)
	self.rankObj:SetActive(state);
	self.emptyObj:SetActive(not state);
end

function Lua_CharmKingRankItem:updatainfo(data)
	self.rankList = data;

	self.nameLab.text = self.rankList.name;
	self.severNameLab.text = LanUtil.formateStr(LanUtil.getValue(141217),tostring(self.rankList.server_name));
	self.charmValueLab.text = self.rankList.receive_value;

	-- 头像框
	if self.rankList.frameId ~= nil and self.rankList.frameId ~=0 then
	local list = DataCenter.roleData:getHeadFrame(self.rankList.frameId);
		self.headFrameIcon:setEnable(true);
		self.headFrameIcon:setAltas(list.atlas, list.sprite);
	else
		self.headFrameIcon:setEnable(false);
	end

	-- 头像
	if isHeadReplaceOpen() == true then
		self:updataHead();
	else
		if self.rankList.frameId ~= nil and self.rankList.frameId ~= 0 then
			self.headImg:setUrl(Lua_ThingDefine.getFashionHeadIconUrlByCareer(self.rankList.career, self.rankList.profession));
		else
			self.headImg:setUrl(Lua_ThingDefine.getHeadIconUrlByCareer(self.rankList.career, self.rankList.profession));
		end
	end
end

function Lua_CharmKingRankItem:updataHead()
	local isDefault = DataCenter.roleData:isDefaultHead(self.rankList.career, self.rankList.role_head);
	if isDefault == true then-- 默认头像
		if self.rankList.frameId ~= nil and self.rankList.frameId ~=0 then
			self.headImg:setUrl(Lua_ThingDefine.getHeadIconUrlByCustom(self.rankList.role_head, 1));
		else
			self.headImg:setUrl(Lua_ThingDefine.getHeadIconUrlByCustom(self.rankList.role_head, 0));
		end
	else
		self.headImg:setUrl(self.rankList.role_head, 99, true);
		-- if self.rankList.frameId ~= nil and self.rankList.frameId ~=0 then
			self.headImg:setRoundSize(0, 0.5, 0.5, 0.25);-- 圆形
		-- else
		-- 	self.headImg:setRoundSize(1, 0.5, 0.5, 0.5);-- 菱形
		-- end
	end
end

function Lua_CharmKingRankItem:sendFlowerClick()
	Lua_MsgUtil.callFunc("SEND_FLOWER", {name = self.rankList.name});
end

function Lua_CharmKingRankItem:dispose()
	self:superCall("dispose");
end