Lua_CharmKingRankRewardItem = class("Lua_CharmKingRankRewardItem", Lua_ListCell);
function Lua_CharmKingRankRewardItem:ctor(p)
	self:superCall("ctor", p, "CharmKingRankRewardItem_skin");
end

function Lua_CharmKingRankRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.selectIcon:setEnable(false);

	self.rItem = Lua_RewardItem.new(self.content);
	self.rItem:setLayout(80, 80, 4);
	self.rItem:setMaxShow(4);
	self.rItem:setDepth(10);
	self.rItem:setClickWin(false);
	self.rItem:setMouseEnble(false);
	self.rItem:setItemScale(0.8, 0.8);
	self.rItem:setLocation(-117, -11, 0);
end

function Lua_CharmKingRankRewardItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local str = "1";
	if data.rank_limit ~= nil and data.rank_limit[1] ~= nil then
		if data.rank_limit[2] ~= nil and data.rank_limit[2] ~= data.rank_limit[1] then
			str = data.rank_limit[1] .. "-" .. data.rank_limit[2];
		else
			str = tostring(data.rank_limit[1]);
		end
	end
	self.desLab.text = LanUtil.formateStr(LanUtil.getValue(141212), str , tostring(data.rank_limit[3]));
	self.rItem:setRewardByToolVoList(data.rewardList);
end

function Lua_CharmKingRankRewardItem:onPlayerSoundClick(go)
	local v = Vector3(UnityEngine.Input.mousePosition.x, UnityEngine.Input.mousePosition.y, 0);
	local screenpos = UICamera.mainCamera:ScreenToWorldPoint(v);
	local mousePosition = self.rItem.content.transform:InverseTransformPoint(screenpos);
	for i, v in ipairs(self.rItem.awords) do
		if self:checkMouseClick(v, mousePosition) then
			if self._data.rewardList[i] ~= nil then
				Lua_PackUtil.showItemInfo(self._data.rewardList[i], false);
			end
			break;
		end
	end
end

function Lua_CharmKingRankRewardItem:onSelectionChange(val)
	self:superCall("onSelectionChange", val);

	self.selectIcon:setEnable(val);
end

function Lua_CharmKingRankRewardItem:checkMouseClick(item, vec)
	local pos = item.content.transform.localPosition;
	if vec.x >= pos.x - 37 and vec.x <= pos.x + 37 and vec.y >= pos.y - 37 and vec.y <= pos.y + 37 then
		return true;
	end
	return false;
end

function Lua_CharmKingRankRewardItem:checkOutBound(showRect)
	if self._data == nil then
		return;
	end

	local rect = Lua_Rectangle.new(self.itemX - 25, self.itemY - 55, 75, 70);
	if showRect:containeRect(rect) then
		for i, v in ipairs(self.rItem.awords) do
			if v.data.show_effect == 1 and v.roundEff == nil then
				v:showRoundEff(true);
			end
		end
	else
		for i, v in ipairs(self.rItem.awords) do
			if v.roundEff ~= nil then
				v:showRoundEff(false);
			end
		end
	end
end

function Lua_CharmKingRankRewardItem:dispose()
	if self.rItem ~= nil then
		self.rItem:dispose();
		self.rItem = nil;
	end
	self._data = nil;

    self:superCall("dispose");
end