-- 魅力之王
checkRequire("Lua_CharmKingRankItem");
checkRequire("Lua_CharmKingRankRewardItem");
checkRequire("Lua_CharmKingCharmRewardItem");
Lua_CharmKingWindow = class("Lua_CharmKingWindow", Lua_FullSizeWindow);
function Lua_CharmKingWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CharmKingWindow";
	self.skinName = "CharmKingWindow_skin";
	self.bgPath = "/images/charmking/ui_mlzw_bg_01.jpg";
	self.showTitle = true;
end

function Lua_CharmKingWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.winTitleBg:setUrl("/images/recharge/ui_chongzhi_btd_01.png");
	self.winTitleBg:SetDimensions(1280, 62);
	self.winTitleBg:setLocation(0, 330, 0);

	self.titleLine:setEnable(false);

	self.btnClose:setAltas("recharge_atlas", "ui_chongzhi_fanhui");
	self.btnClose:SetDimensions(81, 72);
	self.btnClose:setLocation(-592, 324);

	self:setShowTitle("titleName_altas_1", "mlzw");

	if DataCenter.OperationalActivitiesData:getActivitiesByType(1054, nil) == nil then
		OperateAlert.show(LanUtil.getValue(122586));
		return;
	end

	self.desLab.text = LanUtil.getValue(141202);

	self.headFrameIcon:setEnable(false);
	self.emptyObj:SetActive(false);

	self.titleArr = Array();
	self.titleArr:add(LanUtil.getValue(141203));
	self.titleArr:add(LanUtil.getValue(141204));

	self.rankList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 849, 320));
	self.rankList:setLocation(-194, -109, 0);
	self.rankList:setListCell(Lua_CharmKingRankItem, 224, 283, 3);

	self.rankRewardList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 342, 272));
	self.rankRewardList:setLocation(439, 80, 0);
	self.rankRewardList:setListCell(Lua_CharmKingRankRewardItem, 127, 342, 1);

	self.charmRewardList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 342, 145));
	self.charmRewardList:setLocation(439, -152, 0);
	self.charmRewardList:setListCell(Lua_CharmKingCharmRewardItem, 127, 342, 1);

	self.itemImage = Lua_ToolImage.new(self.content);
	self.itemImage:setDepth(5);
	self.itemImage:setScale(0.8, 0.8);
	self.itemImage:setLocation(323, -306, 0);

	self.femaleBtn:addClickFuntion(self, self.onFemaleClick);
	self.maleBtn:addClickFuntion(self, self.onMaleClick);
	self.giftIcon:addClickFuntion(self, self.onGiftClick);
	self.sendFlowerBtn:addClickFuntion(self, self.sendFlowerClick);
	self.rulesBtn:addClickFuntion(self, self.onRulesClick);
	self.buyBtn:addClickFuntion(self, self.onBuyFlowerClick);

	self:addLuaEvent("SEND_FLOWER", self, self.sendFlower);
	self:addLuaEvent("UPDATA_CHARM_KING", self, self.updataCharmKingInfo);
	self:addLuaEvent("UPDATA_CHARM_KING_REAWARD", self, self.updataCharmKingRewardInfo);
	DataCenter.charmKingData.sCharmKingInfo();
end

function Lua_CharmKingWindow:sendFlower(data)
	self.infoList = data;

	local curTime = tonumber(os.date("%H%M", tonumber(tostring(GlobalVar.cur_tick))));
	if curTime >= self.settl_start_time and curTime <= self.settl_end_time and self.settl_switch == 1 then
		self:showTipsWin();
	else
		self:openSendFlowerWin();
	end
end

function Lua_CharmKingWindow:showTipsWin()
	local start_time = math.floor(self.settl_start_time / 100) .. ":" .. string.format("%02d", self.settl_start_time % 100);
	local end_time = math.floor(self.settl_end_time / 100) .. ":" .. string.format("%02d", self.settl_end_time % 100);
	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, des = LanUtil.formateStr(LanUtil.getValue(141214), start_time, end_time),
		titleName = LanUtil.getValue(141215), type = 1, subFun = self.openSendFlowerWin,
		subName = LanUtil.getValue(141213), cancelName = LanUtil.getValue(120545)});
end

function Lua_CharmKingWindow:openSendFlowerWin()
	Lua_WindowUtil.openWin("Lua_FriendSendFlowerWindow", nil, self.infoList);
end

-- 返回更新界面
function Lua_CharmKingWindow:updataCharmKingInfo()
	self.totalTime = DataCenter.charmKingData.end_tick;
	self.sex = DataCenter.charmKingData.sex;
	self.rank_condition = DataCenter.charmKingData.rank_condition;
	self.today_value = DataCenter.charmKingData.today_value;
	self.charm_total = DataCenter.charmKingData.charm_total;
	self.dicountList = DataCenter.charmKingData.dicountList;
	self.rank = DataCenter.charmKingData.rank;
	self.manChampionList = DataCenter.charmKingData.manChampionList;
	self.womanChampionList = DataCenter.charmKingData.womanChampionList;
	self.man_rankersList = DataCenter.charmKingData.man_rankersList;
	self.woman_rankersList = DataCenter.charmKingData.woman_rankersList;
	self.woman_rank_rewardList = DataCenter.charmKingData.woman_rank_rewardList;
	self.man_rank_rewardList = DataCenter.charmKingData.man_rank_rewardList;
	self.isShowGift = DataCenter.charmKingData.isShowGift;
	self.settl_start_time = DataCenter.charmKingData.settl_start_time;
	self.settl_end_time = DataCenter.charmKingData.settl_end_time;
	self.settl_switch = DataCenter.charmKingData.settl_switch;
	self.actContent = DataCenter.charmKingData.act_info.content;

	self.rankArr = {};
	self.rankArr[1] = self.man_rankersList;
	self.rankArr[2] = self.woman_rankersList;
	self.championArr = {};
	self.championArr[1] = self.manChampionList;
	self.championArr[2] = self.womanChampionList;
	self.rank_rewardArr = {};
	self.rank_rewardArr[1] = self.man_rank_rewardList;
	self.rank_rewardArr[2] = self.woman_rank_rewardList;

	local leftTime = self.totalTime - tonumber(tostring(GlobalVar.cur_tick));
	self.timeLab.text = LanUtil.formateStr(LanUtil.getValue(141200), TimeTransform.getInstance():transSeconds1(leftTime, true));
	Lua_CommonUtil.addTimer("Lua_CharmKingWindow", 1, self, self.onActivityTimeDown);

	if self.rankListIdx == nil then
		if self.sex == 1 then
			self:setSelect(1);
		elseif self.sex == 2 then
			self:setSelect(2);
		end
		return;
	end
	self:updataInfo();
end

function Lua_CharmKingWindow:onActivityTimeDown()
	local leftTime = self.totalTime - tonumber(tostring(GlobalVar.cur_tick));
	self.timeLab.text = LanUtil.formateStr(LanUtil.getValue(141200), TimeTransform.getInstance():transSeconds1(leftTime, true));
	if leftTime <= 0 then
		Lua_CommonUtil.removeTimer(self, self.onActivityTimeDown);
	end
end

function Lua_CharmKingWindow:setSelect(value)
	self.rankListIdx = value;
	if value == 1 then
		self:updataButton(false);
		self:updataInfo();
	elseif value == 2 then
		self:updataButton(true);
		self:updataInfo();
	end
end

function Lua_CharmKingWindow:updataButton(state)
	self.femaleNoSelectObj:SetActive(not state);
	self.femaleSelectObj:SetActive(state);
	self.maleNoSelectObj:SetActive(state);
	self.maleSelectObj:SetActive(not state);
end

-- 更新界面
function Lua_CharmKingWindow:updataInfo()
	self:updataChampionInfo();
	-- 个人信息
	self.myCharmValLab.text = LanUtil.formateStr(LanUtil.getValue(141205), tostring(self.charm_total));
	self.conditionLab.text = LanUtil.formateStr(LanUtil.getValue(141206), tostring(self.rank_condition));
	self.todayCharmValLab.text = LanUtil.formateStr(LanUtil.getValue(141207), tostring(self.today_value));
	self.myRankLab.text = LanUtil.formateStr(LanUtil.getValue(141208), tostring(self.rank));

	self:updataCharmKingRewardInfo();

	self.itemImage.data = self.dicountList.discount_item;
	self.primeCostLab.text = self.dicountList.price;
	self.discountCostLab.text = self.dicountList.discount_price;

	self.rankList:setLuaArrayData(self.rankArr[self.rankListIdx]);
	self.rankRewardList:setLuaArrayData(self.rank_rewardArr[self.rankListIdx]);
	self.rankRewardLab.text = self.titleArr[self.rankListIdx];
end

-- 个人奖励
function Lua_CharmKingWindow:updataCharmKingRewardInfo()
	self.aggregate_rewardList = DataCenter.charmKingData.aggregate_rewardList;
	local index;
	for i = 1, self.aggregate_rewardList:getSize() do
		if self.aggregate_rewardList[i].state ~= 2 then
			index = i;
			break;
		end
	end
	self.charmRewardList:setLuaArrayData(self.aggregate_rewardList);
	-- if index ~= nil and index > self.aggregate_rewardList:getSize() - 1 then
	-- 	index = self.charmRewardList:getSize() - 1
	-- end

	if index ~= nil then
		self.charmRewardList:updateSubPos(0, 130 *(index - 1), 0);
	end
end

-- 第一名信息
function Lua_CharmKingWindow:updataChampionInfo()
	self.giftIcon:setEnable(self.isShowGift);

	if self.championArr[self.rankListIdx] ~= nil then
		self:updataRankInfoState(true);
	else
		self:updataRankInfoState(false);
		return;
	end

	self.nameLab.text = self.championArr[self.rankListIdx].name;
	self.severNameLab.text = LanUtil.formateStr(LanUtil.getValue(141217), tostring(self.championArr[self.rankListIdx].server_name));
	self.charmValueLab.text = self.championArr[self.rankListIdx].receive_value;

	-- 头像框
	if self.championArr[self.rankListIdx].frameId ~= nil and self.championArr[self.rankListIdx].frameId ~= 0 then
		local list = DataCenter.roleData:getHeadFrame(self.championArr[self.rankListIdx].frameId);
		self.headFrameIcon:setEnable(true);
		self.headFrameIcon:setAltas(list.atlas, list.sprite);
	else
		self.headFrameIcon:setEnable(false);
	end

	-- 头像 
	if isHeadReplaceOpen() then
		self:updataHead();
	else
		if self.championArr[self.rankListIdx].frameId ~= nil and self.championArr[self.rankListIdx].frameId ~= 0 then
			self.headImg:setUrl(Lua_ThingDefine.getFashionHeadIconUrlByCareer(self.championArr[self.rankListIdx].career, self.championArr[self.rankListIdx].profession));
			self.headImg:SetDimensions(85, 85);
		else
			self.headImg:setUrl(Lua_ThingDefine.getHeadIconUrlByCareer(self.championArr[self.rankListIdx].career, self.championArr[self.rankListIdx].profession));
			self.headImg:SetDimensions(110, 110);
		end
	end
end

function Lua_CharmKingWindow:updataRankInfoState(state)
	self.rankObj:SetActive(state);
	self.emptyObj:SetActive(not state);
end

function Lua_CharmKingWindow:updataHead()
	local isDefault = DataCenter.roleData:isDefaultHead(self.championArr[self.rankListIdx].career, self.championArr[self.rankListIdx].role_head);
	if isDefault or isHeadReplaceOpen() == false then-- 默认头像
		if self.championArr[self.rankListIdx].frameId ~= nil and self.championArr[self.rankListIdx].frameId ~= 0 then
			self.headImg:setUrl(Lua_ThingDefine.getHeadIconUrlByCustom(self.championArr[self.rankListIdx].role_head, 1));
			self.headImg:SetDimensions(85, 85);
		else
			self.headImg:setUrl(Lua_ThingDefine.getHeadIconUrlByCustom(self.championArr[self.rankListIdx].role_head, 0));
			self.headImg:SetDimensions(110, 110);
		end
	else
		self.headImg:setUrl(self.championArr[self.rankListIdx].role_head, 99, true);
		if self.championArr[self.rankListIdx].frameId ~= nil and self.championArr[self.rankListIdx].frameId ~= 0 then
			-- self.headImg:setRoundSize(0, 0.5, 0.5, 0.25); -- 圆形
			self.headImg:SetDimensions(78, 78);
		else
			-- self.headImg:setRoundSize(1, 0.5, 0.5, 0.5); -- 菱形
			self.headImg:SetDimensions(98, 98);
		end
		self.headImg:setRoundSize(0, 0.5, 0.5, 0.25); -- 圆形
	end
end

function Lua_CharmKingWindow:onFemaleClick()
	self:setSelect(2);
end

function Lua_CharmKingWindow:onMaleClick()
	self:setSelect(1);
end

function Lua_CharmKingWindow:onGiftClick()
	local tvo = Lua_ToolVo.createToolVo(201030098);
	Lua_PackUtil.showItemInfo(tvo, false);
end

-- 送花
function Lua_CharmKingWindow:sendFlowerClick()
	if self.championArr[self.rankListIdx].name == DataCenter.roleData.name then
		OperateAlert.show(LanUtil.getValue(141218));
	else
		Lua_MsgUtil.callFunc("SEND_FLOWER", {name = self.championArr[self.rankListIdx].name});
	end
end

function Lua_CharmKingWindow:onRulesClick()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, self.actContent);
end

function Lua_CharmKingWindow:onBuyFlowerClick()
	local goldNum = DataCenter.moneyData:getMoney(Lua_MoneyData.GOLD);
	if goldNum < self.dicountList.discount_price then
		Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, des = LanUtil.getValue(110818), type = 1, subFun = self.openChargeWin});
	else
		local cmd = ProtoPublic_pb.Proto10102085();
		cmd.item_id = self.dicountList.discount_item_id;
		cmd.item_num = 1;
		sendMsg(10102085, cmd);
	end
end

function Lua_CharmKingWindow:openChargeWin()
	Lua_WindowUtil.openWin("Lua_ChongzhiWindow", WinParam.ACTION_OPEN, 1);
end

function Lua_CharmKingWindow:dispose()
	if self.titleArr ~= nil then
		self.titleArr:dispose();
		self.titleArr:clear();
		self.titleArr = nil;
	end
	if self.rankList ~= nil then
		self.rankList:dispose();
		self.rankList = nil;
	end
	if self.rankRewardList ~= nil then
		self.rankRewardList:dispose();
		self.rankRewardList = nil;
	end
	if self.charmRewardList ~= nil then
		self.charmRewardList:dispose();
		self.charmRewardList = nil;
	end
	if self.itemImage ~= nil then
		self.itemImage:dispose();
		self.itemImage = nil;
	end
	Lua_CommonUtil.removeTimer(self, self.onActivityTimeDown);
	self:superCall("dispose");
end