-- 消费寻宝
checkRequire("Lua_ItemShowModelPanel");
Lua_ConsumeTreasureWindow = class("Lua_ConsumeTreasureWindow", Lua_Window);
function Lua_ConsumeTreasureWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ConsumeTreasureWindow";
	self.skinName = "ConsumeTreasureWindow_skin";
end

function Lua_ConsumeTreasureWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.effectList = {};

	local rewardItem;
	self.rewards = Array();
	self.labelList = Array();
	self.maskList = Array();
	self.gouList = Array();
	for i = 1, 30 do
		rewardItem = Lua_ToolImage.new(self["num_" .. i]);
		rewardItem:setDepth(2);
		rewardItem:setCanClick(false);
		rewardItem:setScale(0.7, 0.7);
		self.rewards:add(rewardItem);

		self.labelList:add(self["desLab_" .. i]);

		self["mask_" .. i].alpha = 0.01;
		self["mask_" .. i]:addClickFuntion(self, self.onRewardItemClick);
		self.maskList:add(self["mask_" .. i]);

		self.gouList:add(self["drawIcon_" .. i]);
	end

	self.ruleBtn:addClickFuntion(self, self.onRulesClick);

	DataCenter.redDotData:updateRedDotVoState(22201, false);
	self:addLuaEvent("SET_CONSUMETREASURE_INFO", self, self.updateConsumeTreasureInfo);
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sGetActivityInfo(Lua_OperationalActivitiesData.CONSUMETREASURE);
end

function Lua_ConsumeTreasureWindow:updateConsumeTreasureInfo(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.nextCostLab.text = LanUtil.getValue(144903);
	self.nextTxt.text = "[85A8BE]" .. data.next_step_cost .. "[-]";
	self.nextMoneyIcon:setLocation(self.nextCostLab.mainContent.transform.localPosition.x + self.nextCostLab.width, -66, 0);
	self.nextTxt:setLocation(self.nextMoneyIcon.mainContent.transform.localPosition.x + self.nextMoneyIcon.width, -66, 0);

	self.curCostLab.text = LanUtil.getValue(144904);
	self.costTxt.text = "[85A8BE]" .. data.total_cost .. "[-]";
	self.curMoneyIcon:setLocation(self.curCostLab.mainContent.transform.localPosition.x + self.curCostLab.width, -102, 0);
	self.costTxt:setLocation(self.curMoneyIcon.mainContent.transform.localPosition.x + self.curMoneyIcon.width, -102, 0);

	self.canStepLab.text = LanUtil.formateStr(LanUtil.getValue(144905), tostring(data.today_step));

	if data.cur_steps >= 1 then
		local pos = self["num_" .. data.cur_steps].transform.localPosition;
		self.selectIcon:setLocation(pos.x, pos.y + 93, 0);
	end

	local pos = Vector3(data.model_info[1].value1, data.model_info[1].value2, data.model_info[1].value3);
	local rot = Vector3(data.model_info[2].value1, data.model_info[2].value2, data.model_info[2].value3);
	local sca = Vector3(data.model_info[3].value1, data.model_info[3].value2, data.model_info[3].value3);
	local rewardInfo = data.grid_info;
	local tvo = Lua_ToolVo.createToolVo(rewardInfo[#rewardInfo].item_reward.id);
	if self.modelShowPanel ~= nil then
		self.modelShowPanel:dispose()
		self.modelShowPanel = nil;
	end
	self.modelShowPanel = Lua_ItemShowModelPanel.new(self.content, 200, 250, -5, 100, pos, rot, sca, true);
	self.modelShowPanel.bg:setEnable(false);
	self.modelShowPanel:setShowData(tvo);

	-- is_rebate 0 无奖励，1 返利，2 物品
	local itemInfo;
	for i = 1, 30 do
		if rewardInfo[i].is_rebate ~= 0 then
			if self.rewards[i] ~= nil then
				self.rewards[i]:setEnable(true);
				itemInfo = rewardInfo[i].item_reward;
				if itemInfo ~= nil and itemInfo.id > 0 then
					tvo = Lua_ToolVo.createToolVo(itemInfo.id, itemInfo.amount, itemInfo.bind);
					if rewardInfo[i].item_reward.show_effect == 1 then
						tvo.roundEffect = true;
					end

					if rewardInfo[i].item_reward.equipment ~= nil and rewardInfo[i].item_reward.equipment.star ~= nil then
						tvo.star = rewardInfo[i].item_reward.equipment.star;
					end
					self.rewards[i].data = tvo;
				end
			end

			if self.maskList[i] ~= nil then
				self.maskList[i]:setEnable(true);
				if rewardInfo[i].reward_state == 2 then
					self.maskList[i].alpha = 1;
				else
					self.maskList[i].alpha = 0.01;
				end
			end

			if self.gouList[i] ~= nil then
				self.gouList[i]:setEnable(rewardInfo[i].reward_state == 2);
			end

			if self.labelList[i] ~= nil then
				if rewardInfo[i].is_rebate == 1 then
					self.labelList[i].text = LanUtil.formateStr(LanUtil.getValue(144906), tostring(rewardInfo[i].rebate_percent));
				end
				self.labelList[i]:setEnable(rewardInfo[i].is_rebate == 1);
			end
		else
			if self.rewards[i] ~= nil then
				self.rewards[i]:setEnable(false);
			end
			if self.maskList[i] ~= nil then
				self.maskList[i]:setEnable(false);
			end
			if self.gouList[i] ~= nil then
				self.gouList[i]:setEnable(false);
			end
			if self.labelList[i] ~= nil then
				self.labelList[i]:setEnable(false);
			end
		end
		self:updateEffectState(i);
	end

	self.endTime = tonumber(tostring(data.act_info.end_tick)) - tonumber(tostring(GlobalVar.cur_tick)) + getTime();
	self:startTimer();
	self:checkAutoGet();
end

function Lua_ConsumeTreasureWindow:updateEffectState(index)
	if self.data.grid_info[index].reward_state == 1 then
		if self.effectList[index] == nil then
			local pos = self["num_" .. index].transform.localPosition;
			local effect = UICreate.createUIEffect(self.content, "/effects/scsEffects/xunbaokelingqu", "xunbaokelingqu", pos.x, pos.y);
			effect:SetRenderQueue(self.startIcon, 5, 2, false);
			effect:setSacle(0.8, 0.8, 1);
			self.effectList[index] = effect;
		end
		self.effectList[index]:setEnable(true);
	else
		if self.effectList[index] ~= nil then
			self.effectList[index]:setEnable(false);
		end
	end
end

function Lua_ConsumeTreasureWindow:startTimer()
	if self.countDown ~= true then
		self.countDown = true;
		Lua_CommonUtil.addTimer("Lua_ConsumeTreasureWindow", 1, self, self.checkAutoGet);
	end
end

function Lua_ConsumeTreasureWindow:checkAutoGet()
	local now = getTime();
	self.timeTxt.text = TimeTransform.getInstance():transSeconds1(self.endTime - now, true);
	if self.endTime - now <= 0 then
		self:endTimer();
		self:hide();
		-- Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sGetActivityInfo(Lua_OperationalActivitiesData.CUSTOMIZE);
	end
end

function Lua_ConsumeTreasureWindow:endTimer()
	if self.countDown == true then
		self.countDown = false;
		Lua_CommonUtil.removeTimer(self, self.checkAutoGet);
	end
end

function Lua_ConsumeTreasureWindow:onRewardItemClick(go)
	local index = tonumber(string.split(go.name, "_")[2]);
	local itemInfo = self.data.grid_info[index];
	if itemInfo.reward_state == 1 then
		Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sGetActivityRewards(Lua_OperationalActivitiesData.CONSUMETREASURE, index);
	else
		Lua_PackUtil.showItemInfo(self.rewards[index].data);
	end
end

function Lua_ConsumeTreasureWindow:onRulesClick()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", nil, self.data.act_info.content);
end

function Lua_ConsumeTreasureWindow:dispose()
	if self.rewards ~= nil then
		self.rewards:dispose();
		self.rewards:clear();
		self.rewards = nil;
	end
	if self.labelList ~= nil then
		self.labelList:dispose();
		self.labelList:clear();
		self.labelList = nil;
	end
	if self.maskList ~= nil then
		self.maskList:dispose();
		self.maskList:clear();
		self.maskList = nil;
	end
	if self.gouList ~= nil then
		self.gouList:dispose();
		self.gouList:clear();
		self.gouList = nil;
	end
	if self.modelShowPanel ~= nil then
		self.modelShowPanel:dispose();
		self.modelShowPanel = nil;
	end
	for i = 1, #self.effectList do
		if self.effectList[i] ~= nil then
			self.effectList[i]:dispose();
			self.effectList[i] = nil;
		end
	end
	self:endTimer();

	self:superCall("dispose");
end