-- 循环充值
checkRequire("Lua_CyclicRechargeRewardItem")
Lua_CyclicRechargePanel = class("Lua_CyclicRechargePanel", Lua_DisplayObject)
function Lua_CyclicRechargePanel:ctor(p)
	self:superCall("ctor", p, "CyclicRechargePanel_skin");
end

function Lua_CyclicRechargePanel:buildShowItem()
	self:superCall("buildShowItem");

	if DataCenter.OperationalActivitiesData:getActivitiesByType(1057, nil) == nil then
		OperateAlert.show(LanUtil.getValue(122586));
		return;
	end

	self.desLab.text = LanUtil.getValue(141502);
	self.redDot:setEnable(false);

	self.dragWidth = 520;
	self.rewardList = Lua_DragList.new(self.content, 2, Vector4(0, 0, self.dragWidth, 70));
	self.rewardList:setListCell(Lua_CyclicRechargeRewardItem, 70, 84, 1000);
	self.rewardList:setLocation(124, -70, 0);

	self.drawBtn:addClickFuntion(self, self.onRewardClick);

	self:addLuaEvent("UPDARE_CYCLIC_RECHERGE_INFO", self, self.updataCyclicRechargeInfo);
	Lua_ProxyManager.getProxy("Lua_CyclicRechargeProxy"):sUseRechargeInfo();
end

function Lua_CyclicRechargePanel:updataCyclicRechargeInfo()
	local cyclicRechargeData = DataCenter.cyclicRechargeData;
	self.end_tick = cyclicRechargeData.end_tick;
	self.actTimeLab.text = LanUtil.formateStr(LanUtil.getValue(141500),
		tostring(os.date("%Y-%m-%d %H:%M", cyclicRechargeData.start_tick)),
		tostring(os.date("%Y-%m-%d %H:%M", self.end_tick)));

	self:startTimer();
	self:updateActTime();

	self.desTxt.text = cyclicRechargeData.des;
	
	local gold = cyclicRechargeData.gold;
	self.conditionTxt.text = LanUtil.formateStr(LanUtil.getValue(141505), tostring(gold));

	local len = cyclicRechargeData.rewardList:getSize();
	local posX = len * 84 > self.dragWidth and 124 or 124 + (self.dragWidth - len * 84) / 2;
	self.rewardList:setLuaArrayData(cyclicRechargeData.rewardList);
	self.rewardList:setLocation(posX, -70, 0);

	local totalGold = cyclicRechargeData.total_gold;
	self.num = math.floor(totalGold / gold);
	self.canDrawCountLab.text = LanUtil.formateStr(LanUtil.getValue(141504), tostring(self.num));
	if self.num > 0 then
		self.drawBtn.label = LanUtil.getValue(122527);
		self.redDot:setEnable(true);
	else
		self.drawBtn.label = LanUtil.getValue(122543);
		self.redDot:setEnable(false);
	end

	local curValue;
	if totalGold < gold then
		self.completeBar:setText("["..Lua_ColorDefine.RED_STR.."]"..totalGold.."[-]/"..gold);
		curValue = totalGold;
	else
		self.completeBar:setText("["..Lua_ColorDefine.WHITE_STR.."]"..totalGold.."/"..gold);
		curValue = gold;
	end
	self.completeBar:setMaxValue(gold);
	self.completeBar:setValue(curValue);
end

function Lua_CyclicRechargePanel:startTimer()
	if self.countDown ~= true then
		self.countDown = true;
		Lua_CommonUtil.addTimer("Lua_CyclicRechargePanel", 1, self, self.updateActTime);
	end
end

function Lua_CyclicRechargePanel:updateActTime()
	local leftTime = self.end_tick - tonumber(tostring(GlobalVar.cur_tick));
	self.leftTimeLab.text = LanUtil.formateStr(LanUtil.getValue(141501), TimeTransform.getInstance():transSeconds1(leftTime, true));
	if leftTime <= 0 then
		self:endTimer();
	end
end

function Lua_CyclicRechargePanel:endTimer()
	if self.countDown == true then
		self.countDown = false;
		Lua_CommonUtil.removeTimer(self, self.updateActTime);
	end
end

function Lua_CyclicRechargePanel:onRewardClick()
	if self.num > 0 then
		Lua_ProxyManager.getProxy("Lua_CyclicRechargeProxy"):sGetRechargeAwardeInfo();
	else
		Lua_WindowUtil.openWin("Lua_ChongzhiWindow", WinParam.ACTION_OPEN, 1);
	end
end

function Lua_CyclicRechargePanel:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self:endTimer();

	self:superCall("dispose");
end