Lua_CyclicRechargeRewardItem = class("Lua_CyclicRechargeRewardItem", Lua_ListCell);
function Lua_CyclicRechargeRewardItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_CyclicRechargeRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImage = Lua_ToolImage.new(self.content);
	self.itemImage:setScale(0.8, 0.8);
	self.itemImage:setCanClick(false);
end

function Lua_CyclicRechargeRewardItem:setData(data)
	self.itemImage.data = data;
end

function Lua_CyclicRechargeRewardItem:checkOutBound(showRect)
	if self.itemImage.data == nil then
		return;
	end
	
	local width = self.itemImage.item_bg.width;
	local height = self.itemImage.item_bg.height;
	local rect = Lua_Rectangle.new(self.itemX - width / 2, self.itemY - height / 2, width, height);
	self.inViewEffect = showRect:containeRect(rect);
	self.itemImage:showRoundEff(showRect:containeRect(rect) and self.itemImage.data.show_effect == 1);
end

function Lua_CyclicRechargeRewardItem:onPlayerSoundClick(go)
	if self.itemImage._data ~= nil then
		Lua_PackUtil.showItemInfo(self.itemImage._data, false);
	elseif self.itemImage.setOutputId ~= nil then
		Lua_WindowUtil.openWin("Lua_OutputWindow", nil, self.itemImage.setOutputId);
	end
end

function Lua_CyclicRechargeRewardItem:dispose()
	if self.itemImage ~= nil then
		self.itemImage:dispose();
		self.itemImage = nil;
	end
	
	self:superCall("dispose");
end