Lua_DailyRebateEverydayRewardItem = class("Lua_DailyRebateEverydayRewardItem", Lua_ListCell);
function Lua_DailyRebateEverydayRewardItem:ctor(p)
    self:superCall("ctor", p, "DailyRebateEverydayRewardItem_skin");
    self.purchasedObj1.gameObject:SetActive(false)
    self.btnobj.gameObject:SetActive(false)
end

function Lua_DailyRebateEverydayRewardItem:buildShowItem()
    self:superCall("buildShowItem");
    self.buyBtn:addClickFuntion(self, self.onGetClick)  
    if self.itemImage1 == nil then
        self.itemImage1 = Lua_ToolImage.new(self.content);
        self.itemImage1:setLocation(-51, -27, 0)
        self.itemImage1:setDepth(10)
    end
    if self.itemImage2 == nil then
        self.itemImage2 = Lua_ToolImage.new(self.content);
        self.itemImage2:setLocation(49, -27, 0)
        self.itemImage2:setDepth(10)
    end
    if self.itemImage3 == nil then
        self.itemImage3 = Lua_ToolImage.new(self.content);
        self.itemImage3:setLocation(3, -27, 0)
        self.itemImage3:setDepth(10)
    end
    self.redDot = UICreate.createUIAtlasImage(self.btnobj,"iconantlas4","redDot",80,-249,0,0)
	self.redDot:setDepth(8);
	self.redDot.clickScale = false;
	self.redDot.name = "redDot"	
end

function Lua_DailyRebateEverydayRewardItem:setData(data)
    self.data = data;
    if self.data == nil then return end;
    local len = self.data.reward:getSize();
    if len == 1 then
        self.itemImage1:setEnable(false);
        self.itemImage2:setEnable(false);
        self.itemImage3.data = self.data.reward[1];
        self.itemImage3:setEnable(true);
    elseif len == 2 then
        self.itemImage3:setEnable(false);
        self.itemImage1.data = self.data.reward[1];
        self.itemImage2.data = self.data.reward[2];
        self.itemImage1:setEnable(true);
        self.itemImage2:setEnable(true);
    end
    self.purchasedObj2.gameObject:SetActive(self.data.rewardState==0)
    self.btnobj.gameObject:SetActive(self.data.rewardState==1)
    self.purchasedObj1.gameObject:SetActive(self.data.rewardState==2)
     self.days_txt.text = LanUtil.formateStr(LanUtil.getValue(140403), tostring(self.data.day))
end

function Lua_DailyRebateEverydayRewardItem:onGetClick()
    if self.data == nil then return end;
    DataCenter.dailyRebateData:sGetReward(self.data.day);
end

function Lua_DailyRebateEverydayRewardItem:checkOutBound(showRect)
    if self.data == nil then
        self.inViewEffect = false;
        return;
    end
    local rect1 = Lua_Rectangle.new(self.itemX - 73, self.itemY - 40, 74, 80);
    local rect2 = Lua_Rectangle.new(self.itemX + 18, self.itemY - 40, 74, 80);
    local rect3 = Lua_Rectangle.new(self.itemX -38, self.itemY - 40, 74, 80);
    if showRect:containeRect(rect1) == true then
        self.inViewEffect1 = true;
    else
        self.inViewEffect1 = false;
    end
    if showRect:containeRect(rect2) == true then
        self.inViewEffect2 = true;
    else
        self.inViewEffect2 = false;
    end
    if showRect:containeRect(rect3) == true then
        self.inViewEffect3 = true;
    else
        self.inViewEffect3 = false;
    end
    self:updateEffectState();
end


function Lua_DailyRebateEverydayRewardItem:updateEffectState()
    if self.inViewEffect1 == true and self.data.isShowEffect[1]==1 then
        if self.itemImage1.roundEff == nil then
            self.itemImage1:showRoundEff(true);
        end
    else
        if self.itemImage1.roundEff ~= nil then
            self.itemImage1:showRoundEff(false);
        end
    end
    if self.inViewEffect2 == true and self.data.isShowEffect[2]==1 then
        if self.itemImage2.roundEff == nil then
            self.itemImage2:showRoundEff(true);
        end
    else
        if self.itemImage2.roundEff ~= nil then
            self.itemImage2:showRoundEff(false);
        end
    end
    if self.inViewEffect3 == true and self.data.isShowEffect[1]==1 then
        if self.itemImage3.roundEff == nil then
            self.itemImage3:showRoundEff(true);
        end
    else
        if self.itemImage3.roundEff ~= nil then
            self.itemImage3:showRoundEff(false);
        end
    end
end

function Lua_DailyRebateEverydayRewardItem:dispose()
    self:superCall("dispose");
end