checkRequire("Lua_DailyRebateExtraRewardItem")

Lua_DailyRebateExtraRewardInfPanel = class("Lua_DailyRebateExtraRewardInfPanel", Lua_DragContainerItem);
function Lua_DailyRebateExtraRewardInfPanel:ctor(dragContainer, bar)
    self:superCall("ctor", dragContainer.sub);
    self.bar = bar;
    dragContainer:addSubContainer(self, true);
    self.dragContainer = dragContainer;
end

function Lua_DailyRebateExtraRewardInfPanel:buildShowItem()
    self:superCall("buildShowItem");
    self.itemList = Array();
end

function Lua_DailyRebateExtraRewardInfPanel:setData(data)
    self.ex_rewardList = data;
    if self.ex_rewardList == nil then return end;
    local len = self.ex_rewardList:getSize();
    self.posList = Array();
    for i = 1, len do
        if self.posList[i] == nil then
            self.posList:add( { posX = self.ex_rewardList[i].offset - 386, posY = 0 });
        end
        if self.itemList[i] == nil then
            local item = Lua_DailyRebateExtraRewardItem.new(self.content)
            item:setLocation(self.posList[i].posX, self.posList[i].posY);
            item:setData(self.ex_rewardList[i])
            self.itemList:add(item);
        else
            self.itemList[i]:setData(self.ex_rewardList[i]);
        end
    end
    self.dragContainer:updateChildPos();
    self:checkOutBound()
end

function Lua_DailyRebateExtraRewardInfPanel:getWidth()
    return self.bar.width + 24;
end

function Lua_DailyRebateExtraRewardInfPanel:getHeight()
    return self.bar.height;
end

function Lua_DailyRebateExtraRewardInfPanel:checkOutBound(showRect)
    if showRect == nil then
        showRect = Lua_Rectangle.new(self.dragContainer.vsize.x - self.dragContainer.vsize.z / 2, self.dragContainer.vsize.y - self.dragContainer.vsize.w / 2, self.dragContainer.vsize.z, self.dragContainer.vsize.w);
    end
    for i = 1, self.itemList:getSize() do
        self.itemList[i]:checkOutBound(showRect, self.posList[i])
    end
end

function Lua_DailyRebateExtraRewardInfPanel:dispose()
    self:superCall("dispose");
    if self.itemList ~= nil then
        self.itemList:dispose();
        self.itemList = nil;
    end
end
