
Lua_DailyRebateExtraRewardItem = class("Lua_DailyRebateExtraRewardItem", Lua_DisplayObject);
function Lua_DailyRebateExtraRewardItem:ctor(p)
    self:superCall("ctor", p, "DailyRebateExtraRewardItem_skin");
end

function Lua_DailyRebateExtraRewardItem:buildShowItem()
    self:superCall("buildShowItem"); 
    if self.itemImage == nil then
        self.itemImage = Lua_ToolImage.new(self.itembtm.mainContent);
        self.itemImage:setLocation(0, 0, 0)
        self.itemImage:setDepth(6)
        self.itemImage:setScale(1/0.85, 1/0.85, 1/0.85)
    end

end

function Lua_DailyRebateExtraRewardItem:setData(data)
    self.data = data;
    if self.data == nil then return end;
    self.itemImage.data = self.data.reward;
    self.days_txt.text = LanUtil.formateStr(LanUtil.getValue(140402), tostring(self.data.day))
    self.purchasedBg:setEnable(self.data.curdays >= self.data.day);
    self.purchasedLab:setEnable(self.data.curdays >= self.data.day);
end

function Lua_DailyRebateExtraRewardItem:checkOutBound(showRect, pos)
    if self.data == nil then
        self.inViewEffect = false;
        return;
    end

    local rect = Lua_Rectangle.new(pos.posX - 37, pos.posY - 10, 74, 20);
    if showRect:containeRect(rect) == true then
        self.inViewEffect = true;
    else
        self.inViewEffect = false;
    end

    self:updateEffectState();
end

function Lua_DailyRebateExtraRewardItem:updateEffectState()
    if self.inViewEffect == true and self.data.isShowEffect==1 then
        if self.itemImage.roundEff == nil then
            self.itemImage:showRoundEff(true);
        end
        self.itemImage.roundEff:SetRenderQueue(self.itembtm, 2, 2, false);
    else
        if self.itemImage.roundEff ~= nil then
            self.itemImage:showRoundEff(false);
        end
    end    
end

function Lua_DailyRebateExtraRewardItem:dispose()
    self:superCall("dispose");
end