checkRequire("Lua_DailyRebateEverydayRewardItem")
checkRequire("Lua_DailyRebateExtraRewardItem")
checkRequire("Lua_DailyRebateExtraRewardInfPanel");
Lua_DailyRebateWindow = class("Lua_DailyRebateWindow", Lua_FullSizeWindow);
function Lua_DailyRebateWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_DailyRebateWindow";
	self.skinName = "DailyRebateWindow_skin";
	self.bgPath = "/images/dailyRebate/ui_ttfl_bg_01.png";
end

function Lua_DailyRebateWindow:buildShowItem()
	self:superCall("buildShowItem");

	self:setShowTitle("titleName_altas_1", "ttfl");

	self.fightNum = Lua_NumberImage.new(self.force.mainContent);
	self.fightNum.prefix = "a_";
	self.fightNum.numWidth = 19;
	self.fightNum:setDepth(10);
	self.fightNum:setLocation(42.5, -1.5, 0);

	self.cldayNum = Lua_NumberImage.new(self.recharge_days.mainContent);
	self.cldayNum.pivot = 2;
	self.cldayNum.prefix = "e_";
	self.cldayNum.numWidth = 24;
	self.cldayNum:setDepth(10);
	self.cldayNum:setLocation(15, -1, 0);

	self.extraReward_dragContainer = Lua_DragContainer.new(self.content, 2, Vector4(5, -14, 710, 128));
	self.extraReward_dragContainer:setLocation(232, 131, 0);
	self.extraRewardInfPanel = Lua_DailyRebateExtraRewardInfPanel.new(self.extraReward_dragContainer, self.Bar);

	self.everydayReward_DragList = Lua_DragList.new(self.content, 2, Vector4(239, -154, 724, 370));
	self.everydayReward_DragList:setListCell(Lua_DailyRebateEverydayRewardItem, 370, 245, 100);
	self.everydayReward_DragList:setLocation(0, 0, 0);

	self.Bar:setEnable(false);
	self.Bar:setParent(self.extraReward_dragContainer.sub.transform);
	self.des.text = LanUtil.getValue(140401);

	self:addLuaEvent("UPDATA_DAILY_REBATE", self, self.updataInfo);
	DataCenter.dailyRebateData.sDailyRebateInfo();
end

function Lua_DailyRebateWindow:updataInfo()
	self:getData();

	self.rewardName.text = self.bestRewardName;
	local len = self.ex_rewardList:getSize();
	self.maxDay = self.ex_rewardList[len].day;
	for i = 1, len do
	    -- self.ex_rewardList[i].offset =(self.ex_rewardList[i].day / self.maxDay) * 140 * len;
	    -- 改成等比
	    self.ex_rewardList[i].offset = i * 140;
	end
	self.Bar:SetDimensions(len * 140, 23);
	self.Bar:setLocation(-271 +(len - 1) * 70, 0, 0);
	self.Bar:setMaxValue(self.maxDay);
	local curDay = self.days
	if self.days >= self.maxDay then
		curDay = self.maxDay
	end
	self.Bar:setValue(curDay);
	self.Bar:setEnable(true);

	self.extraRewardInfPanel:setData(self.ex_rewardList)
	self.everydayReward_DragList:setLuaArrayData(self.dailyRewardList);
	local index;
	for i = 1, self.dailyRewardList:getSize() do
		if self.dailyRewardList[i].rewardState ~= 2 then
			index = i;
			break;
		end
	end

	if index~=nil and index > self.dailyRewardList:getSize() -2 then
		index = self.dailyRewardList:getSize() -2
	end

	if index ~= nil then
		self.everydayReward_DragList:updateSubPos(-231 *(index - 1), 0, 0);
	end
	self.cldayNum.num = self.maxDay;
	self.modelId = self.ex_rewardList[len].reward.id;

	self:creatModel();

	self.fightNum.num = Lua_CommonUtil.getCommonConfig("daily_force", 1);
	self.fightNum:setNumScale(0.8,0.8)
	self.recharge_days_text.text = LanUtil.formateStr(LanUtil.getValue(140400),tostring(self.days));
end

function Lua_DailyRebateWindow:getData()
	self.days = DataCenter.dailyRebateData.days
	self.ex_rewardList = DataCenter.dailyRebateData.ex_rewardList
	self.dailyRewardList = DataCenter.dailyRebateData.dailyRewardList
	self.bestRewardName = DataCenter.dailyRebateData.bestRewardName;
end

function Lua_DailyRebateWindow:creatModel()
	local config = getConfig({"item", self.modelId});
	local shapeConfig = getConfig({"playerHanger", tonumber(config.tipShowModel) });
	self.floder = shapeConfig.floder;
	self.modelFile = shapeConfig.fileName;
	self.model = shapeConfig.modelName;
	if self.modelEffect == nil then
		self.modelEffect = UICreate.createUIEffect(self.content, nil, nil, 0, 0);
		self.modelEffect:setRotEnable(true, -247, -89, 300, 400, 1);
		self.modelEffect:setRot(0, 177, 0)
		self.modelEffect:setSacle(110, 110, 110);
		self.modelEffect:setLocation(-363, -192, 0)
		self.modelEffect:SetRenderQueue(self.rewardName, 6, 2, false)
		self.modelEffect:setUrl(shapeConfig.floder .. "/" .. shapeConfig.fileName, tostring(shapeConfig.modelName));
	end
end

function Lua_DailyRebateWindow:showWin(param)
	self:superCall("showWin", param);
end

function Lua_DailyRebateWindow:dispose()
	if self.modelEffect ~= nil then
		self.modelEffect:dispose();
		self.modelEffect = nil;
	end
	if self.everydayReward_DragList ~= nil then
		self.everydayReward_DragList:dispose();
		self.everydayReward_DragList = nil;
	end
	if self.extraReward_dragContainer ~= nil then
		self.extraReward_dragContainer:dispose();
		self.extraReward_dragContainer = nil;
	end
	self:superCall("dispose");
end