-- 折扣商店1075
Lua_DiscountStorePanel = class("Lua_DiscountStorePanel", Lua_DisplayObject)
function Lua_DiscountStorePanel:ctor(p)
	self:superCall("ctor", p, "DiscountStorePanel_skin");
end

function Lua_DiscountStorePanel:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.content,1, Vector4(0, 0, 987, 286));
	self.rewardList:setListCell(Lua_DiscountStoreItem, 126, 329, 3);
	self.rewardList:setLocation(0, -104, 0);

	self:addLuaEvent("SET_DISCOUNTSTORE_INFO", self, self.updatePanelInfo);
	self:addLuaEvent("UPDATE_INVEN_DATA", self, self.updateInvenInfo);
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sGetActivityInfo(Lua_OperationalActivitiesData.DISCOUNTSTORE);
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sWindowIsOpen(Lua_OperationalActivitiesData.DISCOUNTSTORE, 1);
end

function Lua_DiscountStorePanel:updatePanelInfo(data)
	if data == nil then
		return;
	end

	local startTick = tonumber(tostring(data.activity_info.start_tick)); -- 活动开始时间
	local endTick = tonumber(tostring(data.activity_info.end_tick)); -- 活动结束时间
	local atimeStr1 = os.date(LanUtil.getValue(144922) .. " %H:%M", startTick);
	local atimeStr2 = os.date(LanUtil.getValue(144922) .. " %H:%M", endTick);
	self.open_time.text = LanUtil.formateStr(LanUtil.getValue(144907), tostring(atimeStr1 .. "--" .. atimeStr2));

	local content = data.activity_info.content;
	self.show_tips.text = LanUtil.formateStr(LanUtil.getValue(144908), tostring(content))

	if data.reset_limit == 1 then
		local ot = tonumber(tostring(GlobalVar.cur_tick)) % 86400;
		self.endTime = 57600 - ot + getTime();
		self.end_time:setEnable(true);
		self:startTimer();
		self:updateLeftTime();
	else
		self.end_time:setEnable(false);
		self:endTimer();
	end

	local arr = Array();
	for i = 1, #data.items do
		arr:add(data.items[i])
	end
	self.rewardList:setLuaArrayData(arr, false);
end

function Lua_DiscountStorePanel:startTimer()
	if self.countDown ~= true then
		self.countDown = true;
		Lua_CommonUtil.addTimer("Lua_DiscountStorePanel", 1, self, self.updateLeftTime);
	end
end

function Lua_DiscountStorePanel:updateLeftTime()
	local time = math.ceil(self.endTime - getTime());
	if time > 0 then
		self.end_time.text = LanUtil.formateStr(LanUtil.getValue(144901), TimeTransform.getInstance():transSeconds1(time, true));
	else
		self:endTimer();
		Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sGetActivityInfo(Lua_OperationalActivitiesData.DISCOUNTSTORE);
	end
end

function Lua_DiscountStorePanel:endTimer()
	if self.countDown == true then
		self.countDown = false;
		Lua_CommonUtil.removeTimer(self, self.updateLeftTime);
	end
end

function Lua_DiscountStorePanel:updateInvenInfo(data)
	if self.rewardList ~= nil then
		-- id索引 value库存 sub已够买数额 sub2限购数额 tick 0不限购,1个人限购,2全服限购
		local itemInfo = data.info[1];
		local arr = self.rewardList.showList;
		local isShow = false;
		for i = 1, arr:getSize() do
			if arr[i]._data.index == tonumber(itemInfo.id) then
				arr[i]:updateInven(itemInfo.value, itemInfo.sub);
				isShow = true;
			end
		end

		arr = self.rewardList.data;
		if isShow == false then
			arr[tonumber(itemInfo.id) + 1].info.value = itemInfo.value;
			arr[tonumber(itemInfo.id) + 1].info.sub = itemInfo.sub;
		end
	end
end

function Lua_DiscountStorePanel:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose()
		self.rewardList = nil;
	end
	self:endTimer();
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sWindowIsOpen(Lua_OperationalActivitiesData.DISCOUNTSTORE, 0);

	self:superCall("dispose");
end










Lua_DiscountStoreItem = class("Lua_DiscountStoreItem", Lua_ListCell);
function Lua_DiscountStoreItem:ctor(p)
	self:superCall("ctor", p, "DiscountStoreItem_skin");
end

function Lua_DiscountStoreItem:buildShowItem()
	self:superCall("buildShowItem");

	self.toolItem = Lua_ToolImage.new(self.content);
	self.toolItem:setDepth(1);
	self.toolItem:setLocation(-108, 11, 0);
end

function Lua_DiscountStoreItem:setData(data)
	self._data = data;

	local tvo = Lua_ToolVo.createToolVo(data.item.id, data.item.amount, data.item.bind);
	tvo.roundEff = data.item.show_effect == 1;
	if data.item.equipment ~= nil and data.item.equipment.star ~= nil then
		tvo.star = data.item.equipment.star;
	end
	self.toolItem.data = tvo;
	self.toolName.text = tvo.colorName;

	self.costPrice.text = LanUtil.formateStr(LanUtil.getValue(144909), tostring(data.orig_price));
	self.curPrice.text = LanUtil.formateStr(LanUtil.getValue(144910), tostring(data.disc_price));
	self.disNum.text = data.disc_flag .. "折";

	local posX = self.curPrice.mainContent.transform.localPosition.x + self.curPrice.width + 10;
	self.moneySprite:setAltas("icon_atlas_3", "money_"..data.cost_type);
	self.moneySprite:setLocation(posX, -13);

	self:updateInven(data.info.value, data.info.sub);
end

-- val库存 val2已够买数额
function Lua_DiscountStoreItem:updateInven(val, val2)
	self._data.info.value = val;
	self._data.info.sub = val2;
	if val <= 0 then
		self.invenNum.text = LanUtil.formateStr(LanUtil.getValue(144914), "[FF1616]0[-]");
		self.sellIcon:setEnable(true);
		self.zheZhao:setEnable(true);
	else
		self.invenNum.text = LanUtil.formateStr(LanUtil.getValue(144914), "[00E125]" .. val .. "[-]");
		self.sellIcon:setEnable(false);
		self.zheZhao:setEnable(false);
	end

	local canBuyNum = self._data.info.sub2 - val2;
	local buyNumStr = canBuyNum <= 0 and "[FF1616]0" or "[00E125]"..canBuyNum;
	local buyType = tonumber(tostring(self._data.info.tick));
	local desStr;
	if buyType == 1 then
		desStr = LanUtil.getValue(144911);
	elseif buyType == 2 then
		desStr = LanUtil.getValue(144912);
	elseif buyType == 0 then
		desStr = LanUtil.getValue(144923);
	end
	self.purchNum.text = LanUtil.formateStr(desStr, buyNumStr.."/"..self._data.info.sub2);
	-- print(buyType, val2, self._data.info.sub2);
end

function Lua_DiscountStoreItem:onPlayerSoundClick()
	local invenNum = self._data.info.value; -- 库存
	local haveBuyNum = self._data.info.sub; -- 已购买数额
	local purchNum = self._data.info.sub2; -- 限购数额
	local buyType = tonumber(tostring(self._data.info.tick)); -- 0不限购,1个人限购,2全服限购
	if invenNum <= 0 then
		OperateAlert.show(LanUtil.getValue(144915));
		return;
	else
		if buyType ~= 0 and haveBuyNum >= purchNum then
			OperateAlert.show(LanUtil.getValue(144916));
			return;
		end
	end

	local count;
	if buyType == 0 then
		count = invenNum;
	else
		local canBuyNum = purchNum - haveBuyNum;
		count = invenNum < canBuyNum and invenNum or canBuyNum;
	end
	Lua_WindowUtil.openWin("Lua_LimitBuyWindow", WinParam.ACTION_OPEN, {
		first_type = Lua_OperationalActivitiesData.DISCOUNTSTORE,
		index = self._data.index,
		itemVo = self.toolItem.data,
		moneyType = self._data.cost_type,
		curPrice = self._data.disc_price,
		count = count
	});
end

function Lua_DiscountStoreItem:checkOutBound(showRect)
	local width = self.toolItem.item_bg.width;
	local height = self.toolItem.item_bg.height;
	local rect = Lua_Rectangle.new(self.itemX - 108 - width / 2, self.itemY + 11 - height / 2, width, height);
	if self.toolItem.data.subType == Lua_PackTypeDefine.STAMP_ITEM then
		self.toolItem:showStampEff(showRect:containeRect(rect) and self.toolItem.data.roundEff);
	else
		self.toolItem:showRoundEff(showRect:containeRect(rect) and self.toolItem.data.roundEff);
	end
end

function Lua_DiscountStoreItem:dispose()
	self:superCall("dispose");
end