checkRequire("Lua_ExquisitePagodaRecordItem");
Lua_ExquisitePagodaRecordPanel = class("Lua_ExquisitePagodaRecordPanel", Lua_DisplayObject);
function Lua_ExquisitePagodaRecordPanel:ctor(p)
	self:superCall("ctor", p, "ExquisitePagodaRecordPanel_skin");
end

function Lua_ExquisitePagodaRecordPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.dragContainer = Lua_DragContainer.new(self.content, 1, Vector4(100, -119, 200, 238));
	self.dragContainer:setLocation(264, 87, 0);

	self.allRecordBtn:addClickFuntion(self, self.onAllRecordClick);
	self.personalRecordBtn:addClickFuntion(self, self.onPersonalRecordClick);
end

function Lua_ExquisitePagodaRecordPanel:onPersonalRecordClick()
	self.allRecordBtn:setStyle(61);
	self.personalRecordBtn:setStyle(62);

	self.dragContainer:moveToChildIndex(1, true);
	self.dragContainer:removeAllChildren();	

	local tvo;
	local str;
	local item;
	if DataCenter.exquisitePagodaData.per_record ~= nil then
		for k,v in ipairs(DataCenter.exquisitePagodaData.per_record) do
			tvo = Lua_ToolVo.createToolVo(tonumber(v.proto_item.id)); 
			tvo:fromServer(v.proto_item);
			
			str = "[url=showItem_"..v.proto_item.id.."]["..tvo.colorStr.."]"..tvo.name.."*"..v.proto_item.amount.."[-][/url]";
			item = Lua_ExquisitePagodaRecordItem.new(self.dragContainer.sub);
			item:setData(tvo);
			item:setText(LanUtil.formateStr(LanUtil.getValue(141106), str));

			self.dragContainer:addSubContainer(item, false);
		end	
		self.dragContainer:updateChildPos();	
	end	
end

function Lua_ExquisitePagodaRecordPanel:onAllRecordClick()
	self.allRecordBtn:setStyle(62);
	self.personalRecordBtn:setStyle(61);

	self.dragContainer:moveToChildIndex(1, true);
	self.dragContainer:removeAllChildren();

	local tvo;
	local str;
	local nameStr;
	local item;
	if DataCenter.exquisitePagodaData.whole_record ~= nil then
		for k,v in ipairs(DataCenter.exquisitePagodaData.whole_record) do
			tvo = Lua_ToolVo.createToolVo(tonumber(v.proto_item.id)); 
			tvo:fromServer(v.proto_item);

			str = "[url=showItem_"..v.proto_item.id.."]["..tvo.colorStr.."]"..tvo.name.."*"..v.proto_item.amount.."[-][/url]";
			nameStr = "[url=playerClick_"..v.role_id.."]"..v.role_name.."[/url]";
			item = Lua_ExquisitePagodaRecordItem.new(self.dragContainer.sub);
			item:setData(tvo);
			item:setText(LanUtil.formateStr(LanUtil.getValue(141107), nameStr, str));

			self.dragContainer:addSubContainer(item, false);
		end	
		self.dragContainer:updateChildPos();	
	end	
end

function Lua_ExquisitePagodaRecordPanel:dispose()
	if self.dragContainer ~= nil then
		self.dragContainer:dispose();
		self.dragContainer = nil;
	end
	
	self:superCall("dispose");
end