-- 玲珑宝塔结算界面
checkRequire("Lua_TreasureResultWindow");
Lua_ExquisitePagodaResultWindow = class("Lua_ExquisitePagodaResultWindow", Lua_TreasureResultWindow);
function Lua_ExquisitePagodaResultWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ExquisitePagodaResultWindow";
	self.bShowRuneChips = false;
end

function Lua_ExquisitePagodaResultWindow:buildPanel(go)
	self:superCall("buildPanel", go);

	self:addLuaEvent("rEXQUISITE_PAGODA_DRAW", self, self.onExquisitePagodaDraw);
end

function Lua_ExquisitePagodaResultWindow:onExquisitePagodaDraw(msg)
	self.drawType = msg.draw_type;
	if msg.draw_type == 0 or msg.draw_type == 1 then
		self.againBtn.label = LanUtil.getValue(121409);
	elseif msg.draw_type == 2 then
		self.againBtn.label = LanUtil.getValue(121433);
	elseif msg.draw_type == 3 then
		self.againBtn.label = LanUtil.getValue(121434);
	end

	local list = msg.reward; -- 获得的道具列表
	if msg.reward ~= nil then
		if self.drawType == 3 then
			local arr = Array();
			for i = 1, #msg.reward do 
				arr:add(msg.reward[i]);
			end

			if self.dragList == nil then
				self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 800, 280));
				self.dragList:setLocation(0, -5, 0);
				self.dragList:setListCell(Lua_ExquisitePagodaResultItem, 145, 160, 5);
			end
			self.dragList:setLuaArrayData(arr, false);
		else
			local tvo;
			local arr = Array();
			for i = 1, #msg.reward do 
				tvo = Lua_ToolVo.createToolVo(msg.reward[i].id);
				tvo:fromServer(msg.reward[i]);
				tvo.packType = Lua_PackTypeDefine.EQUIP;
				tvo.bShowQualityEff = true;
				arr:add(tvo);
			end
			self:setShowResultData(arr);
		end
	end
end

function Lua_ExquisitePagodaResultWindow:onAgainBtnClick(go)
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.3 then
		OperateAlert.show(LanUtil.getValue(121419));
		return;
	end
	self.clickTime = getTime();

	if self.drawType == nil then
		return;
	end

	local drawInfo = DataCenter.exquisitePagodaData.getDrawInfo;
	self.drawCount = 0;
	self.drawMoney = 0;
	if self.drawType == 0 or self.drawType == 1 then
		self.drawCount = drawInfo[1].drawCount;
		self.drawMoney = drawInfo[1].drawMoney;
	else
		self.drawCount = drawInfo[self.drawType].drawCount;
		self.drawMoney = drawInfo[self.drawType].drawMoney;
	end

	local str;
	if DataCenter.moneyData:getMoney(DataCenter.exquisitePagodaData.money_type) < self.drawMoney then
		str = "[" .. Lua_ColorDefine.RED_STR .. "]".. self.drawMoney .. "[-]";
		self.enoughGold = false;
	else
		str = "[" .. Lua_ColorDefine.GREEN_STR .. "]" .. self.drawMoney .. "[-]";
		self.enoughGold = true;
	end

	if DataCenter.neverTip:getNeverValue("Lua_ExquisitePagodaWindow") then
		if self.enoughGold == false then
			DataCenter.moneyData:isMoneyEnough(DataCenter.exquisitePagodaData.money_type, self.drawMoney, true, true);
		else
			Lua_ProxyManager.getProxy("Lua_ExquisitePagodaProxy"):sExquisitePagodaDraw(self.drawType, DataCenter.exquisitePagodaData.isPass);
		end
		return;
	end

	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {
		owner = self,
		neverTip = "Lua_ExquisitePagodaWindow",
		des = LanUtil.formateStr(LanUtil.getValue(141110), str, tostring(self.drawCount)),
		type = 1,
		subFun = self.onSureFun
	});
end

function Lua_ExquisitePagodaResultWindow:onSureFun()
	if self.enoughGold == false then
		DataCenter.moneyData:isMoneyEnough(DataCenter.exquisitePagodaData.money_type, self.drawMoney, true, true);
	else
		Lua_ProxyManager.getProxy("Lua_ExquisitePagodaProxy"):sExquisitePagodaDraw(self.drawType, DataCenter.exquisitePagodaData.isPass);
	end
end

function Lua_ExquisitePagodaResultWindow:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose()
		self.dragList = nil;
	end
	self.drawType = nil; 

	self:superCall("dispose");
end





--------------------------------------------------





Lua_ExquisitePagodaResultItem = class("Lua_ExquisitePagodaResultItem", Lua_ListCell);
function Lua_ExquisitePagodaResultItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_ExquisitePagodaResultItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImage = Lua_ToolImage.new(self.content);
	self.itemImage:setLocation(0, 25, 0)
	self.itemImage:setDepth(5);

	self.itemName = UICreate.createLabel(self.content, "", 0, -40, 360, 30, 24);
	self.itemName.pivot = UIWidget.Pivot.Center;
	self.itemName:setDepth(5);
end

function Lua_ExquisitePagodaResultItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local tvo = Lua_ToolVo.createToolVo(data.id);
	tvo:fromServer(data);
	tvo.packType = Lua_PackTypeDefine.EQUIP;
	self.itemImage.data = tvo;
	self.itemName.text = tvo.colorName;
end

function Lua_ExquisitePagodaResultItem:checkOutBound(showRect)
	if self._data == nil then
		return;
	end

	local rect = Lua_Rectangle.new(self.itemX - 50, self.itemY - 10, 100, 60);
	self.itemImage:showQualityEff(showRect:containeRect(rect));
end

function Lua_ExquisitePagodaResultItem:dispose()
	if self.itemImage ~= nil then
		self.itemImage:dispose();
		self.itemImage = nil;
	end
	if self.itemName ~= nil then
		self.itemName:dispose();
		self.itemName = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end