Lua_ExquisitePagodaRewardItem = class("Lua_ExquisitePagodaRewardItem", Lua_ListCell);
function Lua_ExquisitePagodaRewardItem:ctor(p)
	self:superCall("ctor", p, "ExquisitePagodaRewardItem_skin");
end

function Lua_ExquisitePagodaRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.redDot:setEnable(false);

	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setDepth(5);
	self.itemImg:setCanClick(true);
	self.itemImg:setScale(0.7, 0.7);
	self.itemImg:setLocation(-59, 0, 0);

	self.getBtn:setBtnEnable(false);
	self.getBtn:setEnable(false);
	self.getBtn:addClickFuntion(self, self.onGetBtnClick);
end

function Lua_ExquisitePagodaRewardItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.itemImg.data = data.vo;
	if data.show_effect == 1 then
		self.itemImg:showRoundEff(true);
	end

	self.nameTxt.text = data.title;

	-- 0：不可领取，1：可领取，2已领取
	if data.state == 0 then
		self.getBtn:setEnable(false);
		self.needTxt.text = LanUtil.formateStr(LanUtil.getValue(141108), tostring(DataCenter.exquisitePagodaData.cur_count), tostring(data.count));
	elseif data.state == 1 then
		self.getBtn.label = LanUtil.getValue(140714);
	elseif data.state == 2 then
		self.getBtn.label = LanUtil.getValue(140715);
	end

	self.getBtn:setEnable(data.state ~= 0);
	self.getBtn:setBtnEnable(data.state == 1);
	self.needTxt:setEnable(data.state == 0);
	self.redDot:setEnable(data.state == 1);
end

function Lua_ExquisitePagodaRewardItem:checkOutBound(showRect)
	if self._data ~= nil then
		local rect = Lua_Rectangle.new(self.itemX, self.itemY - 25, 25, 50);
		self.itemImg:showRoundEff(showRect:containeRect(rect));
	end
end

function Lua_ExquisitePagodaRewardItem:onGetBtnClick()
	Lua_ProxyManager.getProxy("Lua_ExquisitePagodaProxy"):sGetRewards(self._data.index, DataCenter.exquisitePagodaData.firstType);
end

function Lua_ExquisitePagodaRewardItem:dispose()
	if self.itemImg ~= nil then
		self.itemImg:dispose();
		self.itemImg = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end