-- 玲珑宝塔
checkRequire("Lua_ExquisitePagodaRewardItem");
checkRequire("Lua_ExquisitePagodaRecordPanel");
checkRequire("Lua_ExquisitePagodaPanel");
checkRequire("Lua_ItemShowModelPanel");
Lua_ExquisitePagodaWindow = class("Lua_ExquisitePagodaWindow", Lua_Window);
function Lua_ExquisitePagodaWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ExquisitePagodaWindow";
	self.skinName = "ExquisitePagodaWindow_skin";
end

function Lua_ExquisitePagodaWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.oneCostLab.text = LanUtil.getValue(141102);
	self.tenCostLab.text = LanUtil.getValue(141102);
	self.fiftyCostLab.text = LanUtil.getValue(141102);
	self.myMoneyLab.text = LanUtil.getValue(141103);

	self.freeRedDot:setEnable(false);
	self.packRedDot:setEnable(false);
	self.modelObj:SetActive(false);
	self.checkBox.seleted = DataCenter.exquisitePagodaData.isPass ~= 0;

	self.giftsList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 216, 440));
	self.giftsList:setLocation(-393, -23, 0);
	self.giftsList:setListCell(Lua_ExquisitePagodaRewardItem, 86, 216, 1);

	self.fightNum = Lua_NumberImage.new(self.content);
	self.fightNum.prefix = "a_";
	self.fightNum.numWidth = 12;
	self.fightNum:setDepth(5);
	self.fightNum:setLocation(-195, 49, 0);
	self.fightNum:setEnable(false);

	self.pagodaRecordPanel = Lua_ExquisitePagodaRecordPanel.new(self.content, 0, 0, 0, 0);

	self.helpBtn:addClickFuntion(self, self.onHelpBtnClick);
	self.checkBox:addBoxChange(self, self.onCheckBoxClick);
	self.oneBtn:addClickFuntion(self, self.onOneBtnClick);
	self.tenBtn:addClickFuntion(self, self.onTenBtnClick);
	self.fiftyBtn:addClickFuntion(self, self.onFiftyBtnClick);
	self.packBtn:addClickFuntion(self, self.onPackBtnClick);
	
	self:onPackRedDotUpdate(nil);
	DataCenter.redDotData:updateRedDotVoState(22054, false); -- 玲珑宝塔登录红点取消

	self:addLuaEvent("UPDATE_EXQUISITEPAGODA", self, self.updateInfo);
	self:addLuaEvent("UPDATE_REDDOT_EVENT", self, self.onPackRedDotUpdate);
	Lua_ProxyManager.getProxy("Lua_ExquisitePagodaProxy"):sOpenExquisitePagodaWin(DataCenter.exquisitePagodaData.firstType);
end

function Lua_ExquisitePagodaWindow:updateInfo()
	if self.isFirst ~= true then
		self.isFirst = true
		self.pagodaPanel = Lua_ExquisitePagodaPanel.new(self.content, 0, 0, 0, 0);
		
		if DataCenter.exquisitePagodaData.is_show_reward == 1 then
			self.modelObj:SetActive(true);
			if DataCenter.exquisitePagodaData.special_force ~= nil and DataCenter.exquisitePagodaData.special_force > 0 then
				self.fightNum.num = DataCenter.exquisitePagodaData.special_force;
				self.fightNum:setNumScale(0.5, 0.5);
				self.fightNum:setEnable(true);
			end
			
			local tvo = DataCenter.exquisitePagodaData.getSpecialRewardInfo;
			self.modelNameLab.text = tvo.name;

			local pos = DataCenter.exquisitePagodaData.getModelPos;
			local rot = DataCenter.exquisitePagodaData.getModelRot;
			local sca = DataCenter.exquisitePagodaData.getModelSca;
			self.modelPanel = Lua_ItemShowModelPanel.new(self.content, 184, 144, -151, 181, pos, rot, sca, false);
			self.modelPanel.bg:setAltas("exquisitePagoda_atlas", "ui_llbt_bg_05");
			self.modelPanel.bg:setDepth(3);
			self.modelPanel:setShowData(tvo);
		end
	end
	self.pagodaPanel:updateShow();
	self.pagodaRecordPanel:onPersonalRecordClick();

	self.giftsList:setLuaArrayData(DataCenter.exquisitePagodaData.getPartakeRewards, false);
	
	local drawInfo = DataCenter.exquisitePagodaData.getDrawInfo;
	self.oneCostTxt.text = "[B2D2E0]" .. drawInfo[1].drawMoney .. "[-]";
	self.tenCostTxt.text = "[B2D2E0]" .. drawInfo[2].drawMoney .. "[-]";
	self.fiftyCostTxt.text = "[B2D2E0]" .. drawInfo[3].drawMoney .. "[-]";
	self.myMoneyTxt.text = DataCenter.moneyData:getMoney(DataCenter.exquisitePagodaData.money_type);

	if DataCenter.exquisitePagodaData.is_free_draw == 1 then
		self:updateFreeRedDot();

		self.freeTimeTxt:setEnable(true);
		self:startFreeTimer();
		self:updateFreeTime();
	else
		self.freeTimeTxt:setEnable(false);
	end
	
	self:startResidueTimer();
	self:updateResidueTime();
end

function Lua_ExquisitePagodaWindow:startFreeTimer()
	if self.freeCountDown ~= true then
		self.freeCountDown = true;
		Lua_CommonUtil.addTimer("updateFreeTime", 1, self, self.updateFreeTime);
	end
end

-- 免费时间
function Lua_ExquisitePagodaWindow:updateFreeTime()
	local leftTime = DataCenter.exquisitePagodaData.freeDrawTime;
	self.freeTimeTxt.text = LanUtil.formateStr(LanUtil.getValue(141104), TimeTransform.getInstance():transSeconds6(leftTime, true, true));
	if leftTime <= 0 then
		self:updateFreeRedDot();

		self.freeTimeTxt.text = LanUtil.getValue(141105);
		self:endFreeTimer();
	end
end

function Lua_ExquisitePagodaWindow:endFreeTimer()
	if self.freeCountDown == true then
		self.freeCountDown = false;
		Lua_CommonUtil.removeTimer(self, self.updateFreeTime);
	end
end

function Lua_ExquisitePagodaWindow:startResidueTimer()
	if self.residueCountDown ~= true then
		self.residueCountDown = true;
		Lua_CommonUtil.addTimer("updateResidueTime", 1, self, self.updateResidueTime);
	end
end

function Lua_ExquisitePagodaWindow:updateResidueTime()
	local end_time = DataCenter.exquisitePagodaData.end_tick - DataCenter.roleData.serverTime;
	self.endTimeTxt.text = LanUtil.formateStr(LanUtil.getValue(141100), TimeTransform.getInstance():transSeconds1(end_time, true));
	if end_time <= 0 then
		self.endTimeTxt.text = LanUtil.getValue(141101);
		self:endResidueTimer();
	end
end

function Lua_ExquisitePagodaWindow:endResidueTimer()
	if self.residueCountDown == true then
		self.residueCountDown = false;
		Lua_CommonUtil.removeTimer(self, self.updateResidueTime);
	end
end

function Lua_ExquisitePagodaWindow:onCheckBoxClick()
	self.checkBox.seleted = DataCenter.exquisitePagodaData.isPass == 0;
	DataCenter.exquisitePagodaData.isPass = DataCenter.exquisitePagodaData.isPass == 0 and 1 or 0;
end

function Lua_ExquisitePagodaWindow:onHelpBtnClick()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_OPEN, DataCenter.exquisitePagodaData.content);
end

function Lua_ExquisitePagodaWindow:onOneBtnClick()
	if self:onCheckFun() then
		return;
	end
	
	if DataCenter.exquisitePagodaData.is_free_draw == 1 and DataCenter.exquisitePagodaData.freeDrawTime <= 0 then
		Lua_ProxyManager.getProxy("Lua_ExquisitePagodaProxy"):sExquisitePagodaDraw(0, DataCenter.exquisitePagodaData.isPass);
	else
		DataCenter.exquisitePagodaData.drawType = 1;
		self:onDraw();
	end
end

function Lua_ExquisitePagodaWindow:onTenBtnClick()
	if self:onCheckFun() then
		return;
	end
	DataCenter.exquisitePagodaData.drawType = 2;
	self:onDraw();
end

function Lua_ExquisitePagodaWindow:onFiftyBtnClick()
	if self:onCheckFun() then
		return;
	end
	DataCenter.exquisitePagodaData.drawType = 3;
	self:onDraw();
end

function Lua_ExquisitePagodaWindow:onCheckFun()
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.3 then
		OperateAlert.show(LanUtil.getValue(121419));
		return true;
	end
	self.clickTime = getTime();

	if DataCenter.exquisitePagodaData.isDraw == true then
		OperateAlert.show(LanUtil.getValue(141109));
		return true;
	end
	return false;
end

function Lua_ExquisitePagodaWindow:onDraw()
	local drawInfo = DataCenter.exquisitePagodaData.getDrawInfo;
	local drawType = DataCenter.exquisitePagodaData.drawType;
	self.drawMoney = drawType > 1 and drawInfo[drawType].drawMoney or drawInfo[1].drawMoney;
	if DataCenter.neverTip:getNeverValue("Lua_ExquisitePagodaWindow") == true then
		self:onSureFun();
	else
		local str;
		if DataCenter.moneyData:getMoney(money_type) < self.drawMoney then
			str = "["..Lua_ColorDefine.RED_STR.."]"..self.drawMoney.."[-]";
		else
			str = "["..Lua_ColorDefine.GREEN_STR.."]"..self.drawMoney.."[-]";
		end
		local drawCount = drawType > 1 and drawInfo[drawType].drawCount or drawInfo[1].drawCount;

		Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {
			owner = self,
			neverTip = "Lua_ExquisitePagodaWindow",
			des = LanUtil.formateStr(LanUtil.getValue(141110), str, tostring(drawCount)),
			type = 1,
			subFun = self.onSureFun
		});
	end
end

function Lua_ExquisitePagodaWindow:onSureFun()
	local money_type = DataCenter.exquisitePagodaData.money_type;
	if DataCenter.moneyData:getMoney(money_type) < self.drawMoney then
		DataCenter.moneyData:isMoneyEnough(money_type, self.drawMoney, true, true);
	else
		local drawType = DataCenter.exquisitePagodaData.drawType;
		local isPass = DataCenter.exquisitePagodaData.isPass;
		Lua_ProxyManager.getProxy("Lua_ExquisitePagodaProxy"):sExquisitePagodaDraw(drawType, isPass);
	end
end

-- 免费次数红点更新
function Lua_ExquisitePagodaWindow:updateFreeRedDot()
	self.freeRedDot:setEnable(DataCenter.exquisitePagodaData.freeDrawTime <= 0);
end

-- 临时仓库红点更新
function Lua_ExquisitePagodaWindow:onPackRedDotUpdate(obj)
	if obj == nil or obj.evenId == 11217 then
		self.packRedDot:setEnable(DataCenter.redDotData:getRedDotStateByEventId(11217));
	end
end

function Lua_ExquisitePagodaWindow:onPackBtnClick()
	Lua_WindowUtil.openWin("Lua_ExquisitePagodaPackWindow", WinParam.ACTION_OPEN);
end

function Lua_ExquisitePagodaWindow:dispose()
	if self.giftsList ~= nil then
		self.giftsList:dispose();
		self.giftsList = nil;
	end
	if self.fightNum ~= nil then
		self.fightNum:dispose();
		self.fightNum = nil;
	end
	if self.pagodaRecordPanel ~= nil then
		self.pagodaRecordPanel:dispose();
		self.pagodaRecordPanel = nil;
	end
	if self.pagodaPanel ~= nil then
		self.pagodaPanel:dispose();
		self.pagodaPanel = nil;
	end
	if self.modelPanel ~= nil then
		self.modelPanel:dispose();
		self.modelPanel = nil;
	end
	self:endFreeTimer();
	self:endResidueTimer();

	DataCenter.exquisitePagodaData.draw_index = 0;
	DataCenter.exquisitePagodaData.draw_layer = 0;
	if DataCenter.exquisitePagodaData.isDraw == true then
		Lua_ProxyManager.getProxy("Lua_ExquisitePagodaProxy"):sExquisitePagodaDrawEnd(); -- 玲珑宝塔完成抽奖
		DataCenter.exquisitePagodaData.isDraw = false;
	end

	self:superCall("dispose");
end