Lua_AwardsOverviewTipsWindow = class("Lua_AwardsOverviewTipsWindow", Lua_ThirdSizeWindow);
function Lua_AwardsOverviewTipsWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_AwardsOverviewTipsWindow";
	self.skinName = "AwardsOverviewTipsWindow_skin";
	self.w = 600;
	self.h = 475;
	self.titleBgOffsetY = -18;
	self.titleTxtOffsetY = -19;
	self.titleText = "奬勵總覽"
end

function Lua_AwardsOverviewTipsWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.btnClose:setLocation(268, 219.5);

	self.dragContainer = Lua_DragContainer.new(self.content, 1, Vector4(0, -13, 574, 398));
	self.dragContainer:setLocation(0, -3, 0);
	self.draggableInfoPanel = Lua_AwardsOverviewInfoPanel.new(self.dragContainer);
end

function Lua_AwardsOverviewTipsWindow:showWin(param)
	self.draggableInfoPanel:setData(param);
end

function Lua_AwardsOverviewTipsWindow:dispose()
	if self.dragContainer ~= nil then
		self.dragContainer:dispose();
		self.dragContainer = nil;
	end
	if self.draggableInfoPanel ~= nil then
		self.draggableInfoPanel:dispose();
		self.draggableInfoPanel = nil;
	end
	self:superCall("dispose");
end










Lua_AwardsOverviewInfoPanel = class("Lua_AwardsOverviewInfoPanel", Lua_DragContainerItem);
function Lua_AwardsOverviewInfoPanel:ctor(dragContainer)
	self:superCall("ctor", dragContainer.sub);

	self._height = 0;
	dragContainer:addSubContainer(self, true);
	self.dragContainer = dragContainer;
end

function Lua_AwardsOverviewInfoPanel:buildShowItem()
	self:superCall("buildShowItem");
	self.itemArr = Array();
end

function Lua_AwardsOverviewInfoPanel:setData(data)
	if self.itemArr:getSize() > 0 then
		for i = self.itemArr:getSize(), data:getSize(), -1 do
			self.itemArr[i]:setEnable(false);
		end
	end

	local item
	for i = 1, data:getSize() do
		item = self.itemArr[i];
		if item == nil then
			item = Lua_AwardsOverviewItem.new(self.content)
			self.itemArr:add(item);
		end
		item:setEnable(true);
		item:setData(data[i]);
		item:setLocation(0, - self._height, 0);

		self._height = self._height + item.Height;
	end
	self.dragContainer:updateChildPos();
	self.dragContainer.canDrag = self:getHeight() > 440;
end

function Lua_AwardsOverviewInfoPanel:getHeight()
	return self._height;
end










Lua_AwardsOverviewItem = class("Lua_AwardsOverviewItem", Lua_DisplayObject)
function Lua_AwardsOverviewItem:ctor(p)
    self:superCall("ctor",p);
end

function Lua_AwardsOverviewItem:buildShowItem()
	self:superCall("buildShowItem");
	
	self.titleLab = UICreate.createLabel(self.content, "", 0, 151, 100,30, 24);
	self.titleLab.pivot = UIWidget.Pivot.Center;
	self.titleLab.overflowMethod = UILabel.Overflow.ResizeFreely;
	self.titleLab:setDepth(6);

	self.titleBg = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_title_5", 0, 154, 238, 52);
	self.titleBg:setDepth(5);

	self.fengexian = UICreate.createUIAtlasImage(self.content, "common_atlas_2", "ui_common_x_06", 0, -8  , 532, 2);
	self.fengexian:setDepth(6);

	self.rItem = Lua_RewardItem.new(self.content);
	self.rItem:setDepth(6);
	self.rItem:setLayout(115, 110, 5);
	self.rItem:setMaxShow(999);
	self.rItem:setClickWin(true);
	self.rItem:setMouseEnble(true);
	self.rItem:setItemScale(0.9, 0.9);
	self.rItem:setLocation(-230, 74, 0);
end

function Lua_AwardsOverviewItem:setData(data)
	self.rewardData = data;

	self.titleLab.text = self.rewardData.title;

	self.rItem:setRewardByArray(self.rewardData.rewardList);
	for i = 1, #self.rItem.awords do
		local name = UICreate.createLabel(self.rItem.awords[i].mainContent, "", 0, -57, 100, 30, 22);
		name.pivot = UIWidget.Pivot.Center;
		name.overflowMethod = UILabel.Overflow.ResizeFreely;
		name.text = "[85A8BE]"..self.rItem.awords[i].data.name;
		name:setDepth(6);
	end
	self.fengexian:setLocation(0, 125 - self.Line * 133, 0);
end

function Lua_AwardsOverviewItem.Get:Line()
	return math.ceil(self.rewardData.rewardList:getSize() / 5);
end

function Lua_AwardsOverviewItem.Get:Height()
	return 70 + self.Line * 133;
end