Lua_FestivalCarnivalBuffItem = class("Lua_FestivalCarnivalBuffItem", Lua_ListCell);
function Lua_FestivalCarnivalBuffItem:ctor(p)
	self:superCall("ctor", p, "FestivalCarnivalBuffItem_skin");
end

function Lua_FestivalCarnivalBuffItem:buildShowItem()
	self:superCall("buildShowItem");

	self.iconEffect = UICreate.createUIEffect(self.iconImg.mainContent, nil, nil, 0, 0);
	self.iconEffect:setEnable(false);
	self.iconEffect:SetRenderQueue(self.need_value, 5, 2, false);
end

function Lua_FestivalCarnivalBuffItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local offset = data.offset;
	self.circular_frame:setLocation(23 + offset, -15, 0);
	self.need_value:setLocation(23 + offset, -61.5, 0);

	if data.isActive then
		self.need_value.text = "[00E125]" .. data.sum_progress .. "[-]";
	else
		self.need_value.text = "[FF1616]" .. data.sum_progress .. "[-]";
	end

	self.iconImg.name = data.icon_name
	self.iconImg:setAltas(data.atlas, data.icon_name);
	self.iconImg:resetSize();
	self.iconImg:setLocation(23 + offset, -9, 0);

	self.iconEffect:setUrl("/effects/scsEffects/" .. data.effect_name, data.effect_name);

	self.iconImg:setGray(not data.isActive)
	self.circular_frame:setGray(not data.isActive)
end

function Lua_FestivalCarnivalBuffItem:checkOutBound(showRect)
	if self._data == nil then
		return;
	end

	local rect = Lua_Rectangle.new(self.itemX - 39 - (self._data.offset + 23), self.itemY - 40, 78, 80);
	self.iconEffect:setEnable(showRect:containeRect(rect) and self._data.isActive and self._data.isEnd == false);
end

function Lua_FestivalCarnivalBuffItem:onPlayerSoundClick(go)
	Lua_WindowUtil.openWin("Lua_WorldRewardTipsWindow", nil, self._data);
end

function Lua_FestivalCarnivalBuffItem:dispose()
	if self.iconEffect ~= nil then
		self.iconEffect:dispose();
		self.iconEffect = nil;
	end
	self._data = nil;
	
	self:superCall("dispose");
end