-- 节日狂欢1047
checkRequire("Lua_FestivalCarnivalBuffItem");
checkRequire("Lua_FestivalCarnivalRewardItem");
Lua_FestivalCarnivalPanel = class("Lua_FestivalCarnivalPanel", Lua_DisplayObject)
function Lua_FestivalCarnivalPanel:ctor(p)
	self:superCall("ctor", p, "FestivalCarnivalPanel_skin");
end

function Lua_FestivalCarnivalPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.worldProgress.text = "";
	self.timeText.text = "";
	self.buffText.text = LanUtil.getValue(128704);
	self.rewardText.text = LanUtil.getValue(128705);
	self.Bar:setEnable(false);
	self.redDot:setEnable(false);

	local theme = DataCenter.festivalCarnivalData.theme;
	self.bg:setUrl("/images/festivalCarnival/ui_jrkh_bg_0"..theme ..".png");
	self.desIcon:setUrl("/images/festivalCarnival/ui_jrkh_z_0"..theme ..".png");

	self.eventList = DataCenter.festivalCarnivalData.eventlist;

	self.buffList = Lua_DragList.new(self.content, 2, Vector4(0, 0, 468, 120));
	self.buffList:setListCell(Lua_FestivalCarnivalBuffItem, 80, 110, 10);
	self.buffList:setLocation(-215, -12, 0);

	self.rewardList = Lua_DragList.new(self.content, 2, Vector4(0, 0, 506, 80));
	self.rewardList:setListCell(Lua_FestivalCarnivalRewardItem, 80, 72, 10);
	self.rewardList:setLocation(-237, -166, 0);

	self.helpBtn:addClickFuntion(self, self.onHelpClick);
	self.yuanBaoBtn:addClickFuntion(self, self.onYuanBaoClick);
	self.itemBtn:addClickFuntion(self, self.onItemClick);
	self.rewardIcon:addClickFuntion(self, self.onRewardClick);

	self:addLuaEvent("UPDATA_FESTIVAL_CARNIVAL_PANEL", self, self.updataPanelInfo);
	DataCenter.festivalCarnivalData:sFestivalCarnivalInfo();
end

function Lua_FestivalCarnivalPanel:updataPanelInfo()
	local festivalCarnivalData = DataCenter.festivalCarnivalData;
	local personProgress = DataCenter.festivalCarnivalData.persen_sumit;
	local worldRewardArr = festivalCarnivalData.worldList;
	self.maxProgress = worldRewardArr[worldRewardArr:getSize()].sum_progress;
	self.exchangeList = DataCenter.festivalCarnivalData.exchangeList;

	local leftTime = festivalCarnivalData.end_tick - tonumber(tostring(GlobalVar.cur_tick))
	self.timeText.text = LanUtil.formateStr(LanUtil.getValue(128703), TimeTransform.getInstance():transSeconds1(leftTime, true));
	Lua_CommonUtil.addTimer("onActivityTimeDown", 1, self, self.onActivityTimeDown);

	self.worldProgress.text = LanUtil.formateStr(LanUtil.getValue(128701), tostring(festivalCarnivalData.wolrd_submit), tostring(self.maxProgress));
	self.personProgress.text = LanUtil.formateStr(LanUtil.getValue(128706), tostring(personProgress));

	local exchangeAward = self.exchangeList[1];
	local goldNum = DataCenter.moneyData:getMoney(Lua_MoneyData.GOLD);
	local needNum = exchangeAward.money;
	if goldNum >= needNum then
		self.yuanbaoNum.text = "[00E125]" .. needNum .. "[-]";
	else
		self.yuanbaoNum.text = "[FF1616]" .. needNum .. "[-]";
	end

	self.item:setAltas(exchangeAward.item.atlas, exchangeAward.item.referenceId);

	local itemNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(exchangeAward.item.id);
	self.itemText.text = LanUtil.formateStr(LanUtil.getValue(128702), tostring(itemNum));

	local totalTimes = Lua_CommonUtil.getCommonConfig("exchange_times", 1);
	local need_amount = exchangeAward.need_count;
	if math.floor(itemNum / need_amount) < 1 then
		self.itemNum.text = "[FF1616]" .. totalTimes * need_amount .. "[-]";
	else
		self.itemNum.text = "[00E125]" .. totalTimes * need_amount .. "[-]";
	end

	self.redDot:setEnable(itemNum >= need_amount);

	local worldLen = worldRewardArr:getSize();
	self.curindex = 0;
	self.worldArr = Array();
	for i = 1, worldLen do
		if worldRewardArr[i].sum_progress <= festivalCarnivalData.wolrd_submit then
			worldRewardArr[i].isActive = true;
			self.curindex = i
		else
			worldRewardArr[i].isActive = false;
		end
		worldRewardArr[i].isEnd = true;
		worldRewardArr[i].offset = (worldRewardArr[i].sum_progress / self.maxProgress) *
			110 * worldLen - i * 110;
		self.worldArr:add(worldRewardArr[i]);
	end

	self.eventIndex = {};
	for i = 1, self.curindex do
		if self.eventList ~= nil then
			for j = 1, self.eventList:getSize() do
				if self.eventList[j].events == worldRewardArr[i].eventId then
					self.eventIndex[self.eventList[j].events] = i;
				end
			end
		end
	end

	if self.eventIndex ~= nil then
		for k, v in pairs(self.eventIndex) do
			self.worldArr[v].isEnd = false;
		end
	end

	local personLenRewardArr = festivalCarnivalData.persenList;
	local personLen = personLenRewardArr:getSize();
	local showRewardId = personLenRewardArr[1].rewardId;
	if personLenRewardArr[personLen].sum_progress < personProgress then
		showRewardId = personLenRewardArr[personLen].rewardId;
	else
		for i = 1, personLen do
			if personLenRewardArr[i].sum_progress >= personProgress then
				showRewardId = personLenRewardArr[i].rewardId;
				break;
			end
		end
	end
	self.buffList:setLuaArrayData(self.worldArr, false);
	self:creatBar();

	local rewardArr = festivalCarnivalData.rewardList(Array(showRewardId));
	self.rewardList:setLuaArrayData(rewardArr, false);
end

function Lua_FestivalCarnivalPanel:creatBar()
	local len = self.worldArr:getSize()
	local progress = DataCenter.festivalCarnivalData.wolrd_submit;
	if progress >= self.maxProgress then
		progress = self.maxProgress
	end

	self.Bar:setParent(self.buffList.sub.transform)
	self.Bar:SetDimensions(len * 110, 23)
	self.Bar:setLocation(-179 + (len - 1) * 55, 2, 0)
	self.Bar:setMaxValue(self.maxProgress);
	self.Bar:setValue(progress);
	self.Bar:setEnable(true)
end

function Lua_FestivalCarnivalPanel:onActivityTimeDown()
	local leftTime = DataCenter.festivalCarnivalData.end_tick - tonumber(tostring(GlobalVar.cur_tick));
	self.timeText.text = LanUtil.formateStr(LanUtil.getValue(128703), TimeTransform.getInstance():transSeconds1(leftTime, true));
	if leftTime <= 0 then
		Lua_CommonUtil.removeTimer(self, self.onActivityTimeDown);
	end
end

function Lua_FestivalCarnivalPanel:onHelpClick()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, DataCenter.festivalCarnivalData.content);
end

function Lua_FestivalCarnivalPanel:onYuanBaoClick()
	if DataCenter.neverTip:getNeverValue("Lua_FestivalCarnivalPanel") then
		self:onSubmit();
		return;
	end

	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, neverTip = "Lua_FestivalCarnivalPanel",
		des = LanUtil.formateStr(LanUtil.getValue(128710), tostring(self.exchangeList[1].money)),
		type = 1, subFun = self.onSubmit});
end

function Lua_FestivalCarnivalPanel:onSubmit()
	if self.exchangeList == nil then
		return;
	end

	local exchangeAward = self.exchangeList[1];
	local goldNum = DataCenter.moneyData:getMoney(Lua_MoneyData.GOLD);
	local needNum = exchangeAward.money
	if goldNum >= needNum then
		DataCenter.festivalCarnivalData:sFestivalCarnivalExchange({index = exchangeAward.index, times = 1, money_temp = true});
	else
		Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, des = LanUtil.getValue(122521),
			type = 1, subFun = self.openChargeWin});
	end
end

function Lua_FestivalCarnivalPanel:openChargeWin()
	Lua_WindowUtil.openWin("Lua_ChongzhiWindow", WinParam.ACTION_OPEN, 1);
end

function Lua_FestivalCarnivalPanel:onItemClick()
	local exchangeAward = self.exchangeList[1];
	local itemNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(exchangeAward.item.id);
	local need_amount = exchangeAward.need_count;
	local curTimes = math.floor(itemNum / need_amount);
	local totalTimes = Lua_CommonUtil.getCommonConfig("exchange_times", 1);
	if curTimes > totalTimes then
	    curTimes = totalTimes;
	end

	if self.exchangeList == nil then
		return;
	end

	if curTimes >= 1 then
		DataCenter.festivalCarnivalData:sFestivalCarnivalExchange({index = exchangeAward.index,
			money_temp = false, times = curTimes});
	else
		OperateAlert.show(LanUtil.getValue(128709));
	end
end

function Lua_FestivalCarnivalPanel:onRewardClick()
	Lua_WindowUtil.openWin("Lua_AwardsOverviewTipsWindow", WinParam.ACTION_AUTO, DataCenter.festivalCarnivalData.rewardShowList); 
end

function Lua_FestivalCarnivalPanel:dispose()
	if self.buffList ~= nil then
		self.buffList:dispose()
		self.buffList = nil;
	end
	if self.rewardList ~= nil then
		self.rewardList:dispose()
		self.rewardList = nil;
	end
	Lua_CommonUtil.removeTimer(self, self.onActivityTimeDown);

	self:superCall("dispose");
end