Lua_FestivalCarnivalRewardItem = class("Lua_FestivalCarnivalRewardItem", Lua_ListCell);
function Lua_FestivalCarnivalRewardItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_FestivalCarnivalRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImage = Lua_ToolImage.new(self.content);
	self.itemImage:setDepth(10);
	self.itemImage:setScale(0.75, 0.75, 0.75);
	self.itemImage:setCanClick(false);
	self.itemImage:setLocation(15, 0, 0);
end

function Lua_FestivalCarnivalRewardItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.itemImage.data = Lua_ToolVo.createToolVo(data.id);
end

function Lua_FestivalCarnivalRewardItem:checkOutBound(showRect)
	if self._data == nil then
		return;
	end

	local width = self.itemImage.item_bg.width * 0.75;
	local height = self.itemImage.item_bg.height * 0.75;
	local rect = Lua_Rectangle.new(self.itemX - width / 2 + 15, self.itemY - height / 2, width, height);
	self.itemImage:showRoundEff(showRect:containeRect(rect));
end

function Lua_FestivalCarnivalRewardItem:onPlayerSoundClick(go)
	if self.itemImage._data ~= nil then
		Lua_PackUtil.showItemInfo(self.itemImage._data, false);
	elseif self.itemImage.setOutputId ~= nil then
		Lua_WindowUtil.openWin("Lua_OutputWindow", nil, self.itemImage.setOutputId);
	end
end

function Lua_FestivalCarnivalRewardItem:dispose()
	if self.itemImage ~= nil then
		self.itemImage:dispose();
		self.itemImage = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end