-- 节日狂欢
checkRequire("Lua_FestivalCarnivalPanel")-- 节日狂欢

Lua_FestivalCarnivalWindow = class("Lua_FestivalCarnivalWindow", Lua_Window);
function Lua_FestivalCarnivalWindow:ctor()
    self:superCall("ctor");
    self.selected = 1;
    self.windowName = "Lua_FestivalCarnivalWindow";
    self.skinName = "FestivalCarnivalWindow_skin";
end
function Lua_FestivalCarnivalWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.panelDic = {};
	self.panelDic[1047] = { panel = Lua_FestivalCarnivalPanel };
	self.panelDic[1034] = { panel = Lua_BossAndDoublePanel };
	self.panelDic[1035] = { panel = Lua_BossAndDoublePanel };
	self.panelDic[1033] = { panel = Lua_RechargeBagPanel };
	self.panelDic[1036] = { panel = Lua_ExchangeBagPanel };
	self.panelDic[1037] = { panel = Lua_LandingBagPanel };
	self.panelDic[1017] = { panel = Lua_RechargeRitualPanel };
	self.panelDic[1019] = { panel = Lua_HelloEveryonePanel };
	self.panelDic[1020] = { panel = Lua_KingComesPanel };
	self.panelDic[1027] = { panel = Lua_OnlyLovesOnePersonPanel, clickRemoveEvent = 21001 };
	self.panelDic[1024] = { panel = Lua_AllOneIsLlifePanel, clickRemoveEvent = 21002 };
	self.panelDic[1045] = { panel = Lua_SuitSecKillPanel };
	self.panelDic[1047] = { panel = Lua_FestivalCarnivalPanel };

	self.dragList = Lua_DragList.new(self.content, 2, Vector4(0, 0, 800, 70));
	self.dragList:setLocation(-65, 218, 0);
	self.dragList:setListCell(Lua_FestivalCarnivalWindowItem, 75, 150, 999);

	DataCenter.redDotData:updateRedDotVoState(22030, false);
	Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", { evenId = 22030, val = 1, bShow = false });
	Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", false); -- 变强事件
	
	self:addLuaEvent("UPDATE_ACTIVITIES_DATA", self, self.createButtonList);
	self:addLuaEvent("ON_FESTIVALCARNIVAL_ITEM_CLICK", self, self.updateFestivalCarnivalPanelInfo); -- 打开panel

	self:addLuaEvent("SET_ACTIVITIES_BTN_REDDOT", self, self.rSetBtnRedDot);
	self:updateRedDot()
	DataCenter.OperationalActivitiesData:sGetActivitiesInfo();
end

function Lua_FestivalCarnivalWindow:createButtonList()
	local actList = DataCenter.OperationalActivitiesData:getActivitiesByIcon(self.iconId);
	local vo;
	self.activitList = Array();
	for i = 1, actList:getSize() do
		vo = actList[i];
		if vo ~= nil then
			self.activitList:add({
				data = vo,
				sort = vo.sort,
				index = nil,
				isRedDot = false,
				panel = self.panelDic[vo.first_type].panel,
				clickRemoveEvent = self.panelDic[vo.first_type].clickRemoveEvent
			});
		end
	end
	self.activitList:sort("sort", true);
	for i = 1, self.activitList:getSize() do
		self.activitList[i].index = i;
	end

	self.selectNum = 1;
	if self.showData == nil then
		self.selectNum = 1;
	elseif type(self.showData) == "table" and self.showData.opName ~= nil then
		-- 变强跳转
		for i = 1, self.activitList:getSize() do
			if self.showData.opName == self.activitList[i].data.title then
				self.selectNum = i;
			end
		end
	end

	if self.selectedIndex ~= nil and self.activitList[self.selectedIndex] ~= nil then
		self.selectNum = self.selectedIndex;
	end
	if self.activitList[self.selectNum] == nil then
		return;
	end
	self.dragList:setLuaArrayData(self.activitList, false);
	self.dragList:setSelected(self.selectNum);
	self:updateFestivalCarnivalPanelInfo(self.activitList[self.selectNum], true);
end

function Lua_FestivalCarnivalWindow:showWin(param)
	self.showData = param;
	self.iconId = DataCenter.OperationalActivitiesData.exActList[1047]:getRighTopIconId();
end

function Lua_FestivalCarnivalWindow:rSetBtnRedDot(iSselect)
	local isRedDot;
	for i = 1, self.activitList:getSize() do
		isRedDot = false;
		if DataCenter.OperationalActivitiesData.notify_list:getSize() > 0 then
			for j = 1, #DataCenter.OperationalActivitiesData.notify_list[1] do
				if self.activitList[i].data.act_index == DataCenter.OperationalActivitiesData.notify_list[1][j] then
					isRedDot = true;
				end
			end
		end
		if self.activitList[i].data.first_type == 1047 then        
			if DataCenter.redDotData:getRedDotStateByEventId(17001) == true then                
				isRedDot = true;
			end
		end
		self.activitList[i].isRedDot = isRedDot;
	end

	if iSselect == nil or iSselect == true then
		self.dragList:setSelected(self.selectNum);
	end
	self:updateRedDot();
end

function Lua_FestivalCarnivalWindow:updateFestivalCarnivalPanelInfo(val)
	if self.selectedIndex == val.index then
		return;
	end
	self.selectedIndex = val.index;

	if self.curPanel ~= nil then
		self.curPanel:dispose();
		self.curPanel = nil;
	end
	if val.data.first_type == 1047 then
		if DataCenter.festivalCarnivalData.end_time - tonumber(tostring(GlobalVar.cur_tick)) <= 0 then
			OperateAlert.show(LanUtil.getValue(122586));
			return;
		end
	end
	self.curPanel = val.panel.new(self.content);
	self.curPanel.first_type = val.data.first_type;

	if val.data.first_type ~= 1047 then
		DataCenter.OperationalActivitiesData:sGetOperationalActivities(val.data.act_index, val.data.first_type);
	end
	self:updateRedDot()
end

function Lua_FestivalCarnivalWindow:updateRedDot()
	-- 刷新红点状态
	if self.dragList ~= nil then
		local arr = self.dragList.showList;
		for i = 1, arr:getSize() do
			arr[i]:updateRedDot();
		end
	end
end

function Lua_FestivalCarnivalWindow:dispose()
	if self.activitList ~= nil then
		self.activitList:clear()
		self.activitList = nil;
	end
	if self.dragList ~= nil then
		self.dragList:dispose()
		self.dragList = nil;
	end
	if self.curPanel ~= nil then
		self.curPanel:dispose();
		self.curPanel = nil;
	end

	self:superCall("dispose");
end










Lua_FestivalCarnivalWindowItem = class("Lua_FestivalCarnivalWindowItem", Lua_ListCell);
function Lua_FestivalCarnivalWindowItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_FestivalCarnivalWindowItem:buildShowItem()
	self:superCall("buildShowItem");

	self.btnBg = UICreate.createUIAtlasImage(self.content, "", "", 20, 0, 0, 0);
	self.btnBg:setDepth(8);
	self.btnBg:setScale(0.9, 0.9);

	self.btnTxt = UICreate.createLabel(self.content, "", 20, 0, 200, 30, 24);
	self.btnTxt.pivot = UIWidget.Pivot.Center;
	self.btnTxt:setDepth(15);

	self.redDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 74, 12, 0, 0);
	self.redDot.name = "redDot";
	self.redDot:setDepth(16);
end

function Lua_FestivalCarnivalWindowItem:setData(data)
	self._data = data;
	self:updateRedDot();
end

function Lua_FestivalCarnivalWindowItem:updateRedDot()
	self.redDot:setEnable(self._data.isRedDot);
end

function Lua_FestivalCarnivalWindowItem:onPlayerSoundClick(go)
	Lua_MsgUtil.callFunc("ON_FESTIVALCARNIVAL_ITEM_CLICK", self._data);
end

function Lua_FestivalCarnivalWindowItem:onSelectionChange(val)
	self:superCall("onSelectionChange", val);
	if val == true then
		self.btnBg:setAltas("common_atlas_2", "ui_common_btn_y13");
		self.btnTxt.color = Color.New(255 / 255, 255 / 255, 255 / 255, 1)
		self.btnTxt.uiwidget.text = self._data.data.title;
		self.btnBg:setLocation(20,3)
		self.btnTxt:setLocation(20,4)
		self.redDot:setLocation(91,26)
	else
		self.btnBg:setAltas("common_atlas_2", "ui_common_btn_y12");
		self.btnTxt.color = Color.New(138 / 255, 186 / 255, 200 / 255, 1)
		self.btnTxt.uiwidget.text = self._data.data.title;
		self.btnBg:setLocation(20,-1)
		self.btnTxt:setLocation(20,0)
		self.redDot:setLocation(91,22)
	end
end

function Lua_FestivalCarnivalWindowItem:dispose()
	self:superCall("dispose");
end