-- 0元礼包
Lua_GiftsWindow = class("Lua_GiftsWindow", Lua_Window);
function Lua_GiftsWindow:ctor()
	self:superCall("ctor", self.list);

	self.windowName = "Lua_GiftsWindow";
	self.skinName = "GiftsWindow_skin";
	self.showClose = false;
end

function Lua_GiftsWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.roleIcon:setUrl("/images/common/ui_0yuanlibao.png");
	self.roleIcon:SetDimensions(264, 310);

	self.upBg.imgTypeNum = 4;
	self.upBg.widget.border = Vector4(200, 0, 200, 0);
	
	local avo = DataCenter.OperationalActivitiesData:getActivitiesByType(1042, nil);
	if avo == nil then
		self:hide();
		return;
	end

	self.cotent = avo.content;
	self.actIndex = avo.act_index;

	local arr = Array();
	local item;
	local configData = DataCenter.giftsData.configData;
	self.uiSpare = {};
	for i = 1, configData:getSize() do
		arr:add("");

		item = Lua_zeroGiftsItem.new(self.content);
		item:setItemName(i);
		item:setIconAtlas(configData[i].setAltas, configData[i].id);
		item:setLocation(-368 + (i - 1) * 106, 101.5, 0);
		self.uiSpare[i] = item;
	end

	self.btnList = Lua_ButtonList.new(self.content, arr, 106, self, self.onButtonListClick,
		"ui_zhujiemian_txk_02", "ui_0yuan_bg_09", Vector4(0, 0, 98, 98), Vector4(0, 0, 98, 118),
		Lua_ColorDefine.transColor("FFFFFF"), Lua_ColorDefine.transColor("FFFFFF"), Vector4(22, 22, 130, 30), 2, "zeroYuan_atlas");
	self.btnList:setLocation(-368, 101.5, 0);
	self.btnList:setDepth(6);
	self.btnList:setRedDotPos(35, 35);

	self.dragWidth = 360;
	self.dragList = Lua_DragList.new(self.content,2, Vector4(0, 0, self.dragWidth, 70));
	self.dragList:setListCell(Lua_GiftsCellItem, 70, 90, 100);
	self.dragList:setLocation(116, -128, 0);

	self.redDot:setEnable(false);
	self.buyBtn:setEnable(false);
	self.buyBtn:addClickFuntion(self, self.onBtnClick);
	self.buyBg:addClickFuntion(self, self.buyClick);
	self.wenhao:addClickFuntion(self, self.tipsClick);

	self:addLuaEvent("OPENGIFTSINFO_UPDATE", self, self.fromServer51400028);
	self:addLuaEvent("UPDATE_ONEPANEL_DATA", self, self.rsetData);
	DataCenter.OperationalActivitiesData:sGetOperationalActivities(avo.act_index, 1042);
end

function Lua_GiftsWindow:tipsClick()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", nil, self.cotent);
end

function Lua_GiftsWindow:onButtonListClick(val)
	self.index = val;
	self.uiSpare[val]:setShowState(3, true);

	local isRoundEff;
	local rewardInfo = DataCenter.giftsData.reward_info[val];
	local arr = Array();
	for k,v in ipairs(rewardInfo.reward_set) do
		isRoundEff = false;
		for i = 1, #rewardInfo.spec_effect_item do
			if tonumber(v.id) == tonumber(rewardInfo.spec_effect_item[i]) then
				isRoundEff = true;
				break;
			end
		end
		arr:add({id = v.id, amount = v.amount, bind = v.bind, star = v.equipment.star, isRoundEff = isRoundEff});
	end
	local posX = arr:getSize() * 90 >= self.dragWidth and 116 or 116 + (self.dragWidth - (arr:getSize() * 90)) / 2;
	self.dragList:setLuaArrayData(arr, false);
	self.dragList:setLocation(posX, -128, 0);

	self.buyTxt.text = DataCenter.giftsData.cost[1];
	self.money:setAltas("item1", tostring(DataCenter.giftsData.cost[2]));

	if DataCenter.giftsData.cur_tick < val then 
		self.buyBtn.label = LanUtil.getValue(124511);
		self.buyBtn:removeClickFuntion(self, self.ClickFuntion)
	else
		self.buyBtn.label = LanUtil.getValue(122901);
		self.buyBtn:addClickFuntion(self, self.onBtnClick);
	end

	-- arrive == 1 领取状态 drawed 领取情况
	local isbuyBtn; -- 领取btn状态
	local isbuytipsObj = false; -- 购买后
	local isredDot = false; -- 红点
	if self.isBuy then
		isbuyBtn = rewardInfo.drawed == 1 and false or true;
		isbuytipsObj = rewardInfo.drawed == 1 and true or false;
		isredDot = rewardInfo.arrive == 1 and rewardInfo.drawed == 0 and true or false;
	else
		isbuyBtn = false;
	end

	self.buyBtn:setEnable(isbuyBtn);
	self.redDot:setEnable(isredDot);
	self.buyObj:SetActive(not self.isBuy); -- 购买状态
	self.buytipsObj:SetActive(isbuytipsObj);
end

function Lua_GiftsWindow:fromServer51400028(msg)
	if msg == nil then
		return;
	end

	self.is_succeed = msg.is_succeed; -- 是否成功购买
	self.buyBtn:setEnable(msg.is_succeed);
	self.redDot:setEnable(msg.is_succeed);
	self.buyObj:SetActive(not msg.is_succeed);
end

function Lua_GiftsWindow:rsetData(msg)
	if msg.act_detail.first_type ~= 1042 then
		return;
	end
	DataCenter.giftsData:updateGiftsInfo(msg);

	self.bar:setMaxValue(8);
	if DataCenter.giftsData.cur_tick < 5 then
		self.bar:setValue(DataCenter.giftsData.cur_tick - 1);
	else
		self.bar:setValue(DataCenter.giftsData.cur_tick);
	end

	if tonumber(msg.act_detail.sub_value) == 0 then
		self.buyBtn:setEnable(false);
		self.buyObj:SetActive(true);
		self.buytipsObj:SetActive(false);
	else
		self.buyBtn:setEnable(true);
		self.buyObj:SetActive(false);
		self.buytipsObj:SetActive(false);
	end

	local rewardInfo = DataCenter.giftsData.reward_info;
	for i = 1, 8 do
		if rewardInfo[i].drawed == 0 and rewardInfo[i].arrive == 1 and DataCenter.giftsData.cur_tick >= i then
			self.uiSpare[i]:setShowState(4, true);
			self.isBuy = true;
		end

		if rewardInfo[i].drawed == 1 then
			self.isBuy = true;
			self.uiSpare[i]:setShowState(4, false);
			self.uiSpare[i]:setShowState(1, true);
			self.uiSpare[i]:setShowState(2, true);
		else
			self.uiSpare[i]:setShowState(1, false);
			self.uiSpare[i]:setShowState(2, false);
		end
	end

	local selectedIndex;
	for i = 1, 8 do
		if self.is_succeed == nil then 
			if rewardInfo[DataCenter.giftsData.cur_tick].drawed == 1 then
				if rewardInfo[i].drawed == 0 then
				    selectedIndex = i;
					return self.btnList:setSelected(i, true);
				end
			else
				return self.btnList:setSelected(DataCenter.giftsData.cur_tick, true);
			end
		end
	end

	if selectedIndex ~= nil then
		self.btnList:setSelected(selectedIndex, true);
	else
		self.btnList:setSelected(DataCenter.giftsData.cur_tick, true);
	end

	if self.is_succeed ~= nil then 
		self.is_succeed = nil;
	end
end

function Lua_GiftsWindow:buyClick()
	DataCenter.moneyData:showReconfigPanel(tonumber(DataCenter.giftsData.cost[1]), self, self.buyGift);
end

function Lua_GiftsWindow:buyGift()
	if DataCenter.moneyData:isMoneyEnough(209000003, tonumber(DataCenter.giftsData.cost[1]), true, true) == false then
		return;
	end
	Lua_ProxyManager.getProxy("Lua_GiftsProxy"):sBuyZeroYuanGift();
end

function Lua_GiftsWindow:onBtnClick()
	DataCenter.OperationalActivitiesData:buyReward(self.actIndex, self.index - 1, 1)
end

function Lua_GiftsWindow:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	self:superCall("dispose");
end





--------------------------------------------------





Lua_zeroGiftsItem = class("Lua_zeroGiftsItem", Lua_DisplayObject);
function Lua_zeroGiftsItem:ctor(p)
	self:superCall("ctor", p, "zeroGiftsItem_skin");
end

function Lua_zeroGiftsItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemBg:setEnable(false);
	self.maskIcon:setEnable(false);
	self.recivedIcon:setEnable(false);
	self.rewardRedDot:setEnable(false);

	-- self.itemIcon:addLoadCompleteFun(self, self.onLoadCompleteImg);
end

function Lua_zeroGiftsItem:onLoadCompleteImg()
	self.itemIcon:resetSize();
end

function Lua_zeroGiftsItem:setItemName(index)
	self.content.name = "Lua_zeroGiftsItem" .. index;
end

function Lua_zeroGiftsItem:setIconAtlas(atlas, sprite)
	self.itemIcon:setAltas(atlas, sprite);
end

function Lua_zeroGiftsItem:setShowState(index, state)
	if index == 1 then
		self.maskIcon:setEnable(state);
	elseif index == 2 then
		self.recivedIcon:setEnable(state);
	elseif index == 3 then
		self.itemBg:setEnable(state);
	elseif index == 4 then
		self.rewardRedDot:setEnable(state);
	end
end





--------------------------------------------------





Lua_GiftsCellItem = class("Lua_GiftsCellItem", Lua_ListCell);
function Lua_GiftsCellItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_GiftsCellItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setDepth(5);
	self.itemImg:setScale(0.8, 0.8, 0);
	self.itemImg:setCanClick(false);
end

function Lua_GiftsCellItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	local reward = Lua_ToolVo.createToolVo(tonumber(data.id), data.amount, data.bind)
	reward.star = data.star;
	reward.packType = 999;
	self.itemImg.data = reward;
end

function Lua_GiftsCellItem:onPlayerSoundClick()
	Lua_PackUtil.showItemInfo(self.itemImg.data);
end

function Lua_GiftsCellItem:checkOutBound(showRect)
	if self.data == nil then
		return;
	end

	local width = self.itemImg.item_bg.width * 0.8;
	local height = self.itemImg.item_bg.height * 0.8;
	local rect = Lua_Rectangle.new(self.itemX - width / 2, self.itemY - height / 2, width, height);
	if showRect:containeRect(rect) and self.itemImg.data.color >= 3 and self.data.isRoundEff then
		self.itemImg:showRoundEff(true);
	else
		self.itemImg:showRoundEff(false);
	end
end

function Lua_GiftsCellItem:dispose()
	if self.itemImg ~= nil then
		self.itemImg:dispose();
		self.itemImg = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end