Lua_GoodLuckDialRecordItem = class("Lua_GoodLuckDialRecordItem", Lua_DragContainerItem);
function Lua_GoodLuckDialRecordItem:ctor(p)
    self:superCall("ctor", p);
end

function Lua_GoodLuckDialRecordItem:buildShowItem()
    self:superCall("buildShowItem");

    self._height = 0;
    self.label = UICreate.createLabel(self.content, "", 0, 0, 446, 20, 20);
    self.label.overflowMethod = UILabel.Overflow.ResizeHeight;
    self.label.pivot = UIWidget.Pivot.TopLeft;
    self.label.spacingY = 10;
    self.label:setDepth(5);
end

function Lua_GoodLuckDialRecordItem:dispose()
    self.vo = nil;
    self._height = 0;
    self:superCall("dispose");
end

function Lua_GoodLuckDialRecordItem:getHeight()
    return self._height;
end

function Lua_GoodLuckDialRecordItem:setData(data)
    self.data = data;
    if self.data ~= nil then
        self.vo = Lua_ToolVo.createToolVo(tonumber(self.data.proto_item.id));
        self.vo:fromServer(self.data.proto_item);
        if self.vo ~= nil then
            local str;
            local nameStr = "[url=playerClick_"..self.data.role_id.."]"..self.data.role_name.."[/url]";

            if self.data.proto_item.id == Lua_MoneyData.GOLD then -- 元宝
                str = "[url=showItem_"..self.data.proto_item.id.."]".."["..self.vo.colorStr.."]"..self.data.proto_item.amount..self.vo.name.."[-]".."[/url]";
                self.label.text = LanUtil.formateStr(LanUtil.getValue(140708), nameStr, str);
            else
                if self.data.proto_item.amount > 1 then
                    str = "[url=showItem_"..self.data.proto_item.id.."]".."["..self.vo.colorStr.."]"..self.vo.name.."*"..self.data.proto_item.amount.."[-]".."[/url]";
                else
                    str = "[url=showItem_"..self.data.proto_item.id.."]"..self.vo.colorName.."[/url]"; 
                end
                self.label.text = LanUtil.formateStr(LanUtil.getValue(140707), nameStr, str);
            end
        end
    end

    self._height = self.label.height;
end

function Lua_GoodLuckDialRecordItem:onPlayerSoundClick()
    self:superCall("onPlayerSoundClick");
    local urlStr = self.label:getUrlByMousePos();
    if urlStr ~= nil then
        local arr = string.split(urlStr, "_");
        if arr[1] == "showItem" then
            Lua_PackUtil.showItemInfo(self.vo);
        elseif arr[1] == "playerClick" then
            Lua_ChatUtil.playerMenuPopListShow({role_id = tonumber(arr[2])});
        end
    end
end