-- 幸运转盘结算界面
checkRequire("Lua_TreasureResultWindow");
Lua_GoodLuckDialResultWindow = class("Lua_GoodLuckDialResultWindow", Lua_TreasureResultWindow);
function Lua_GoodLuckDialResultWindow:ctor()
	self:superCall("ctor");
	self.bShowRuneChips = false;
	self.windowName = "Lua_GoodLuckDialResultWindow";
end

function Lua_GoodLuckDialResultWindow:buildPanel(go)
	self:superCall("buildPanel", go);

	self:addLuaEvent("rGOODLUCKDIAL_DRAW", self, self.onGoodLuckDialDraw);
end

function Lua_GoodLuckDialResultWindow:onGoodLuckDialDraw(list)
	self.drawType = DataCenter.goodLuckDialData.drawType; -- 抽奖类型 0一次 1十次 2五十次
	if self.drawType == 0 then
		self.againBtn.label = LanUtil.getValue(121409);
	elseif self.drawType == 1 then
		self.againBtn.label = LanUtil.getValue(121433);
	elseif self.drawType == 2 then
		self.againBtn.label = LanUtil.getValue(121434);
	end

	if list ~= nil then
		local arr;
		local len = #list;
		if self.drawType == 2 then
			arr = Array();
			for i = 1, len do 
				arr:add(list[i]);
			end

			if self.dragList == nil then
				self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 800, 280));
				self.dragList:setLocation(0, -5, 0);
				self.dragList:setListCell(Lua_GoodLuckDialResultItem, 145, 160, 5);
			end
			self.dragList:setLuaArrayData(arr, false);
		else
			local tvo;
			arr = Array();
			for i = 1, len do 
				tvo = Lua_ToolVo.createToolVo(list[i].id);
				tvo:fromServer(list[i]);
				tvo.packType = Lua_PackTypeDefine.EQUIP;
				tvo.bShowQualityEff = true;
				arr:add(tvo);
			end
			self:setShowResultData(arr);
		end
	end
end

function Lua_GoodLuckDialResultWindow:onAgainBtnClick(go)
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.3 then
		OperateAlert.show(LanUtil.getValue(121419));
		return;
	end
	self.clickTime = getTime();

	if self.drawType == nil then
		return;
	end

	local allFreeCount = DataCenter.goodLuckDialData.getAllFreeCount;
	local freeCount = DataCenter.goodLuckDialData.free_draw_reward;
	local drawNum;
	local needDrawNum;
	if self.drawType == 0 then
		drawNum = DataCenter.goodLuckDialData.oneDrawNum;
		needDrawNum = drawNum - allFreeCount;
	elseif self.drawType == 1 then
		drawNum = DataCenter.goodLuckDialData.tenDrawNum;
		needDrawNum = drawNum - freeCount;
	elseif self.drawType == 2 then
		drawNum = DataCenter.goodLuckDialData.fiftyDrawNum;
		needDrawNum = drawNum - freeCount;
	end

	if needDrawNum > 0 then
		local str = "";
		self.costGoldNum = DataCenter.goodLuckDialData.cost * needDrawNum;
		if DataCenter.moneyData:getMoney(Lua_MoneyData.GOLD) < self.costGoldNum then
			str = "["..Lua_ColorDefine.RED_STR.."]"..tostring(self.costGoldNum).."[-]";
			self.enoughGold = false;
		else
			str = "["..Lua_ColorDefine.GREEN_STR.."]"..tostring(self.costGoldNum).."[-]";
			self.enoughGold = true;
		end

		if DataCenter.neverTip:getNeverValue("Lua_GoodLuckDialWindow") == true then
			if self.enoughGold == false then
				DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD, self.costGoldNum, true, true);
			else
				Lua_ProxyManager.getProxy("Lua_GoodLuckDialProxy"):sGoodLuckDialDraw(DataCenter.goodLuckDialData.drawType);
			end
			return;
		end

		local tipData = {};
		if DataCenter.goodLuckDialData.open_recharge_reward == 1 then
			tipData.des = LanUtil.formateStr(LanUtil.getValue(140713), str, tostring(needDrawNum), tostring(DataCenter.goodLuckDialData.free_draw_reward));
		else
			tipData.des = LanUtil.formateStr(LanUtil.getValue(140718), str, tostring(needDrawNum));
		end 
		tipData.neverTip = "Lua_GoodLuckDialWindow";
		tipData.owner = self;
		tipData.type = 1;
		tipData.subFun = self.onSureFun;   --确定
		Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
	else
		Lua_ProxyManager.getProxy("Lua_GoodLuckDialProxy"):sGoodLuckDialDraw(self.drawType);
	end
end

function Lua_GoodLuckDialResultWindow:onSureFun()
	if self.enoughGold == false then
		DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD, self.costGoldNum, true, true);
	else
		Lua_ProxyManager.getProxy("Lua_GoodLuckDialProxy"):sGoodLuckDialDraw(self.drawType);
	end
end

function Lua_GoodLuckDialResultWindow:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose()
		self.dragList = nil;
	end
	self.drawType = nil; 

	self:superCall("dispose");
end





--------------------------------------------------





Lua_GoodLuckDialResultItem = class("Lua_GoodLuckDialResultItem", Lua_ListCell);
function Lua_GoodLuckDialResultItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_GoodLuckDialResultItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImage = Lua_ToolImage.new(self.content);
	self.itemImage:setLocation(0, 25, 0)
	self.itemImage:setDepth(5);

	self.itemName = UICreate.createLabel(self.content, "", 0, -40, 360, 30, 24);
	self.itemName.pivot = UIWidget.Pivot.Center;
	self.itemName:setDepth(5);
end

function Lua_GoodLuckDialResultItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local tvo = Lua_ToolVo.createToolVo(data.id);
	tvo:fromServer(data);
	tvo.packType = Lua_PackTypeDefine.EQUIP;
	self.itemImage.data = tvo;
	self.itemName.text = tvo.colorName;
end

function Lua_GoodLuckDialResultItem:checkOutBound(showRect)
	if self._data == nil then
		self.inViewEffect = false;
		return;
	end

	local rect = Lua_Rectangle.new(self.itemX - 50, self.itemY - 10, 100,60);
	self.itemImage:showQualityEff(showRect:containeRect(rect));
end

function Lua_GoodLuckDialResultItem:dispose()
	if self.itemImage ~= nil then
		self.itemImage:dispose();
		self.itemImage = nil;
	end
	if self.itemName ~= nil then
		self.itemName:dispose();
		self.itemName = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end