-- 幸运转盘
checkRequire("Lua_GoodLuckRewardItem");
checkRequire("Lua_GoodLuckDialRecordItem");
checkRequire("Lua_RotActionItem");
Lua_GoodLuckDialWindow = class("Lua_GoodLuckDialWindow", Lua_Window);
function Lua_GoodLuckDialWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_GoodLuckDialWindow";
	self.skinName = "GoodLuckDialWindow_skin";
end

function Lua_GoodLuckDialWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.myMoneyLab.text = LanUtil.getValue(140702);

	self.checkBox.seleted = DataCenter.goodLuckDialData.isPass;
	self.oneBtnRedDot:setEnable(false);
	self.tenBtnRedDot:setEnable(false);
	self.fiftyBtnRedDot:setEnable(false);

	self.rewardsList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 445, 216));
	self.rewardsList:setLocation(276, -7, 0);
	self.rewardsList:setListCell(Lua_GoodLuckRewardItem, 90, 445, 1);

	self.dragContainer = Lua_DragContainer.new(self.content, 1, Vector4(223, -80, 446, 160));
	self.dragContainer:setLocation(53, -134, 0);

	self.pointCircle = Lua_RotActionItem.new(self.pointer);

	self.helpBtn:addClickFuntion(self, self.onHelpBtnClick);
	self.checkBox:addBoxChange(self, self.onCheckBoxClick);
	self.oneBtn:addClickFuntion(self, self.onOneBtnClick);
	self.tenBtn:addClickFuntion(self, self.onTenBtnClick);
	self.fiftyBtn:addClickFuntion(self, self.onFiftyBtnClick);
	self.rechargeBtn:addClickFuntion(self, self.onRechargeBtnClick);

	self:addLuaEvent("rGOODLUCKDIAL_RECORDS", self, self.updateGoodLuckRecords);
	self:addLuaEvent("rGOODLUCKDIAL_JACKPOTNOW", self, self.updateJackpotNow);
	self:addLuaEvent("rGOODLUCKDIAL_DRAWRESULT", self, self.updateDrawResult);
	self:addLuaEvent("UPDATE_GOODLUCKDIAL", self, self.updateInfo);
	Lua_ProxyManager.getProxy("Lua_GoodLuckDialProxy"):sOpenGoodLuckDialWin();
end

function Lua_GoodLuckDialWindow:updateInfo()
	if DataCenter.goodLuckDialData.isShow == false then
		DataCenter.goodLuckDialData.isShow = true;
		-- 显示展示道具
		local arr = DataCenter.goodLuckDialData.getShowItem;
		local posX;
		local posY;
		local angle = 360 / arr:getSize();
		local radius = 168; -- 道具的半径
		local cell;
		for i = 1, arr:getSize() do
			posX = -226 + radius * math.sin(math.rad(angle * (i - 1)));
			posY = 35 + radius * math.cos(math.rad(angle * (i - 1)));

			cell = Lua_GoodLuckShowIcon.new(self.content);
			cell.content.name = "cell"..i;
			cell:setDepth(4);
			cell:setShowData(arr[i]);
			cell:setLocation(posX, posY, 0);
		end
	end

	self.rewardsList:setLuaArrayData(DataCenter.goodLuckDialData.getExchangeReward, false);
	self.moneyCountLab.text = DataCenter.moneyData:getMoney(Lua_MoneyData.GOLD);

	if DataCenter.goodLuckDialData.open_recharge_reward == 1 then
		self.freeCount:setEnable(true);
		self.freeCount.text = LanUtil.formateStr(LanUtil.getValue(140719), tostring(DataCenter.goodLuckDialData.free_draw_reward));
		self.rechargeBtn.mainContent:SetActive(true);
		self.tipsLab.text = LanUtil.formateStr(LanUtil.getValue(140701), tostring(DataCenter.goodLuckDialData.add_gold));
	else
		self.freeCount:setEnable(false);
		self.rechargeBtn.mainContent:SetActive(false);
		self.tipsLab.text = LanUtil.formateStr(LanUtil.getValue(140717), tostring(DataCenter.goodLuckDialData.add_gold));
	end

	if DataCenter.goodLuckDialData.open_free_count == 1 then
		self.freeTime:setEnable(true);
		self:updateFreeTime();
	else
		self.freeTime:setEnable(false);
	end
	self:updateResidueTime();
	self:updateCost();
end

-- 免费时间
function Lua_GoodLuckDialWindow:updateFreeTime()
	self.free_time = tonumber(DataCenter.goodLuckDialData.left_time);
	self.freeTime.text = LanUtil.formateStr(LanUtil.getValue(140703), TimeTransform.getInstance():transSeconds6(self.free_time, true, true));
	if self.free_time <= 0 then
		self.freeTime.text = LanUtil.getValue(140704);
		Lua_CommonUtil.removeTimer(self, self.onFreeTimer);
		return;
	end
	Lua_CommonUtil.addTimer("goodLuckDial_freeTimer", 1, self, self.onFreeTimer);
end

function Lua_GoodLuckDialWindow:onFreeTimer()
	self.free_time = self.free_time - 1;
	self.freeTime.text = LanUtil.formateStr(LanUtil.getValue(140703), TimeTransform.getInstance():transSeconds6(self.free_time, true, true));
	if self.free_time <= 0 then
		self.freeTime.text = LanUtil.getValue(140704);
		Lua_CommonUtil.removeTimer(self, self.onFreeTimer);
	end
end

-- 活动剩余时间
function Lua_GoodLuckDialWindow:updateResidueTime()
	self.residue_time = tonumber(DataCenter.goodLuckDialData.act_left_time);
	self.endTime.text = LanUtil.formateStr(LanUtil.getValue(140705), TimeTransform.getInstance():transSeconds1(self.residue_time, true));
	if self.residue_time <= 0 then
		self.endTime.text = LanUtil.getValue(140720);
		Lua_CommonUtil.removeTimer(self, self.onResidueTimer);
		return;
	end
	Lua_CommonUtil.addTimer("goodLuckDial_residueTimer", 1, self, self.onResidueTimer);
end

function Lua_GoodLuckDialWindow:onResidueTimer()
	self.residue_time = self.residue_time - 1;
	self.endTime.text = LanUtil.formateStr(LanUtil.getValue(140705), TimeTransform.getInstance():transSeconds1(self.residue_time, true));
	if self.residue_time <= 0 then
		self.endTime.text = LanUtil.getValue(140720);
		Lua_CommonUtil.removeTimer(self, self.onResidueTimer);
	end
end

function Lua_GoodLuckDialWindow:onHelpBtnClick()
	if DataCenter.goodLuckDialData.isEnd == true then
		OperateAlert.show(LanUtil.getValue(122586));
		return;
	end

	if DataCenter.goodLuckDialData.ruleTips ~= nil then 
		Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_OPEN, DataCenter.goodLuckDialData.ruleTips);
	end
end

function Lua_GoodLuckDialWindow:onCheckBoxClick()
	DataCenter.goodLuckDialData.isPass = not DataCenter.goodLuckDialData.isPass;
	self.checkBox.seleted = DataCenter.goodLuckDialData.isPass;
end

-- 更新消耗
function Lua_GoodLuckDialWindow:updateCost()
	local allFreeCount = DataCenter.goodLuckDialData.getAllFreeCount;
	local oneDrawNum = DataCenter.goodLuckDialData.oneDrawNum;
	self.enoughOneCost = allFreeCount >= oneDrawNum;
	self.oneBtnRedDot:setEnable(self.enoughOneCost);
    
	local freeCount = DataCenter.goodLuckDialData.free_draw_reward;
	local tenDrawNum = DataCenter.goodLuckDialData.tenDrawNum;
	self.enoughTenCost = freeCount >= tenDrawNum;
	self.tenBtnRedDot:setEnable(self.enoughTenCost);

	local fiftyDrawNum = DataCenter.goodLuckDialData.fiftyDrawNum;
	self.enoughFiftyCost = freeCount >= fiftyDrawNum;
	self.fiftyBtnRedDot:setEnable(self.enoughFiftyCost);
end

function Lua_GoodLuckDialWindow:onOneBtnClick()
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.3 then
		OperateAlert.show(LanUtil.getValue(121419));
		return;
	end
	self.clickTime = getTime();

	if DataCenter.goodLuckDialData.isEnd then
		OperateAlert.show(LanUtil.getValue(122586));
		return;
	end

	DataCenter.goodLuckDialData.drawType = 0;
	if self.enoughOneCost == false then
		local freeCount = DataCenter.goodLuckDialData.getAllFreeCount;
		self.drawNum = DataCenter.goodLuckDialData.oneDrawNum;
		local needDrawNum = self.drawNum - freeCount;
		self:onDraw(needDrawNum);
	else
		Lua_ProxyManager.getProxy("Lua_GoodLuckDialProxy"):sGoodLuckDialDraw(0);
	end
end

function Lua_GoodLuckDialWindow:onTenBtnClick()
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.3 then
		OperateAlert.show(LanUtil.getValue(121419));
		return;
	end
	self.clickTime = getTime();

	if DataCenter.goodLuckDialData.isEnd == true then
		OperateAlert.show(LanUtil.getValue(122586));
		return;
	end

	DataCenter.goodLuckDialData.drawType = 1;
	if self.enoughTenCost == false then
		local freeCount = DataCenter.goodLuckDialData.free_draw_reward;
		self.drawNum = DataCenter.goodLuckDialData.tenDrawNum;
		local needDrawNum = self.drawNum - freeCount;
		self:onDraw(needDrawNum);
	else
		Lua_ProxyManager.getProxy("Lua_GoodLuckDialProxy"):sGoodLuckDialDraw(1);
	end
end

function Lua_GoodLuckDialWindow:onFiftyBtnClick()
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.3 then
		OperateAlert.show(LanUtil.getValue(121419));
		return;
	end
	self.clickTime = getTime();

	if DataCenter.goodLuckDialData.isEnd == true then
		OperateAlert.show(LanUtil.getValue(122586));
		return;
	end

	DataCenter.goodLuckDialData.drawType = 2;
	if self.enoughFiftyCost == false then
		local freeCount = DataCenter.goodLuckDialData.free_draw_reward;
		self.drawNum = DataCenter.goodLuckDialData.fiftyDrawNum;
		
		local needDrawNum = self.drawNum - freeCount;
		self:onDraw(needDrawNum);
	else
		Lua_ProxyManager.getProxy("Lua_GoodLuckDialProxy"):sGoodLuckDialDraw(2);
	end
end

function Lua_GoodLuckDialWindow:onDraw(needDrawNum)
	if needDrawNum > 0 then
		local str = "";
		self.costGoldNum = DataCenter.goodLuckDialData.cost * needDrawNum;
		if DataCenter.moneyData:getMoney(Lua_MoneyData.GOLD) < self.costGoldNum then
			str = "["..Lua_ColorDefine.RED_STR.."]"..tostring(self.costGoldNum).."[-]";
			self.enoughGold = false;
		else
			str = "["..Lua_ColorDefine.GREEN_STR.."]"..tostring(self.costGoldNum).."[-]";
			self.enoughGold = true;
		end

		if DataCenter.neverTip:getNeverValue("Lua_GoodLuckDialWindow") == true then
			if self.enoughGold == false then
				DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD, self.costGoldNum, true, true);
			else
				Lua_ProxyManager.getProxy("Lua_GoodLuckDialProxy"):sGoodLuckDialDraw(DataCenter.goodLuckDialData.drawType);
			end
			return;
		end

		local tipData = {};
		if DataCenter.goodLuckDialData.open_recharge_reward == 1 then
			tipData.des = LanUtil.formateStr(LanUtil.getValue(140713), str, tostring(self.drawNum), tostring(DataCenter.goodLuckDialData.free_draw_reward));
		else
			tipData.des = LanUtil.formateStr(LanUtil.getValue(140718), str, tostring(self.drawNum));
		end
		tipData.neverTip = "Lua_GoodLuckDialWindow";
		tipData.owner = self;
		tipData.type = 1;
		tipData.subFun = self.onSureFun; -- 确定
		Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
	end
end

function Lua_GoodLuckDialWindow:onSureFun()
	if self.enoughGold == false then
		DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD, self.costGoldNum, true, true);
	else
		Lua_ProxyManager.getProxy("Lua_GoodLuckDialProxy"):sGoodLuckDialDraw(DataCenter.goodLuckDialData.drawType);
	end
end

-- 更新抽奖记录
function Lua_GoodLuckDialWindow:updateGoodLuckRecords(val)
	if val ~= nil then
		for k,v in ipairs(val) do
			item = Lua_GoodLuckDialRecordItem.new(self.dragContainer.sub);
			self.dragContainer:addSubContainer(item, false);
			self.dragContainer.childrenList[k]:setData(v);
		end	
		self.dragContainer:updateChildPos();
	end	
end

-- 更新当前奖池
function Lua_GoodLuckDialWindow:updateJackpotNow(val)
	if val ~= nil then
		self.jackpotTxt.text = LanUtil.formateStr(LanUtil.getValue(140700), tostring(val));
	end
end

-- 更新抽奖结果
function Lua_GoodLuckDialWindow:updateDrawResult(val)
	if val ~= nil then
		if DataCenter.goodLuckDialData.drawType == 0 then
			if DataCenter.goodLuckDialData.isPass then
				self.pointCircle:setRot(val * -36);
			else
				self.pointCircle:setParams(-2500, -360 * 2 + val * -36);
				self.pointCircle:start();
			end
		else
			self.pointCircle:setRot(val * -36);
		end
	end	
end

function Lua_GoodLuckDialWindow:onBtnCloseClick(go)
	Lua_ProxyManager.getProxy("Lua_GoodLuckDialProxy"):sCloseGoodLuckDialWin();
	self:hide();
end

function Lua_GoodLuckDialWindow:onRechargeBtnClick()
	if DataCenter.goodLuckDialData.isEnd then
		OperateAlert.show(LanUtil.getValue(122586));
		return;
	end
	Lua_WindowUtil.openWin("Lua_ChongzhiRewardsWindow", WinParam.ACTION_OPEN);
end

function Lua_GoodLuckDialWindow:dispose()
	if self.rewardsList ~= nil then
		self.rewardsList:dispose();
		self.rewardsList = nil;
	end
	if self.dragContainer ~= nil then
		self.dragContainer:dispose();
		self.dragContainer = nil;
	end
	if self.pointCircle ~= nil then
		self.pointCircle:dispose();
		self.pointCircle = nil;
	end
	Lua_CommonUtil.removeTimer(self, self.onResidueTimer);
	Lua_CommonUtil.removeTimer(self, self.onFreeTimer);
	DataCenter.goodLuckDialData.isShow = false;

    self:superCall("dispose");
end





--------------------------------------------------





-- 展示道具ICON
Lua_GoodLuckShowIcon = class("Lua_GoodLuckShowIcon", Lua_DisplayObject);
function Lua_GoodLuckShowIcon:ctor(p)
	self:superCall("ctor", p);
end

function Lua_GoodLuckShowIcon:buildShowItem()
	self:superCall("buildShowItem");

	self.toolImg = Lua_ToolImage.new(self.content);
	self.toolImg:setDepth(5);
	self.toolImg:setScale(0.9, 0.9);

	self.tag = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_bq_002", -11, 11, 0, 0);
	self.tag:setDepth(10);
	self.tag:setSacle(0.7, 0.7);
	self.tag:setEnable(false);

	self.tagLab = UICreate.createLabel(self.content, "", -17, 17, 100, 30, 18);
	self.tagLab.pivot = UIWidget.Pivot.Center;
	self.tagLab.overflowMethod = UILabel.Overflow.ResizeFreely;
	self.tagLab.colorStr = Lua_ColorDefine.transColor("E4EEFF");
	self.tagLab.effectStyle = 3;
	self.tagLab.effectColorStr = Lua_ColorDefine.transColor("000000");
	self.tagLab:setEffectDistance(0.5, 0.5);
	self.tagLab:setDepth(11);
	self.tagLab:setRot(0, 0, 45);
	self.tagLab:setEnable(false);
end

function Lua_GoodLuckShowIcon:setShowData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.toolImg.data = data.vo;
	if data.effect == 1 then
		self.toolImg:showRoundEff(data.effect == 1);
	end

	if data.percent ~= nil and data.percent > 0 then
		self.tag:setEnable(true);
		self.tagLab:setEnable(true);
		self.tagLab.text = data.percent .. "%";
	end
end

function Lua_GoodLuckShowIcon:dispose()
	if self.toolImg ~= nil then
		self.toolImg:dispose();
		self.toolImg = nil;
	end
	if self.tag ~= nil then
		self.tag:dispose();
		self.tag = nil;
	end
	if self.tagLab ~= nil then
		self.tagLab:dispose();
		self.tagLab = nil;
	end
	self._data = nil;

    self:superCall("dispose");
end