Lua_GoodLuckRewardItem = class("Lua_GoodLuckRewardItem", Lua_ListCell);
function Lua_GoodLuckRewardItem:ctor(p)
	self:superCall("ctor", p, "GoodLuckRewardItem_skin");
end

function Lua_GoodLuckRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setDepth(5);
	self.itemImg:setScale(0.8, 0.8);
	self.itemImg:setCanClick(true);
	self.itemImg:setLocation(-181.5, 0, 0);

	self.redDot = UICreate.createUIAtlasImage(self.content,"iconantlas4","redDot",246,17,0,0);
	self.redDot:setDepth(3);
	self.redDot:setEnable(false);

	self.getBtn:addClickFuntion(self, self.onGetBtnClick);
	self.getBtn:setBtnEnable(false);
end

function Lua_GoodLuckRewardItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.itemImg.data = data.vo;
	if data.effect == 1 then
		self.itemImg:showRoundEff(true)
	end

	self.needTxt.text = LanUtil.formateStr(LanUtil.getValue(140706), tostring(data.need_draw), tostring(data.leftCount));
	
	if data.state == 1 then -- 已领取
		self.redDot:setEnable(false);
		self.getBtn:setBtnEnable(false);
		self.getBtn.label = LanUtil.getValue(140715);
	else
		self.redDot:setEnable(data.isCanGet);
		self.getBtn:setBtnEnable(data.isCanGet);
		self.getBtn.label = LanUtil.getValue(140714);
	end
end

function Lua_GoodLuckRewardItem:checkOutBound(showRect)
	local rect = Lua_Rectangle.new(self.itemX, self.itemY - 25, 25, 50);
	self.itemImg:showRoundEff(showRect:containeRect(rect));
end

function Lua_GoodLuckRewardItem:onGetBtnClick()
	if DataCenter.goodLuckDialData.isEnd then
		OperateAlert.show(LanUtil.getValue(122586));
		return;
	end
	Lua_ProxyManager.getProxy("Lua_GoodLuckDialProxy"):sGetRewards(self._data.index);
end

function Lua_GoodLuckRewardItem:dispose()
	if self.itemImg ~= nil then
		self.itemImg:dispose();
		self.itemImg = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end