-- 绑元放送
Lua_BindCopperGiftPanel = class("Lua_BindCopperGiftPanel", Lua_DisplayObject)
function Lua_BindCopperGiftPanel:ctor(p)
	self:superCall("ctor", p, "BindCopperGiftPanel_skin");
end

function Lua_BindCopperGiftPanel:buildShowItem()
    self:superCall("buildShowItem");
    
    self:updateInfo();
    self.chargeBtn:addClickFuntion(self, self.oncChargeBtnClick);
    self.descTxt.text = LanUtil.getValue(142100);
    Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sGetActivityInfo(Lua_OperationalActivitiesData.BIND_COPPER_GIFT);
    self:addLuaEvent("rBindCopperGiftInfo", self, self.updateInfo);
end

function Lua_BindCopperGiftPanel:updateInfo()
	self:updateShowTime();
end

function Lua_BindCopperGiftPanel:updateShowTime()
	local endTime = DataCenter.OperationalActivitiesData.bindCopperGiftEndTime;
	local leftTime = 0;
	if endTime ~= nil and endTime > 0 then
		leftTime = endTime - tonumber(tostring(GlobalVar.cur_tick));
	end

	if leftTime > 0 then
		if self.bStartTime == nil or self.bStartTime == false then
			self.bStartTime = true;
			Lua_CommonUtil.addTimer("updateShowTime", 1, self, self.updateShowTime);
		end
	else
		leftTime = 0;
		if self.bStartTime ~= nil and self.bStartTime == true then
			self.bStartTime = false;
			Lua_CommonUtil.removeTimer(self, self.updateShowTime);
		end
	end
    self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(142101), TimeTransform.getInstance():transSeconds1(leftTime, true));
end

function Lua_BindCopperGiftPanel:oncChargeBtnClick()
    Lua_WindowUtil.openWin("Lua_ChongzhiWindow", WinParam.ACTION_OPEN, 1);
end

function Lua_BindCopperGiftPanel:dispose()
    if self.bStartTime ~= nil and self.bStartTime == true then
    	self.bStartTime = false;
		Lua_CommonUtil.removeTimer(self, self.updateShowTime);
	end

    self:superCall("dispose");
end