-- 双倍、BOSS掉落
Lua_BossAndDoublePanel = class("Lua_BossAndDoublePanel", Lua_DisplayObject)
function Lua_BossAndDoublePanel:ctor(p)
	self:superCall("ctor", p, "BossAndDoublePanel_skin");
end

function Lua_BossAndDoublePanel:buildShowItem()
	self:superCall("buildShowItem");

	self.desIcon:addLoadCompleteFun(self, self.onLoadCompleteFun1);
	self.infoIcon:addLoadCompleteFun(self, self.onLoadCompleteFun2);
	self.subBtn:addClickFuntion(self, self.onGetBtnClick);
	
	self:addLuaEvent("UPDATE_ONEPANEL_DATA", self, self.updatePanelInfo);
end

function Lua_BossAndDoublePanel:updatePanelInfo()
	local OpenDressCarnivalData = DataCenter.OpenDressCarnivalData;
	if OpenDressCarnivalData.first_type ~= self.first_type then
		return;
	end

	self.curTime = OpenDressCarnivalData.times; -- 服务器当前时间戳（客户端使用）
	self.eTimeNum = OpenDressCarnivalData.stop_tick; -- 活动结束时间

	local atimeStr1 =  TimeTransform.getInstance():transSeconds8(OpenDressCarnivalData.start_tick, "yyyy-MM-dd HH:mm");
	local atimeStr2 =  TimeTransform.getInstance():transSeconds8(OpenDressCarnivalData.stop_tick, "yyyy-MM-dd HH:mm");
	self.timeLab.text = LanUtil.formateStr(LanUtil.getValue(127300), atimeStr1.."--"..atimeStr2);
	
	self.subBtn:setEnable(true);
	self.tipsLab:setEnable(false);
	self.timeTxt:setEnable(false);
	if self.first_type == Lua_OperationalActivitiesData.ACT_DOUBLE then -- 副本双倍 1034
		self.roleIcon:setUrl("/images/common/ui_fubenshuangbei.png");
		self.roleIcon:SetDimensions(284, 418);

		self.contentLab.text = LanUtil.formateStr(LanUtil.getValue(127302), OpenDressCarnivalData.content_tips);
		self.isOpenBouble = OpenDressCarnivalData.isOpenDoubleExp; -- 是否开启经验双倍
		if self.isOpenBouble == false then
			self.tipsLab:setEnable(true);
			self.tipsLab.text = LanUtil.formateStr(LanUtil.getValue(127313), OpenDressCarnivalData.getDoubleNnemeInfo);

			-- 打副本，领双倍
			self.desIcon:setAltas("crossServerRecharge_atlas", "ui_sbhd_font1");
			-- 副本通关有惊喜，双倍掉落奖不停
			self.infoIcon:setAltas("crossServerRecharge_atlas", "ui_sbhd_font2");
			Lua_CommonUtil.removeTimer(self, self.onTimeStrTimer);
		else
			self.start_tick_time = OpenDressCarnivalData.start_tick_time; -- 活动结束时间
			
			self.subBtn:setEnable(false);
			self.timeTxt:setEnable(self.start_tick_time - self.curTime > 0);

			-- 双倍经验，升级冲冲冲 漏
			self.desIcon:setAltas("crossServerRecharge_atlas", "ui_sbhd_font3");
			
			if self.start_tick_time - self.curTime <= 0 then
				-- 活动已开启
				self.infoIcon:setAltas("crossServerRecharge_atlas", "ui_sbhd_font5");
				Lua_CommonUtil.removeTimer(self, self.onTimeStrTimer);
			else
				self.timeTxt.text = "[FF1616]"..TimeTransform.getInstance():transSeconds1((self.start_tick_time - self.curTime), true).."[-]";

				-- 活动开启倒计时
				self.infoIcon:setAltas("crossServerRecharge_atlas", "ui_sbhd_font4");
				Lua_CommonUtil.addTimer("bossAndDouble_Timer", 1, self,self.onTimeStrTimer);
			end
		end
	elseif self.first_type == Lua_OperationalActivitiesData.ACT_BOSS then -- boss掉落 1035
		self.roleIcon:setUrl("/images/common/ui_bossdiaoluo.png");
		self.roleIcon:SetDimensions(284, 418);
		self.roleIcon:setLocation(-376, 8, 0);

		self.contentLab.text = LanUtil.formateStr(LanUtil.getValue(127302), OpenDressCarnivalData.content);
		self.desIcon:setAltas("crossServerRecharge_atlas", "ui_bossdl_font2");
		self.infoIcon:setAltas("crossServerRecharge_atlas", "ui_bossdl_font");
	end
end

function Lua_BossAndDoublePanel:onTimeStrTimer()
	self.start_tick_time = self.start_tick_time - 1;
	self.timeTxt.text = "[FF1616]"..TimeTransform.getInstance():transSeconds1(self.start_tick_time - self.curTime, true).."[-]";
	if self.start_tick_time - self.curTime <= 0 then
		self.timeTxt:setEnable(false);

		-- 活动已开启
		self.infoIcon:setAltas("crossServerRecharge_atlas", "ui_sbhd_font4");
		Lua_CommonUtil.removeTimer(self, self.onTimeStrTimer);
	end
end

function Lua_BossAndDoublePanel:onLoadCompleteFun1()
	self.desIcon:resetSize();
end

function Lua_BossAndDoublePanel:onLoadCompleteFun2()
	self.infoIcon:resetSize();
end

function Lua_BossAndDoublePanel:onGetBtnClick()
	if self.first_type == Lua_OperationalActivitiesData.ACT_DOUBLE then -- 副本双倍 1034
		if self.isOpenBouble == 1 then
			sendMsg(10404305);
		else
			Lua_WindowUtil.openWin("Lua_GrandCeremonyWindow", WinParam.ACTION_CLOSE);
			Lua_WindowUtil.openWin("Lua_CopyWindow", WinParam.ACTION_OPEN, 1);
		end
	elseif self.first_type == Lua_OperationalActivitiesData.ACT_BOSS then -- boss掉落 1035
		Lua_WindowUtil.openWin("Lua_GrandCeremonyWindow", WinParam.ACTION_CLOSE);
		Lua_WindowUtil.openWin("Lua_BossMainWindow", WinParam.ACTION_OPEN, 1);
	end
end

function Lua_BossAndDoublePanel:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose()
		self.dragList = nil;
	end
	Lua_CommonUtil.removeTimer(self, self.onTimeStrTimer);

	self:superCall("dispose");
end