-- 限时兑换1036
Lua_ExchangeBagPanel = class("Lua_ExchangeBagPanel", Lua_DisplayObject)
function Lua_ExchangeBagPanel:ctor(p)
	self:superCall("ctor", p, "CommonActivityPanel_skin");
end

function Lua_ExchangeBagPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.roleImg:setUrl("/images/common/ui_xianshiduihuan.png");
	self.roleImg:SetDimensions(230, 418);
	self.roleImg:setLocation(-379, 30, 0);

	self.end_time:setEnable(false);
	self.tips:setEnable(false);

	self.dragList = Lua_DragList.new(self.content,1, Vector4(0, 0, 733, 285));
	self.dragList:setListCell(Lua_ExchangeBagItem, 122, 365, 2);
	self.dragList:setLocation(128, -102, 0);

	self.artDesIcon:setAltas("shengdianActive_atlas", "ui_xxdh_z");
	self.artDesIcon:resetSize();

	self:addLuaEvent("UPDATE_ONEPANEL_DATA", self, self.updatePanelInfo);
end

function Lua_ExchangeBagPanel:updatePanelInfo()
	if DataCenter.OpenDressCarnivalData.first_type == 1036 then
		self.eTimeNum = DataCenter.OpenDressCarnivalData.stop_tick; -- 活动结束时间
		self.times = DataCenter.OpenDressCarnivalData.times; -- 服务器当前时间戳（客户端使用）

		local start_tick = DataCenter.OpenDressCarnivalData.start_tick; -- 活动开始时间
		local atimeStr1 =  TimeTransform.getInstance():transSeconds8(start_tick, "yyyy-MM-dd HH:mm");
		local atimeStr2 =  TimeTransform.getInstance():transSeconds8(self.eTimeNum, "yyyy-MM-dd HH:mm");
		self.open_time.text = LanUtil.formateStr(LanUtil.getValue(127300), tostring(atimeStr1.."--"..atimeStr2));

		local content = DataCenter.OpenDressCarnivalData.content;
		self.show_tips.text = LanUtil.formateStr(LanUtil.getValue(127302), tostring(content));

		local arr = DataCenter.OpenDressCarnivalData.getOpenExchangeData;
		self.dragList:setLuaArrayData(arr, false);
	end
end

function Lua_ExchangeBagPanel:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose()
		self.dragList = nil;
	end
	self:superCall("dispose");
end





--------------------------------------------------





Lua_ExchangeBagItem = class("Lua_ExchangeBagItem", Lua_ListCell);
function Lua_ExchangeBagItem:ctor(p)
	self:superCall("ctor", p, "ExchangeBagItem_skin");
end

function Lua_ExchangeBagItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImg1 = Lua_ToolImage.new(self.content);
	self.itemImg1:setDepth(1);
	self.itemImg1:setLocation(-133, 0, 0);

	self.itemImg2 = Lua_ToolImage.new(self.content);
	self.itemImg2:setDepth(1);
	self.itemImg2:setLocation(-73, -20, 0);
	self.itemImg2:setScale(0.5, 0.5);

	self.redDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 165, 40, 0, 0);
	self.redDot.name = "redDot";
	self.redDot:setDepth(6);
	self.redDot:setEnable(false);

	self.subBtn:addClickFuntion(self,self.onGetBtnClick);
end

function Lua_ExchangeBagItem:setData(data)
    self._data = data;
    if data == nil then
    	return;
    end
 
	self.nameTxt.text = data.name;

	local str;
	if tonumber(data.need_item_num) >= tonumber(data.cuont_num) then
		str = LanUtil.getValue(127311);
	else
		str = LanUtil.getValue(127315);
	end
	self.numTxt.text = LanUtil.formateStr(str, tostring(data.need_item_num), tostring(data.cuont_num));
	self.condTxt.text = LanUtil.formateStr(LanUtil.getValue(127310), tostring(data.Exchange_num));

	self.itemImg1.data = Lua_ToolVo.createToolVo(data.id, data.amount, data.bind);
	self.itemImg2.data = Lua_ToolVo.createToolVo(tonumber(data.small_id), 0, 0);

	-- 0未领取，1已领取，2表示条件不足
	self.subBtn:setBtnEnable(data.isReward ~= 1);
	self.redDot:setEnable(data.isReward == 0);
end

function Lua_ExchangeBagItem:checkOutBound(showRect)
	if self._data == nil then
		self.inViewEffect = false;
		return;
	end

	local width = self.itemImg1.item_bg.width;
	local height = self.itemImg1.item_bg.height;
	local rect = Lua_Rectangle.new(self.itemX - 125 - width / 2, self.itemY - height / 2, width, height);
	self.itemImg1:showRoundEff(showRect:containeRect(rect) and self._data.isShowEffect );
end

function Lua_ExchangeBagItem:onGetBtnClick()
	if self._data.isReward == 2 then
		OperateAlert.show(LanUtil.getValue(127314));
	else
		local avo = DataCenter.OperationalActivitiesData:getActivitiesByType(1036, nil);
		if avo == nil then
			return;
		end
		DataCenter.OperationalActivitiesData:buyReward(avo.act_index, tonumber(self._data.reward_index), 1);
	end
end

function Lua_ExchangeBagItem:dispose()
	if self.itemImg1 ~= nil then
		self.itemImg1:dispose();
		self.itemImg1 = nil;
	end
	if self.itemImg2 ~= nil then
		self.itemImg2:dispose();
		self.itemImg2 = nil;
	end
	if self.redDot ~= nil then
		self.redDot:dispose();
		self.redDot = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end