-- 盛典活动
checkRequire("Lua_BossAndDoublePanel") -- 双倍、BOSS掉落、兑换
checkRequire("Lua_RechargeBagPanel") -- 累充
checkRequire("Lua_ExchangeBagPanel") -- 兑换
checkRequire("Lua_LandingBagPanel")-- 登陆
checkRequire("Lua_KingComesPanel") -- 王者降临
checkRequire("Lua_RechargeRitualPanel") -- 充值大礼
checkRequire("Lua_HelloEveryonePanel") -- 全民来嗨
checkRequire("Lua_OnlyLovesOnePersonPanel") -- 只爱一人
checkRequire("Lua_AllOneIsLlifePanel") -- 一生一世
checkRequire("Lua_SuitSecKillPanel") -- 秒杀
checkRequire("Lua_FestivalCarnivalPanel") -- 节日狂欢
checkRequire("Lua_OpenCommonActivityPanel")
checkRequire("Lua_CyclicRechargePanel") -- 循环充值
checkRequire("Lua_CyclicConsumePanel") -- 循环消费
checkRequire("Lua_BossFirstKillActPanel"); -- BOSS首杀
checkRequire("Lua_BossEveryoneActPanel"); -- 全民BOSS
checkRequire("Lua_CumulativeConsumptionPanel"); -- 累计消费
checkRequire("Lua_BindCopperGiftPanel"); -- 绑元放送
checkRequire("Lua_TieTheKnotPanel"); -- 喜结良缘
checkRequire("Lua_SingleChargingPanel"); -- 单笔充值
checkRequire("Lua_DiscountStorePanel"); -- 折扣商店
Lua_GrandCeremonyWindow = class("Lua_GrandCeremonyWindow", Lua_Window);
function Lua_GrandCeremonyWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_GrandCeremonyWindow";
	self.skinName = "GrandCeremonyWindow_skin";
end

function Lua_GrandCeremonyWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.panelDic = {};
	self.panelDic[1034] = {panel = Lua_BossAndDoublePanel};
	self.panelDic[1035] = {panel = Lua_BossAndDoublePanel};
	self.panelDic[1033] = {panel = Lua_RechargeBagPanel};
	self.panelDic[1036] = {panel = Lua_ExchangeBagPanel};
	self.panelDic[1037] = {panel = Lua_LandingBagPanel};
	self.panelDic[1017] = {panel = Lua_RechargeRitualPanel};
	self.panelDic[1019] = {panel = Lua_HelloEveryonePanel};
	self.panelDic[1020] = {panel = Lua_KingComesPanel};
	self.panelDic[1027] = {panel = Lua_OnlyLovesOnePersonPanel, clickRemoveEvent = 21001};
	self.panelDic[1024] = {panel = Lua_AllOneIsLlifePanel, clickRemoveEvent = 21002};
	self.panelDic[1045] = {panel = Lua_SuitSecKillPanel};
	self.panelDic[1047] = {panel = Lua_FestivalCarnivalPanel};
	self.panelDic[1002] = {panel = Lua_OpenCommonActivityPanel};
	self.panelDic[1055] = {panel = Lua_BossFirstKillActPanel, clickRemoveEvent = 21008};
	self.panelDic[1056] = {panel = Lua_BossEveryoneActPanel, clickRemoveEvent = 21009};
	self.panelDic[1057] = {panel = Lua_CyclicRechargePanel, clickRemoveEvent = 21010};
	self.panelDic[1058] = {panel = Lua_CyclicConsumePanel, clickRemoveEvent = 21011};
	self.panelDic[1061] = {panel = Lua_CumulativeConsumptionPanel, clickRemoveEvent = 21012};
	self.panelDic[1063] = {panel = Lua_BindCopperGiftPanel, clickRemoveEvent = 22058};
	self.panelDic[1068] = {panel = Lua_TieTheKnotPanel, clickRemoveEvent = 22062};
	self.panelDic[1062] = {panel = Lua_SingleChargingPanel, clickRemoveEvent = 22060};
    self.panelDic[1075] = {panel = Lua_DiscountStorePanel, clickRemoveEvent = 22076};
	self.panelDic[1090] = {panel = Lua_SingleChargingPanel, clickRemoveEvent = 22066};

	self.dragList = Lua_DragList.new(self.content, 2, Vector4(0, 0, 790, 70));
	self.dragList:setListCell(Lua_GrandCeremonyWindowItem, 75, 150, 999);
	self.dragList:setLocation(-50, 218, 0);

	DataCenter.redDotData:updateRedDotVoState(21007, false);
	Lua_MsgUtil.callFunc("UPDATE_REDDOT_EVENT", {evenId = 21007, val = 1, bShow = false});
	Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", false); -- 变强事件

	self:addLuaEvent("UPDATE_ACTIVITIES_DATA", self, self.createButtonList);
	self:addLuaEvent("GRANDCEREMONY_BTNCLICK", self, self.updataClickInfo); -- 打开panel
	self:addLuaEvent("SET_ACTIVITIES_BTN_REDDOT", self, self.updateRedDotState);
	self:addLuaEvent("UPDATE_REDDOT_EVENT", self, self.updateRedDot);
	DataCenter.OperationalActivitiesData:sGetActivitiesInfo();
end

function Lua_GrandCeremonyWindow:createButtonList()
	local actList = DataCenter.OperationalActivitiesData:getActivitiesByIcon(self.iconId);
	local actVo;
	self.activitList = Array();
	for i = 1, actList:getSize() do
		actVo = actList[i];
		if actVo ~= nil then
			-- print(i, actVo.first_type);
			self.activitList:add({
				data = actVo,
				sort = actVo.sort,
				index = nil,
				panel = self.panelDic[actVo.first_type].panel,
				isRedDot = false,
				clickRemoveEvent = self.panelDic[actVo.first_type].clickRemoveEvent
			});
		end
	end
	self.activitList:sort("sort", true);

	for i = 1, self.activitList:getSize() do
		self.activitList[i].index = i;
	end

	self.selectNum = 1;
	if self.showData == nil then
		self.selectNum = 1;
	elseif type(self.showData) == "table" and self.showData.opName ~= nil then
		for i = 1, self.activitList:getSize() do
			if self.showData.opName == self.activitList[i].data.title then
				self.selectNum = i;
			end
		end
	end

	if self.selectedIndex ~= nil and self.activitList[self.selectedIndex] ~= nil then
		self.selectNum = self.selectedIndex;
	end

	if self.activitList[self.selectNum] == nil then
		return;
	end

	self:updataClickInfo(self.activitList[self.selectNum], true);
	self.dragList:setLuaArrayData(self.activitList, false);
	self.dragList:setSelected(self.selectNum);
end

function Lua_GrandCeremonyWindow:showWin(param)
	self:superCall("showWin", param);

	self.iconId = param.iconId;
end

function Lua_GrandCeremonyWindow:updateRedDot(val)
	if val.evenId == 11219 then
		self:updateRedDotState();
	end
end

function Lua_GrandCeremonyWindow:updateRedDotState(isselect)
	for i = 1, self.activitList:getSize() do
		local isRedDot = false;
		if DataCenter.OperationalActivitiesData.notify_list:getSize() > 0 then
			for j = 1, #DataCenter.OperationalActivitiesData.notify_list[1] do
				if self.activitList[i].data.act_index == DataCenter.OperationalActivitiesData.notify_list[1][j] then
					isRedDot = true;
				end
			end
		end

		if self.activitList[i].data.first_type == 1057 then --循环充值
			if DataCenter.redDotData:getRedDotStateByEventId(12220) then
				isRedDot = true;
			end
		end

		if self.activitList[i].data.first_type == 1058 then --循环消费
			if DataCenter.redDotData:getRedDotStateByEventId(12221) then
				isRedDot = true;
			end
		end

		if self.activitList[i].data.first_type == 1056 then -- 全民BOSS
			if DataCenter.redDotData:getRedDotStateByEventId(11219) then
				isRedDot = true;
			end
		end

		if self.activitList[i].data.first_type == 1061 then -- 累计消费
			if DataCenter.redDotData:getRedDotStateByEventId(22057) then
				isRedDot = true;
			end
		end

		if self.activitList[i].data.first_type == 1068 then -- 喜结良缘   
			isRedDot = DataCenter.redDotData:getRedDotStateByEventId(22063);  
		end

		if self.activitList[i].data.first_type == 1062 then -- 单笔消费   
		isRedDot = DataCenter.OperationalActivitiesData.isSingCharging;  
		end

		if self.activitList[i].data.first_type == 1090 then -- 单笔充值(每日轮换) 
			isRedDot = DataCenter.OperationalActivitiesData.isSingCharge;  
        end

		self.activitList[i].isRedDot = isRedDot;
		DataCenter.redDotData:updateRedDotVoState(self.activitList[i].clickRemoveEvent, isRedDot);
	end

	if isselect == nil or isselect == true then
		self.dragList:setSelected(self.selectNum);
	end
	self:updateRedDot()
end

function Lua_GrandCeremonyWindow:updataClickInfo(val)
	if self.selectedIndex == val.index then
		return;
	end
	self.selectedIndex = val.index;
	DataCenter.OperationalActivitiesData.curFirstType = val.data.first_type;

	if self.curPanel ~= nil then
		self.curPanel:dispose();
		self.curPanel = nil;
	end
	DataCenter.redDotData:updateRedDotVoState(val.clickRemoveEvent, false);

	if DataCenter.OperationalActivitiesData.isSingCharging == true then
		DataCenter.redDotData:updateRedDotVoState(22060, true);
	end

	if DataCenter.OperationalActivitiesData.isSingCharge == true then
        DataCenter.redDotData:updateRedDotVoState(22066, true);
    end

	Lua_MsgUtil.callFunc("TOPRIGHT_UPDATE_ICONS");
	self.curPanel = val.panel.new(self.content);
	self.curPanel.first_type = val.data.first_type;
	DataCenter.OperationalActivitiesData:sGetOperationalActivities(val.data.act_index,val.data.first_type);

	self:updateRedDot()
	self:updateWindowDepth();
end

-- 刷新红点状态
function Lua_GrandCeremonyWindow:updateRedDot()
	if self.dragList ~= nil then
		local arr = self.dragList.showList;
		local len = arr:getSize();
		for i = 1, len do
			arr[i]:updateRedDot();
		end
	end
end

function Lua_GrandCeremonyWindow:dispose()
	if self.activitList ~= nil then
		self.activitList:clear()
		self.activitList= nil;
	end
	if self.dragList ~= nil then
		self.dragList:dispose()
		self.dragList = nil;
	end
	if self.curPanel ~= nil then
		self.curPanel:dispose();
		self.curPanel = nil;
	end
	self:superCall("dispose");
end





--------------------------------------------------





Lua_GrandCeremonyWindowItem = class("Lua_GrandCeremonyWindowItem", Lua_ListCell);
function Lua_GrandCeremonyWindowItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_GrandCeremonyWindowItem:buildShowItem()
	self:superCall("buildShowItem");

	self.btnBg = UICreate.createUIAtlasImage(self.content, "", "", 0, 0, 152, 47);
	self.btnBg:setDepth(0);

	self.btnTxt = UICreate.createLabel(self.content, "", 0, 0, 200, 30, 24);
	self.btnTxt.pivot = UIWidget.Pivot.Center;
	self.btnTxt.overflowMethod = UILabel.Overflow.ResizeFreely;
	self.btnTxt:setDepth(1);

	self.redDot = UICreate.createUIAtlasImage(self.content,"common_atlas_1","ui_common_hongdian", 74, 12, 0, 0);
	self.redDot.name = "redDot"
	self.redDot:setDepth(2);
end

function Lua_GrandCeremonyWindowItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end
	
	self.btnTxt.text = self._data.data.title;
	self:updateRedDot();
end

function Lua_GrandCeremonyWindowItem:updateRedDot()
	self.redDot:setEnable(self._data.isRedDot or DataCenter.redDotData:getRedDotStateByEventId(self._data.clickRemoveEvent));
end

function Lua_GrandCeremonyWindowItem:onPlayerSoundClick(go)
	Lua_MsgUtil.callFunc("GRANDCEREMONY_BTNCLICK", self._data);
end

function Lua_GrandCeremonyWindowItem:onSelectionChange(val)
	self:superCall("onSelectionChange", val);

	if val then
		self.btnBg:setAltas("common_atlas_2", "ui_common_btn_y13");
		self.btnTxt.colorStr = Lua_ColorDefine.transColor("FFFFFF");
		self.btnBg:setLocation(0, 3);
		self.btnTxt:setLocation(0, 4);
		self.redDot:setLocation(70, 26);
	else
		self.btnBg:setAltas("common_atlas_2", "ui_common_btn_y12");
		self.btnTxt.colorStr = Lua_ColorDefine.transColor("85A8BE");
		self.btnBg:setLocation(0, -1);
		self.btnTxt:setLocation(0, 0);
		self.redDot:setLocation(70, 22);
	end
end

function Lua_GrandCeremonyWindowItem:dispose()
	if self.btnBg ~= nil then
		self.btnBg:dispose();
		self.btnBg = nil;
	end
	if self.btnTxt ~= nil then
		self.btnTxt:dispose();
		self.btnTxt = nil;
	end
	if self.redDot ~= nil then
		self.redDot:dispose();
		self.redDot = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end