-- 全民来嗨
Lua_HelloEveryonePanel = class("Lua_HelloEveryonePanel", Lua_DisplayObject)
function Lua_HelloEveryonePanel:ctor(p)
	self:superCall("ctor", p, "HelloEveryonePanel_skin");
end

function Lua_HelloEveryonePanel:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.content,1, Vector4(0, 0, 635, 393));
	self.rewardList:setLocation(-183, -18, 0);
	self.rewardList:setListCell(Lua_HelloEveryoneRewardItem, 125, 630, 1);

	self.cumulativeList = Lua_DragList.new(self.content,1, Vector4(0, 0, 340, 336));
	self.cumulativeList:setLocation(297, -44, 0);
	self.cumulativeList:setListCell(Lua_HelloEveryoneCumulativeItem, 125, 330, 1);

	self:addLuaEvent("SET_NATIONAL_FESTIVAL", self, self.updatePanelInfo);
	sendMsg(11400021);
end

function Lua_HelloEveryonePanel:updatePanelInfo()
	local arr = DataCenter.OperationalActivitiesData:getNationalFestivalData(self.first_type);
	local rewardArr = Array();
	for k,v in ipairs(arr.reward_info) do
		rewardArr:add({index = k - 1, data = v});
	end
	self.rewardList:setLuaArrayData(rewardArr, false);

	self.haiDianTxt.text = LanUtil.formateStr(LanUtil.getValue(124504), tostring(DataCenter.OperationalActivitiesData.cur_hai_point));
	self.desTxt.text = arr.content;

	local cumulativeArr = Array();
	for k,v in pairs(arr.qmlh_info) do
		if v.event_id ~= nil and v.event_id ~= 0 then
			cumulativeArr:add(v);
		end
	end

	local _a;
	local _b;
	local _temp;
	for i = 1, cumulativeArr:getSize() do
		for j = i + 1, cumulativeArr:getSize() do
			_a = cumulativeArr[i];
			_b = cumulativeArr[j];
			if tonumber(_a.event_id) ~= 4001 and tonumber(_b.event_id) == 4001 then
				_temp = cumulativeArr[i]
				cumulativeArr[i] = cumulativeArr[j]
				cumulativeArr[j] = _temp
			end
		end
	end
	self.cumulativeList:setLuaArrayData(cumulativeArr, false);

	self.eTimeNum = tonumber(tostring(arr.stop_tick));
	self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(124507), TimeTransform.getInstance():transSeconds9(self.eTimeNum - tonumber(tostring(GlobalVar.cur_tick))));
	self:startTimer();
	self:onUpdateActTime();
end

function Lua_HelloEveryonePanel:startTimer()
	if self.countDown ~= true then
		self.countDown = true;
		Lua_CommonUtil.addTimer("Lua_HelloEveryonePanel", 1, self, self.onUpdateActTime);
	end
end

function Lua_HelloEveryonePanel:onUpdateActTime()
	self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(124507), TimeTransform.getInstance():transSeconds9(self.eTimeNum - tonumber(tostring(GlobalVar.cur_tick))));
	if self.eTimeNum - tonumber(tostring(GlobalVar.cur_tick)) <= 0 then
		Lua_CommonUtil.removeTimer(self, self.onUpdateActTime);
	end
end

function Lua_HelloEveryonePanel:endTimer()
	if self.countDown == true then
		self.countDown = false;
		Lua_CommonUtil.removeTimer(self, self.onUpdateActTime);
	end
end

function Lua_HelloEveryonePanel:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	if self.cumulativeList ~= nil then
		self.cumulativeList:dispose();
		self.cumulativeList = nil;
	end
	self:endTimer();

	self:superCall("dispose");
end





--------------------------------------------------





Lua_HelloEveryoneRewardItem = class("Lua_HelloEveryoneRewardItem", Lua_ListCell);
function Lua_HelloEveryoneRewardItem:ctor(p)
	self:superCall("ctor", p, "HelloEveryoneRewardItem_skin");
end

function Lua_HelloEveryoneRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemArr = Array();
	self.effectList = Array();

	self.leftArrow:addClickFuntion(self, self.onLeftClick);
	self.rightArrow:addClickFuntion(self, self.onRightClick);
	self.getBtn:addClickFuntion(self, self.onGetBtnClick);
end

function Lua_HelloEveryoneRewardItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	if data.data.draw_flag == 0 then
		self.desTxt.text = LanUtil.formateStr(LanUtil.getValue(124505), data.data.cond[1]);
	elseif data.data.draw_flag == 1 then
		self.getBg:setAltas("common_atlas_1", "ui_common_b_");
		self.desTxt.text = LanUtil.formateStr(LanUtil.getValue(124505), data.data.cond[1]);
	else
		self.getBg:setAltas("common_atlas_3", "ui_common_b_yidahceng1");
		self.desTxt.text = LanUtil.formateStr(LanUtil.getValue(124505), "[fd0000]"..DataCenter.OperationalActivitiesData.cur_hai_point.."[-]/"..data.data.cond[1]);
	end
	self.getBg:setEnable(data.data.draw_flag ~= 0);
	self.getBtn:setEnable(data.data.draw_flag == 0);
	self.redDot:setEnable(data.data.draw_flag == 0);

	-- 创建道具
	if #data.data.reward_set > self.itemArr:getSize() then
		for i = 1, #data.data.reward_set do
			itemImg = self.itemArr[i];
			if itemImg == nil then
				itemImg = Lua_ToolImage.new(self.content);
				itemImg:setDepth(5);
				itemImg:setScale(0.88, 0.88, 0.88);
				itemImg:setEnable(false);
				self.itemArr:add(itemImg);
			end
		end
	end
	self.leftArrow:setEnable(false);
	self.rightArrow:setEnable(#data.data.reward_set > 3);

	self.itemIdx = 1;
	self.endItemIdx = #data.data.reward_set > 3 and 3 or #data.data.reward_set;
	self:setItemImgData();
end

function Lua_HelloEveryoneRewardItem:setItemImgData()
	for i = 1, self.itemArr:getSize() do
		self.itemArr[i]:setEnable(false);
	end

	if self.effectList:getSize() > 0 then
		self.effectList:clear();
	end

	local obj;
	local tvo;
	local itemImg;
	local sortNum = 1;
	for i = self.itemIdx, self.endItemIdx do
		obj = self._data.data.reward_set[i];
		tvo = Lua_ToolVo.createToolVo(obj.id, obj.amount, obj.bind == 2 and 1 or obj.bind);
		tvo.star = obj.equipment.star;

		itemImg = self.itemArr[i];
		itemImg.data = tvo;
		itemImg:setEnable(true);
		itemImg:showMaskSp(false);
		itemImg:showNotYetImg(false);
		itemImg:setLocation(-217 + (sortNum - 1) * 79, -13, 0);
		sortNum = sortNum + 1;

		for j = 1, #self._data.data.spec_effect_item do
			if obj.id == tonumber(self._data.data.spec_effect_item[j]) then
				itemImg:showRoundEff(true);
				self.effectList:add(itemImg);
			end
		end
	end
end

function Lua_HelloEveryoneRewardItem:checkOutBound(showRect)
	local rect = Lua_Rectangle.new(self.itemX - 33, self.itemY - 46, 66, 66);
	for i = 1, self.effectList:getSize() do
		self.effectList[i]:showRoundEff(showRect:containeRect(rect));
	end
end

function Lua_HelloEveryoneRewardItem:onLeftClick()
	self.itemIdx = self.itemIdx - 3;
	self.leftArrow:setEnable(self.itemIdx ~= 1);
	self.rightArrow:setEnable(true);

	self.endItemIdx = #self._data.data.reward_set - self.endItemIdx >= 3 and self.endItemIdx - 3 or self.endItemIdx - #self._data.data.reward_set % 3;
	self:setItemImgData();
end

function Lua_HelloEveryoneRewardItem:onRightClick()
	self.itemIdx = self.itemIdx + 3;
	self.leftArrow:setEnable(true);
	self.rightArrow:setEnable(#self._data.data.reward_set - self.endItemIdx > 3);

	self.endItemIdx = #self._data.data.reward_set - self.endItemIdx >= 3 and self.endItemIdx + 3 or #self._data.data.reward_set;
	self:setItemImgData();
end

function Lua_HelloEveryoneRewardItem:onGetBtnClick()
	local cmd = ProtoPublic_pb.Proto11400024();
	cmd.index = self._data.index;
	sendMsg(11400024, cmd);
end

function Lua_HelloEveryoneRewardItem:dispose()
	if 	self.itemArr ~= nil then
		self.itemArr:dispose();
		self.itemArr:clear();
		self.itemArr = nil;
	end
	if 	self.effectList ~= nil then
		self.effectList:dispose();
		self.effectList:clear();
		self.effectList = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end





--------------------------------------------------





Lua_HelloEveryoneCumulativeItem = class("Lua_HelloEveryoneCumulativeItem", Lua_ListCell);
function Lua_HelloEveryoneCumulativeItem:ctor(p)
	self:superCall("ctor", p, "HelloEveryoneCumulativeItem_skin");
end

function Lua_HelloEveryoneCumulativeItem:buildShowItem()
	self:superCall("buildShowItem");

	self.getBtn:addClickFuntion(self, self.onGetBtnClick);
end

function Lua_HelloEveryoneCumulativeItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.desTxt.text = data.content;
	self.numTxt.text = data.cur_finish_times.."/"..data.limit_times;

	local icon = DataCenter.OperationalActivitiesData:openCorrespondingWindow(data.event_id, "icon");
	local atlas = DataCenter.OperationalActivitiesData:openCorrespondingWindow(data.event_id, "atlas");
	self.icon:setAltas(atlas, icon);
end

function Lua_HelloEveryoneCumulativeItem:onGetBtnClick()
	local WindowName = DataCenter.OperationalActivitiesData:openCorrespondingWindow(self._data.event_id, "corresponding_window")
	local WindowIndex = DataCenter.OperationalActivitiesData:openCorrespondingWindow(self._data.event_id, "winIndex")
	local itemId = DataCenter.OperationalActivitiesData:openCorrespondingWindow(self._data.event_id, "itemId")
	local openId = DataCenter.OperationalActivitiesData:openCorrespondingWindow(self._data.event_id, "open_id")
	if WindowName == nil then
		return
	elseif DataCenter.funcOpenData:isOpened(openId) == false then
		-- 功能没开启，需要提示
		local cfg = getConfig({"func_open", openId});
		if cfg ~= nil and cfg.advance_message ~= nil then
			OperateAlert.show(cfg.advance_message);
		end
		return;
	else
		if WindowIndex == -1 then
			Lua_WindowUtil.openWin(WindowName)
		elseif WindowIndex == 0 then
			local oo = DataCenter.copyData.copyDic;
			Lua_WindowUtil.openWin(WindowName, nil, oo[itemId]);
		elseif WindowIndex == -2 then
			local tlist = DataCenter.taskData:getListByType(Lua_TaskDefine.ROUTINE);
			if tlist ~= nil and tlist:getSize() > 0 then
				Lua_WindowUtil.openWin(WindowName, WinParam.ACTION_OPEN, tlist[1]);
			else
				OperateAlert.show(LanUtil.getValue(121919));
				return
			end
		elseif WindowIndex == -3 then
			Lua_ProxyManager.getProxy("Lua_YunBiaoProxy"):goYunBiao()
		else
			if WindowName == "Lua_NationalFestivalWindow" then
				local avo = DataCenter.OperationalActivitiesData:getActivitiesByType(1018, nil);
				if avo == nil then
					OperateAlert.show(LanUtil.getValue(110646));
					return;
				end
			end
			Lua_WindowUtil.openWin(WindowName, WinParam.ACTION_OPEN, WindowIndex);
		end

		if WindowName ~= "Lua_GrandCeremonyWindow" then
			Lua_WindowUtil.openWin("Lua_GrandCeremonyWindow", WinParam.ACTION_CLOSE);
		end
		if WindowName ~= "Lua_SuitWindow" then
			Lua_WindowUtil.openWin("Lua_SuitWindow", WinParam.ACTION_CLOSE);
		end
	end
end