-- 王者降临
Lua_KingComesPanel = class("Lua_KingComesPanel", Lua_DisplayObject)
function Lua_KingComesPanel:ctor(p)
	self:superCall("ctor", p, "KingComesPanel_skin");
end

function Lua_KingComesPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.roleImg:setUrl("/images/common/ui_wangzhejianglin.png");
	self.roleImg:SetDimensions(284, 418);
	self.roleImg:setLocation(-379, -35, 0);

	self.rewardList = Lua_DragList.new(self.content,1, Vector4(0, 0, 735, 325));
	self.rewardList:setLocation(127, -37, 0);
	self.rewardList:setListCell(Lua_KingComesItem, 110, 620, 1);

	self:addLuaEvent("SET_NATIONAL_FESTIVAL",self,self.updatePanelInfo);
	sendMsg(11400021);
end

function Lua_KingComesPanel:updatePanelInfo()
	local arr = DataCenter.OperationalActivitiesData:getNationalFestivalData(self.first_type);
	self.eTimeNum = tonumber(tostring(arr.stop_tick));
	self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(124507), TimeTransform.getInstance():transSeconds9(self.eTimeNum - tonumber(tostring(GlobalVar.cur_tick))));
	self:startTimer();
	self:updateActTime();
	
	local len;
	local index = 1;
	local nameStr;
	local rewardArr = Array();
	for k,v in ipairs(arr.reward_info) do
		len = v.cond[3] - v.cond[2] + 1;
		for i = 1, len do
			nameStr = (#v.role_id_name >= i and v.role_id_name[i].data_string ~= nil) and v.role_id_name[i].data_string or nil;
			rewardArr:add({index = index, data = v, name = nameStr, cost_type = arr.cost_type});
			index = index + 1;
		end
	end
	self.rewardList:setLuaArrayData(rewardArr, false);
	self.desTxt.text = arr.content;
end

function Lua_KingComesPanel:startTimer()
	if self.countDown ~= true then
		self.countDown = true;
		Lua_CommonUtil.addTimer("Lua_KingComesPanel", 1, self, self.updateActTime);
	end
end

function Lua_KingComesPanel:updateActTime()
	self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(124507), TimeTransform.getInstance():transSeconds9(self.eTimeNum - tonumber(tostring(GlobalVar.cur_tick))));
	if self.eTimeNum - tonumber(tostring(GlobalVar.cur_tick)) <= 0 then
		self:endTimer();
	end
end

function Lua_KingComesPanel:endTimer()
	if self.countDown == true then
		self.countDown = false;
		Lua_CommonUtil.removeTimer(self, self.updateActTime);
	end
end

function Lua_KingComesPanel:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self:endTimer();

	self:superCall("dispose");
end





--------------------------------------------------





Lua_KingComesItem = class("Lua_KingComesItem", Lua_ListCell);
function Lua_KingComesItem:ctor(p)
	self:superCall("ctor", p, "KingComesItem_skin");
end

function Lua_KingComesItem:buildShowItem()
	self:superCall("buildShowItem");

	self.effectList = Array();

	self.rItem = Lua_RewardItem.new(self.content);
	self.rItem.pivot = 2;
	self.rItem:setDepth(5);
	self.rItem:setMaxShow(5);
	self.rItem:setClickWin(true);
	self.rItem:setMouseEnble(true);
	self.rItem:setLocation(50, 0);
end

function Lua_KingComesItem:setData(data)
	if data == nil then
		return;
	end
	self._data = data.data;
	
	if data.index ~= nil  then
		if data.index <= 3 then
			self.pSp:setEnable(true);
			self.pTxt:setEnable(false);
			self.pSp:setAltas("leaderBoard_atlas", "ui_paihang_widget_no"..data.index);
		else
			self.pSp:setEnable(false);
			self.pTxt:setEnable(true);
			self.pTxt.text = data.index;
		end
	end

	if data.name ~= nil then
		self.nameTxt.text = "[FF57E9]"..data.name .."[-]";
	else
		self.nameTxt.text = "[9DC4DD]"..LanUtil.getValue(124513).."[-]";
	end

	if data.cost_type == 1 then
		self.desTxt.text = LanUtil.getValue(124509);
	else
		self.desTxt.text = LanUtil.getValue(124510);
	end

	local obj;
	local tvo;
	local rewardArr = Array();
	for i = 1, #data.data.reward_set do
		obj = data.data.reward_set[i];
		tvo = Lua_ToolVo.createToolVo(obj.id, obj.amount, obj.bind == 2 and 1 or obj.bind);
		tvo.star = obj.equipment.star;
		rewardArr:add(tvo);
	end
	self.rItem:setRewardByArray(rewardArr);

	if self.effectList:getSize() > 0 then
		self.effectList:clear();
	end

	local itemId;
	local toolImg;
	for i = 1, #data.data.reward_set do
		itemId = data.data.reward_set[i].id;
		toolImg = self.rItem:getToolImageById(itemId);
		toolImg:showMaskSp(false);
		toolImg:showNotYetImg(false);

		for j = 1, #data.data.spec_effect_item do
			if itemId == tonumber(data.data.spec_effect_item[j]) then
				toolImg:showRoundEff(true);
				self.effectList:add(toolImg);
			end
		end
	end
end

function Lua_KingComesItem:checkOutBound(showRect)
	if self._data ~= nil then
		local rect = Lua_Rectangle.new(self.itemX - 38, self.itemY - 38, 76, 76);
		for i = 1, self.effectList:getSize() do
			self.effectList[i]:showRoundEff(showRect:containeRect(rect));
		end
	end
end

function Lua_KingComesItem:dispose()
	if self.rItem ~= nil then
		self.rItem:dispose();
		self.rItem = nil;
	end
	if self.effectList ~= nil then
		self.effectList:dispose();
		self.effectList:clear();
		self.effectList = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end