-- 登录有礼
Lua_LandingBagPanel = class("Lua_LandingBagPanel", Lua_DisplayObject)
function Lua_LandingBagPanel:ctor(p)
	self:superCall("ctor", p, "CommonActivityPanel_skin");
end

function Lua_LandingBagPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.roleImg:setUrl("/images/common/ui_dengluyouli.png");
	self.roleImg:SetDimensions(284, 418);
	self.roleImg:setLocation(-386, -40, 0);

	self.end_time:setEnable(false);
	self.tips:setEnable(false);

	self.dragList = Lua_DragList.new(self.content,1, Vector4(0, 0, 730, 285));
	self.dragList:setListCell(Lua_LandingBagItem, 119, 725, 1);
	self.dragList:setLocation(129, -104, 0);

	self:addLuaEvent("UPDATE_ONEPANEL_DATA", self, self.updateLandingBagPanelInfo);
end

function Lua_LandingBagPanel:updateLandingBagPanelInfo()
	if DataCenter.OpenDressCarnivalData.first_type == self.first_type then
		self.eTimeNum = DataCenter.OpenDressCarnivalData.stop_tick; -- 活动结束时间
		self.times = DataCenter.OpenDressCarnivalData.times; -- 服务器当前时间戳（客户端使用）
		
		local start_tick = DataCenter.OpenDressCarnivalData.start_tick; -- 活动开始时间
		local atimeStr1 =  TimeTransform.getInstance():transSeconds8(start_tick, "yyyy-MM-dd HH:mm");
		local atimeStr2 =  TimeTransform.getInstance():transSeconds8(self.eTimeNum, "yyyy-MM-dd HH:mm");
		self.open_time.text = LanUtil.formateStr(LanUtil.getValue(127300), tostring(atimeStr1.."--"..atimeStr2));

		local content = DataCenter.OpenDressCarnivalData.content;
		self.show_tips.text = LanUtil.formateStr(LanUtil.getValue(127302), tostring(content)) 

		local arr = DataCenter.OpenDressCarnivalData.getOpenCommonData;
		self.dragList:setLuaArrayData(arr, false);
	end
end

function Lua_LandingBagPanel:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose()
		self.dragList = nil;
	end
	self:superCall("dispose");
end





--------------------------------------------------





Lua_LandingBagItem = class("Lua_LandingBagItem", Lua_ListCell);
function Lua_LandingBagItem:ctor(p)
	self:superCall("ctor", p, "LandingBagItem_skin");
end

function Lua_LandingBagItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rItem = Lua_RewardItem.new(self.content);
	self.rItem:setDepth(1);
	self.rItem:setMaxShow(6);
	self.rItem:setClickWin(true);
	self.rItem:setMouseEnble(true);
	self.rItem:setLocation(-195, 0);

	self.redDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 318, 17, 0, 0)
	self.redDot.name = "redDot";
	self.redDot:setDepth(6);
	self.redDot:setEnable(false);

	self.subBtn:addClickFuntion(self, self.onGetBtnClick);
end

function Lua_LandingBagItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.titleTxt.text = data.open_tiem;

	local effList = data.spec_effect_item;
	local effDic = {};
	for i = 1, #effList do
		effDic[tonumber(effList[i])] = 1;
	end
	-- print(#effList, "Lua_LandingBagPanel");

	local obj;
	local tvo;
	local rewardInfoArr = Array();
	for i = 1, #data.reward_set do
		obj = data.reward_set[i];

		tvo = Lua_ToolVo.createToolVo(obj.id, obj.amount, obj.bind == 2 and 1 or obj.bind);
		tvo.packType = 999;
		tvo.star = obj.equipment.star;
		tvo.bShowItemBg = true;
		tvo.roundEffect = effDic[obj.id] == 1;
		rewardInfoArr:add(tvo);
	end
	self.rItem:setRewardByArray(rewardInfoArr);

	if data.isReward == 0 then -- 0未领取，1已领取，2表示条件不足
		self.subBtn:setBtnEnable(true);
		self.subBtn.label = LanUtil.getValue(121148);
	elseif data.isReward == 1 then
		self.subBtn:setBtnEnable(false);
		self.subBtn.label = LanUtil.getValue(122528);
	else
		if data.arrive == 0 and data.isPast == true then -- 0未登陆
			self.subBtn:setBtnEnable(false);
			self.subBtn.label = LanUtil.getValue(110879);
		else
			self.subBtn:setBtnEnable(false);
			self.subBtn.label = LanUtil.getValue(121148);
		end
	end
	self.redDot:setEnable(data.isReward == 0);
end

function Lua_LandingBagItem:checkOutBound(showRect)
	if self._data == nil then
		return;
	end

	local width = self.rItem.awords[1].item_bg.width;
	local height = self.rItem.awords[1].item_bg.height;
	local itemImg;
	local rect = Lua_Rectangle.new(self.itemX - width / 2, self.itemY - height / 2, width, height);
	for i = 1, #self._data.reward_set do
		itemImg = self.rItem:getToolImageById(self._data.reward_set[i].id)
		itemImg:showRoundEff(showRect:containeRect(rect) and itemImg.data.roundEffect);
	end
end

function Lua_LandingBagItem:onGetBtnClick()
	local avo = DataCenter.OperationalActivitiesData:getActivitiesByType(1037, nil);
	if avo == nil then
		return;
	end
	DataCenter.OperationalActivitiesData:buyReward(avo.act_index, tonumber(self._data.reward_index), 1);
end

function Lua_LandingBagItem:dispose()
	if self.rItem ~= nil then
		self.rItem:dispose();
		self.rItem = nil;
	end
	if self.redDot ~= nil then
		self.redDot:dispose();
		self.redDot = nil;
	end

	self:superCall("dispose");
end