-- 累充好礼1033
Lua_RechargeBagPanel = class("Lua_RechargeBagPanel", Lua_DisplayObject)
function Lua_RechargeBagPanel:ctor(p)
	self:superCall("ctor", p, "CommonActivityPanel_skin");
end

function Lua_RechargeBagPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.roleImg:setUrl("/images/common/ui_leichuhaoli.png");
	self.roleImg:SetDimensions(284, 418);
	self.roleImg:setLocation(-376, -40, 0);

	self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 732, 290));
	self.dragList:setListCell(Lua_RechargeBagItem, 122, 732, 1);
	self.dragList:setLocation(115, -105, 0);

	self.artDesIcon:setAltas("crossServerRecharge_atlas", "ui_lchl_z");
	self.artDesIcon:resetSize();

	self:addLuaEvent("UPDATE_ONEPANEL_DATA", self, self.updatePanelInfo);
end

function Lua_RechargeBagPanel:updatePanelInfo()
	if DataCenter.OpenDressCarnivalData.first_type == 1033 then
		self.eTimeNum = DataCenter.OpenDressCarnivalData.stop_tick; -- 活动结束时间
		self.times = DataCenter.OpenDressCarnivalData.times; -- 服务器当前时间戳（客户端使用）
		
		local start_tick = DataCenter.OpenDressCarnivalData.start_tick; -- 活动开始时间
		local atimeStr1 =  TimeTransform.getInstance():transSeconds8(start_tick, "yyyy-MM-dd HH:mm");
		local atimeStr2 =  TimeTransform.getInstance():transSeconds8(self.eTimeNum, "yyyy-MM-dd HH:mm");
		self.open_time.text = LanUtil.formateStr(LanUtil.getValue(141750),tostring(atimeStr1.."--"..atimeStr2));

		self.end_time.text = LanUtil.formateStr(LanUtil.getValue(141751),
			TimeTransform.getInstance():transSeconds1(self.eTimeNum - self.times, true));
		Lua_CommonUtil.addTimer("Lua_RechargeBagPanel", 1, self, self.onTimeStrTimer);

		local content = DataCenter.OpenDressCarnivalData.content;
		self.tips.text = LanUtil.formateStr(LanUtil.getValue(141752), tostring(content));

		local arr = DataCenter.OpenDressCarnivalData.getOpenCommonData;
		self.dragList:setLuaArrayData(arr, false);
	end
end

function Lua_RechargeBagPanel:onTimeStrTimer()
	self.eTimeNum = self.eTimeNum - 1;
	if self.eTimeNum - self.times > 0 then
		self.end_time.text = LanUtil.formateStr(LanUtil.getValue(141751),
			TimeTransform.getInstance():transSeconds1(self.eTimeNum - self.times, true));
	else
		Lua_CommonUtil.removeTimer(self, self.onTimeStrTimer);
	end
end

function Lua_RechargeBagPanel:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose()
		self.dragList = nil;
	end
	Lua_CommonUtil.removeTimer(self, self.onTimeStrTimer);

	self:superCall("dispose");
end





--------------------------------------------------





Lua_RechargeBagItem = class("Lua_RechargeBagItem", Lua_ListCell);
function Lua_RechargeBagItem:ctor(p)
	self:superCall("ctor", p, "RechargeBagItem_skin");
end

function Lua_RechargeBagItem:buildShowItem()
	self:superCall("buildShowItem");

	self.showItem = Lua_RechargeBagShowItem.new(self.content);

	self.redDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 330, 16, 0, 0);
	self.redDot.name = "redDot";
	self.redDot.clickScale = false;
	self.redDot:setDepth(10);

	self.subBtn:addClickFuntion(self, self.onGetBtnClick);
end

function Lua_RechargeBagItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local str;
	if tonumber(tostring(data.sub_value)) >= tonumber(tostring(data.cond[1])) then
		str = "[" .. Lua_ColorDefine.GREEN_STR .. "]" .. data.cond[1] .. "[-]";
	else
		str = "[" .. Lua_ColorDefine.RED_STR .. "]" .. data.sub_value .. "[-]";
	end
	self.titleTxt.text = LanUtil.formateStr(LanUtil.getValue(141754), str, tostring(data.cond[1]));
	
	-- 0 未领取，1 已领取，2 表示条件不足
	if data.isReward == 0 then
		self.subBtn.label = LanUtil.getValue(121148);
	elseif data.isReward == 1 then
		self.subBtn.label = LanUtil.getValue(122528);
	else
		self.subBtn.label = LanUtil.getValue(122543);
	end

	self.showItem:setData(data);

	self.subBtn:setBtnEnable(data.isReward ~= 1);
	self.redDot:setEnable(data.isReward == 0);
end

function Lua_RechargeBagItem:checkOutBound(showRect)
	if self._data == nil then
		return;
	end

	local rect = Lua_Rectangle.new(self.itemX - 30, self.itemY - 18 - 30, 60, 60);
	self.showItem:setItemShowState(showRect:containeRect(rect));
end

function Lua_RechargeBagItem:onGetBtnClick()
	local avo = DataCenter.OperationalActivitiesData:getActivitiesByType(1033, nil);
	if avo == nil then
		return;
	end

	local act_index = avo.act_index;
	if self._data.isReward == 0 then
		DataCenter.OperationalActivitiesData:buyReward(tonumber(act_index), tonumber(self._data.reward_index), 1);
	else
		Lua_WindowUtil.openWin("Lua_OpenDressCarnivalWindow", WinParam.ACTION_CLOSE, nil);
		Lua_WindowUtil.openWin("Lua_ChongzhiWindow", WinParam.ACTION_OPEN, 1);
	end
end

function Lua_RechargeBagItem:dispose()
	if self.redDot ~= nil then
		self.redDot:dispose();
		self.redDot = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end





--------------------------------------------------





Lua_RechargeBagShowItem = class("Lua_RechargeBagShowItem", Lua_DisplayObject);
function Lua_RechargeBagShowItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_RechargeBagShowItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemArr = Array();
end

function Lua_RechargeBagShowItem:setData(data)
	self._data = data;

	local effList = data.spec_effect_item;
	local effDic = {};
	for i = 1, #effList do
		effDic[tonumber(effList[i])] = 1;
	end
	-- print(data.cond[1], #effList, "Lua_RechargeBagPanel");

	local maxNum = #data.reward_set > self.itemArr:getSize() and #data.reward_set or self.itemArr:getSize();
	local obj;
	local tvo;
	local itemImg;
	for i = 1, maxNum do
		itemImg = self.itemArr[i];
		if i <= #data.reward_set then
			obj = data.reward_set[i];
			tvo = Lua_ToolVo.createToolVo(obj.id, obj.amount, obj.bind == 2 and 1 or obj.bind);
			tvo.packType = 999;
			tvo.star = obj.equipment.star;
			tvo.bShowItemBg = true;
			tvo.roundEffect = tvo.color > 2 and effDic[obj.id] == 1;

			if itemImg == nil then
				itemImg = Lua_ToolImage.new(self.content);
				self.itemArr:add(itemImg);
			end
			itemImg.data = tvo;
			itemImg:setDepth(2);
			itemImg:setScale(0.77, 0.77, 0.77);
			itemImg:setLocation(-300 + (i - 1) * 70, -18, 0);
			itemImg:setEnable(true);
		else
			if itemImg ~= nil then
				itemImg:setEnable(false);
			end
		end
	end
end

function Lua_RechargeBagShowItem:setItemShowState(state)
	for i = 1, #self._data.reward_set do
		self.itemArr[i]:showRoundEff(state and self.itemArr[i].data.roundEffect);
	end
end

function Lua_RechargeBagShowItem:dispose()
	if self.itemArr ~= nil then
		self.itemArr:dispose();
		self.itemArr:clear();
		self.itemArr = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end