-- 充值大礼
Lua_RechargeRitualPanel = class("Lua_RechargeRitualPanel", Lua_DisplayObject)
function Lua_RechargeRitualPanel:ctor(p)
	self:superCall("ctor", p, "RechargeRitualPanel_skin");
end

function Lua_RechargeRitualPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.roleIcon:setUrl("/images/common/ui_chuzhidali.png");
	self.roleIcon:SetDimensions(284, 418);
	self.roleIcon:setLocation(-389, -35, 0);

	self.dragWidth = 504;
	self.rewardList = Lua_DragList.new(self.content, 2, Vector4(0, 0, self.dragWidth, 66));
	self.rewardList:setListCell(Lua_RechargeRitualItem, 66, 84, 999);
	self.rewardList:setLocation(124, -40, 0);

	self.getBtn:addClickFuntion(self, self.onGetBtnClick);
	self.chargeBtn:addClickFuntion(self, self.onChargeBtnClick);

	self:addLuaEvent("SET_NATIONAL_FESTIVAL", self, self.updatePanelInfo);
	sendMsg(11400021);
end

function Lua_RechargeRitualPanel:updatePanelInfo()
	local arr = DataCenter.OperationalActivitiesData:getNationalFestivalData(self.first_type);
	local draw_flag = arr.reward_info[1].draw_flag;
	if draw_flag == 0 then
		self.getBtn.label = LanUtil.getValue(124514);
	elseif draw_flag == 1 then
		self.getBtn.label = LanUtil.getValue(124515);
	else
		self.getBtn.label = LanUtil.getValue(124514);
	end
	self.getBtn:setBtnEnable(draw_flag == 0);
	self.redDot:setEnable(draw_flag == 0);

	local isShow;
	local rewardArr = Array();
	for k,v in ipairs(arr.reward_info[1].reward_set) do
		isShow = false;
		for j,p in ipairs(arr.reward_info[1].spec_effect_item) do
			if v.id == tonumber(p) then
				isShow = true;
			end
		end
		rewardArr:add({data = v, isShow = isShow});
	end
	self.rewardList:setLuaArrayData(rewardArr, false);

	local len = rewardArr:getSize();
	local posX = len * 84 > self.dragWidth and 124 or 124 + (self.dragWidth - len * 84) / 2;
	self.rewardList:setLocation(posX, -40, 0);

	self.eTimeNum = tonumber(tostring(arr.stop_tick));
	self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(124507), TimeTransform.getInstance():transSeconds9(self.eTimeNum - tonumber(tostring(GlobalVar.cur_tick))));
	self:startTimer();
	self:updateActTime();
end

function Lua_RechargeRitualPanel:startTimer()
	if self.countDown ~= true then
		self.countDown = true;
		Lua_CommonUtil.addTimer("Lua_RechargeRitualPanel", 1, self, self.updateActTime);
	end
end

function Lua_RechargeRitualPanel:updateActTime()
	self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(124507), TimeTransform.getInstance():transSeconds9(self.eTimeNum - tonumber(tostring(GlobalVar.cur_tick))));
	if self.eTimeNum - tonumber(tostring(GlobalVar.cur_tick)) <= 0 then
		self:endTimer();
	end
end

function Lua_RechargeRitualPanel:endTimer()
	if self.countDown == true then
		self.countDown = false;
		Lua_CommonUtil.removeTimer(self, self.updateActTime);
	end
end

function Lua_RechargeRitualPanel:onGetBtnClick()
	sendMsg(11400022);
	sendMsg(11400021);
end

function Lua_RechargeRitualPanel:onChargeBtnClick()
	Lua_WindowUtil.openWin("Lua_ChongzhiWindow",WinParam.ACTION_OPEN,1);
	Lua_WindowUtil.openWin("Lua_GrandCeremonyWindow",WinParam.ACTION_CLOSE);
end

function Lua_RechargeRitualPanel:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self:endTimer();

	self:superCall("dispose");
end





--------------------------------------------------





Lua_RechargeRitualItem = class("Lua_RechargeRitualItem", Lua_ListCell);
function Lua_RechargeRitualItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_RechargeRitualItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setDepth(5);
	self.itemImg:setScale(0.8, 0.8);
	self.itemImg:setCanClick(false);
end

function Lua_RechargeRitualItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local tvo = Lua_ToolVo.createToolVo(data.data.id, data.data.amount, data.data.bind == 2 and 1 or data.data.bind);
	tvo.star = data.data.equipment.star;

	self.itemImg.data = tvo;
	self.itemImg:showMaskSp(false);
	self.itemImg:showNotYetImg(false);
	if data.isShow then
		self.itemImg:showRoundEff(true);
	end
end

function Lua_RechargeRitualItem:onPlayerSoundClick(go)
	if self._data.data ~= nil then
		Lua_PackUtil.showItemInfo(self.itemImg.data);
	end
end

function Lua_RechargeRitualItem:checkOutBound(showRect)
	if self._data ~= nil then
		local width = self.itemImg.item_bg.width * 0.8;
		local height = self.itemImg.item_bg.width * 0.8;
		local rect = Lua_Rectangle.new(self.itemX - width / 2, self.itemY - height / 2, width, height);
		self.itemImg:showRoundEff(showRect:containeRect(rect));
	end
end

function Lua_RechargeRitualItem:dispose()
	if self.itemImg ~= nil then
		self.itemImg:dispose();
		self.itemImg = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end