Lua_GroupBuyBoxItem = class("Lua_GroupBuyBoxItem", Lua_DisplayObject);
function Lua_GroupBuyBoxItem:ctor(p)
    self:superCall("ctor", p, "GroupBuyBoxItem_skin");
end
function Lua_GroupBuyBoxItem:buildShowItem()
    self:superCall("buildShowItem");
    self.box:addClickFuntion(self, self.onClick);
    if self.effect == nil then
        self.effect = UICreate.createUIEffect(self.box.mainContent, "/effects/scsEffects/gui_fallen_gift", "gui_fallen_gift", 0, 0);
        self.effect:SetRenderQueue(self.box, 5, 2, false);
    end
end

function Lua_GroupBuyBoxItem:setData(data)
    self.data = data;
    self.num.text = self.data.count;
    self.vip.text = LanUtil.formateStr(LanUtil.getValue(160103), tostring(self.data.vipLevel));
    self.vip:setEnable(self.data.vipLevel ~= 0);
    local spriteName = self.data.state == 2 and "ui_daily_icon_bx2" or "ui_daily_icon_bx";
    self.box:setAltas("groupBuy_atlas", spriteName);
    self.box:resetSize();
    self.box.mouseEnable = self.data.state ~= 2;
    self.effect:setEnable(self.data.state == 1);
end

function Lua_GroupBuyBoxItem:onClick()
    if self.data.state == 1 then
        Lua_ProxyManager.getProxy("Lua_GroupBuyProxy"):sGroupBuyGetRewards(self.data.index);
    elseif self.data.state == 0 then
        Lua_WindowUtil.openWin("Lua_GroupBuyRewardShowWindow", nil, self.data);
    end
end

function Lua_GroupBuyBoxItem:dispose()
    self:superCall("dispose");
end
