checkRequire("Lua_NumberInputItem");
Lua_GroupBuyShopBuyWindow = class("Lua_GroupBuyShopBuyWindow", Lua_Window);
function Lua_GroupBuyShopBuyWindow:ctor()
	self:superCall("ctor");
	self.windowName = "Lua_GroupBuyShopBuyWindow";
	self.skinName = "GroupBuyShopBuyWindow_skin";
end

function Lua_GroupBuyShopBuyWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setDepth(3);
	self.itemImg:setLocation(-120, 120, 0);

	self.numItem = Lua_NumberInputItem.new(self.content);
	self.numItem.owner = self;
	self.numItem.callBack = self.onNumChange;
	self.numItem:setDepth(3);
	self.numItem:setAddTen(true);
	self.numItem:setMinMaxValue(1, 999);
	self.numItem:setWindowOffset(305, -70);
	self.numItem:setLocation(-65, -25, 0);

	self.subBtn:addClickFuntion(self,self.onBuyClick);
end

function Lua_GroupBuyShopBuyWindow:showWin(param)
	self.data = param;

	self.itemImg.data = self.data.itemVo;
	self.itemTxt.text = self.data.itemVo.colorName;
	self.perTxt.text = tostring(self.data.curPrice);

	local count = self.data.count == -1 and 999 or self.data.count;
	self.limitCount.text = LanUtil.formateStr(LanUtil.getValue(160110), tostring(count));
	self.limitCount:setEnable(self.data.count ~= -1);
	
	self.numItem:setMinMaxValue(1, count);
	self.numItem:setNum(1);

	local moneyType = self.data.moneyType;
	local atlas = Lua_MoneyData.getMoneyIconAtlas(moneyType);
	local sprite = Lua_MoneyData.getIconSpByMoneyType(moneyType);
	self.moneyIcon1:setAltas(atlas, sprite);
	self.moneyIcon2:setAltas(atlas, sprite);
end

function Lua_GroupBuyShopBuyWindow:onNumChange(val)
	local costNum = val * self.data.curPrice;
	if DataCenter.moneyData:isMoneyEnough(self.data.moneyType, costNum, false, false) == true then
		self.allTxt.text = Lua_ColorDefine.colorStr(tostring(costNum), Lua_ColorDefine.GREEN_STR);
	else
		self.allTxt.text = Lua_ColorDefine.colorStr(tostring(costNum), Lua_ColorDefine.RED_STR);
	end
end

function Lua_GroupBuyShopBuyWindow:onBuyClick(go)
	self.needMoney = self.numItem.num * self.data.curPrice;
	if self.data.moneyType == Lua_MoneyData.GOLD or self.data.moneyType == Lua_MoneyData.BIND_GOLD then
		self:openTipWindow();
		return;
	end
	self:checkMoney();
end

function Lua_GroupBuyShopBuyWindow:openTipWindow()
	local moneyName = Lua_MoneyData:getNameByType(self.data.moneyType);
	local str = self.needMoney .. moneyName;
	local tipData = {};
	tipData.des = LanUtil.formateStr(LanUtil.getValue(160111), str);
	tipData.owner = self;
	tipData.type = 1;
	tipData.subFun = self.checkMoney;
	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
end

function Lua_GroupBuyShopBuyWindow:checkMoney()
	if DataCenter.moneyData:isMoneyEnough(self.data.moneyType, self.needMoney, true, true) == true then
		local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
		local leftNum = bagData:getLeftSize()
		if leftNum <= 0 then
			if Lua_WindowUtil.isWindowShowing("Lua_TipsWindow") == false and Lua_WindowUtil.isWindowShowing("Lua_PackWindow") == false then
				DataCenter.packData:showFullBagTip(Lua_PackData.BAG_PACK);
			end
			return;
		end
		self:sendMessage();
	end
end

function Lua_GroupBuyShopBuyWindow:sendMessage()
	Lua_ProxyManager.getProxy("Lua_GroupBuyProxy"):sGroupBuyShop(self.data.index, self.numItem.num);
end