Lua_GroupBuyShopItem = class("Lua_GroupBuyShopItem", Lua_ListCell);
function Lua_GroupBuyShopItem:ctor(p)
    self:superCall("ctor", p, "GroupBuyShopItem_skin");
end
function Lua_GroupBuyShopItem:buildShowItem()
    self:superCall("buildShowItem");
    
    self.buyBtnTxt.text = LanUtil.getValue(160106);
    self.buyBtn:addClickFuntion(self, self.buyClick);

    if self.itemImage == nil then
        self.itemImage = Lua_ToolImage.new(self.content);
        self.itemImage:setLocation(-86, 0, 0);
        self.itemImage:setDepth(10);
    end
end

function Lua_GroupBuyShopItem:setData(data)
    self.data = data;
    self.itemImage.data = self.data.itemVo;
    self.name.text = self.data.itemVo.colorName;
    self.priceDes1.text = LanUtil.formateStr(LanUtil.getValue(160107), self.data.orPrice);
    self.priceDes2.text = LanUtil.formateStr(LanUtil.getValue(160113), self.data.curPrice);

    local moneyType = self.data.moneyType;
    local atlas = Lua_MoneyData.getMoneyIconAtlas(moneyType);
    local sprite = Lua_MoneyData.getIconSpByMoneyType(moneyType);
    self.moneyIcon1:setAltas(atlas, sprite);
    self.moneyIcon1:setLocation(-17 + self.priceDes1.width, 23, 0);
    self.moneyIcon2:setAltas(atlas, sprite);
    self.moneyIcon2:setLocation(-17 + self.priceDes1.width, -5, 0);

    self.endSp:setEnable(self.data.state == 1);
    self.buyBtn:setEnable(self.data.state ~= 1);
    self.buyBtnTxt:setEnable(self.data.state ~= 1);
    local color = self.data.count == 0 and " [FF1616]" or " [00E125]";
    if self.data.count == -1 then
        self.countDes.text = LanUtil.getValue(160112);
    else
        self.countDes.text = LanUtil.getValue(self.data.shopType == 1 and 160101 or 160102) .. color .. self.data.count .. "[-]" .. "[00E125]/" .. self.data.totleCount .. "[-]";
    end
end

function Lua_GroupBuyShopItem:buyClick()
    Lua_WindowUtil.openWin("Lua_GroupBuyShopBuyWindow", nil, self.data);
end

function Lua_GroupBuyShopItem:checkOutBound(showRect)
    if self.data == nil then
        self.inViewEffect = false;
        self:updateEffectState();
        return;
    end
    local rect = Lua_Rectangle.new(self.itemX - 112, self.itemY - 37, 74, 74);
    self.inViewEffect = showRect:containeRect(rect);
    self:updateEffectState();
end

function Lua_GroupBuyShopItem:updateEffectState()
    if self.inViewEffect == true then
        if self.itemImage.roundEff == nil and self.itemImage.data.show_effect == 1 then
            self.itemImage:showRoundEff(true);
        end
    else
        if self.itemImage.roundEff ~= nil then
            self.itemImage:showRoundEff(false);
        end
    end
end

function Lua_GroupBuyShopItem:dispose()
    self:superCall("dispose");
end
