checkRequire("Lua_GroupBuyShopItem")
checkRequire("Lua_GroupBuyBoxItem")
Lua_GroupBuyWindow = class("Lua_GroupBuyWindow", Lua_Window);

function Lua_GroupBuyWindow:ctor()
    self:superCall("ctor");
    self.windowName = "Lua_GroupBuyWindow";
    self.skinName = "GroupBuyWindow_skin";
    self.showTitle = false;
end

function Lua_GroupBuyWindow:buildShowItem()
    self:superCall("buildShowItem");
    DataCenter.redDotData:updateRedDotVoState(22503, false);
    self:addListener();
    self:createDragList();
    self.boxArr = Array();

    self.proBar.type = UIBasicSprite.Type.Filled;
    self.proBar.fillDirection = UIBasicSprite.FillDirection.Horizontal;
    self.proBar.fillAmount = 0;

    Lua_ProxyManager.getProxy("Lua_GroupBuyProxy"):sGroupBuyInfo();
end

function Lua_GroupBuyWindow:addListener()
    self:addLuaEvent("UPDATE_GROUP_BUY_PANEL", self, self.updatePanel);
    self:addLuaEvent("UPDATE_GROUP_BUY_REAWARD", self, self.updateRewardInfo);
    self:addLuaEvent("UPDATE_GROUP_BUY_SHOP_ITEM", self, self.updateShopInfo);
    self:addLuaEvent("UPDATE_GROUP_BUY_LIMITTED_TIMES", self, self.updateBuyTimes);
end

function Lua_GroupBuyWindow:createDragList()
    self.itemDragList = Lua_DragList.new(self.content, 2, Vector4(0, 0, 935, 176));
    self.itemDragList:setListCell(Lua_GroupBuyShopItem, 176, 310, 999);
    self.itemDragList:setLocation(148, 20, 0);
end

function Lua_GroupBuyWindow:updatePanel()
    self:updateRewardInfo();
    self:updateBuyTimes();
    self.des.text = DataCenter.groupBuyData.des;

    self.totalTime = DataCenter.groupBuyData.totalTime;
    local leftTime = self.totalTime - tonumber(tostring(GlobalVar.cur_tick));
    self.timeDes.text = LanUtil.formateStr(LanUtil.getValue(160104), TimeTransform.getInstance():transSeconds1(leftTime, true));
    self:addTimer("onActivityTimeDown", 1, self, self.onActivityTimeDown);
end

function Lua_GroupBuyWindow:updateBuyTimes()
    self.buyDes.text = LanUtil.formateStr(LanUtil.getValue(160105), DataCenter.groupBuyData.progress);
    self:updateShopInfo();
end

function Lua_GroupBuyWindow:updateShopInfo()
    local shopList = DataCenter.groupBuyData.shopList;
    self.itemDragList:setLuaArrayData(shopList, false);

    local peopleNum = DataCenter.groupBuyData.progress;
    local val = peopleNum > self.totleNum and self.totleNum or peopleNum;
    self.proBar.fillAmount = val / self.totleNum;
end

function Lua_GroupBuyWindow:updateRewardInfo()
    local rewardList = DataCenter.groupBuyData.rewardList;
    local len = rewardList:getSize();
    self.totleNum = rewardList[len].count;
    for i = 1, len do
        if self.boxArr[i] == nil then
            local count = rewardList[i].count
            local box = Lua_GroupBuyBoxItem.new(self.content);
            box:setLocation(-305 + 912 * count / self.totleNum - 30, -145, 0);
            self.boxArr:add(box);
        end
        self.boxArr[i]:setData(rewardList[i]);
    end
end

function Lua_GroupBuyWindow:onActivityTimeDown()
    local leftTime = self.totalTime - tonumber(tostring(GlobalVar.cur_tick));
    self.timeDes.text = LanUtil.formateStr(LanUtil.getValue(160104), TimeTransform.getInstance():transSeconds1(leftTime, true));
    if leftTime <= 0 then
        Lua_CommonUtil.removeTimer(self, self.onActivityTimeDown);
    end
end

function Lua_GroupBuyWindow:dispose()
    Lua_ProxyManager.getProxy("Lua_GroupBuyProxy"):sClosePanel();
    Lua_CommonUtil.removeTimer(self, self.onActivityTimeDown);
    self:superCall("dispose");
end