checkRequire("Lua_JinJieBenefitItem");
checkRequire("Lua_JinJieBenefitRewardItem");
Lua_JinJieBenefitPanel = class("Lua_JinJieBenefitPanel", Lua_DisplayObject);
function Lua_JinJieBenefitPanel:ctor(p)
	self:superCall("ctor", p, "JinJieBenefitPanel_skin");
end

function Lua_JinJieBenefitPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.giftBtnList = Lua_DragList.new(self.content, 2, Vector4(0, 0, 950, 166));
	self.giftBtnList:setListCell(Lua_JinJieBenefitItem, 166, 294, 999);
	self.giftBtnList:setLocation(0, 83, 0);

	self.dragPosy = -90;
	self.rewardList = Lua_DragList.new(self.content, 2, Vector4(0, 0, 340, 70));
	self.rewardList:setListCell(Lua_JinJieBenefitRewardItem, 70, 85, 999);
	self.rewardList:setLocation(202, self.dragPosy, 0);

	self.buyBtn:addClickFuntion(self, self.onBuyClick);

	self:addLuaEvent("UPDATA_JIN_JIE_BENEFIT_PANEL", self, self.updateInfo);
	self:addLuaEvent("UPDATE_BENEFIT_PANEL_CLICK", self, self.BtnChildCellClick);
end

function Lua_JinJieBenefitPanel:updateInfo(btnType)
	self.giftType = btnType;
	self.upTypeIcon:setAltas("jinJieBenefit_atlas", "ui_jjth_z_0" .. btnType);

	self.totalTime = DataCenter.jinJieBenefitData.end_tick;
	local leftTime = self.totalTime - tonumber(tostring(GlobalVar.cur_tick));
	self.time.text = LanUtil.formateStr(LanUtil.getValue(145603), TimeTransform.getInstance():transSeconds1(leftTime, true));
	self:addTimer("onActivityTimeDown", 1, self, self.onActivityTimeDown);

	self.giftList = DataCenter.jinJieBenefitData:getInfoByType(btnType);
	for i = 1, self.giftList.gift:getSize() do
		self.giftList.gift[i].idx = i;
	end

	if self.selectedIndex == nil or self.giftList.gift[self.selectedIndex] == nil then
		self.selectedNum = 1;
	else
		self.selectedNum = self.selectedIndex;
	end
	
	self.giftBtnList:setLuaArrayData(self.giftList.gift, false);
	self.giftBtnList:setSelected(self.selectedNum);

	self:BtnChildCellClick(self.giftList.gift[self.selectedNum]);
end

function Lua_JinJieBenefitPanel:BtnChildCellClick(oneGiftInfo)
	self.rewardInfo = oneGiftInfo;
	self.selectedIndex = oneGiftInfo.idx;

	local len = oneGiftInfo.item:getSize();
	local posX = len * 85 > 340 and 202 or 202 + (340 - len * 85) / 2;
	self.rewardList:setLuaArrayData(oneGiftInfo.item, false);
	self.rewardList:setLocation(posX, self.dragPosy, 0);

	self.olePriceLab.text = LanUtil.formateStr(LanUtil.getValue(145600), tostring(oneGiftInfo.price));
	self.curPriceLab.text = LanUtil.formateStr(LanUtil.getValue(145601), tostring(oneGiftInfo.curPrice));
	if oneGiftInfo.limitNum > 0 then
		self.limitTxt.text = LanUtil.formateStr(LanUtil.getValue(145604), tostring(oneGiftInfo.limitNum));
	else
		self.limitTxt.text = LanUtil.formateStr(LanUtil.getValue(145605), tostring(oneGiftInfo.limitNum));
	end
	
	if oneGiftInfo.state == 1 then
		self.buyBtn:setGray(true);
		self.buyBtn.label = LanUtil.getValue(127406);
	else
		self.buyBtn:setGray(false);
		self.buyBtn.label = LanUtil.getValue(145602);
	end
end

function Lua_JinJieBenefitPanel:onBuyClick(val)
	if self.rewardInfo.state == 1 then return end;
	local goldNum = DataCenter.moneyData:getMoney(Lua_MoneyData.GOLD);
	if goldNum < self.rewardInfo.curPrice then
		Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, des = LanUtil.getValue(122521), type = 1, subFun = self.openChargeWin});
		return;
	end

	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	if bagData:getLeftSize() <= 0 then
		if Lua_WindowUtil.isWindowShowing("Lua_TipsWindow") == false and Lua_WindowUtil.isWindowShowing("Lua_PackWindow") == false then
			DataCenter.packData:showFullBagTip(Lua_PackData.BAG_PACK);
		end
		return;
	end
	Lua_ProxyManager.getProxy("Lua_JinJieBenefitProxy"):sGetReward(self.selectedIndex - 1, self.giftType);
end

function Lua_JinJieBenefitPanel:openChargeWin()
	Lua_WindowUtil.openWin("Lua_ChongzhiWindow", WinParam.ACTION_OPEN, 1);
end

function Lua_JinJieBenefitPanel:onActivityTimeDown()
	local leftTime = self.totalTime - tonumber(tostring(GlobalVar.cur_tick));
	self.time.text = LanUtil.formateStr(LanUtil.getValue(145603), TimeTransform.getInstance():transSeconds1(leftTime, true));
	if leftTime <= 0 then
		Lua_CommonUtil.removeTimer(self, self.onActivityTimeDown);
	end
end

function Lua_JinJieBenefitPanel:dispose()
	if self.giftBtnList ~= nil then
		self.giftBtnList:dispose();
		self.giftBtnList = nil;
	end
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end

	self:superCall("dispose");    
end