-- 超值特惠
checkRequire("Lua_JinJieBenefitPanel");
Lua_JinJieBenefitWindow = class("Lua_JinJieBenefitWindow", Lua_Window);
function Lua_JinJieBenefitWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_JinJieBenefitWindow";
	self.skinName = "JinJieBenefitWindow_skin";
end

function Lua_JinJieBenefitWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.btnList = Lua_DragList.new(self.content, 2, Vector4(0, 0, 830, 58));
	self.btnList:setLocation(-47, 215, 0);
	self.btnList:setListCell(Lua_JinJieBenefitBtnItem, 58, 153, 999);

	self.curPanel = Lua_JinJieBenefitPanel.new(self.content);

	-- 移除登录红点
	DataCenter.redDotData:updateRedDotVoState(22303, false);

	self:addLuaEvent("UPDATE_BENEFIT_DATA", self, self.createButtonList);
	self:addLuaEvent("ON_JINJIEBENEFIT_ITEM_CLICK", self, self.updateJinJieBeneFitPanelInfo);
	Lua_ProxyManager.getProxy("Lua_JinJieBenefitProxy"):sInformation();
end

function Lua_JinJieBenefitWindow:createButtonList()
	local giftList = DataCenter.jinJieBenefitData.giftList;
	if giftList:getSize() <= 0 then
		return;
	end

	local selectNum = self.selectedIndex == nil and 1 or self.selectedIndex;
	for i = 1, giftList:getSize() do
		giftList[i].index = i;
	end
	self.btnList:setLuaArrayData(giftList, false);
	self.btnList:setSelected(selectNum);
	self:updateJinJieBeneFitPanelInfo(giftList[selectNum]);
end

function Lua_JinJieBenefitWindow:updateJinJieBeneFitPanelInfo(oneGiftInfo)
	self.selectedIndex = oneGiftInfo.index;
	Lua_MsgUtil.callFunc("UPDATA_JIN_JIE_BENEFIT_PANEL", oneGiftInfo.giftType);
end

function Lua_JinJieBenefitWindow:dispose()
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.curPanel ~= nil then
		self.curPanel:dispose();
		self.curPanel = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_JinJieBenefitBtnItem = class("Lua_JinJieBenefitBtnItem", Lua_ListCell);
function Lua_JinJieBenefitBtnItem:ctor(p)
	self:superCall("ctor", p, "JinJieBenefitBtnItem_skin");
end

function Lua_JinJieBenefitBtnItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.nameLab.text = data.title;
end

function Lua_JinJieBenefitBtnItem:onPlayerSoundClick()
	Lua_MsgUtil.callFunc("ON_JINJIEBENEFIT_ITEM_CLICK", self._data);
end

function Lua_JinJieBenefitBtnItem:onSelectionChange(val)
	self:superCall("onSelectionChange", val);
	
	if val then
		self.itemBg:setAltas("common_atlas_2", "ui_common_btn_y13");
		self.itemBg:setLocation(0, 3, 0);

		self.nameLab.colorStr = Lua_ColorDefine.transColor("FFFFFF");
		self.nameLab:setLocation(0, 5, 0);
	else
		self.itemBg:setAltas("common_atlas_2", "ui_common_btn_y12");
		self.itemBg:setLocation(0, -3, 0);

		self.nameLab.colorStr = Lua_ColorDefine.transColor("8ABAC8");
		self.nameLab:setLocation(0, -1, 0);
	end
end

function Lua_JinJieBenefitBtnItem:dispose()
	self._data = nil;
	self:superCall("dispose");
end