-- 全民BOSS 1056
Lua_BossEveryoneActPanel = class("Lua_BossEveryoneActPanel", Lua_DisplayObject)
function Lua_BossEveryoneActPanel:ctor(p)
	self:superCall("ctor", p, "OpenCommonPanel_skin");
end

function Lua_BossEveryoneActPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.roleBg:setUrl("/images/openDressCarnival/kfkh_bossEveryone.png");

	self.dragList = Lua_DragList.new(self.content,1, Vector4(0, 0, 715, 320));
	self.dragList:setListCell(Lua_BossEveryoneActItem, 119, 504, 1);
	self.dragList:setLocation(108, -126, 0);

	self:addLuaEvent("UPDATE_ACT_BOSS_EVERYONE", self, self.updatePanelInfo);
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sGetActivityInfo(Lua_OperationalActivitiesData.ACT_BOSS_EVERYONE);
end

function Lua_BossEveryoneActPanel:updatePanelInfo()
	local start_tick = tonumber(DataCenter.killBossActData.bossEveryone_startTick);
	local sTimeStr = TimeTransform.getInstance():transSeconds8(start_tick, "yyyy-MM-dd HH:mm");
	local end_tick = tonumber(DataCenter.killBossActData.bossEveryone_endTick);
	local eTimeStr = TimeTransform.getInstance():transSeconds8(end_tick, "yyyy-MM-dd HH:mm");
	self.open_time.text = LanUtil.formateStr(LanUtil.getValue(141600), tostring(sTimeStr .. "--" .. eTimeStr));

	local content = DataCenter.killBossActData.bossEveryone_content;
	self.tips.text = LanUtil.formateStr(LanUtil.getValue(141602), tostring(content));

	Lua_CommonUtil.addTimer("BossEveryoneAct_ResidueTime", 1, self, self.updateResidueTime);
	self:updateResidueTime();

	local data = DataCenter.killBossActData.getBossEveryoneData;
	self.dragList:setLuaArrayData(data, false);
end

-- 活动剩余时间
function Lua_BossEveryoneActPanel:updateResidueTime()
	local end_time = tonumber(DataCenter.killBossActData.bossEveryone_endTick) - DataCenter.roleData.serverTime;
	if end_time > 0 then
		self.end_time.text = LanUtil.formateStr(LanUtil.getValue(141601), TimeTransform.getInstance():transSeconds1(end_time, true));
	else
		self.end_time.text = LanUtil.getValue(141603);
		Lua_CommonUtil.removeTimer(self, self.updateResidueTime);
	end
end

function Lua_BossEveryoneActPanel:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	Lua_CommonUtil.removeTimer(self, self.updateResidueTime);

	self:superCall("dispose");
end










Lua_BossEveryoneActItem = class("Lua_BossEveryoneActItem", Lua_ListCell);
function Lua_BossEveryoneActItem:ctor(p)
    self:superCall("ctor", p, "BossFirstKillActItem_skin");
end

function Lua_BossEveryoneActItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemArr = Array();
	self.killerName:setEnable(false);
	self.leftArrow:setEnable(false);
	self.rightArrow:setEnable(false);

	self.bossIcon = UICreate.createImage(self.content, "", -199, 9, 80, 80);
	self.bossIcon.pivot = UIWidget.Pivot.Center;
	self.bossIcon:setUVRect(Vector4(0.01, 0, 1, 1));
	self.bossIcon:setDepth(2);

	self.redDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 445, 15, 0, 0);
	self.redDot.name = "redDot";
	self.redDot:setDepth(2);
	self.redDot:setEnable(false);

	self.subBtn:addClickFuntion(self, self.onSubBtnClick);
end

function Lua_BossEveryoneActItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	if self.bossIcon ~= nil then
		self.bossIcon:setUrl("/images/head/boss/" .. data.monster_icon .. ".png");
	end
	self.bossName.text = data.monster_name;
	self.bossInfo.text = data.monster_bornScene;
	self.bossLvl.text = LanUtil.formateStr(LanUtil.getValue(141606), tostring(data.monster_lvl));
	
	local maxNum = data.tvoArr:getSize() > self.itemArr:getSize() and data.tvoArr:getSize() or self.itemArr:getSize();
	local tvo;
	local itemImg;
	for i = 1, maxNum do
		itemImg = self.itemArr[i];
		if i <= data.tvoArr:getSize() then
			if itemImg == nil then
				itemImg = Lua_ToolImage.new(self.content);
				self.itemArr:add(itemImg);
			end
			itemImg.data = data.tvoArr[i];
			itemImg:setDepth(2);
			itemImg:setScale(0.8, 0.8, 0.8);
			itemImg:setLocation(72 + (i - 1) * 73, 0, 0);
			itemImg:setEnable(true);
		else
			if itemImg ~= nil then
				itemImg:setEnable(false);
			end
		end
	end

	if data.state == 0 then -- 不可领取
		self:updateRrefreshTime();
		self.subBtn.label = LanUtil.getValue(141608);
	elseif data.state == 1 then -- 可领取
		self.subBtn.label = LanUtil.getValue(140714);
	elseif data.state == 2 then -- 已领取
		self.subBtn.label = LanUtil.getValue(140715);
	end
	self.refreshTime:setEnable(data.state == 0);
	self.subBtn:setBtnEnable(data.state ~= 2);
	self.redDot:setEnable(data.state == 1);
end

function Lua_BossEveryoneActItem:checkOutBound(showRect)
	local width = 75 * 0.8;
	local height = 77 * 0.8;
	local rect = Lua_Rectangle.new(self.itemX - width / 2, self.itemY - height / 2, width, height);
	local isShow = showRect:containeRect(rect);
	for i = 1, self.itemArr:getSize() do
		if self.itemArr[i].data.subType ~= Lua_PackTypeDefine.STAMP_ITEM then
			self.itemArr[i]:showRoundEff(isShow and self.itemArr[i].data.roundEffect);
		else
			self.itemArr[i]:showStampEff(isShow and self.itemArr[i].data.roundEffect);
		end
	end
end

-- 刷新时间
function Lua_BossEveryoneActItem:updateRrefreshTime()
	self.refresh_time = tonumber(self.data.relive_sec);
	if self.refresh_time > 0 then
		Lua_CommonUtil.addTimer("BossEveryoneAct_RrefreshTime", 1, self, self.onRrefreshTimer);
		self.refreshTime.text = LanUtil.formateStr(LanUtil.getValue(141604), TimeTransform.getInstance():transSeconds6(self.refresh_time, true, true));
	else
		self.refreshTime.text = LanUtil.getValue(141605);
		Lua_CommonUtil.removeTimer(self, self.onRrefreshTimer);
	end
end

function Lua_BossEveryoneActItem:onRrefreshTimer()
	self.refresh_time = self.refresh_time - 1;
	if self.refresh_time > 0 then
		self.refreshTime.text = LanUtil.formateStr(LanUtil.getValue(141604), TimeTransform.getInstance():transSeconds6(self.refresh_time, true, true));
	else
		self.refreshTime.text = LanUtil.getValue(141605);
		Lua_CommonUtil.removeTimer(self, self.onRrefreshTimer);
	end
end

function Lua_BossEveryoneActItem:onSubBtnClick()
	if self.data.state == 0 then
		if self.data.illus_group_id ~= nil then
			if self.data.illus_group_id == 201 then -- 世界boss
				local secen_id = getConfig({"monster", self.data.monster_id, "scene_id"});
	            local sceneMinLevel = 0;
	            local sceneData = Lua_SceneConfigData.getSceneConfig(secen_id);
	            if secen_id ~= nil then
	                if sceneData ~= nil then
	                    sceneMinLevel = sceneData.config.level[1];
	                end
	            end
	            if DataCenter.roleData.level < sceneMinLevel then
	                OperateAlert.show(LanUtil.getValue(141609));
	                return;
	            end
			end

			local grouping_cfg = getConfig({"illus_upgrade_group", self.data.illus_group_id});
			if DataCenter.funcOpenData:isOpened(grouping_cfg.func_openId) == false then
				local func_cfg = getConfig( {"func_open", grouping_cfg.func_openId});
		        if func_cfg ~= nil and func_cfg.advance_message ~= nil then
		            OperateAlert.show(func_cfg.advance_message);
		            return;
		        end
		    end

			DataCenter.bossData.checkBossId = self.data.monster_id;
			if self.data.illus_group_id == 205 then
				Lua_WindowUtil.openWin("Lua_BossMainWindow", WinParam.ACTION_OPEN, 5); -- 神兽岛特殊处理
			else
				Lua_WindowUtil.openWin("Lua_BossMainWindow", WinParam.ACTION_OPEN, Lua_BossData.BOSS_NAME_2_INDEX[grouping_cfg.illus_group_name]);
			end
			Lua_WindowUtil.openWin("Lua_OpenDressCarnivalWindow", WinParam.ACTION_CLOSE, nil);
			Lua_WindowUtil.openWin("Lua_GrandCeremonyWindow", WinParam.ACTION_CLOSE, nil);
			Lua_WindowUtil.openWin("Lua_SuitWindow", WinParam.ACTION_CLOSE, nil);
		end
	elseif self.data.state == 1 then
		local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
		local leftNum = bagData:getLeftSize();
		if leftNum <= 0 then
			DataCenter.packData:showFullBagTip(Lua_PackData.BAG_PACK);
			return;
		end
		Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sGetActivityRewards(Lua_OperationalActivitiesData.ACT_BOSS_EVERYONE, self.data.index);
	end
end

function Lua_BossEveryoneActItem:dispose()
	Lua_CommonUtil.removeTimer(self, self.onRrefreshTimer);
    self:superCall("dispose");
end