-- BOSS首杀
Lua_BossFirstKillActPanel = class("Lua_BossFirstKillActPanel", Lua_DisplayObject)
function Lua_BossFirstKillActPanel:ctor(p)
	self:superCall("ctor", p, "BossFirstKillActPanel_skin");
end

function Lua_BossFirstKillActPanel:buildShowItem()
    self:superCall("buildShowItem");

    Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sGetActivityInfo(Lua_OperationalActivitiesData.ACT_BOSS_FIRSTKILL);

    self.dragList = Lua_DragList.new(self.content,1, Vector4(0, -9, 715, 294));
    self.dragList:setLocation(108, -130, 0);
    self.dragList:setListCell(Lua_BossFirstKillActItem, 119, 502, 1);

    self:addLuaEvent("UPDATE_ACT_BOSS_FIRSTKILL",self,self.updatePanelInfo);
end

function Lua_BossFirstKillActPanel:dispose()
	if self.dragList ~= nil then
        self.dragList:dispose();
        self.dragList = nil;
    end

    Lua_CommonUtil.removeTimer(self, self.updateResidueTime);

    self:superCall("dispose");
end

function Lua_BossFirstKillActPanel:updatePanelInfo()
	local start_tick = tonumber(DataCenter.killBossActData.bossFirstKill_startTick);
	local end_tick = tonumber(DataCenter.killBossActData.bossFirstKill_endTick);
	local content = DataCenter.killBossActData.bossFirstKill_content;

	local sTimeStr = TimeTransform.getInstance():transSeconds8(start_tick, "yyyy-MM-dd HH:mm");
	local eTimeStr = TimeTransform.getInstance():transSeconds8(end_tick, "yyyy-MM-dd HH:mm");
	self.actTime.text = LanUtil.formateStr(LanUtil.getValue(141600), tostring(sTimeStr .. "--" .. eTimeStr));
	self.actContent.text = LanUtil.formateStr(LanUtil.getValue(141602), tostring(content));
	Lua_CommonUtil.addTimer("BossFirstKillAct_ResidueTime", 1, self, self.updateResidueTime, nil, -1);
	self:updateResidueTime();
	
    local data = DataCenter.killBossActData.getBossFirstKillData;
	self.dragList:setLuaArrayData(data, false);
end

-- 活动剩余时间
function Lua_BossFirstKillActPanel:updateResidueTime()
	local end_time = tonumber(DataCenter.killBossActData.bossFirstKill_endTick) - DataCenter.roleData.serverTime;
	if end_time > 0 then
		self.endTime.text = LanUtil.formateStr(LanUtil.getValue(141601), TimeTransform.getInstance():transSeconds1(end_time, true));
	else
		self.endTime.text = LanUtil.getValue(141603);
		Lua_CommonUtil.removeTimer(self, self.updateResidueTime);
	end
end




















---------------------------------------------------------------------------
Lua_BossFirstKillActItem = class("Lua_BossFirstKillActItem", Lua_ListCell);
function Lua_BossFirstKillActItem:ctor(p)
    self:superCall("ctor", p, "BossFirstKillActItem_skin");
end

function Lua_BossFirstKillActItem:buildShowItem()
    self:superCall("buildShowItem");

	self.killerName:setEnable(false);
	self.leftArrow:setEnable(false);
    self.rightArrow:setEnable(false);
    self.subBtn:addClickFuntion(self, self.onSubBtnClick);
    
    if self.bossIcon == nil then
        self.bossIcon = UICreate.createImage(self.content, "", 0, 0, 80, 80);
        self.bossIcon:setUVRect(Vector4(0.01, 0, 1, 1));
        self.bossIcon.pivot = UIWidget.Pivot.Center;
        self.bossIcon:setLocation(-199, 9.5, 0);
        self.bossIcon:setDepth(2); 
    end

    self.rewardArr = Array();
end

function Lua_BossFirstKillActItem:setData(data)
	if data ~= nil then
		self.data = data;

		if self.bossIcon ~= nil then
		    self.bossIcon:setUrl("/images/head/boss/" .. data.monster_icon .. ".png");
		end
		self.bossName.text = data.monster_name;
		self.bossInfo.text = data.monster_bornScene;
		self.bossLvl.text = LanUtil.formateStr(LanUtil.getValue(141606), tostring(data.monster_lvl));
		self:creationRewardCell();

		if tonumber(data.kill_role_id) == 0 then
			self.killerName:setEnable(false);
			self.subBtn:setEnable(true);
			self.subBtn.label = LanUtil.getValue(141608);

			self.refreshTime:setEnable(true);
			self:updateRrefreshTime();
		else
			self.subBtn:setEnable(false);
			self.refreshTime:setEnable(false);

			self.killerName:setEnable(true);
			if data.kill_type == 1 then
				self.killerName.text = data.kill_name;
			elseif data.kill_type == 2 then
				self.killerName.text = LanUtil.formateStr(LanUtil.getValue(141607), data.kill_name);
			end
		end
	end
end

-- 创建奖励道具
function Lua_BossFirstKillActItem:creationRewardCell()
	local data = self.data.reward_data;
	self.len = data:getSize();
	local num = self.rewardArr:getSize() - self.len;

	local itemImg;
	while(num > 0) do
		itemImg = self.rewardArr:shift();
		itemImg:dispose();
		num = num - 1;
	end

	while (num < 0) do
		itemImg = Lua_ToolImage.new(self.content);
		itemImg:setDepth(5);
		itemImg:setScale(0.8, 0.8, 0.8);
		itemImg:setEnable(false);
		itemImg:setCanClick(true);
		self.rewardArr:add(itemImg);
		num = num + 1;
	end

	self:setItemImgData();
end

function Lua_BossFirstKillActItem:setItemImgData()
	local sortNum = 1;
	for i=1, self.len do
		self.rewardArr[i]:setLocation(72 + (sortNum - 1) * 73, 0, 0);
		self.rewardArr[i].data = self.data.reward_data[i].vo;
		self.rewardArr[i]:setEnable(true);
		if self.data.reward_data[i].show_effect == 1 then
			self.rewardArr[i]:showRoundEff(true);
			if roundEff ~= nil then
				self.rewardArr[i].roundEff:setSacle(0.9,0.9,0.9);
				self.rewardArr[i].roundEff:SetRenderQueue(self.rewardArr[i].item_bg, 5, 2, true);
			end
		end
		sortNum = sortNum + 1;
	end
end

function Lua_BossFirstKillActItem:checkOutBound(showRect)
	local len = self.rewardArr:getSize();
	for i=1,len do
		if self.rewardArr[i].roundEff ~= nil then
			local rect = Lua_Rectangle.new(self.itemX, self.itemY - 25, 25, 50);
			if showRect:containeRect(rect) == true then
				self.rewardArr[i].roundEff:setEnable(true);
			else
				self.rewardArr[i].roundEff:setEnable(false);
			end
		end

		if self.rewardArr[i].data.subType == Lua_PackTypeDefine.STAMP_ITEM then
			if self.rewardArr[i].stampEff ~= nil then
				local rect = Lua_Rectangle.new(self.itemX, self.itemY - 25, 25, 50);
				if showRect:containeRect(rect) == true then
					self.rewardArr[i].stampEff:setEnable(true);
				else
					self.rewardArr[i].stampEff:setEnable(false);
				end
			end
		end
		
		if self.rewardArr[i].data.subType == Lua_PackTypeDefine.ARMY_EQUIP_ITEM then
			if self.rewardArr[i].armyEff ~= nil then
				local rect = Lua_Rectangle.new(self.itemX, self.itemY - 25, 25, 50);
				if showRect:containeRect(rect) == true then
					self.rewardArr[i].armyEff:setEnable(true);
				else
					self.rewardArr[i].armyEff:setEnable(false);
				end
			end
		end
	end
end

-- 刷新时间
function Lua_BossFirstKillActItem:updateRrefreshTime()
	self.refresh_time = tonumber(self.data.relive_sec);
	if self.refresh_time > 0 then
		Lua_CommonUtil.addTimer("BossFirstKillAct_RrefreshTime", 1, self, self.onRrefreshTimer, nil, -1);
		self.refreshTime.text = LanUtil.formateStr(LanUtil.getValue(141604), TimeTransform.getInstance():transSeconds6(self.refresh_time, true, true));
	else
		self.refreshTime.text = LanUtil.getValue(141605);
		Lua_CommonUtil.removeTimer(self, self.onRrefreshTimer);
	end
end

function Lua_BossFirstKillActItem:onRrefreshTimer()
	self.refresh_time = self.refresh_time - 1;
	if self.refresh_time > 0 then
		self.refreshTime.text = LanUtil.formateStr(LanUtil.getValue(141604), TimeTransform.getInstance():transSeconds6(self.refresh_time, true, true));
	else
		self.refreshTime.text = LanUtil.getValue(141605);
		Lua_CommonUtil.removeTimer(self, self.onRrefreshTimer);
	end
end

function Lua_BossFirstKillActItem:onSubBtnClick()
	if self.data.state == 0 then
		if self.data.illus_group_id ~= nil then
			local grouping_cfg = getConfig({"illus_upgrade_group", self.data.illus_group_id});

			if self.data.illus_group_id == 201 then -- 世界boss
				local secen_id = getConfig({"monster", self.data.monster_id, "scene_id"});
	            local sceneMinLevel = 0;
	            local sceneData = Lua_SceneConfigData.getSceneConfig(secen_id);
	            if secen_id ~= nil then
	                if sceneData ~= nil then
	                    sceneMinLevel = sceneData.config.level[1];
	                end
	            end
	            if DataCenter.roleData.level < sceneMinLevel then
	                OperateAlert.show(LanUtil.getValue(141609));
	                return;
	            end
			end

			if DataCenter.funcOpenData:isOpened(grouping_cfg.func_openId) == false then
				local func_cfg = getConfig( {"func_open", grouping_cfg.func_openId});
		        if func_cfg ~= nil and func_cfg.advance_message ~= nil then
		            OperateAlert.show(func_cfg.advance_message);
		            return;
		        end
		    end

			DataCenter.bossData.checkBossId = self.data.monster_id;
			if self.data.illus_group_id == 205 then
				Lua_WindowUtil.openWin("Lua_BossMainWindow", WinParam.ACTION_OPEN, 5); -- 神兽岛特殊处理
			else
				Lua_WindowUtil.openWin("Lua_BossMainWindow", WinParam.ACTION_OPEN, Lua_BossData.BOSS_NAME_2_INDEX[grouping_cfg.illus_group_name]);
			end
			Lua_WindowUtil.openWin("Lua_OpenDressCarnivalWindow", WinParam.ACTION_CLOSE, nil);
			Lua_WindowUtil.openWin("Lua_GrandCeremonyWindow", WinParam.ACTION_CLOSE, nil);
			Lua_WindowUtil.openWin("Lua_SuitWindow", WinParam.ACTION_CLOSE, nil);
		end
	end
end

function Lua_BossFirstKillActItem:dispose()
	Lua_CommonUtil.removeTimer(self, self.onRrefreshTimer);
    self:superCall("dispose");
end