Lua_LoversRechargeRewardWindow = class("Lua_LoversRechargeRewardWindow", Lua_SecondSizeWindow);
function Lua_LoversRechargeRewardWindow:ctor()
    self:superCall("ctor");
    self.windowName = "Lua_LoversRechargeRewardWindow";
    self.skinName = "LoversRechargeRewardWindow_skin";
    self.titleText = "奬勵列表"
end

function Lua_LoversRechargeRewardWindow:showWin(param)
    self:superCall("showWin", param);

    self.infoBg:setLocation(0, -27)
    self.infoBg:SetDimensions(912, 514);
    self.winTitleBg:setLocation(0, 255)
    self.winTitleBg:SetDimensions(912, 78)
    self.titleNameTxt:setLocation(0, 255)
    self.btnClose:setLocation(418, 255)

    self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, -31, 880, 378));
    self.dragList:setLocation(0, 0, 0);
    self.dragList:setListCell(loveRechargeRewardItem, 84, 880, 1);

    local rewardDragArr = Array();
    for _, v in ipairs(param.rank_reward) do
        rewardDragArr:add(v)
    end
    self.dragList:setLuaArrayData(rewardDragArr, false)
end

------------分割线---------------------
loveRechargeRewardItem = class("loveRechargeRewardItem", Lua_ListCell);
function loveRechargeRewardItem:ctor(p)
    self:superCall("ctor", p, "LoversRechargeRewardItem_skin");
end

function loveRechargeRewardItem:buildShowItem()
    self:superCall("buildShowItem");
    self.itemArr = Array()
end

function loveRechargeRewardItem:setData(data)
    self.data = data;
    local itemImg;
    local len = #data.reward_items;
    local itemNum = self.itemArr:getSize() - len;
    while itemNum > 0 do
        itemImg = self.itemArr:shift()
        itemImg:dispose();
        itemNum = itemNum - 1;
    end

    while itemNum < 0 do
        itemImg = Lua_ToolImage.new(self.content)
        itemImg:setDepth(5);
        self.itemArr:add(itemImg)
        itemNum = itemNum + 1;
    end

    for i = 1, len do
        itemImg = self.itemArr[i];
        local reward = Lua_ToolVo.createToolVo(data.reward_items[i].id, data.reward_items[i].amount, data.reward_items[i].bind);
        reward.packType = 999;
        reward.star = data.reward_items[i].equipment.star;

        itemImg.data = reward;
        itemImg:showStampEff(false);
        itemImg:setLocation(-125 + (i - 1) * 85, 3, 0);
        itemImg:setScale(0.8, 0.8)
    end

    self.rankSp:setEnable(true);
    self.rankTxt:setEnable(false);
    local rank = data.cond[2];
    if rank == 1 then
        self.rankSp:setAltas("leaderBoard_atlas", "ui_paihang_widget_no1");
    elseif rank == 2 then
        self.rankSp:setAltas("leaderBoard_atlas", "ui_paihang_widget_no2");
    elseif rank == 3 then
        self.rankSp:setAltas("leaderBoard_atlas", "ui_paihang_widget_no3");
    else
        self.rankSp:setEnable(false);
        self.rankTxt:setEnable(true);
        self.rankBg:setEnable(false)
        if data.cond[2] ~= data.cond[3] then
            self.rankTxt.text = data.cond[2] .. "-" .. data.cond[3];
        else
            self.rankTxt.text = rank;
        end
    end

end

function loveRechargeRewardItem:checkOutBound(showRect)
    if not self.data then
        self.inViewEffect = false;
        return ;
    end

    local rect = Lua_Rectangle.new(self.itemX, self.itemY - 30, 50, 60);
    if showRect:containeRect(rect) then
        self.inViewEffect = true;
    else
        self.inViewEffect = false;
    end

    for i = 1, #self.data.reward_items do
        self:updateEffectState(i);
    end
end

function loveRechargeRewardItem:updateEffectState(index)
    if self.inViewEffect == true and self.data.reward_items[index].show_effect == 1 and self.itemArr[index].data.color >= 3 then
        if not self.itemArr[index].roundEff then
            self.itemArr[index]:showRoundEff(true)
            if self.itemArr[index].roundEff then
                self.itemArr[index].roundEff:setSacle(0.9, 0.9, 0.9);
                self.itemArr[index].roundEff:SetRenderQueue(self.itemArr[index].item_bg, 8, 10, false);
            end
        end
        if self.itemArr[index].roundEff then
            self.itemArr[index].roundEff:setEnable(true);
        else
            self.itemArr[index]:showArmyEff(true);
        end
    else
        if self.itemArr[index].roundEff then
            self.itemArr[index].roundEff:setEnable(false);
        else
            self.itemArr[index]:showArmyEff(false);
        end
    end
end