-- 情侣充值
Lua_LoversRechargeWindow = class("Lua_LoversRechargeWindow", Lua_Window);
function Lua_LoversRechargeWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_LoversRechargeWindow";
	self.skinName = "LoversRechargeWindow_skin";
end

function Lua_LoversRechargeWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.goMarryBtn:addClickFuntion(self, self.onMarryClick);
	self.goChargeBtn:addClickFuntion(self, self.onChargeClick);
	self.helpSp:addClickFuntion(self, self.onHelpClick);
	self.rewardBtn:addClickFuntion(self, self.onRewardBtnClick);

	self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 542, 314));
	self.dragList:setListCell(Lua_LoversRechargeItem, 91, 542, 1);
	self.dragList:setLocation(-222, 9, 0);

	DataCenter.redDotData:updateRedDotVoState(22061, false);

	self:addLuaEvent("LOVERSCHARGING_INFO", self, self.loversRecharge);
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sGetActivityInfo(1065);
end

function Lua_LoversRechargeWindow:loversRecharge(msg)
    self.msg = msg;

    self.contentInfo = msg.activity_info.content
    if self.msg.rank == 0 then
        self.myRankTxt.text = string.gsub(LanUtil.formateStr(LanUtil.getValue(128111), tostring("[00E125]" .. LanUtil.getValue(140333) .. "[-]")), "FFDF05", "B2D2E0")
    else
        self.myRankTxt.text = string.gsub(LanUtil.formateStr(LanUtil.getValue(128111), tostring("[00E125]" .. msg.rank .. "[-]")), "FFDF05", "B2D2E0");
    end
    
    self.myChargeTxt.text = "[B2D2E0]" .. LanUtil.formateStr(LanUtil.getValue(143100), tostring("[00E125]" .. msg.total_gold .. "[-]"));

	local dragLen = 0;
	local rankLen = msg.rank_reward[#msg.rank_reward].cond[3];
	local rankDragArr = Array();
	while dragLen < rankLen do
		dragLen = dragLen + 1;
		rankDragArr:add({rank = dragLen});
	end

	for i = 1, dragLen do
		for _, v in ipairs(msg.rankers) do
			if rankDragArr[i].rank == v.rank then
				rankDragArr[i].rankers = v;
			end
		end
	end
	self.dragList:setLuaArrayData(rankDragArr, false);

	if tonumber(msg.activity_info.end_tick) > 0 then
		self.countDown = tonumber(msg.activity_info.end_tick);
		self:addTimer("Lua_LoversRechargeWindow", 0.3, self, self.onCountDown);
	end
	self:roleMode();
end

function Lua_LoversRechargeWindow:onCountDown()
	local pt = self.countDown - tonumber(tostring(GlobalVar.cur_tick));
	self.countdownTxt.text = LanUtil.formateStr(LanUtil.getValue(143101), TimeTransform.getInstance():transSeconds1(pt, true));
	if pt <= 0 then
		self.countdownTxt.text = "";
		Lua_CommonUtil.removeTimer(self, self.onCountDown)
	end
end

function Lua_LoversRechargeWindow:roleMode()
	local modelData = UsData();
	modelData.career = self.msg.career ~= 2 and self.msg.career or 1;
	modelData.fashion_clothes_id = self.msg.man_clothes;
	modelData.fashion_weapon_id = self.msg.man_weapon;
	modelData.nickname = "";
	modelData.hp = 1;
	modelData.kind = 2;
	modelData.isShowName = false;
	modelData.IsUI = true;

	self.manModel = ModelPlayer();
	self.manModel:init(self.content, Vector3(196, -145, 200), Vector3(0, 90, 0), modelData, nil, 180);
	self.manModel:SetRenderQueue(self.roleBg, 5, 2);

	local girlModelData = UsData();
	girlModelData.career = 2;
	girlModelData.gender = 1;
	girlModelData.fashion_weapon_id = self.msg.female_weapon;
	girlModelData.fashion_clothes_id = self.msg.female_clothes;
	girlModelData.nickname = "";
	girlModelData.hp = 1
	girlModelData.kind = 1;
	girlModelData.isShowName = true;
	girlModelData.IsUI = true;
	girlModelData.showShadow = false;
	girlModelData.curState:setState(4, true);

	self.girlModel = ModelPlayer();
	self.girlModel:init(self.content, Vector3(361, -145, 200), Vector3(0, 90, 0), girlModelData, nil, 180);
	self.girlModel:SetRenderQueue(self.roleBg, 5, 2);
end

function Lua_LoversRechargeWindow:onMarryClick(go)
	Lua_ProxyManager.getProxy("Lua_MapProxy"):sTransfer(10103, 18366, 1975, 9383, 0);
	self:hide();
end

function Lua_LoversRechargeWindow:onChargeClick(go)
	Lua_WindowUtil.openWin("Lua_ChongzhiWindow");
	self:hide();
end

function Lua_LoversRechargeWindow:onHelpClick(go)
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", nil, self.contentInfo)
end

function Lua_LoversRechargeWindow:onRewardBtnClick(go)
	Lua_WindowUtil.openWin("Lua_LoversRechargeRewardWindow", nil, self.msg);
end

function Lua_LoversRechargeWindow:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	if self.girlModel then
		self.girlModel:dispose();
		self.girlModel = nil;
	end
	if self.manModel then
		self.manModel:dispose();
		self.manModel = nil;
	end
	Lua_CommonUtil.removeTimer(self, self.onCountDown);
	DataCenter.OperationalActivitiesData.isLoveRecharge = nil;

	self:superCall("dispose")
end





--------------------------------------------------





Lua_LoversRechargeItem = class("Lua_LoversRechargeItem", Lua_ListCell);
function Lua_LoversRechargeItem:ctor(p)
	self:superCall("ctor", p, "LoversRechargeItem_skin");
end

function Lua_LoversRechargeItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	if not data.rankers then
		self.valueTxt.text = "";
		self.ownNameTxt.text = LanUtil.getValue(120014);
		self.partnerNameTxt.text = LanUtil.getValue(120014);
	else
		if #data.rankers.ranker == 1 then
			self.ownNameTxt.text = data.rankers.ranker[1].server_flag .. "." .. data.rankers.ranker[1].name;
			self.partnerNameTxt.text = LanUtil.getValue(120014);
		else
			self.ownNameTxt.text = data.rankers.ranker[1].server_flag .. "." .. data.rankers.ranker[1].name;
			self.partnerNameTxt.text = data.rankers.ranker[2].server_flag .. "." .. data.rankers.ranker[2].name;
		end
		self.valueTxt.text = data.rankers.value;
	end

	if data.rank <= 3 then
		self.rankSp:setAltas("loversRecharge_atlas", "ui_qlczb_no" .. data.rank);
	end
	self.rankTxt.text = data.rank;

	self.rankTxt:setEnable(data.rank > 3)
	self.rankSp:setEnable(data.rank <= 3);
end