checkRequire("Lua_LuckySignRecordItem");
Lua_LuckySignWindow = class("Lua_LuckySignWindow", Lua_Window);
function Lua_LuckySignWindow:ctor()
	self:superCall("ctor");
	self.windowName = "Lua_LuckySignWindow";
	self.skinName = "LuckySignWindow_skin";
end

function Lua_LuckySignWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.des1.text = LanUtil.getValue(145403);
	self.des2.text = LanUtil.getValue(145406);
	self.title1.text = LanUtil.getValue(145407);
	self.oneBtnTxt.text = LanUtil.getValue(145401);
	self.tenBtnTxt.text = LanUtil.getValue(145402);

	self.posX = { -341, -247, -153, -59, -294, -200, -106, -247, -153, -200 };
	self.posY = { -103, -103, -103, -103, -21, -21, -21, 61, 61, 143 };

	self.dragContainer = Lua_DragContainer.new(self.content, 1, Vector4(77, -103, 360, 214));
	self.dragContainer:setLocation(227, 150, 0);

	self.help:addClickFuntion(self, self.onHelpClick);
	self.oneBtn:addClickFuntion(self, self.onOneClick);
	self.tenBtn:addClickFuntion(self, self.onTenClick);

	self:addLuaEvent("UPDATE_LUCKY_SIGN_RECORDS", self, self.updateRecords);
	self:addLuaEvent("UPDATE_LUCKY_SIGN_INFO", self, self.updateInfo);
	Lua_ProxyManager.getProxy("Lua_LuckySignProxy"):sLuckySignInfo();
	Lua_ProxyManager.getProxy("Lua_LuckySignProxy"):sLuckySignWinStatus(1);
end

function Lua_LuckySignWindow:updateInfo()
	self:updateReward();

	local luckySignData = DataCenter.luckySignData;
	local leftTime = luckySignData.end_tick - tonumber(tostring(GlobalVar.cur_tick));
	self.time.text = LanUtil.formateStr(LanUtil.getValue(146007), TimeTransform.getInstance():transSeconds1(leftTime, true));
	Lua_CommonUtil.addTimer("onActivityTimeDown", 1, self, self.onActivityTimeDown);

	-- 初始化全服记录
	if luckySignData.pub_record ~= nil then
		self:updateRecords(luckySignData.pub_record);
	end

	self.draw_one = luckySignData.draw_one;
	self.draw_ten = luckySignData.draw_ten;
	self.amount.text = LanUtil.formateStr(LanUtil.getValue(145400), tostring(luckySignData.left));
	self.money1.text = self.draw_one;
	self.moneyIcon1:setLocation(403 + self.money1.width, -146, 0);
	self.money2.text = self.draw_ten;
	self.moneyIcon2:setLocation(403 + self.money2.width, -218, 0);
end

function Lua_LuckySignWindow:updateReward()
	if self.itemList == nil then
		self.itemList = Array();
	end

	local arr = DataCenter.luckySignData.showTvoArr;
	local itemImg;
	for i = 1, arr:getSize() do
		itemImg = self.itemList[i];
		if itemImg == nil then
			itemImg = Lua_ToolImage.new(self.content);
			itemImg:setDepth(5);
			itemImg:setLocation(self.posX[i], self.posY[i], 0)
			self.itemList:add(itemImg);
		end
		itemImg.data = arr[i];
		itemImg:showRoundEff(arr[i].show_effect == 1);
	end
end

function Lua_LuckySignWindow:updateRecords(val)
	if val ~= nil then
		for k, v in ipairs(val) do
			if self.dragContainer.childrenList[k] == nil then
				local item = Lua_LuckySignRecordItem.new(self.dragContainer.sub);
				self.dragContainer:addSubContainer(item, false);
			end
			self.dragContainer.childrenList[k]:setData(v);
		end
		self.dragContainer:updateChildPos();
	end
end

function Lua_LuckySignWindow:showTips(money, subfun, neverTip, num)
	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {
		owner = self,
		neverTip = neverTip,
		des = LanUtil.formateStr(LanUtil.getValue(145408), tostring(money), tostring(num)),
		type = 1,
		subFun = subfun
	});
end

function Lua_LuckySignWindow:onOneClick()
	if DataCenter.neverTip:getNeverValue("Lua_LuckySignWindow0") then
		self:sendOneMessage();
	else
		self:showTips(self.draw_one, self.sendOneMessage, "Lua_LuckySignWindow0", 1);
	end
end

function Lua_LuckySignWindow:onTenClick()
	if DataCenter.neverTip:getNeverValue("Lua_LuckySignWindow1") then
		self:sendTenMessage();
	else
		self:showTips(self.draw_ten, self.sendTenMessage, "Lua_LuckySignWindow1", 10);
	end
end

function Lua_LuckySignWindow:sendOneMessage()
	if self:checkClick(self.draw_one) == false then
		return;
	end
	Lua_ProxyManager.getProxy("Lua_LuckySignProxy"):sLuckySignDraw(0);
end

function Lua_LuckySignWindow:sendTenMessage()
	if self:checkClick(self.draw_ten) == false then
		return;
	end
	Lua_ProxyManager.getProxy("Lua_LuckySignProxy"):sLuckySignDraw(1);
end

function Lua_LuckySignWindow:checkClick(gold)
	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	local leftNum = bagData:getLeftSize()
	if leftNum <= 0 then
		if not Lua_WindowUtil.isWindowShowing("Lua_TipsWindow") and not Lua_WindowUtil.isWindowShowing("Lua_PackWindow") then
			DataCenter.packData:showFullBagTip(Lua_PackData.BAG_PACK);
		end
		return false;
	end

	if DataCenter.moneyData:getMoney(Lua_MoneyData.GOLD) < gold then
		Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {
			owner = self,
			des = LanUtil.getValue(122521),
			type = 1,
			subFun = self.openChargeWin
		});
		return false;
	end
	return true;
end

function Lua_LuckySignWindow:openChargeWin()
	self:hide();
	Lua_WindowUtil.openWin("Lua_ChongzhiWindow", WinParam.ACTION_OPEN, 1);
end

function Lua_LuckySignWindow:onActivityTimeDown()
	local leftTime = DataCenter.luckySignData.end_tick - tonumber(tostring(GlobalVar.cur_tick));
	self.time.text = LanUtil.formateStr(LanUtil.getValue(146007), TimeTransform.getInstance():transSeconds1(leftTime, true));
	if leftTime <= 0 then
		Lua_CommonUtil.removeTimer(self, self.onActivityTimeDown);
	end
end

function Lua_LuckySignWindow:onHelpClick()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, DataCenter.luckySignData.actContent);
end

function Lua_LuckySignWindow:dispose()
	Lua_CommonUtil.removeTimer(self, self.onActivityTimeDown);
	Lua_ProxyManager.getProxy("Lua_LuckySignProxy"):sLuckySignWinStatus(0);
	self:superCall("dispose");
end