Lua_Integralitem = class("Lua_Integralitem",Lua_ListCell)
function Lua_Integralitem:ctor(p)
	self:superCall("ctor",p,"IntegralItem_skin");
end

function Lua_Integralitem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setDepth(5);
	self.itemImg:setScale(0.8,0.8,0.8);
	self.itemImg:setLocation(-105, 2, 0);

	self.integralBtn:setScale(0.8, 0.8, 0.8);
	self.integralBtn:addClickFuntion(self, self.integerClick);

	self.redDot = UICreate.createUIAtlasImage(self.content,"common_atlas_1", "ui_common_hongdian", 133, -4, 0, 0);
	self.redDot:setDepth(6);
end

function Lua_Integralitem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local tvo  =  Lua_ToolVo.createToolVo(data.item_id, data.sub_value, data.is_bind);
	tvo.roundEffect = data.is_effect;
	tvo.packType = 999;
	tvo.star = data.star;
	self.itemImg.data = tvo;

	self.needTxt.text = LanUtil.formateStr(LanUtil.getValue(130005), tostring(data.type));
	self.surplusTxt.text = LanUtil.formateStr(LanUtil.getValue(130006), tostring(data.value));

	self.integralBtn:setBtnEnable(data.value ~= 0);
	self.redDot:setEnable(data.type <= DataCenter.MazeHuntData.score and data.value ~= 0);
end

-- function Lua_Integralitem:onPlayerSoundClick()
-- 	Lua_PackUtil.showItemInfo(self.itemImg.data);
-- end

function Lua_Integralitem:integerClick()
	local cmd = ProtoPublic_pb.Proto10105213();
	cmd.index = self._data.index - 1;
	sendMsg(10105213, cmd)
end

function Lua_Integralitem:checkOutBound(showRect)
	if self._data == nil then
		return;
	end

	local width = self.itemImg.item_bg.width;
	local height = self.itemImg.item_bg.height;
	local rect = Lua_Rectangle.new(self.itemX - width / 2 - 105, self.itemY - height / 2 + 2, width, height);
	self.itemImg:showRoundEff(showRect:containeRect(rect) and self._data.is_effect);
end