Lua_MazeHuntItem=class("Lua_MazeHuntItem", Lua_DisplayObject);
function Lua_MazeHuntItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_MazeHuntItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardbg = UICreate.createUIAtlasImage(self.content, "mazeHunt_atlas", "ui_mgxb_widget_02", 0, 7, 0, 0)
	self.rewardbg:setDepth(6);
	self.rewardbg:setEnable(true);

	self.rewardSp = UICreate.createUIAtlasImage(self.content, "mazeHunt_atlas", "ui_mgxb_widget_01", 1, 20, 0, 0)
	self.rewardSp:setDepth(6);

	self.wenhaoSp = UICreate.createUIAtlasImage(self.content, "mazeHunt_atlas", "ui_mgxb_icon_07", 1, 20, 0, 0)
	self.wenhaoSp.clickScale = false;
	self.wenhaoSp:setDepth(6);
	self.wenhaoSp:setEnable(false)

	self.image = Lua_ToolImage.new(self.content);
	self.image:setDepth(7);
	self.image:setLocation(1, 20, 0);
	self.image:setScale(0.45, 0.45, 0.45);
end

function Lua_MazeHuntItem:setData(data)
	self._data = data;

	self.rewardSp:setEnable(true);
	self.wenhaoSp:setEnable(true);
	self.image:setEnable(true);
	if #data.item_list == 1 then
		self.wenhaoSp:setEnable(false);
		self.wenhaoSp:removeClickFuntion(self, self.onHelpClick);
		self.image:setEnable(true);

		local tvo;
		for i,v in ipairs(data.item_list) do
			tvo  =  Lua_ToolVo.createToolVo(v.item_id,v.value,v.is_bind)
			tvo.bShowItemBg = false;
			tvo.star = v.star;
			-- tvo.roundEffect = v.is_effect;
			self.image.data = tvo
			self.image:showStampEff(false);
			if v.is_effect == true then
				self:effectShow();
			end
		end	
	else
		self.wenhaoSp:setEnable(true);
		self.image:setEnable(false);
		self.wenhaoSp:addClickFuntion(self, self.onHelpClick);
	end
	self.image:showMaskSp(false);
	self.image:showNotYetImg(false);
end

function Lua_MazeHuntItem:onHelpClick()
	Lua_WindowUtil.openWin("Lua_RewardShowWindow", nil, self._data);
end

function Lua_MazeHuntItem:effectShow()
	if self.effect04 == nil then
		self.effect04 = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_activity_circle_04", "gui_activity_circle_04", 1, 20);
		self.effect04:SetRenderQueue(self.rewardbg, 10, 2, false);
		self.effect04:setScale(0.55, 0.55, 0.55);
	end
end

function Lua_MazeHuntItem:isShow(val)
	self.rewardSp:setEnable(val);
	self.wenhaoSp:setEnable(val);
	self.image:setEnable(val);
	if self.effect04 ~= nil then
		self.effect04:setEnable(val);
	end
end

function Lua_MazeHuntItem:modelShow(mazeHuntData)
	self:isShow(false);
	self.rewardbg:setEnable(false)
	
	DataCenter.MazeHuntData:modelUrl(mazeHuntData.show_id);

	if self.effectp == nil then
		self.effectp = UICreate.createUIEffect(self.content, nil, nil, 0,0);
		self.effectp:SetRenderQueue(self.endSp, 10, 2, true);
	end
	
	if mazeHuntData.mounter_pos ~= nil then
		self.effectp:setUrl(mazeHuntData.modelFile, mazeHuntData.model);
		self.effectp:setLocation(mazeHuntData.mounter_pos[1], mazeHuntData.mounter_pos[2], mazeHuntData.mounter_pos[3])
		self.effectp:setRot(mazeHuntData.mounter_rot[1], mazeHuntData.mounter_rot[2], mazeHuntData.mounter_rot[3])
		self.effectp:setSacle(mazeHuntData.mounter_sca[1], mazeHuntData.mounter_sca[2], mazeHuntData.mounter_sca[3]);	
		if mazeHuntData.await == nil then
			self.effectp:setAction(0);
		else
			self.effectp:setAction(mazeHuntData.await);
		end
	end
	
	if mazeHuntData.isLoop == true then
		Lua_CommonUtil.addTimer("effectRoot", 2, self, self.effectRoot);
	else
		Lua_CommonUtil.removeTimer(self, self.effectRoot);
	end
end

function Lua_MazeHuntItem:isModelShow(val)
	self:isShow(false);
	self.rewardbg:setEnable(false)
	if self.effectp ~= nil then
		self.effectp:setEnable(val);
	end
end

function Lua_MazeHuntItem:effectRoot()
	if self.effectp == nil then
		return;
	end
	self.effectp:setEnable(false);
	self.effectp:setEnable(true);
end

function Lua_MazeHuntItem:dispose()
	Lua_CommonUtil.removeTimer(self, self.effectRoot);
	self:superCall("dispose");
end