checkRequire("Lua_MazeHuntItem");
checkRequire("Lua_MyPlayerModel");
Lua_MazeHuntItemPanel = class("Lua_MazeHuntItemPanel", Lua_DisplayObject)
function Lua_MazeHuntItemPanel:ctor(p)
	self.cellPosList = {{-418.5, 199.5}, {-357.5, 199.5}, {-296.5, 199.5}, {-235.5, 199.5}, {-174.5, 199.5}, {-113.5, 199.5}, {-52.5, 199.5}, {8.5, 199.5}, {69.5, 199.5}, {128.5, 199.5},
						{189.5, 199.5}, {189.5, 136.5}, {189.5, 75.5}, {189.5, 14.5}, {189.5, -46.5}, {189.5, -107.5}, {189.5, -168.5}, {130.5, -168.5}, {69.5, -168.5},
						{69.5, -107.5}, {69.5, -46.5}, {69.5, 14.5}, {69.5,75.5}, {12, 75.5}, {-45.5, 75.5}, {-103, 75.5}, {-160.5, 75.5}, {-218, 75.5}, {-275.5, 75.5},
						{-333, 75.5}, {-390.5, 75.5}, {-448, 75.5}, {-505.5, 75.5},
						{-505.5, 14.5}, {-505.5, -46.5}, {-505.5, -107.5}, {-505.5, -168.5}, {-505.5, -217.5}, {-448, -217.5},{-390.5, -217.5}, {-390.5,-168.5}, {-390.5, -107.5},
						{-390.5, -46.5}, {-333, -46.5}, {-275.5, -46.5}, {-275.5, -107.5}};
	self.cellPosList[0] = {-492.5,197.5};
	self.cellPosList[47] = {-109,-50}; 
	self.moveSpeed = 230;
	self:superCall("ctor", p);
	self.isStep = true;
end

function Lua_MazeHuntItemPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.mazeHuntItemArr = Array();
	local numCount = 47;
	for i = 1, numCount do
		local cell = Lua_MazeHuntItem.new(self.content);
		cell.content.name = "Lua_MazeHuntItem"..i;
		cell:setDepth(4);
		cell:setLocation(self.cellPosList[i][1], self.cellPosList[i][2], 0);
		self.mazeHuntItemArr:add(cell);	
	end

	-- 赋值1后会进行渲染、会有drawCall，FinalRenderQueue才不会为0，Scaling Mode就会设置Hierarchy
	self.depthLab = UICreate.createLabel(self.content, "1", 0, 720, 100, 20, 20);

	local rd = DataCenter.roleData;
	self.modelData = UsData();
	self.modelData.roleId = rd.roleId;
	self.modelData.career = rd.career;
	self.modelData.gender = 1;
	self.modelData.weapon_id = rd.weapon_id;
	self.modelData.clothes_id = rd.clothes_id;
	self.modelData.mount_id = rd.mount_id;
	self.modelData.wingId = rd.wingId;
	self.modelData.fairyId = rd.fairyId;
	-- self.modelData.faqiId = rd.faqiId;
	-- self.modelData.spoorId = rd.spoorId;
	self.modelData.fashion_weapon_id = rd.fashion_weapon_id;
	self.modelData.fashion_clothes_id = rd.fashion_clothes_id;
	self.modelData.fashionHeadId = rd.fashionHeadId;
	self.modelData.nickname = "";
	self.modelData.hp = 1;
	self.modelData.kind = 1;
	self.modelData.isShowName = false;
	self.modelData.IsUI = true;

	self.playerModel = ModelPlayer();
	self.playerModel:init(self.content, Vector3(0, 0, 0), Vector3(0, 60, 0), self.modelData, nil, 45);
	self.playerModel:setRotEnable(false, 0, 200, 900, 400, 2);
	self.playerModel:SetRenderQueue(self.depthLab, 5, 2);

	self:addLuaEvent("GET_MAZEHUNTINFO", self, self.mazeHuntInfo);
	self:addLuaEvent("GET_MAZEHUNT_UPDATA", self, self.mazeHuntUpdata);
end

function Lua_MazeHuntItemPanel:mazeHuntInfo()
	local mazeSlot  = DataCenter.MazeHuntData;
	local len = mazeSlot.slot:getSize();
	for i = 1, len - 1 do
		self.mazeHuntItemArr[i]:isShow(true);
		self.mazeHuntItemArr[i]:setData(mazeSlot.slot[i]);
	end
	self.mazeHuntItemArr[47]:modelShow(mazeSlot)
end

function Lua_MazeHuntItemPanel:mazeHuntUpdata(data)
	local mazeHuntData  = DataCenter.MazeHuntData; 
	if self.isStep == true then
		if DataCenter.MazeHuntData.step == -1 or DataCenter.MazeHuntData.step == nil then
			self:setPlayerCell(0);
		else
			self:setPlayerCell(DataCenter.MazeHuntData.step);
		end
		self.isStep = false;
	end
end

function Lua_MazeHuntItemPanel:setPlayerCell(index)
	self:setPlayerPos(self.cellPosList[index][1], self.cellPosList[index][2]);
	if index == 47 then
		self.mazeHuntItemArr[47]:isModelShow(false);
		index = 46;
	else
		self.mazeHuntItemArr[47]:isModelShow(true);
	end
	self.playerCellIndex = index;

	local mazeSlot  = DataCenter.MazeHuntData;
	local len = mazeSlot.slot:getSize();
	for i = 1, len-1 do
		self.mazeHuntItemArr[i]:isShow(true);
		self.mazeHuntItemArr[i]:setData(mazeSlot.slot[i]);
	end

	for i = 1, index do
		self.mazeHuntItemArr[i]:isShow(false);
	end
end

function Lua_MazeHuntItemPanel:setPlayerPos(posX, posY)
	self.playerPosx = posX;
	self.playerPosy = posY;
	self.playerModel:setPosition(posX, posY, -150);
end

function Lua_MazeHuntItemPanel:movePlayerTo(index)
	self.targetCellIndex = index;
	if self:isPlayerMoveing() == true then
		return; -- 移动中
	end

	self.moveing = true;
	self.playerModel:setAction(1);
	self.startTime = getTime();
	self:addTimer("Maze_move", 0.01, self, self.onMoveing);
end

function Lua_MazeHuntItemPanel:isPlayerMoveing()
	if self.moveing == true then
		return true;
	end
	return false;
end

function Lua_MazeHuntItemPanel:onMoveing()
	if self.targetCellIndex == self.playerCellIndex then--到达目标
		self:setPlayerCell(self.targetCellIndex);
		self.moveing = false;
		self.playerModel:setAction(0);
		Lua_CommonUtil.removeTimer(self, self.onMoveing);
		DataCenter.MazeHuntData.isSieveBtnClick = true;
		return;
	end

	local moveToCell = 0;
	if self.targetCellIndex > self.playerCellIndex then
		moveToCell = self.playerCellIndex + 1;
	-- else
	-- 	moveToCell = self.playerCellIndex + 1;	
	end

	if moveToCell >  46 and DataCenter.MazeHuntData.step ~= 47 then
		self:setPlayerCell(0);
		moveToCell = 0;
		self.targetCellIndex = self.targetCellIndex  - 47;
		DataCenter.MazeHuntData.isTips = false;
	end

	if DataCenter.MazeHuntData.step == 47 then
		self:movePlayerTo(47);
		moveToCell = 1;
		self.targetCellIndex = self.targetCellIndex  - 46;
	end

	local dir = Vector2(self.cellPosList[moveToCell][1] - self.playerPosx, self.cellPosList[moveToCell][2] - self.playerPosy);
	local angle = math.atan2(dir.y, dir.x) * 180 / 3.1415926 + 90;
	self.playerModel:setDir(angle);
	
	local dis = math.sqrt(dir:SqrMagnitude());
	local dt = getTime() - self.startTime;
	self.startTime = getTime();
	local moveLen = self.moveSpeed * dt;
	if moveLen >= dis or dis == 0 then -- 到达下一个点
		self:setPlayerCell(moveToCell);
	else
		local movex = dir.x * moveLen / dis;
		local movey = dir.y * moveLen / dis;
		self:setPlayerPos(movex + self.playerPosx, movey + self.playerPosy);
	end
end

function Lua_MazeHuntItemPanel:dispose()
	if self.playerModel ~= nil then
		self.playerModel:dispose();
		self.playerModel = nil;
	end
	self:superCall("dispose");
end