checkRequire("Lua_Integralitem");
checkRequire("Lua_RecordItem");
Lua_MazeHuntRecordPanel = class("Lua_MazeHuntRecordPanel", Lua_DisplayObject)
function Lua_MazeHuntRecordPanel:ctor(p)
	self:superCall("ctor", p,"MazeHuntRecordPanel_skin");
end

function Lua_MazeHuntRecordPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.btnSpDic = {self.inFulDressBg, self.personalBg, self.integralBg};
	self.btnTxtDic = {self.inFulDressTxt, self.personalTxt, self.tintegralTxt};

	self.inFulDressBg:addClickFuntion(self, self.onInFulDressBtnClick);
	self.personalBg:addClickFuntion(self, self.onPersonalBtnClick);
	self.integralBg:addClickFuntion(self, self.onIntegralBtnClick);

	self.integralObj = UICreate.createGameObject(self.content, 0, 0, 0);

	self.integralDrage = Lua_DragList.new(self.integralObj, 1, Vector4(144, -123, 312, 246));
	self.integralDrage:setLocation(246, 212, 0);
	self.integralDrage:setListCell(Lua_Integralitem, 110, 312, 1);
	self.integralDrage:setDepth(3600);

	self.textWidth = 288;
	self.textHeight = 246;
	self.textObj = UICreate.createGameObject(self.content, 0, 0, 0);
	self.dragContainer = Lua_DragContainer.new(self.textObj, 1, Vector4(self.textWidth / 2, - self.textHeight / 2, self.textWidth, self.textHeight));
	self.dragContainer:setLocation(246, 212, 0);

	WindowMananger.getInstance():resetChildParent(self.textObj.transform);
	LuaUtil.updateWindowDepth(nil);
	self:onInFulDressBtnClick();
end

function Lua_MazeHuntRecordPanel:onInFulDressBtnClick()
	self.tabIndex = 1;

	self:showBtnColor(1);
	self:onInFulDress();
end

-- 全服记录
function Lua_MazeHuntRecordPanel:onInFulDress()
	self.dragContainer:updateChildPos();
	if self.tabIndex == 1 then
		self.dragContainer:removeAllChildren();
		local logStr = "";
		local arr = Array() ;
		if DataCenter.MazeHuntData.record_list ~= nil then
			for k,v in ipairs(DataCenter.MazeHuntData.record_list) do
				vo = Lua_ToolVo.new(tonumber(v.proto_item.id)); 
				vo:fromServer(v.proto_item);

				str = "[url=showItem_"..v.proto_item.id.."]"..vo.colorName.."[/url]";
				nameStr = "[url=playerClick_"..v.role_id.."]"..v.role_name.."[/url]";
				logStr = LanUtil.formateStr(LanUtil.getValue(130008), tostring(nameStr),tostring(str));
				
				item = Lua_RecordItem.new(self.dragContainer.sub);
				item:setData(vo);
				item:setText(logStr);
				self.dragContainer:addSubContainer(item, false);
			end
		end
		self.dragContainer:updateChildPos();
	end
end

function Lua_MazeHuntRecordPanel:onPersonalBtnClick() 
	self.tabIndex = 2;

	self:showBtnColor(2);
	self:onPersonal();
end

-- 个人记录
function Lua_MazeHuntRecordPanel:onPersonal()
	self.dragContainer:updateChildPos();
	if self.tabIndex == 2 then
		self.dragContainer:removeAllChildren();
		local logStr = "";
		if DataCenter.MazeHuntData.got_items ~= nil then
			for k,v in ipairs(DataCenter.MazeHuntData.got_items) do
				local vo = Lua_ToolVo.new(tonumber(v.id));
				vo:fromServer(DataCenter.MazeHuntData.got_items[k]);
				
				str = "[url=showItem_"..vo.id.."]"..vo.colorName.."[/url]";
				nameStr = "[url=playerClick_"..DataCenter.roleData.name.."][/url]";
				logStr = LanUtil.formateStr(LanUtil.getValue(130009),tostring(str));
				
				item = Lua_RecordItem.new(self.dragContainer.sub);
				item:setData(vo);
				item:setText(logStr);
				self.dragContainer:addSubContainer(item, false);
			end
		end
		self.dragContainer:updateChildPos();
	end
end

function Lua_MazeHuntRecordPanel:onIntegralBtnClick()
	self.tabIndex = 3;
	self:showBtnColor(3);
	self:onIntegral();
end

-- 积分兑换
function Lua_MazeHuntRecordPanel:onIntegral()
	if self.tabIndex == 3 then
		local arr = Array()
		for i,v in ipairs(DataCenter.MazeHuntData.exchangeItems) do
			local data = {};
			data.item_id = v.item_id;
			data.value = v.value;
			data.star = v.star;
			data.is_bind = v.is_bind;
			data.is_effect = v.is_effect;
			data.type = v.type;
			data.index = i;
			data.sub_value = v.sub_value;
			arr:add(data)
		end
		self.integralDrage:setLuaArrayData(arr, false)
	end
end

function Lua_MazeHuntRecordPanel:showBtnColor(index)
	for k,v in pairs(self.btnSpDic) do
		if k == index then
			self.btnSpDic[k]:setAltas("common_atlas_1", "ui_common_btn_c1")
			self.btnTxtDic[k].text = string.gsub(self.btnTxtDic[k].text, "D2D8DC", "FFFFFF")
		else
			self.btnSpDic[k]:setAltas("common_atlas_1", "ui_common_btn_c2")
			self.btnTxtDic[k].text = string.gsub(self.btnTxtDic[k].text, "FFFFFF", "D2D8DC")
		end

		if index == 3 then
			self.integralObj:SetActive(true);
			self.textObj:SetActive(false);
		else
			self.integralObj:SetActive(false);
			self.textObj:SetActive(true);
		end
	end	
end