checkRequire("Lua_MazeHuntItemPanel");
Lua_MazeHuntSievePanel = class("Lua_MazeHuntSievePanel", Lua_DisplayObject)
function Lua_MazeHuntSievePanel:ctor(p)
	self:superCall("ctor", p,"MazeHuntSievePanelPanel_skin");
	DataCenter.MazeHuntData.isSieveBtnClick = true;
end

function Lua_MazeHuntSievePanel:buildShowItem()
	self:superCall("buildShowItem");

	self.step = 0;

	self.mazeHuntPanel = Lua_MazeHuntItemPanel.new(self.content)

	self.pointsSp = UICreate.createUIAtlasImage(self.content, "mazeHunt_atlas", "ui_mgxb_icon_01", -304, -216, 0, 0)
	self.pointsSp:setDepth(6);

	self.sieveBtn:addClickFuntion(self, self.onSieveBtnClick);

	self:addLuaEvent("GET_MAZEHUNT_UPDATA", self, self.mazeHuntUpdata);
end

function Lua_MazeHuntSievePanel:mazeHuntUpdata()
	self:effectDispose();
	self:setBtnEnableTrue();

	if self.step ~= DataCenter.MazeHuntData.step and DataCenter.MazeHuntData.istIntegral ~= true then
		self:removeOnKeyTiming();
	end
end

-- 删除特效
function Lua_MazeHuntSievePanel:effectDispose()
	if self.effect ~= nil then
		self.effect:dispose();
		self.effect = nil;
	end

	if DataCenter.MazeHuntData.number > 0 then
		self.pointsSp:setAltas("mazeHunt_atlas", "ui_mgxb_icon_0" .. DataCenter.MazeHuntData.number);
	end
	self.pointsSp:setEnable(true);
end

-- 摇筛按钮高亮
function Lua_MazeHuntSievePanel:setBtnEnableTrue()
	self.sieveSp.color = Color.New(1, 1, 1, 1);
	self.sieveBtn.color = Color.New(1, 1, 1, 1);
end

function Lua_MazeHuntSievePanel:removeOnKeyTiming()
	local MazeHuntData = DataCenter.MazeHuntData;
	if self.step > MazeHuntData.step then
		self.step = self.step + MazeHuntData.number;
		MazeHuntData.isSieveBtnClick = false;
	else
		if MazeHuntData.isSieveBtnClick == true then
			self.step = MazeHuntData.step;
		end
	end

	if MazeHuntData.step >= 47 then -- 最后一轮
		self.mazeHuntPanel:setPlayerCell(47);
		self:setBtnEnableFalse();
	else
		self.mazeHuntPanel:movePlayerTo(self.step)
	end
	
	if self.step > 46 and MazeHuntData.step ~= 47 then
		self.step = self.step - 46;

		self:effectDispose();

		MazeHuntData.isTips = true;
		MazeHuntData.isIgnoreAndOnKey = false;

		self.sieveBtn:removeClickFuntion(self, self.onStopBtnClick);
		self.sieveBtn:addClickFuntion(self, self.onSieveBtnClick);

		Lua_CommonUtil.removeTimer(self, self.notIgnoreSieve);
		Lua_CommonUtil.removeTimer(self, self.ignoreSieveAndOnKey);
		Lua_CommonUtil.removeTimer(self, self.notIgnoreSieveAndOnKey);

		self.sieveSp:setAltas("mazeHunt_atlas", "ui_mgxb_z_02")
		Lua_MsgUtil.callFunc("MAZEHUNT_END");
	end
end

-- 摇筛按钮置灰
function Lua_MazeHuntSievePanel:setBtnEnableFalse()
	if DataCenter.MazeHuntData.isIgnore ~= true then
		self.sieveSp.color = Color.New(0, 1, 1, 1);
		self.sieveBtn.color = Color.New(0, 1, 1, 1);
		self.sieveBtn:removeClickFuntion(self, self.onSieveBtnClick);
	end
end

function Lua_MazeHuntSievePanel:onSieveBtnClick()
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.3 then
		return;
	end
	self.clickTime = getTime();

	if DataCenter.MazeHuntData.isTips == true or DataCenter.MazeHuntData.isSieveBtnClick == false then
		OperateAlert.show(LanUtil.getValue(130010));
		return
	end

	if DataCenter.MazeHuntData.isOnKey == true then -- 一键到底
		self:onKey();
	else
		if DataCenter.MazeHuntData.left_free_count > 0 or 
			DataCenter.neverTip:getNeverValue(Lua_NeverTipData.SIEVE_MAZEHUN) == true then
			self:onSingleClick()
		else
			local tipData = {};
			tipData.des = LanUtil.formateStr(LanUtil.getValue(130004), tostring(DataCenter.MazeHuntData.one_cost));
			tipData.owner = self;
			tipData.type = 1;
			tipData.subFun = self.onSingleClick; -- 确定
			tipData.neverTip = Lua_NeverTipData.SIEVE_MAZEHUN;
			Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
		end
	end
end

function Lua_MazeHuntSievePanel:onKey() 
	if DataCenter.neverTip:getNeverValue(Lua_NeverTipData.MAZEHUN) == true then
		self:onKyeSingleClick();
	else
		local tipData = {};
		tipData.des = LanUtil.getValue(130003);
		tipData.owner = self;
		tipData.type = 1;
		tipData.subFun = self.onKyeSingleClick; -- 确定
		tipData.neverTip = Lua_NeverTipData.MAZEHUN
		Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
	end
end

function Lua_MazeHuntSievePanel:onKyeSingleClick()
	if DataCenter.MazeHuntData.left_free_count <= 0 then
		if DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD,DataCenter.MazeHuntData.one_cost, true, true) == false then
			return;
		end
	end

	if DataCenter.MazeHuntData.isIgnore == true then -- 忽略动画
		self:ignoreSieveAndOnKey();
		self:addTimer("Lua_MazeHuntSievePanel", 0.5, self, self.ignoreSieveAndOnKey);
	else
		self.notIgnoreSieveAndOnKeyTimt = 1 ;
		self:notIgnoreSieveAndOnKey();
		self:addTimer("Lua_MazeHuntSievePanel", 0.5, self, self.notIgnoreSieveAndOnKey);
	end
end

function Lua_MazeHuntSievePanel:ignoreSieveAndOnKey() -- 忽略动画一键到底
	if DataCenter.MazeHuntData.left_free_count <= 0 then
		if DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD,DataCenter.MazeHuntData.one_cost, true, true) == false then
			self.sieveSp:setAltas("mazeHunt_atlas","ui_mgxb_z_02")
			Lua_CommonUtil.removeTimer(self, self.notIgnoreSieveAndOnKey);
			Lua_CommonUtil.removeTimer(self, self.ignoreSieveAndOnKey);
			return;
		end
	end
	DataCenter.MazeHuntData.isIgnoreAndOnKey = true;

	self.sieveBtn:removeClickFuntion(self, self.onSieveBtnClick)
	self:stopShow();
	Lua_ProxyManager.getProxy("Lua_MazeHuntProxy"):sMazeHuntRollDice();
end

function Lua_MazeHuntSievePanel:notIgnoreSieveAndOnKey()
	if DataCenter.MazeHuntData.left_free_count <= 0 then
		if DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD,DataCenter.MazeHuntData.one_cost, true, true) == false then
			self.sieveSp:setAltas("mazeHunt_atlas","ui_mgxb_z_02")
			Lua_CommonUtil.removeTimer(self, self.notIgnoreSieveAndOnKey);
			Lua_CommonUtil.removeTimer(self, self.ignoreSieveAndOnKey);
			return;
		end
	end
	DataCenter.MazeHuntData.isIgnoreAndOnKey = true;

	if self.notIgnoreSieveAndOnKeyTimt > 0 then 
		self.notIgnoreSieveAndOnKeyTimt = self.notIgnoreSieveAndOnKeyTimt - 0.5;
		self:effectAdd();
		self:setBtnEnableFalse();
		self.sieveSp:setAltas("mazeHunt_atlas","ui_mgxb_z_03")
		self.sieveBtn:removeClickFuntion(self, self.onSieveBtnClick)
		self.sieveBtn:removeClickFuntion(self, self.onStopBtnClick)
	else
		self:stopShow();
		self:setBtnEnableTrue();
		self.notIgnoreSieveAndOnKeyTimt = 1;
		Lua_ProxyManager.getProxy("Lua_MazeHuntProxy"):sMazeHuntRollDice();
	end
end

function Lua_MazeHuntSievePanel:stopShow() 
	self.sieveSp:setAltas("mazeHunt_atlas","ui_mgxb_z_03")
	self.sieveBtn:addClickFuntion(self, self.onStopBtnClick);
end

-- 创建特效
function Lua_MazeHuntSievePanel:effectAdd()
	if self.effect == nil then
		self.effect = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_touzi", "gui_touzi", -304, -216);
		self.effect:SetRenderQueue(self.sieveBtn, 10, 2, true);
		self.effect:setSacle(220, 220, 1);
		self.effect:setAction(7);
	end
	self.pointsSp:setEnable(false);
end

function Lua_MazeHuntSievePanel:onSingleClick()
	if DataCenter.MazeHuntData.isIgnore == true then -- 忽略动画
		self:ignoreSieve();
	else
		if DataCenter.MazeHuntData.left_free_count <= 0 then
			if DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD, DataCenter.MazeHuntData.one_cost, true, true) == false then
				return;
			end
		end
		self.notIgnoreSieveTime = 1;
		self:notIgnoreSieve();
		self:addTimer("Lua_MazeHuntSievePanel", 0.5, self, self.notIgnoreSieve);
	end
end

function Lua_MazeHuntSievePanel:ignoreSieve()
	if DataCenter.MazeHuntData.left_free_count <= 0 then
		if DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD,DataCenter.MazeHuntData.one_cost, true, true) == false then
			return;
		end
	end
	Lua_ProxyManager.getProxy("Lua_MazeHuntProxy"):sMazeHuntRollDice();
end

function Lua_MazeHuntSievePanel:notIgnoreSieve()
	if self.notIgnoreSieveTime > 0 then 
		self.notIgnoreSieveTime = self.notIgnoreSieveTime - 0.5;
		self:effectAdd();
		self:setBtnEnableFalse();
	else
		self.sieveBtn:addClickFuntion(self, self.onSieveBtnClick);
		Lua_CommonUtil.removeTimer(self, self.notIgnoreSieve);
		Lua_ProxyManager.getProxy("Lua_MazeHuntProxy"):sMazeHuntRollDice();
	end
end

function Lua_MazeHuntSievePanel:judgeMoney() 
	if DataCenter.MazeHuntData.left_free_count <= 0 then
		if DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD,DataCenter.MazeHuntData.one_cost, true, true) == false then
			self.sieveSp:setAltas("mazeHunt_atlas", "ui_mgxb_z_02")
			Lua_CommonUtil.removeTimer(self, self.notIgnoreSieveAndOnKey);
			Lua_CommonUtil.removeTimer(self, self.ignoreSieveAndOnKey);
			return;
		end
	end
end

function Lua_MazeHuntSievePanel:onStopBtnClick()
	self.sieveSp:setAltas("mazeHunt_atlas","ui_mgxb_z_02");
	self.notIgnoreSieveAndOnKeyTimt = 0;
	self:effectDispose();

	DataCenter.MazeHuntData.isIgnoreAndOnKey = false;

	self.sieveBtn:removeClickFuntion(self, self.onStopBtnClick);
	self.sieveBtn:addClickFuntion(self, self.onSieveBtnClick);
	self.pointsSp:setAltas("mazeHunt_atlas", "ui_mgxb_icon_0" .. DataCenter.MazeHuntData.number)
	self.pointsSp:setEnable(true);
	
	Lua_CommonUtil.removeTimer(self, self.notIgnoreSieveAndOnKey);
	Lua_CommonUtil.removeTimer(self, self.ignoreSieveAndOnKey);
end

function Lua_MazeHuntSievePanel:dispose()
	if self.mazeHuntPanel ~= nil then
		self.mazeHuntPanel:dispose();
		self.mazeHuntPanel = nil;
	end
	if self.pointsSp ~= nil then
		self.pointsSp:dispose();
		self.pointsSp = nil;
	end
	Lua_CommonUtil.removeTimer(self, self.notIgnoreSieve);
	Lua_CommonUtil.removeTimer(self, self.ignoreSieveAndOnKey);
	Lua_CommonUtil.removeTimer(self, self.notIgnoreSieveAndOnKey);

	self:superCall("dispose");
end