checkRequire("Lua_MazeHuntSievePanel");
checkRequire("Lua_MazeHuntRecordPanel");
checkRequire("Lua_BigRewardItem");
Lua_MazeHuntWindow = class("Lua_MazeHuntWindow", Lua_Window);
function Lua_MazeHuntWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_MazeHuntWindow";
	self.skinName = "MazeHuntWindow_skin";
end

function Lua_MazeHuntWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.sievePanel = Lua_MazeHuntSievePanel.new(self.content);
	self.recordPanel = Lua_MazeHuntRecordPanel.new(self.content);

	DataCenter.MazeHuntData.isOnKey = false;
	DataCenter.MazeHuntData.isIgnore = false;
	DataCenter.MazeHuntData.isIgnoreAndOnKey = false;

	self.mazeHuntDrage = Lua_DragList.new(self.content,1, Vector4(389, -169, 306, 184));
	self.mazeHuntDrage:setListCell(Lua_BigRewardItem, 90, 95, 3);
	self.mazeHuntDrage:setLocation(0, 0, 0);
	
	self.sieveRedDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", -30, -210, 0, 0);
	self.sieveRedDot:setDepth(6);
	self.sieveRedDot:setEnable(false);

	self.integralRedDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 540, 256, 0, 0);
	self.integralRedDot:setDepth(6);
	self.integralRedDot:setEnable(false);

	self.onKey:setScale(0.75, 0.75, 0.75);
	self.ignore:setScale(0.75, 0.75, 0.75);
	self.onKey:addBoxChange(self, self.onKeyCheckBox);
	self.ignore:addBoxChange(self, self.onIgnoreBtnClick);

	self:addLuaEvent("GET_MAZEHUNT_UPDATA", self, self.mazeHuntUpdata);
	self:addLuaEvent("GET_MAZEHUNTINFO", self, self.mazeHuntInfo);
	self:addLuaEvent("rMAZEHUNT_UPDATA", self, self.mazeHuntUpdata);
	self:addLuaEvent("MAZEHUNT_INFULDRESS", self, self.mazeHuntInFulDressUpdata);
	self:addLuaEvent("rMAZEHUNT_INFULDRESS", self, self.mazeHuntInFulDressUpdata);
	-- self:addLuaEvent("CONTENT_TIPS", self, self.mazeHuntContent);
	self:addLuaEvent("MAZEHUNT_END", self, self.onMazeHuntEnd);
	Lua_ProxyManager.getProxy("Lua_MazeHuntProxy"):sMazeHuntAllInfo();
	Lua_ProxyManager.getProxy("Lua_MazeHuntProxy"):sMazeHuntAllStateInfo();
	Lua_ProxyManager.getProxy("Lua_MazeHuntProxy"):sMazeHuntAllrecordInfo(1);
end

function Lua_MazeHuntWindow:mazeHuntUpdata()
	local mazeHuntData = DataCenter.MazeHuntData;
	if mazeHuntData.left_time ~= nil then
		self.left_time = tonumber(mazeHuntData.left_time) + tonumber(tostring(GlobalVar.cur_tick));
		self:onCountDown();
	end
	
	-- self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(122594), tostring(mazeHuntData.left_time))
	self.clearanceTxt1.text = LanUtil.formateStr(LanUtil.getValue(130000), tostring(mazeHuntData.finish_count));
	if mazeHuntData.free == 0 and getLanType() == 1 then
		self.clearanceTxt2.text = "";
	else
		self.clearanceTxt2.text = LanUtil.formateStr(LanUtil.getValue(130001), tostring(mazeHuntData.need), tostring(mazeHuntData.free));
	end

	if mazeHuntData.left_free_count == 0 and getLanType() == 1 then
		self.freeTxt.text = "";
	else
		self.freeTxt.text = LanUtil.formateStr(LanUtil.getValue(130007),tostring(mazeHuntData.left_free_count));
	end

	self.integralTxt.text = LanUtil.formateStr(LanUtil.getValue(130002),tostring(mazeHuntData.score));
	-- self.recordPanel:isIntegraShow(mazeHuntData.open_exchange);
	self:addTimer("Lua_MazeHuntWindow", 0.3, self, self.onCountDown);
	
	self.recordPanel:onPersonal();
	self.recordPanel:onIntegral();
	if mazeHuntData.step == 47 then
		self.sievePanel:setBtnEnableFalse();
	end

	if mazeHuntData.left_free_count ~= nil then
		if tonumber(mazeHuntData.left_free_count) > 0  then
			self.sieveRedDot:setEnable(true);
		else
			self.sieveRedDot:setEnable(false);
		end
	end
	mazeHuntData:redShow();
	if mazeHuntData.isRedShow == true then
		self.integralRedDot:setEnable(true);
	else
		self.integralRedDot:setEnable(false);
	end
	self.wenhao:addClickFuntion(self, self.onHelpBtnClick);
end

function Lua_MazeHuntWindow:mazeHuntInfo()
	local arr = Array()
	for i,v in ipairs(DataCenter.MazeHuntData.slot[47].item_list) do
		arr:add({
			item_id = v.item_id,
			value = v.value,
			is_bind = v.is_bind,
			star = v.star,
			is_effect = v.is_effect,
			sub_value = v.sub_value
		});
	end
	self.mazeHuntDrage:setLuaArrayData(arr, false)
end

function Lua_MazeHuntWindow:onCountDown()
	if self.left_time == nil then
		return;
	end

	local pt = self.left_time - tonumber(tostring(GlobalVar.cur_tick));
	if pt > 0 then
		self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(127101), TimeTransform.getInstance():transSeconds1(pt, true));

	else
		self.timeTxt.text = LanUtil.getValue(122586);
		Lua_CommonUtil.removeTimer(self, self.onCountDown); 
	end
end

function Lua_MazeHuntWindow:onHelpBtnClick()
	if DataCenter.MazeHuntData.tips == nil then
		DataCenter.MazeHuntData.tips = "";
	end
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", nil, DataCenter.MazeHuntData.tips)
end

function Lua_MazeHuntWindow:onMazeHuntEnd(val)
	if getLanType() == 1 then
		DataCenter.MazeHuntData.isOnKey = false;
		self.onKey.seleted = false;
	end
end

function Lua_MazeHuntWindow:onKeyCheckBox(val)
	if DataCenter.MazeHuntData.isIgnoreAndOnKey == true then
		self.onKey.seleted = DataCenter.MazeHuntData.isIgnore;
		return;
	end
	DataCenter.MazeHuntData.isOnKey = val;
end

function Lua_MazeHuntWindow:onIgnoreBtnClick(val)
	if DataCenter.MazeHuntData.isIgnoreAndOnKey == true then
		self.ignore.seleted = DataCenter.MazeHuntData.isIgnore;
		return;
	end
	DataCenter.MazeHuntData.isIgnore = val;
end

-- 刷新全服记录
function Lua_MazeHuntWindow:mazeHuntInFulDressUpdata()
	self.recordPanel:onInFulDress()
end

function Lua_MazeHuntWindow:dispose()
	if self.sievePanel ~= nil then
		self.sievePanel:dispose();
		self.sievePanel = nil;
	end
	if self.recordPanel ~= nil then
		self.recordPanel:dispose();
		self.recordPanel = nil;
	end
	if self.mazeHuntDrage ~= nil then
		self.mazeHuntDrage:dispose();
		self.mazeHuntDrage = nil;
	end
	if self.sieveRedDot ~= nil then
		self.sieveRedDot:dispose();
		self.sieveRedDot = nil;
	end
	if self.integralRedDot ~= nil then
		self.integralRedDot:dispose();
		self.integralRedDot = nil;
	end
	Lua_ProxyManager.getProxy("Lua_MazeHuntProxy"):sMazeHuntAllrecordInfo(0);
   	
	self:superCall("dispose");
end