-- 帮派争霸，集字，累充
Lua_OpenCommonActivityPanel = class("Lua_OpenCommonActivityPanel", Lua_DisplayObject)
function Lua_OpenCommonActivityPanel:ctor(p)
	self:superCall("ctor", p, "OpenCommonPanel_skin");
end

function Lua_OpenCommonActivityPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 750, 285));
	self.dragList:setListCell(Lua_OpenCommonActivityItem, 130, 750, 1);
	self.dragList:setLocation(119, -105, 0);

	self:addLuaEvent("UPDATE_ONEPANEL_DATA", self, self.updatePanelInfo);
end

function Lua_OpenCommonActivityPanel:updatePanelInfo()
	local OpenDressCarnivalData = DataCenter.OpenDressCarnivalData;
	if OpenDressCarnivalData.first_type == self.first_type then
		local end_other = OpenDressCarnivalData.end_other;
		local stop_tick = OpenDressCarnivalData.stop_tick; -- 活动结束时间
		self.eTimeNum = end_other > 0 and end_other or stop_tick;

		local start_tick = OpenDressCarnivalData.start_tick; -- 活动开始时间
		local atimeStr1 = TimeTransform.getInstance():transSeconds8(start_tick, "yyyy-MM-dd HH:mm");
		local atimeStr2 = TimeTransform.getInstance():transSeconds8(self.eTimeNum, "yyyy-MM-dd HH:mm");
		self.open_time.text = LanUtil.formateStr(LanUtil.getValue(127300), atimeStr1 .. " ~ " .. atimeStr2);

		self.times = OpenDressCarnivalData.times; -- 服务器当前时间戳（客户端使用）
		if end_other > 0 and end_other < self.times then
			self.end_time.text = LanUtil.getValue(127308);
			Lua_CommonUtil.removeTimer(self, self.onTimeStrTimer);
		else
			self.end_time.text = LanUtil.formateStr(LanUtil.getValue(127301), TimeTransform.getInstance():transSeconds1((self.eTimeNum - self.times), true));
			Lua_CommonUtil.addTimer("openFactionFight_Timer", 1, self, self.onTimeStrTimer);
		end
		
		self.tips.text = LanUtil.formateStr(LanUtil.getValue(127302), OpenDressCarnivalData.content);

		local first_type = OpenDressCarnivalData.first_type;
		if first_type == Lua_OperationalActivitiesData.ACT_FACTION then -- 1026社团争霸
			if OpenDressCarnivalData.icon_type == 10102 then -- 合服
				self.show_time.text = LanUtil.formateStr(LanUtil.getValue(127316), tostring(OpenDressCarnivalData.combine_server_day));
			else
				self.show_time.text = LanUtil.formateStr(LanUtil.getValue(127309), tostring(OpenDressCarnivalData.open_server_day));
			end
			self.roleImg:setUrl("/images/common/ui_shetuanzhengba.png");
			self.roleImg:SetDimensions(304, 439);
			self.artDesIcon:setAltas("openServiceActivities_atlas", "ui_bpzb_z");
		elseif first_type == Lua_OperationalActivitiesData.ACT_RECHARGE then -- 1002累计充值
			self.artDesIcon:setAltas("openServiceActivities_atlas", "ui_kfkk_font_01");
			self.roleImg:setUrl("/images/common/ui_leijichuzhi.png");
			self.roleImg:SetDimensions(284, 418);
			self.roleImg:setLocation(-380, -8, 0);
		elseif first_type == Lua_OperationalActivitiesData.ACT_CHARCATER then -- 1013集字送礼
			self.artDesIcon:setAltas("openServiceActivities_atlas", "ui_jizidh01");
			self.roleImg:setUrl("/images/common/ui_jizisongli.png");
			self.roleImg:SetDimensions(284, 418);
		end
		self.artDesIcon:resetSize();
		self.show_time:setEnable(first_type == Lua_OperationalActivitiesData.ACT_FACTION);

		local arr = OpenDressCarnivalData.getOpenCommonData;
		self.dragList:setLuaArrayData(arr, false);
	end
end

function Lua_OpenCommonActivityPanel:onTimeStrTimer()
	self.eTimeNum = self.eTimeNum - 1;
	if self.eTimeNum - self.times > 0 then
		self.end_time.text = LanUtil.formateStr(LanUtil.getValue(127301), TimeTransform.getInstance():transSeconds1(self.eTimeNum - self.times, true));
	else
		Lua_CommonUtil.removeTimer(self, self.onTimeStrTimer);
	end
end

function Lua_OpenCommonActivityPanel:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose()
		self.dragList = nil;
	end
	Lua_CommonUtil.removeTimer(self, self.onTimeStrTimer);

	self:superCall("dispose");
end





--------------------------------------------------





Lua_OpenCommonActivityItem = class("Lua_OpenCommonActivityItem", Lua_ListCell);
function Lua_OpenCommonActivityItem:ctor(p)
	self:superCall("ctor", p, "OpenCommonItem_skin");
end

function Lua_OpenCommonActivityItem:buildShowItem()
	self:superCall("buildShowItem");

	self.act_recharge = Lua_OperationalActivitiesData.ACT_RECHARGE; -- 累计充值
	self.act_charcater = Lua_OperationalActivitiesData.ACT_CHARCATER; -- 集字送礼
	self.act_faction = Lua_OperationalActivitiesData.ACT_FACTION; -- 社团争霸

	self.itemArr = Array();
	self.effectArr = Array();
	self.condArr = Array();
	self.condSpArr = Array();

	self.redDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 330, 16, 0, 0)
	self.redDot.name = "redDot";
	self.redDot:setDepth(10);
	self.redDot:setEnable(false);

	self.subBtn:addClickFuntion(self, self.onGetBtnClick);
end

function Lua_OpenCommonActivityItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.titleTxt.text = data.title_name;

	if data.first_type == self.act_charcater then
		if tonumber(data.cond[1]) ~= 0 then
			if tonumber(data.cond[1]) == 1 then
				self.condTxt.text = LanUtil.formateStr(LanUtil.getValue(122570), tostring(data.sub_number))
			else
				self.condTxt.text = LanUtil.formateStr(LanUtil.getValue(122571), tostring(data.sub_number))
			end
		end
	else
		if data.first_type == self.act_recharge then
			local str;
			if tonumber(tostring(data.sub_value)) >= tonumber(tostring(data.cond[1])) then
				str = "[" .. Lua_ColorDefine.GREEN_STR .. "]" .. data.cond[1] .. "[-]";
			else
				str = "[" .. Lua_ColorDefine.RED_STR .. "]" .. data.sub_value .. "[-]";
			end
			self.titleTxt.text = LanUtil.formateStr(data.title_name, str);
			-- print(data.title_name, data.cond[1], tostring(data.sub_value));
		end
	end
	self.condTxt:setEnable(data.first_type == self.act_charcater and tonumber(data.cond[1]) ~= 0);

	-- 0未领取，1已领取，2表示条件不足
	if data.isReward == 0 then
		self.subBtn:setBtnEnable(true);
		if data.first_type == self.act_charcater then
			self.subBtn.label = LanUtil.getValue(121031);
		elseif data.first_type == self.act_recharge then
			self.subBtn.label = LanUtil.getValue(121148);
		elseif data.first_type == self.act_faction then
			self.subBtn.label = LanUtil.getValue(121148);
		end
	elseif data.isReward == 1 then
		self.subBtn:setBtnEnable(false);
		if data.first_type == self.act_charcater then
			self.subBtn.label = LanUtil.getValue(121031);
			self.subBtn:setBtnEnable(true);
		elseif data.first_type == self.act_recharge then
			self.subBtn.label = LanUtil.getValue(122528);
		elseif data.first_type == self.act_faction then
			self.subBtn.label = LanUtil.getValue(122528);
		end
	else
		if data.first_type == self.act_charcater then
			self.subBtn:setBtnEnable(true);
			self.subBtn.label = LanUtil.getValue(110917);
		elseif data.first_type == self.act_recharge then
			self.subBtn:setBtnEnable(true);
			self.subBtn.label = LanUtil.getValue(122543);
		elseif data.first_type == self.act_faction then
			self.subBtn:setBtnEnable(false);
			self.subBtn.label = LanUtil.getValue(121148);
		end
	end
	self.redDot:setEnable(data.isReward == 0);

	self:setCond();
	self:creationReardCell();
end

function Lua_OpenCommonActivityItem:setCond()
	if self._data.first_type == self.act_charcater then
		local cond = self._data.cond;
		if cond[#cond - 1] > cond[#cond] then -- 世界等级
			self.condLen = (#cond - 2) / 2;
		else
			self.condLen = (#cond - 4) / 2;
		end

		local condNum = self.condArr:getSize() - self.condLen;
		local condImg;
		local condSp;
		while(condNum > 0) do
			condImg = self.condArr:shift();
			condSp = self.condSpArr:shift();
			condImg:dispose();
			condSp:dispose();
			condNum = condNum - 1;
		end
		
		while(condNum < 0) do
			condNum = condNum + 1;

			condImg = Lua_ToolImage.new(self.content);
			condImg:setDepth(5);
			condImg:setScale(0.76, 0.76, 0.76);
			self.condArr:add(condImg);

			condSp = UICreate.createUIAtlasImage(self.content, "", "", 0, 0, 28, 28);
			condSp:setDepth(6);
			self.condSpArr:add(condSp);
		end

		local itemNum;
		self.itemNumArr = Array();
		for i = 1, self.condLen do
			itemNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(tonumber(cond[i * 2 + 1]));
			self.itemNumArr:add({num = itemNum / tonumber(cond[i * 2 + 2])});
			
			reward = Lua_ToolVo.createToolVo(tonumber(cond[i * 2 + 1]), itemNum, 0);
			reward.bShowItemBg = true;
			reward.packType = 999;

			condImg = self.condArr[i];
			condImg.data = reward;
			condImg:showNum(itemNum, true)
			condImg:setLocation(-320 + (i - 1) * 87, -13, 0);
		end

		for i = 1, self.condSpArr:getSize() do
			if i < self.condSpArr:getSize() then
				self.condSpArr[i]:setAltas("common_atlas_2", "ui_common_widget_jiahao_03")
			else
				self.condSpArr[i]:setAltas("common_atlas_2", "ui_common_widget_dengyu")
			end
			self.condSpArr[i]:setLocation(-277 + (i - 1) * 87, -13, 0);
		end
	else
		for i = 1, self.condArr:getSize() do
			self.condArr[i]:dispose();
		end

		for i = 1, self.condSpArr:getSize() do
			self.condSpArr[i]:setEnable(false);
		end
	end
end

-- 创建道具
function Lua_OpenCommonActivityItem:creationReardCell()
	if self.itemArr:getSize() > 0 then
		for i = self.itemArr:getSize(), self.itemArr:getSize() - #self._data.reward_set, -1 do
			if i > #self._data.reward_set then
				self.itemArr[i]:setEnable(false);
			else
				break;
			end
		end
	end

	for i = 1, self.effectArr:getSize() do
		self.effectArr:clear();
	end

	local obj;
	local tvo;
	local itemImg;
	for i = 1, #self._data.reward_set do
		obj = self._data.reward_set[i];

		tvo = Lua_ToolVo.createToolVo(obj.id, obj.amount, obj.bind == 2 and 1 or obj.bind);
		tvo.packType = 999;
		tvo.star = obj.equipment.star;
		tvo.bShowItemBg = true;

		itemImg = self.itemArr[i];
		if itemImg == nil then
			itemImg = Lua_ToolImage.new(self.content);
			itemImg:setDepth(5);
			self.itemArr:add(itemImg);
		end
		itemImg:setEnable(true);

		itemImg.data = tvo;
		if self._data.first_type ~= self.act_charcater then
			itemImg:showNum(obj.amount, false);
			itemImg:setScale(0.85, 0.85);
			itemImg:setLocation(-310 + (i - 1) * 70, -13, 0);
		else
			self.itemNumArr:sort("num", false)
			itemImg:showNum(self.itemNumArr[1].num, true);
			itemImg:setScale(0.76, 0.76);
			itemImg:setLocation(-320 + (i - 1 + self.condLen) * 87, -13, 0);
		end

		for i = 1, #self._data.spec_effect_item do
			if itemImg.data.id == tonumber(self._data.spec_effect_item[i]) then
				if tvo.color >= 3 then
					-- itemImg:showRoundEff(true);
					self.effectArr:add(itemImg);
				end
			end
		end
	end
end

function Lua_OpenCommonActivityItem:checkOutBound(showRect)
	if self._data == nil then
		return;
	end

	local rect = Lua_Rectangle.new(self.itemX - 25, self.itemY - 25, 60, 60);
	for i = 1, self.effectArr:getSize() do
		self.effectArr[i]:showRoundEff(showRect:containeRect(rect));
	end
end


function Lua_OpenCommonActivityItem:onGetBtnClick()
	local avo = DataCenter.OperationalActivitiesData:getActivitiesByType(self._data.first_type, 0);
	if self._data.isReward == 0 then
		DataCenter.OperationalActivitiesData:buyReward(tonumber(avo.act_index), tonumber(self._data.reward_index), 1);
	elseif self._data.isReward == 1 then
		if self._data.first_type == self.act_charcater then -- 集字送礼
			OperateAlert.show(LanUtil.getValue(122572));
		end
	else
		if self._data.first_type == self.act_charcater then -- 集字送礼
			sendMsg(10404305);
			Lua_WindowUtil.openWin("Lua_OpenDressCarnivalWindow",WinParam.ACTION_CLOSE, nil);
			Lua_WindowUtil.openWin("Lua_SuitWindow",WinParam.ACTION_CLOSE, nil);
		elseif self._data.first_type == self.act_recharge then -- 累充
			Lua_WindowUtil.openWin("Lua_OpenDressCarnivalWindow",WinParam.ACTION_CLOSE, nil);
			Lua_WindowUtil.openWin("Lua_SuitWindow",WinParam.ACTION_CLOSE, nil);
			Lua_WindowUtil.openWin("Lua_ChongzhiWindow",WinParam.ACTION_OPEN, 1);
		end
	end
end

function Lua_OpenCommonActivityItem:dispose()
	if self.condSpArr ~= nil then
		self.condSpArr:dispose();
		self.condSpArr:clear();
		self.condSpArr = nil;
	end
	if self.condArr ~= nil then
		self.condArr:dispose();
		self.condArr:clear();
		self.condArr = nil;
	end
	if self.itemArr ~= nil then
		self.itemArr:dispose();
		self.itemArr:clear();
		self.itemArr = nil;
	end
	if self.effectArr ~= nil then
		self.effectArr:dispose();
		self.effectArr:clear();
		self.effectArr = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end