-- 开服狂欢
checkRequire("Lua_OnlyLovesOnePersonPanel") -- 只爱一人
checkRequire("Lua_AllOneIsLlifePanel") -- 一生一世
checkRequire("Lua_OpenCommonActivityPanel") -- 通用
checkRequire("Lua_OpenFoundFactionPanel") -- 开宗立派
checkRequire("Lua_CyclicRechargePanel") -- 循环充值
checkRequire("Lua_CyclicConsumePanel") -- 循环消费
checkRequire("Lua_BossFirstKillActPanel"); -- BOSS首杀
checkRequire("Lua_BossEveryoneActPanel"); -- 全民BOSS
checkRequire("Lua_CumulativeConsumptionPanel"); -- 累计消费
checkRequire("Lua_SingleChargingPanel"); -- 单笔充值
checkRequire("Lua_TieTheKnotPanel"); -- 喜结良缘
checkRequire("Lua_DiscountStorePanel"); -- 折扣商店
Lua_OpenDressCarnivalWindow = class("Lua_OpenDressCarnivalWindow", Lua_Window);
function Lua_OpenDressCarnivalWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_OpenDressCarnivalWindow";
	self.skinName = "OpenDressCarnivalWindow_skin";
end

function Lua_OpenDressCarnivalWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.panelDic = {};
	self.panelDic[1027] = {clickRemoveEvent = 21001, panel = Lua_OnlyLovesOnePersonPanel};
	self.panelDic[1024] = {clickRemoveEvent = 21002, panel = Lua_AllOneIsLlifePanel};
	self.panelDic[1002] = {clickRemoveEvent = 21005, panel = Lua_OpenCommonActivityPanel};
	self.panelDic[1013] = {clickRemoveEvent = 21006, panel = Lua_OpenCommonActivityPanel};
	self.panelDic[1025] = {clickRemoveEvent = 21003, panel = Lua_OpenFoundFactionPanel};
	self.panelDic[1026] = {clickRemoveEvent = 21004, panel = Lua_OpenCommonActivityPanel};
	self.panelDic[1057] = {clickRemoveEvent = 21010, panel = Lua_CyclicRechargePanel};
	self.panelDic[1058] = {clickRemoveEvent = 21011, panel = Lua_CyclicConsumePanel};
	self.panelDic[1055] = {clickRemoveEvent = 21008, panel = Lua_BossFirstKillActPanel};
	self.panelDic[1056] = {clickRemoveEvent = 21009, panel = Lua_BossEveryoneActPanel};
	self.panelDic[1061] = {clickRemoveEvent = 21012, panel = Lua_CumulativeConsumptionPanel};
	self.panelDic[1062] = {clickRemoveEvent = 22060, panel = Lua_SingleChargingPanel};
	self.panelDic[1068] = {clickRemoveEvent = 22062, panel = Lua_TieTheKnotPanel};
    self.panelDic[1075] = {clickRemoveEvent = 22076, panel = Lua_DiscountStorePanel};
	self.panelDic[1090] = {clickRemoveEvent = 22066, panel = Lua_SingleChargingPanel};

	self.dragList = Lua_DragList.new(self.content, 2, Vector4(0, 0, 790, 70));
	self.dragList:setListCell(Lua_OpenDressCarnivalItem, 75, 150, 999);
	self.dragList:setLocation(-50, 218, 0);

	self:addLuaEvent("UPDATE_ACTIVITIES_DATA", self, self.createButtonList);
	self:addLuaEvent("ON_OPENDRESSCANRNIVAL_ITEM_CLICK", self, self.updateOpenServerPanelInfo); -- 打开panel
	self:addLuaEvent("SET_ACTIVITIES_BTN_REDDOT", self, self.rSetBtnRedDot);
	self:addLuaEvent("UPDATE_REDDOT_EVENT", self, self.updateAllPeopleRedDot);
	DataCenter.OperationalActivitiesData:sGetActivitiesInfo();
	-- self:createButtonList()
end

function Lua_OpenDressCarnivalWindow:showWin(param)
	self:superCall("showWin", param);

	self.iconId = param.iconId;
end

function Lua_OpenDressCarnivalWindow:createButtonList()
	local actList = DataCenter.OperationalActivitiesData:getActivitiesByIcon(self.iconId);
	local vo;
	local idx = 0;
	self.activitList = Array();
	for i = 1, actList:getSize() do
		vo = actList[i];
		if vo ~= nil then
			idx = idx + 1;
			self.activitList:add({
				data = vo,
				index = idx,
				isRedDot = false,
				panel = self.panelDic[vo.first_type].panel,
				clickRemoveEvent = self.panelDic[vo.first_type].clickRemoveEvent
			});
		end
	end

	self.selectNum = 1;
	if self.showData == nil then
		self.selectNum = 1;
	elseif type(self.showData) == "table" and self.showData.opName ~= nil then
		for i = 1, self.activitList:getSize() do
			if self.showData.opName == self.activitList[i].data.title then
				self.selectNum = i;
			end
		end
	end

	if self.selectedIndex ~= nil and self.activitList[self.selectedIndex] ~= nil then
		self.selectNum = self.selectedIndex;
	end
	if self.activitList[self.selectNum] == nil then
		return;
	end
	self.dragList:setLuaArrayData(self.activitList, false);
	self.dragList:setSelected(self.selectNum);
	self:updateOpenServerPanelInfo(self.activitList[self.selectNum], true);
end

function Lua_OpenDressCarnivalWindow:updateOpenServerPanelInfo(val)
	if self.selectedIndex == val.index then
		return;
	end
	self.selectedIndex = val.index;
	DataCenter.OperationalActivitiesData.curFirstType = val.data.first_type;

	local isResolve;
	if DataCenter.OperationalActivitiesData.notify_list:getSize() > 0 then
		for j = 1, #DataCenter.OperationalActivitiesData.notify_list[1] do
			if tonumber(DataCenter.OperationalActivitiesData.notify_list[1][j]) == tonumber(val.data.act_index)  then
				isResolve = true;
			end
		end
	end

	if isResolve ~= true then
		DataCenter.redDotData:updateRedDotVoState(val.clickRemoveEvent, false);
	end

	if DataCenter.OperationalActivitiesData.isSingCharging == true then
		DataCenter.redDotData:updateRedDotVoState(22060, true);
	end

	if DataCenter.OperationalActivitiesData.isSingCharge == true then
        DataCenter.redDotData:updateRedDotVoState(22066, true);
    end

	if self.curPanel ~= nil then
		self.curPanel:dispose();
		self.curPanel = nil;
	end
	self.curPanel = val.panel.new(self.content);
	self.curPanel.first_type = val.data.first_type;

	DataCenter.OperationalActivitiesData:sGetOperationalActivities(val.data.act_index, val.data.first_type);
	self:updateRedDot();
end

function Lua_OpenDressCarnivalWindow:rSetBtnRedDot(isselect)
	for i = 1, self.activitList:getSize() do
		local isRedDot = false;
		if DataCenter.OperationalActivitiesData.notify_list:getSize() > 0 then
			for j = 1, #DataCenter.OperationalActivitiesData.notify_list[1] do
				if self.activitList[i].data.act_index == DataCenter.OperationalActivitiesData.notify_list[1][j] then
					isRedDot = true;
				end
			end
		end

		if self.activitList[i].data.first_type == 1057 then -- 循环充值
			if DataCenter.redDotData:getRedDotStateByEventId(12220) then
				isRedDot = true;
			end
		end

		if self.activitList[i].data.first_type == 1058 then -- 循环消费
			if DataCenter.redDotData:getRedDotStateByEventId(12221) then
				isRedDot = true;
			end
		end

		if self.activitList[i].data.first_type == 1056 then -- 全民BOSS
			if DataCenter.redDotData:getRedDotStateByEventId(11219) then
				isRedDot = true;
			end
		end

		if self.activitList[i].data.first_type == 1061 then -- 累计消费
			if DataCenter.redDotData:getRedDotStateByEventId(22057) then
				isRedDot = true;
			end
		end

		if self.activitList[i].data.first_type == 1062 then -- 单笔消费   
			isRedDot = DataCenter.OperationalActivitiesData.isSingCharging;  
		end

		if self.activitList[i].data.first_type == 1090 then -- 单笔充值(每日轮换)    
			isRedDot = DataCenter.OperationalActivitiesData.isSingCharge; 
        end

		if self.activitList[i].data.first_type == 1068 then -- 喜结良缘   
			isRedDot = DataCenter.redDotData:getRedDotStateByEventId(22063);  
		end

		DataCenter.redDotData:updateRedDotVoState(self.activitList[i].clickRemoveEvent, isRedDot);
		self.activitList[i].isRedDot = isRedDot;
	end

	if isselect == nil or isselect then
		self.dragList:setSelected(self.selectNum);
	end
	self:updateRedDot()
end

-- 全民BOSS
function Lua_OpenDressCarnivalWindow:updateAllPeopleRedDot(val)
	if val.evenId == 11219 then
		self:rSetBtnRedDot();
	end
end

function Lua_OpenDressCarnivalWindow:updateRedDot() -- 刷新红点状态
	if self.dragList ~= nil then
		local arr = self.dragList.showList;
		for i = 1, arr:getSize() do
			arr[i]:updateRedDot();
		end
	end
end

function Lua_OpenDressCarnivalWindow:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	if self.activitList ~= nil then
		self.activitList:dispose();
		self.activitList:clear();
		self.activitList= nil;
	end
	if self.curPanel ~= nil then
		self.curPanel:dispose();
		self.curPanel = nil;
	end
	DataCenter.OperationalActivitiesData.isSingCharging = nil;

	self:superCall("dispose");
end





--------------------------------------------------





Lua_OpenDressCarnivalItem = class("Lua_OpenDressCarnivalItem", Lua_ListCell);
function Lua_OpenDressCarnivalItem:ctor(p)
	self:superCall("ctor", p, "OpenDressCarnivalItem_skin");
end

function Lua_OpenDressCarnivalItem:buildShowItem()
	self:superCall("buildShowItem");

	self.redDot:setEnable(false);
end

function Lua_OpenDressCarnivalItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.btnTxt.text = data.data.title;
	self:updateRedDot();
end

function Lua_OpenDressCarnivalItem:updateRedDot()
	self.redDot:setEnable(self._data.isRedDot or DataCenter.redDotData:getRedDotStateByEventId(self._data.clickRemoveEvent));
end

function Lua_OpenDressCarnivalItem:onPlayerSoundClick(go)
	Lua_MsgUtil.callFunc("ON_OPENDRESSCANRNIVAL_ITEM_CLICK", self._data);
end

function Lua_OpenDressCarnivalItem:onSelectionChange(val)
	self:superCall("onSelectionChange", val);

	if val then
		self.btnBg:setAltas("common_atlas_2", "ui_common_btn_y13");
		self.btnBg:setLocation(0, 3);
		self.btnTxt:setLocation(0, 4);
		self.redDot:setLocation(70, 26);
		self.btnTxt.colorStr = Lua_ColorDefine.transColor("FFFFFF");
	else
		self.btnBg:setAltas("common_atlas_2", "ui_common_btn_y12");
		self.btnBg:setLocation(0, -1);
		self.btnTxt:setLocation(0, 0);
		self.redDot:setLocation(70, 22);
		self.btnTxt.colorStr = Lua_ColorDefine.transColor("8ABAC8");
	end
end

function Lua_OpenDressCarnivalItem:dispose()
	self._data = nil;
	self:superCall("dispose");
end