-- 开宗立派
Lua_OpenFoundFactionPanel = class("Lua_OpenFoundFactionPanel", Lua_DisplayObject)
function Lua_OpenFoundFactionPanel:ctor(p)
	self:superCall("ctor", p, "OpenFoundFactionPanel_skin");
end

function Lua_OpenFoundFactionPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.roleIcon:setUrl("/images/common/ui_chuangtuanliye.png");
	self.roleIcon:SetDimensions(304, 439);
	self.roleIcon:setLocation(-397, -50, 0);

	self.dragList = Lua_DragList.new(self.content,1, Vector4(0, 0, 722, 225));
	self.dragList:setListCell(Lua_OpenFoundFactionItem, 90, 722, 1);
	self.dragList:setLocation(120, -131, 0);

	self:addLuaEvent("UPDATE_ONEPANEL_DATA", self, self.updatePanelInfo);
end

function Lua_OpenFoundFactionPanel:updatePanelInfo()
	if DataCenter.OpenDressCarnivalData.first_type == 1025 then
		self.eTimeNum = DataCenter.OpenDressCarnivalData.stop_tick; -- 活动结束时间
		self.times = DataCenter.OpenDressCarnivalData.times; -- 服务器当前时间戳（客户端使用）

		local start_tick = DataCenter.OpenDressCarnivalData.start_tick; -- 活动开始时间
		local content = DataCenter.OpenDressCarnivalData.content;

		local atimeStr1 =  TimeTransform.getInstance():transSeconds8(start_tick, "yyyy-MM-dd HH:mm");
		local atimeStr2 =  TimeTransform.getInstance():transSeconds8(self.eTimeNum, "yyyy-MM-dd HH:mm");
		local etimeStr =  TimeTransform.getInstance():transSeconds1((self.eTimeNum - self.times), true);
		self.openTimeLab.text = LanUtil.formateStr(LanUtil.getValue(127300), tostring(atimeStr1 .. "--" .. atimeStr2));
		self.endTimeLab.text = LanUtil.formateStr(LanUtil.getValue(127301), tostring(etimeStr));
		self.tipsLab.text = LanUtil.formateStr(LanUtil.getValue(127302), tostring(content)) 

		Lua_CommonUtil.addTimer("openFoundFaction_Timer", 1, self,self.onTimeStrTimer);

		self.dragList:setLuaArrayData(DataCenter.OpenDressCarnivalData.getOpenCommonData, false);
	end
end

function Lua_OpenFoundFactionPanel:onTimeStrTimer()
	self.eTimeNum = self.eTimeNum - 1;
	if self.eTimeNum - self.times > 0 then
		local etimeStr = TimeTransform.getInstance():transSeconds1(self.eTimeNum - self.times, true);
		self.endTimeLab.text = LanUtil.formateStr(LanUtil.getValue(127301), tostring(etimeStr));
	else
		Lua_CommonUtil.removeTimer(self, self.onTimeStrTimer);
	end
end

function Lua_OpenFoundFactionPanel:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose()
		self.dragList = nil;
	end
	Lua_CommonUtil.removeTimer(self, self.onTimeStrTimer);

	self:superCall("dispose");
end





--------------------------------------------------





Lua_OpenFoundFactionItem = class("Lua_OpenFoundFactionItem", Lua_ListCell);
function Lua_OpenFoundFactionItem:ctor(p)
	self:superCall("ctor", p, "OpenFoundFactionItem_skin");
end

function Lua_OpenFoundFactionItem:buildShowItem()
	self:superCall("buildShowItem");

	self.redDot:setEnable(false);

	self.rItem = Lua_RewardItem.new(self.content);
	self.rItem:setDepth(5);
	self.rItem:setMaxShow(3);
	self.rItem:setLayout(70, 70, 5);
	self.rItem:setClickWin(true);
	self.rItem:setMouseEnble(true);
	self.rItem:setItemScale(0.85, 0.85);
	self.rItem:setLocation(21, 1, 0);

	self.subBtn:addClickFuntion(self,self.onGetBtnClick);
end

function Lua_OpenFoundFactionItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.nameTxt.text = data.title_name;
	self.numbeTxt.text = data.sub_number;

	local effList = data.spec_effect_item;
	local effDic = {};
	for i = 1, #effList do
		effDic[tonumber(effList[i])] = 1;
	end
	-- print(#effList, "Lua_OpenFoundFactionPanel");

	local obj;
	local tvo;
	local rewardInfoArr = Array();
	for i = 1, #data.reward_set do
		obj = data.reward_set[i];
		if obj.bind == 2 then
			tvo = Lua_ToolVo.createToolVo(obj.id, obj.amount, 1);
		else
			tvo = Lua_ToolVo.createToolVo(obj.id, obj.amount, obj.bind);
		end
		tvo.packType = 999;
		tvo.star = obj.equipment.star;
		tvo.bShowItemBg = true;
		tvo.roundEffect = effDic[obj.id] == 1;

		rewardInfoArr:add(tvo);
	end
	self.rItem:setRewardByArray(rewardInfoArr);

	if data.isReward == 0 then -- 0未领取，1已领取，2表示条件不足
		self.subBtn.label = LanUtil.getValue(122527);
	elseif data.isReward == 1 then
		self.subBtn.label  = LanUtil.getValue(122528);
	else
		self.subBtn.label  = LanUtil.getValue(122527);
	end
	self.redDot:setEnable(data.isReward == 0);
	self.subBtn:setBtnEnable(data.isReward == 0);
end

function Lua_OpenFoundFactionItem:checkOutBound(showRect)
	if self._data == nil then
		return;
	end

	local width = self.rItem.awords[1].item_bg.width;
	local height = self.rItem.awords[1].item_bg.height;
	local itemImg;
	local rect = Lua_Rectangle.new(self.itemX - width / 2, self.itemY - height / 2, width, height);
	for i = 1, #self._data.reward_set do
		itemImg = self.rItem:getToolImageById(self._data.reward_set[i].id)
		itemImg:showRoundEff(showRect:containeRect(rect) and itemImg.data.roundEffect);
	end
end

function Lua_OpenFoundFactionItem:onGetBtnClick()
	local avo = DataCenter.OperationalActivitiesData:getActivitiesByType(1025, nil);
	if avo == nil then
		return;
	end
	DataCenter.OperationalActivitiesData:buyReward(avo.act_index, tonumber(self._data.reward_index), 1);
end

function Lua_OpenFoundFactionItem:dispose()
	if self.rItem ~= nil then
		self.rItem:dispose();
		self.rItem = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end