-- 单笔充值
Lua_SingleChargingPanel = class("Lua_SingleChargingPanel", Lua_DisplayObject)
function Lua_SingleChargingPanel:ctor(p)
	self:superCall("ctor", p, "OpenCommonPanel_skin");
end

function Lua_SingleChargingPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.artDesIcon:setAltas("crossServerRecharge_atlas", "ui_dbcz_z1");

	self.dragList = Lua_DragList.new(self.content,1, Vector4(0, 0, 750, 285));
	self.dragList:setLocation(119, -105, 0);
	self.dragList:setListCell(Lua_SingleChargingItem, 130, 750, 1);

	self:addLuaEvent("SINGLE_CHARGINGINFO", self, self.updatePanelInfo);
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sGetActivityInfo(DataCenter.OperationalActivitiesData.curFirstType);
end

function Lua_SingleChargingPanel:updatePanelInfo(msg)
	local data = msg.activity_info
	local end_other = tonumber(tostring(data.end_tick));
	local stop_tick = tonumber(tostring(data.start_tick)); -- 活动结束时间
	local start_tick = tonumber(tostring(data.start_tick)); -- 活动开始时间
	self.eTimeNum = end_other > 0 and end_other or stop_tick;
	if self.eTimeNum - tonumber(tostring(GlobalVar.cur_tick)) >= 86400 * 30 then
		self.open_time.text = LanUtil.formateStr(LanUtil.getValue(127300), "永久开启");
	else
		local atimeStr1 =  TimeTransform.getInstance():transSeconds8(start_tick, "yyyy-MM-dd HH:mm");
		local atimeStr2 =  TimeTransform.getInstance():transSeconds8(self.eTimeNum, "yyyy-MM-dd HH:mm");
		self.open_time.text = LanUtil.formateStr(LanUtil.getValue(127300), tostring(atimeStr1.."--"..atimeStr2));
	end

	if end_other > 0  then
		self:onTimeStrTimer();
		Lua_CommonUtil.addTimer("openFactionFight_Timer", 1, self, self.onTimeStrTimer);
	end
	self.tips.text = LanUtil.formateStr(LanUtil.getValue(127302), tostring(data.content));

	local arr = Array();
	for i,v in ipairs(msg.rewards) do
		arr:add(v);
	end
	self.dragList:setLuaArrayData(arr, false);
end

function Lua_SingleChargingPanel:onTimeStrTimer()
	local pt = self.eTimeNum - tonumber(tostring(GlobalVar.cur_tick));
	if pt > 0 then
		if pt > 86400 * 30 then
			self.end_time.text = LanUtil.formateStr(LanUtil.getValue(127301), "永久开启");
		else
			local etimeStr = TimeTransform.getInstance():transSeconds1(pt, true);
			self.end_time.text = LanUtil.formateStr(LanUtil.getValue(127301), tostring(etimeStr));
		end
	else
		Lua_CommonUtil.removeTimer(self, self.onTimeStrTimer);
	end
end

function Lua_SingleChargingPanel:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose()
		self.dragList = nil;
	end
	Lua_CommonUtil.removeTimer(self, self.onTimeStrTimer);

	self:superCall("dispose");
end










Lua_SingleChargingItem = class("Lua_SingleChargingItem", Lua_ListCell);
function Lua_SingleChargingItem:ctor(p)
	self:superCall("ctor", p, "OpenCommonItem_skin");
end

function Lua_SingleChargingItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemArr = Array();
	self.condTxt:setEnable(false);

	self.redDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 332, 23, 0, 0);
	self.redDot.name = "redDot";
	self.redDot:setDepth(6);
	self.redDot:setEnable(false);

	self.money = UICreate.createUIAtlasImage(self.content, "icon_atlas_3", "money_209000003", -231, 47, 30, 30)
	self.money:setDepth(3);

	self.subBtn:addClickFuntion(self, self.onGetBtnClick);
end

function Lua_SingleChargingItem:setData(data)
    self._data = data;
    if data == nil then
    	return;
    end

	local moneyNum;
	if data.cond[1] ~= nil then
		moneyNum = data.cond[1];
	elseif data.cond[2] ~= nil then
		moneyNum = data.cond[2];
	elseif data.cond[3] ~= nil then
		moneyNum = data.cond[3];
	end
	-- self.titleTxt.text = data.title_name;
	self.titleTxt.text = LanUtil.formateStr(LanUtil.getValue(127317), tostring(moneyNum));

	local maxNum = #data.reward_items > self.itemArr:getSize() and #data.reward_items or self.itemArr:getSize();
	local obj;
	local tvo;
	local itemImg;
	for i = 1, maxNum do
		itemImg = self.itemArr[i];
		if i <= #data.reward_items then
			obj = data.reward_items[i];
			tvo = Lua_ToolVo.createToolVo(obj.id, obj.amount, obj.bind == 2 and 1 or obj.bind);
			tvo.packType = 999;
			tvo.star = obj.equipment.star;
			tvo.bShowItemBg = true;
			tvo.roundEffect = obj.show_effect == 1;

			if itemImg == nil then
				itemImg = Lua_ToolImage.new(self.content);
				self.itemArr:add(itemImg);
			end
			itemImg.data = tvo;
			itemImg:setDepth(2);
			itemImg:setScale(0.85, 0.85, 0.85);
			itemImg:setLocation(-310 + (i - 1) * 70, -18, 0);
			itemImg:setEnable(true);
		else
			if itemImg ~= nil then
				itemImg:setEnable(false);
			end
		end
	end

	if data.state == 0 then
		self.subBtn.label = LanUtil.getValue(122543);
	elseif data.state == 1 then
		self.subBtn.label = LanUtil.getValue(140714);
	else
		self.subBtn.label = LanUtil.getValue(127603);
	end
	self.redDot:setEnable(data.state == 1);
end

function Lua_SingleChargingItem:checkOutBound(showRect)
	local width = 75 * 0.85;
	local height = 77 * 0.85;
	local rect = Lua_Rectangle.new(self.itemX - width / 2, self.itemY - height / 2 - 18, width, height);
	local isShow = showRect:containeRect(rect);
	local item;
	for i = 1, self.itemArr:getSize() do
		item = self.itemArr[i];
		item:showRoundEff(item.data.roundEffect and isShow);
	end
end

function Lua_SingleChargingItem:onGetBtnClick()
	if self._data.state == 0 then
		Lua_WindowUtil.openWin("Lua_ChongzhiWindow")
		Lua_WindowUtil.openWin("Lua_OpenDressCarnivalWindow", WinParam.ACTION_CLOSE)
	elseif self._data.state == 1 then
		local cmd = ProtoPublic_pb.Proto10105602();
		cmd.index = tonumber(self._data.index);
		cmd.first_type = DataCenter.OperationalActivitiesData.curFirstType;
		sendMsg(10105602, cmd);
	end
end

function Lua_SingleChargingItem:dispose()
	self:superCall("dispose");
end