-- 喜结良缘
Lua_TieTheKnotPanel = class("Lua_TieTheKnotPanel", Lua_DisplayObject);
function Lua_TieTheKnotPanel:ctor(p)
	self:superCall("ctor", p, "TieTheKnotPanel_skin");
end

function Lua_TieTheKnotPanel:buildShowItem()
	self:superCall("buildShowItem");
	self.roleBg:setUrl("/images/operationalActivities/yyhd_xjly.png");

	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sGetActivityInfo(Lua_OperationalActivitiesData.ACT_TIE_THE_KNOT);

	self.rItemList_1 = Lua_DragList.new(self.content, 2, Vector4(0, 0, 300, 85));
	self.rItemList_1:setLocation(-65, -90, 0);
	self.rItemList_1:setListCell(Lua_TieTheKnotItem, 85, 85, 9999);

	self.rItemList_2 = Lua_DragList.new(self.content, 2, Vector4(0, 0, 300, 85));
	self.rItemList_2:setLocation(285, -90, 0);
	self.rItemList_2:setListCell(Lua_TieTheKnotItem, 85, 85, 9999);

	self.redDot_1:setEnable(false);
	self.redDot_2:setEnable(false);
	self.getBtn_1:setBtnEnable(false);
	self.getBtn_2:setBtnEnable(false);
	self.getBtn_1:addClickFuntion(self,self.onGetBtn1Click);
	self.getBtn_2:addClickFuntion(self,self.onGetBtn2Click);

    self:addLuaEvent("UPDATE_TIE_THE_KNOT",self,self.updatePanelInfo);
end

function Lua_TieTheKnotPanel:dispose()
	Lua_CommonUtil.removeTimer(self, self.updateResidueTime);
	self:superCall("dispose");
end

function Lua_TieTheKnotPanel:updatePanelInfo()
	local start_tick = tonumber(DataCenter.tieTheKnotData.start_tick);
	local end_tick = tonumber(DataCenter.tieTheKnotData.end_tick);
	local content = DataCenter.tieTheKnotData.content;

	local sTimeStr = TimeTransform.getInstance():transSeconds8(start_tick, "yyyy-MM-dd HH:mm");
	local eTimeStr = TimeTransform.getInstance():transSeconds8(end_tick, "yyyy-MM-dd HH:mm");
	self.open_time.text = LanUtil.formateStr(LanUtil.getValue(141600), tostring(sTimeStr .. "--" .. eTimeStr));
	self.tips.text = LanUtil.formateStr(LanUtil.getValue(141602), tostring(content));

	Lua_CommonUtil.addTimer("TieTheKnot_ResidueTime", 1, self, self.updateResidueTime, nil, -1);
	self:updateResidueTime();

	self.data = DataCenter.tieTheKnotData.getRewardsData;
	self.rItemList_1:setLuaArrayData(self.data[1].rewardArr, false);
	self.rItemList_2:setLuaArrayData(self.data[2].rewardArr, false);

	if self.data[1].state == 0 then
		self.redDot_1:setEnable(false);
		self.getLabel_1:setEnable(false);
		self.getBtn_1:setEnable(true);
		self.getBtn_1:setBtnEnable(false);
		self.getBtn_1.label = LanUtil.getValue(140714);
	elseif self.data[1].state == 1 then
		self.redDot_1:setEnable(true);
		self.getLabel_1:setEnable(false);
		self.getBtn_1:setEnable(true);
		self.getBtn_1:setBtnEnable(true);
		self.getBtn_1.label = LanUtil.getValue(140714);
	elseif self.data[1].state == 2 then
		self.redDot_1:setEnable(false);
		self.getLabel_1:setEnable(true);
		self.getBtn_1:setEnable(false);
		self.getLabel_1.text = "["..Lua_ColorDefine.GREEN_STR.."]"..LanUtil.getValue(140715);
	end

	if self.data[2].state == 0 then
		self.redDot_2:setEnable(false);
		self.getLabel_2:setEnable(false);
		self.getBtn_2:setEnable(true);
		self.getBtn_2:setBtnEnable(false);
		self.getBtn_2.label = LanUtil.getValue(140714);
	elseif self.data[2].state == 1 then
		self.redDot_2:setEnable(true);
		self.getLabel_2:setEnable(false);
		self.getBtn_2:setEnable(true);
		self.getBtn_2:setBtnEnable(true);
		self.getBtn_2.label = LanUtil.getValue(140714);
	elseif self.data[2].state == 2 then
		self.redDot_2:setEnable(false);
		self.getLabel_2:setEnable(true);
		self.getBtn_2:setEnable(false);
		self.getLabel_2.text = "["..Lua_ColorDefine.GREEN_STR.."]"..LanUtil.getValue(140715);
	end
end

-- 活动剩余时间
function Lua_TieTheKnotPanel:updateResidueTime()
	local end_time = tonumber(DataCenter.tieTheKnotData.end_tick) - DataCenter.roleData.serverTime;
	if end_time > 0 then
		self.end_time.text = LanUtil.formateStr(LanUtil.getValue(141601), TimeTransform.getInstance():transSeconds1(end_time, true));
	else
		self.end_time.text = LanUtil.getValue(141603);
		Lua_CommonUtil.removeTimer(self, self.updateResidueTime);
	end
end

function Lua_TieTheKnotPanel:onGetBtn1Click()
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sGetActivityRewards(Lua_OperationalActivitiesData.ACT_TIE_THE_KNOT, self.data[1].index);
end

function Lua_TieTheKnotPanel:onGetBtn2Click()
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sGetActivityRewards( Lua_OperationalActivitiesData.ACT_TIE_THE_KNOT, self.data[2].index);
end



















Lua_TieTheKnotItem = class("Lua_TieTheKnotItem", Lua_ListCell);
function Lua_TieTheKnotItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImg = Lua_ToolImage.new(self.content);
    self.itemImg:setDepth(5);
    self.itemImg:setLocation(0, 0, 0);
    self.itemImg:setScale(1, 1, 1);
    self.itemImg:setCanClick(false);
end
function Lua_TieTheKnotItem:setData(data)
	self.data = data;

	self.itemImg.data = data.vo;
	self.itemImg:showMaskSp(false);
	self.itemImg:showNotYetImg(false);

	if data.show_effect == 1 then
		self.itemImg:showRoundEff(true);
		if roundEff ~= nil then
			self.itemImg.roundEff:setSacle(0.9,0.9,0.9);
			self.itemImg.roundEff:SetRenderQueue(self.itemImg.item_bg, 5, 2, true);
		end
	end
end 
function Lua_TieTheKnotItem:onPlayerSoundClick(go)
	if self.data ~= nil then
		Lua_PackUtil.showItemInfo(self.data.vo);
	end
end

function Lua_TieTheKnotItem:checkOutBound(showRect)
	if self.itemImg.roundEff ~= nil then
		local rect = Lua_Rectangle.new(self.itemX - 20, self.itemY, 49, 35);
		if showRect:containeRect(rect) == true then
			self.itemImg.roundEff:setEnable(true);
		else
			self.itemImg.roundEff:setEnable(false);
		end
	end
end