-- 0元抢购
checkRequire("Lua_Purchasetem");
checkRequire("Lua_PurchaseData");
Lua_PurchaseWindow = class("Lua_PurchaseWindow", Lua_Window);
function Lua_PurchaseWindow:ctor()
	self:superCall("ctor", self.list);

	self.windowName = "Lua_PurchaseWindow";
	self.skinName = "PirchaseWindow_skin";
	self.showClose = false;
end

function Lua_PurchaseWindow:buildShowItem()
	self:superCall("buildShowItem");

	local avo = DataCenter.OperationalActivitiesData:getActivitiesByType(1031, 0);
	if avo == nil then
		self:hide();
		return;
	end
	self.cotent = avo.content;
	self.end_tick = avo.end_tick;
	self.times = avo.times;
	self.actIndex = avo.act_index;

	DataCenter.OperationalActivitiesData:sGetOperationalActivities(avo.act_index, 1031);
	DataCenter.OperationalActivitiesData:sGetActivitiesInfo();

	self.lengthact = 1;
	self.arr = Array()

	self.purchasedList = Lua_DragList.new(self.content, 2, Vector4(0, 0, 1054, 470));
	self.purchasedList.canDrag = false; -- 设置不可拖动
	self.purchasedList:setListCell(Lua_Purchasetem, 404, 1054, 30);
	self.purchasedList:setLocation(-4, -41, 0);

	self.panel = UICreate.createGameObject(self.content, 0, 0, 0);
	self.uiPanel = self.panel:AddComponent(typeof(UIPanel));

	self.arrowLeft = UICreate.createUIAtlasImage(self.panel, "common_atlas_2", "ui_common_jiantou_03", -493.5, -8, 0, 0);
	self.arrowLeft.name = "arrowLeft";
	self.arrowLeft:setDepth(20);
	self.arrowLeft:setEnable(false);

	self.arrowRight = UICreate.createUIAtlasImage(self.panel, "common_atlas_2", "ui_common_jiantou_03", 486.5, -8, 0, 0);
	self.arrowRight.name = "arrowRight";
	self.arrowRight:setDepth(20);
	self.arrowRight:setScale(-1, 1, 1);

	self.time = self.end_tick - self.times;
	self.isShowBtn = self.time <= 0;
	if self.time > 0 then
		Lua_CommonUtil.addTimer("CountDown", 0.3, self, self.onCountDown);
	else
		Lua_CommonUtil.removeTimer(self, self.onCountDown);
	end
	self:onCountDown();

	self.arrowLeft:addClickFuntion(self, self.arrowLeftBtnClick);
	self.arrowRight:addClickFuntion(self, self.arrowRightBtnClick);
	self.ruleIcon:addClickFuntion(self, self.onRuleClick);

	self:addLuaEvent("UPDATE_ONEPANEL_DATA", self, self.rpurchaseData);
end

function Lua_PurchaseWindow:onCountDown()
	local pt = self.end_tick - tonumber(tostring(GlobalVar.cur_tick))
	if pt > 0 then
		self.timetips.text = LanUtil.formateStr(LanUtil.getValue(127503), TimeTransform.getInstance():transSeconds1(pt, true));
	else
		self.timetips.text = LanUtil.getValue(122586);
		self.isShowBtn = true;
		Lua_CommonUtil.removeTimer(self, self.onCountDown);
	end
end

function Lua_PurchaseWindow:rpurchaseData(msg)
	if DataCenter.OperationalActivitiesData.act_detail.first_type ~= 1031 then
		return ;
	end

	local purchaseData = Lua_PurchaseData.new();
	purchaseData:sGetPurchaseRewardInfo(msg)

	local len = purchaseData.arr:getSize();
	for i = 1, len do
		purchaseData.arr[i].actIndex = self.actIndex;
		purchaseData.arr[i].isShowBtn = self.isShowBtn;
	end

	self.length = math.ceil(len / 3);
	self:showBtn(self.length);

	local arr = Array();
	for i = 1, self.length do
		arr:add({page = i, arr = purchaseData.arr, startIndex = (i - 1) * 3, actIndex = self.actIndex});
	end
	self.purchasedList:setLuaArrayData(arr, true);
end

function Lua_PurchaseWindow:arrowRightBtnClick()
	self.lengthact = self.lengthact + 1;
	self:showBtn(self.length)
end

function Lua_PurchaseWindow:arrowLeftBtnClick()
	self.lengthact = self.lengthact - 1;
	self:showBtn(self.length)
end

function Lua_PurchaseWindow:showBtn(index)
	self.arrowRight:setEnable(self.lengthact < index);
	self.arrowLeft:setEnable(self.lengthact > 1);
	self.purchasedList:moveToIndex(self.lengthact);
end

function Lua_PurchaseWindow:onRuleClick()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", nil, self.cotent)
end

function Lua_PurchaseWindow:dispose()
	Lua_CommonUtil.removeTimer(self, self.onCountDown);

	self:superCall("dispose");
end