Lua_Purchasetem = class("Lua_Purchasetem", Lua_ListCell)
function Lua_Purchasetem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_Purchasetem:buildShowItem()
	self:superCall("buildShowItem");

	local posX = {-340, 0, 340};
	local item;
	self.purchaseArr = Array();
	for i = 1, 3 do
		item = Lua_Purchaserofferitem.new(self.content);
		item:setLocation(posX[i], 0, 0);
		self.purchaseArr:add(item);
	end
end

function Lua_Purchasetem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local subItemData;
	for i = 1, self.purchaseArr:getSize() do
		subItemData = data.arr[data.startIndex + i];
		if subItemData == nil then
			self.purchaseArr[i]:setEnable(false);
		else
			self.purchaseArr[i]:setEnable(true);
			self.purchaseArr[i]:loadCallFun();
			self.purchaseArr[i]:setData(subItemData, i);
		end
	end
end

function Lua_Purchasetem:checkOutBound(showRect)
	local subItemData;
	local width = 300;
	local height = 295;
	local rect;
	for i = 1, self.purchaseArr:getSize() do
		subItemData = self._data.arr[self._data.startIndex + i];
		if subItemData ~= nil then
			rect = Lua_Rectangle.new(self.itemX + self.purchaseArr[i].x - width / 2, self.itemY - height / 2, width, height);
			self.purchaseArr[i]:setModelState(showRect:containeRect(rect));
		end
	end
end

function Lua_Purchasetem:dispose()
	if self.purchaseArr ~= nil then
		self.purchaseArr:dispose();
		self.purchaseArr = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end










Lua_Purchaserofferitem = class("Lua_Purchaserofferitem", Lua_DisplayObject)
function Lua_Purchaserofferitem:ctor(p)
	self:superCall("ctor", p, "Pirchaseitem_skin");
end

function Lua_Purchaserofferitem:buildShowItem()
	self:superCall("buildShowItem");

	self.fightNum = Lua_NumberImage.new(self.content);
	self.fightNum.prefix = "a_";
	self.fightNum.numWidth = 19
	self.fightNum:setDepth(6);
	self.fightNum:setLocation(-99, -170, 0);

	self.titleLab.clickScale = false;
	self.titleLab:addClickFuntion(self, self.onTipsClick);
	self.buyBtn:addClickFuntion(self, self.buybtnClick);
end

function Lua_Purchaserofferitem:setData(data, index)
	self._data = data;
	self.setindex = index;
	-- print(data.id, data.subType, data.mounter_sca[1]);

	if self.playerModel ~= nil then
		self.playerModel:dispose();
		self.playerModel = nil;
	end
	if self.modelTexture ~= nil then
		self.modelTexture:dispose();
		self.modelTexture = nil;
	end
	if data.subType == Lua_PackTypeDefine.FASION then
		self:createModelPlayer();
	else
		self:createUIModelTexture();
	end

	self.titleLab.text = data.name;

	self.fightNum.num = data.force;
	self.fightNum:setNumScale(0.8, 0.8)

	local day = math.floor(data.days / 86400);
	-- print("Lua_Purchasetem", data.days, data.days / 86400, day);
	day = day <= 0 and 1 + 3 or day + 3;
	day = day > 7 and 10 or day; -- 大于7天，照样显示7天
	self.returnNumIcon:setAltas("purchase_atlas", "ui_zero_font".. day);
	self.returnNumIcon:resetSize();

	local time = TimeTransform.getInstance():transTimeLeft(data.arrive_tick);
	self.returnMoneyLab.text = data.returnmoneyNum;
	self.buyMoneyLab.text = data.moneyNum;
	self.tipsLab.text = LanUtil.formateStr(LanUtil.getValue(127501), tostring(time), tostring(data.returnmoneyNum));

	self.returnMoneyIcon:setAltas("icon_atlas_3", "money_" .. data.returnmoneyType);
	self.buyMoneyIcon:setAltas("icon_atlas_3", "money_" .. data.moneyType);
	self.tipsMoneyIcon:setAltas("icon_atlas_3", "money_" .. data.returnmoneyType);

	if data.draw_flag == 1 then
		if data.isReturn == 1 then
			if data.arrive_tick == 0 then
				self.tipsLab.text = LanUtil.getValue(127502)
			else
				self.tipsLab.text = LanUtil.formateStr(LanUtil.getValue(127501), time, tostring(data.returnmoneyNum));
			end
			local posX = self.tipsLab.mainContent.transform.localPosition.x + self.tipsLab.width / 2 + 4;
			self.tipsMoneyIcon:setLocation(posX, 2, 0);
		end
		self.purchasedObj:SetActive(true);
		self.btnObj:SetActive(false);
		self.tipsObj:SetActive(data.isReturn == 1);
	else
		self.purchasedObj:SetActive(false);
		self.btnObj:SetActive(true);
		self.tipsObj:SetActive(false);
	end
	if data.isShowBtn == true then
		self.btnObj:SetActive(false);
	end
	self.returnObj:SetActive(data.isReturn == 1);
end

function Lua_Purchaserofferitem:createModelPlayer()
	local modelData = UsData();
	modelData.career = DataCenter.roleData.career;
	modelData.gender = modelData.career == 2 and Lua_ThingDefine.FEMALE or Lua_ThingDefine.MALE; -- 性别

	local fashion_clothes_id = self._data.temaiShowModelID == nil and self._data.model or self._data.temaiShowModelID;
	if self._data.part == 3 then
		modelData.fashion_clothes_id = fashion_clothes_id; -- 时装衣服
	elseif self._data.part == 2 then
		modelData.fashion_weapon_id = fashion_clothes_id; -- 时装武器
	elseif self._data.part == 1 then
		modelData.fashionHeadId = fashion_clothes_id; -- 时装头饰
	end
	modelData.nickname = "";
	modelData.hp = 1;
	modelData.kind = 2;
	modelData.isShowName = false;
	modelData.IsUI = true;

	local pos = Vector3(-6, -130, 0);
	local rot = Vector3(0, 90, 0);
	self.playerModel = ModelPlayer();
	self.playerModel:init(self.content, pos, rot, modelData, nil, self._data.mounter_sca[1]);
	self.playerModel:setRotEnable(true, 6, 130, 300, 295, 2);
	self.playerModel:SetRenderQueue(self.forceBg, -1, 2);
	self.playerModel:addLuaLoadedCallBack(self, self.onModelLoaded);
	-- self.playerModel:setAction();
end

function Lua_Purchaserofferitem:createUIModelTexture()
	local imgPos = Vector2(0, 0);
	local imgSize = Vector2(300, 295);
	local modelRot = Vector3(0, 180, 0);
	local modelOffset = Vector2(-0, -900);

	self.modelTexture = UIModelTexture();
	self.modelTexture:init(self.content, imgPos, imgSize, 2, modelRot, modelOffset, self._data.mounter_sca[1]);
	self.modelTexture:setCamView(5);
	self.modelTexture:setCamPos(0, self.setindex * 2000, 0);
	self.modelTexture:setRotEnable(true, 0, 0, 300, 295, 2)
	self.modelTexture:setModelOffset(self._data.mounter_pos[1], self._data.mounter_pos[2], 6500);
	self.modelTexture:setEffectPos(self._data.setmodelAngle[1], self._data.setmodelAngle[2], self._data.setmodelAngle[3]);
	self.modelTexture:setModelAngle(self._data.mounter_rot[1], self._data.mounter_rot[2], self._data.mounter_rot[3]);
	self.modelTexture:addLuaLoadedCallBack(self, self.onModelLoaded);

	if self._data.temaiShowModelID == nil then
		self.modelTexture:setUrl(self._data.floder .. "/" .. self._data.modelFile, self._data.model);
	else
		self.modelTexture:setUrl(self._data.floder .. "/" .. self._data.temaiShowModelID, self._data.temaiShowModelID);
	end
end

function Lua_Purchaserofferitem:onModelLoaded()
	if self.loadEffect ~= nil then
		self.loadEffect:setEnable(false);
	end
end

function Lua_Purchaserofferitem:onTipsClick()
	Lua_PackUtil.showItemInfo(Lua_ToolVo.new(self._data.id), false)
end

function Lua_Purchaserofferitem:buybtnClick()
	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	local bagNum = bagData:getLeftSize()
	if bagNum <= 0 then
		DataCenter.packData:showFullBagTip(Lua_PackData.BAG_PACK);
			return;
		end

		if self._data.moneyType == Lua_MoneyData.BIND_GOLD then
			if DataCenter.moneyData:getMoney(Lua_MoneyData.BIND_GOLD) < self._data.moneyNum
				and DataCenter.moneyData:getMoney(Lua_MoneyData.GOLD) >= self._data.moneyNum then
					Lua_WindowUtil.openWin("Lua_TipsWindow", WinParam.ACTION_OPEN, {
						owner = self, des = LanUtil.getValue(122577), type = 1, subFun = self.onSubCallback
					});
		else
			DataCenter.OperationalActivitiesData:buyReward(self._data.actIndex, self._data.index, 1)
		end
	else
		if DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD, self._data.moneyNum, true, true) == false then
			return;
		end
		DataCenter.OperationalActivitiesData:buyReward(self._data.actIndex, self._data.index, 1);
	end
end

function Lua_Purchaserofferitem:onSubCallback()
	DataCenter.OperationalActivitiesData:buyReward(self._data.actIndex, self._data.index, 1)
end

function Lua_Purchaserofferitem:loadCallFun()
	if self.loadEffect == nil then
		self.loadEffect = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_loadingring", "gui_loadingring", 0, 0);
		self.loadEffect:SetRenderQueue(self.bg, 1, 2, false);
	end
	self.loadEffect:setEnable(false);
	self.loadEffect:setEnable(true);
end

function Lua_Purchaserofferitem:setModelState(val)
	if val == true then
		if data.subType == Lua_PackTypeDefine.FASION then
			self.playerModel:setActive(true);
		else
			if self.modelTexture ~= nil then
				self.modelTexture:setEffectActive(true);
				-- self.modelTexture.uiEffect:setAction(self._data.setAction);
			end
		end

		-- 循环播放
		-- self.modelTexture.uiEffect:setLoop(true);
		-- 交替显隐
		if self._data.setAction == 2 then
			Lua_CommonUtil.addTimer("Lua_Purchaserofferitem", 2, self, self.effectRoot);
		else
			Lua_CommonUtil.removeTimer(self, self.effectRoot);
		end
	else
		if data.subType == Lua_PackTypeDefine.FASION then
			self.playerModel:setActive(false);
		else
			self.modelTexture:setEffectActive(false);
		end
		Lua_CommonUtil.removeTimer(self, self.effectRoot);
	end
end

function Lua_Purchaserofferitem:effectRoot()
	if self.modelTexture == nil then
		return;
	end
	self.modelTexture.uiEffect:setEnable(false);
	self.modelTexture.uiEffect:setEnable(true);
end

function Lua_Purchaserofferitem:dispose(p)
	if self.modelTexture ~= nil then
		self.modelTexture:dispose();
		self.modelTexture = nil;
	end
	Lua_CommonUtil.removeTimer(self, self.effectRoot);
	self._data = nil;

	self:superCall("dispose");
end