-- 外观特卖
checkRequire("Lua_Specialofferitem");
Lua_SpecialofferWindow = class("Lua_SpecialofferWindow", Lua_Window);
function Lua_SpecialofferWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_SpecialofferWindow";
	self.skinName = "SpecialofferWindow_skin";
	self.showClose = false;
end

function Lua_SpecialofferWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.firstType = 1014;
	self.length = 1;

	self.showList = Lua_DragList.new(self.content,2, Vector4(0, 0, 1054, 481));
	self.showList.canDrag = false;
	self.showList:setListCell(Lua_Specialofferitem, 481, 1054, 30);
	self.showList:setLocation(0, -57, 0);

	self.panel = UICreate.createGameObject(self.content, 0, 0, 0);
	self.uiPanel = self.panel:AddComponent(typeof(UIPanel)); 

	self.arrowLeft = UICreate.createUIAtlasImage(self.panel, "common_atlas_2", "ui_common_jiantou_03", -495, -8, 0, 0);
	self.arrowLeft.name = "arrowLeft";
	self.arrowLeft.clickScale = false;
	self.arrowLeft:setDepth(20);
	self.arrowLeft:setEnable(false);

	self.arrowRight = UICreate.createUIAtlasImage(self.panel, "common_atlas_2", "ui_common_jiantou_03", 486, -8, 0, 0);
	self.arrowRight.name = "arrowRight";
	self.arrowRight.clickScale = false;
	self.arrowRight:setDepth(20);
	self.arrowRight:setScale(-1, 1, 1);

	self.arrowLeft:addClickFuntion(self, self.arrowLeftBtnClick);
	self.arrowRight:addClickFuntion(self, self.arrowRightBtnClick);
	self.wenhao:addClickFuntion(self, self.onRulesClick);
end

function Lua_SpecialofferWindow:showWin(param)
	self:superCall("showWin", param);

	if type(param) == "number" then
		self.secondType = param;
	else
		self.secondType = param.openIdx
	end

	local avo = DataCenter.OperationalActivitiesData:getActivitiesByType(self.firstType, self.secondType);
	if avo == nil then
		self:hide();
	end

	self.actIndex = avo.act_index; -- 活动id
	self.cotent = avo.content; -- 活动描述
	self.end_tick = avo.end_tick; -- 结束时间
	self.cur_tick = avo.times; -- 服务器当前时间戳

	-- if self.secondType == 1 then
	-- 	self.titleIcon:setAltas("Specialofferwindow", "xuanzhuangTitle"); -- 旋转特卖
	-- 	self.tipsLab.text = LanUtil.getValue(122588);
	-- elseif self.secondType == 2 then
	-- 	self.titleIcon:setAltas("Specialofferwindow", "temaiTitle"); -- 外观特卖
	-- 	self.tipsLab.text = LanUtil.getValue(122589);
	-- end

	self:addLuaEvent("UPDATE_ONEPANEL_DATA", self, self.rspecialofferData);
	DataCenter.OperationalActivitiesData:sGetActivitiesInfo();
	DataCenter.OperationalActivitiesData:sGetOperationalActivities(avo.act_index, self.firstType);
end

function Lua_SpecialofferWindow:rspecialofferData()
	if DataCenter.OperationalActivitiesData.act_detail.first_type ~= self.firstType then
		return;
	end

	local actdetail = DataCenter.OperationalActivitiesData:getOpenSpecialofferData();
	self.lengthact = actdetail:getSize()
	for i = 1, self.lengthact do
		actdetail[i].actIndex = self.actIndex;	
	end

	local arr = Array();
	local len = math.ceil(self.lengthact / 3);
	for i = 1, len do
		arr:add({
			actIndex = self.actIndex,
			firstType = self.firstType,
			secondType = self.secondType,
			arr = actdetail,
			startIndex = (i - 1) * 3
		});
	end
	self.showList:setLuaArrayData(arr, true);

	self:startTimer();
	self:onCountDown();

	self.arrowRight:setEnable(self.lengthact > 3 * self.length);
	self.arrowLeft:setEnable(self.length > 1);
end

function Lua_SpecialofferWindow:startTimer()
	if self.countDown ~= true then
		self.countDown = true;
		Lua_CommonUtil.addTimer("Lua_SpecialofferWindow", 1, self, self.onCountDown);
	end
end

function Lua_SpecialofferWindow:onCountDown()
	local time = self.end_tick - tonumber(tostring(GlobalVar.cur_tick));
	if time > 0 then
		self.timetips.text = LanUtil.formateStr(LanUtil.getValue(127520), TimeTransform.getInstance():transSeconds1(time, true));
	else
		self.timetips.text = LanUtil.getValue(122586);
		self:endTimer();
	end
end

function Lua_SpecialofferWindow:endTimer()
	if self.countDown == true then
		self.countDown = false;
		Lua_CommonUtil.removeTimer(self, self.onCountDown); 
	end
end

function Lua_SpecialofferWindow:arrowRightBtnClick()
	if self.lengthact == nil then
		return;
	end

	if self.lengthact > 3 then
		self.length = self.length + 1;
	end
	self:arrowbtnClick(self.length);
end

function Lua_SpecialofferWindow:arrowLeftBtnClick()
	if self.lengthact == nil then
		return;
	end

	if self.length > 1 then
		self.length = self.length - 1;
	end
	self:arrowbtnClick(self.length);
end

function Lua_SpecialofferWindow:arrowbtnClick(index)
	if self.lengthact == nil then
		return;
	end
	self.arrowRight:setEnable(self.lengthact > 3 * index);
	self.arrowLeft:setEnable(index > 1)
	self.showList:moveToIndex(index);
end

function Lua_SpecialofferWindow:onRulesClick()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", nil, self.cotent)
end

function Lua_SpecialofferWindow:dispose()
	if self.showList ~= nil then
		self.showList:dispose()
		self.showList = nil;
	end
	self:endTimer(); 

	self:superCall("dispose");
end