Lua_Specialofferitem = class("Lua_Specialofferitem",Lua_ListCell)
function Lua_Specialofferitem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_Specialofferitem:buildShowItem()
	self:superCall("buildShowItem");

	local pos = {-340, 0, 340};
	local item;
	self.subItemArr = Array();
	for i = 1, #pos do
		item = Lua_SpecialofferSubItem.new(self.content);
		item:setLocation(pos[i], 0, 0);
		self.subItemArr:add(item);
	end
end

function Lua_Specialofferitem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local subItemData;
	for i = 1, self.subItemArr:getSize() do
		subItemData = data.arr[data.startIndex + i];
		if subItemData == nil then
			self.subItemArr[i]:setEnable(false);
		else
			self.subItemArr[i]:setEnable(true);
			self.subItemArr[i]:loadCallFun();
			self.subItemArr[i]:setData(subItemData, i);
		end
	end
end

function Lua_Specialofferitem:checkOutBound(showRect)
	local subItemData;
	local width = 300;
	local height = 295;
	local rect;
	for i = 1, self.subItemArr:getSize() do
		subItemData = self._data.arr[self._data.startIndex + i];
		if subItemData ~= nil then
			rect = Lua_Rectangle.new(self.itemX + self.subItemArr[i].x - width / 2, self.itemY - height / 2, width, height);
			self.subItemArr[i]:setModelState(showRect:containeRect(rect));
		end
	end
end

function Lua_Specialofferitem:dispose()
	if self.subItemArr ~= nil then
		self.subItemArr:dispose();
		self.subItemArr = nil;
	end
	self:superCall("dispose");
end





--------------------------------------------------





Lua_SpecialofferSubItem = class("Lua_SpecialofferSubItem", Lua_DisplayObject);
function Lua_SpecialofferSubItem:ctor(p)
	self:superCall("ctor", p, "SpecialofferSubItem_skin");
end

function Lua_SpecialofferSubItem:buildShowItem()
	self:superCall("buildShowItem");

	self.fightNum = Lua_NumberImage.new(self.content);
	self.fightNum.prefix = "a_";
	self.fightNum.numWidth = 19;
	self.fightNum:setDepth(5);
	self.fightNum:setLocation(-80, -115, 0);

	self.titleLab.clickScale = false;
	self.titleLab:addClickFuntion(self, self.onTipsClick);
	self.buybtn:addClickFuntion(self, self.onBuyClick);
end

function Lua_SpecialofferSubItem:setData(data, index)
	self._data = data;
	self.setindex = index;
	-- print(data.id, data.subType, data.mounter_sca[1]);

	if self.modelTexture ~= nil then
		self.modelTexture:dispose();
		self.modelTexture = nil ;
	end
	if self.playerModel ~= nil then
		self.playerModel:dispose();
		self.playerModel = nil;
	end

	if data.subType == Lua_PackTypeDefine.FASION then
		self:createModelPlayer();
	else
		self:createUIModelTexture();
	end

	self.fightNum.num = data.force;
	self.fightNum:setNumScale(0.8, 0.8);

	self.titleLab.text = "[u]"..data.name.."[/u]";
	self.moneyLab.text = data.money;
	self.moneyIcon:setAltas("icon_atlas_3", "money_" .. data.moneyType);

	if data.allRestricted == 0 then
		self.tipsLab.text = "";
	elseif data.allRestricted == 1 then
		self.tipsLab.text = LanUtil.formateStr(LanUtil.getValue(122578), tostring(data.sub_value));
	elseif data.allRestricted == 2 then
		self.tipsLab.text = LanUtil.formateStr(LanUtil.getValue(122579), tostring(data.sub_value));
	end
end

function Lua_SpecialofferSubItem:createModelPlayer()
	local modelData = UsData();
	modelData.career = DataCenter.roleData.career;
	modelData.gender = modelData.career == 2 and Lua_ThingDefine.FEMALE or Lua_ThingDefine.MALE; -- 性别

	local fashion_clothes_id = self._data.temaiShowModelID == nil and self._data.model or self._data.temaiShowModelID;
	if self._data.part == 3 then
		modelData.fashion_clothes_id = fashion_clothes_id; -- 时装衣服
	elseif self._data.part == 2 then
		modelData.fashion_weapon_id = fashion_clothes_id; -- 时装武器
	elseif self._data.part == 1 then
		modelData.fashionHeadId = fashion_clothes_id; -- 时装头饰
	end
	modelData.nickname = "";
	modelData.hp = 1;
	modelData.kind = 2;
	modelData.isShowName = false;
	modelData.IsUI = true;

	local pos = Vector3(-6, -73, 0);
	local rot = Vector3(0, 90, 0);
	self.playerModel = ModelPlayer();
	self.playerModel:init(self.content, pos, rot, modelData, nil, self._data.mounter_sca[1]);
	self.playerModel:setRotEnable(true, 6, 118, 300, 295, 2);
	self.playerModel:SetRenderQueue(self.forceBg, -1, 2);
	self.playerModel:addLuaLoadedCallBack(self, self.onModelLoaded);
	-- self.playerModel:setAction();
end

function Lua_SpecialofferSubItem:createUIModelTexture()
	local imgPos = Vector2(0, 45);
	local imgSize = Vector2(300, 295);
	local modelRot = Vector3(0, 180, 0);
	local modelOffset = Vector2(0, -900);
	local effectPos = self._data.offset_pos == nil and self._data.setmodelAngle or self._data.offset_pos;
	effectPos = effectPos == nil and {0, 0, 0} or effectPos;

	self.modelTexture = UIModelTexture();
	self.modelTexture:init(self.content, imgPos, imgSize, 2, modelRot, modelOffset, self._data.mounter_sca[1]);
	self.modelTexture:setCamView(5);
	self.modelTexture:setCamPos(0, self.setindex * 2000, 0);
	self.modelTexture:setRotEnable(true, 0, 0, 300, 295, 2);
	self.modelTexture:setModelOffset(self._data.mounter_pos[1], self._data.mounter_pos[2], 6500);
	self.modelTexture:setEffectPos(effectPos[1], effectPos[2], effectPos[3]);
	self.modelTexture:setModelAngle(self._data.mounter_rot[1], self._data.mounter_rot[2], self._data.mounter_rot[3]);
	self.modelTexture:addLuaLoadedCallBack(self, self.onModelLoaded);

	if self._data.temaiShowModelID == nil then
		self.modelTexture:setUrl(self._data.floder.."/"..self._data.modelFile, self._data.model);
	else
		self.modelTexture:setUrl(self._data.floder.."/"..self._data.temaiShowModelID, self._data.temaiShowModelID);
	end
end

function Lua_SpecialofferSubItem:onModelLoaded()
	if self.loadEffect ~= nil then
		self.loadEffect:setEnable(false);
	end
end

function Lua_SpecialofferSubItem:onTipsClick()
	Lua_PackUtil.showItemInfo(Lua_ToolVo.new(self._data.id), false);
end

function Lua_SpecialofferSubItem:onBuyClick()
	DataCenter.moneyData:showReconfigPanel(self._data.money, self, self.buyClick);
end

function Lua_SpecialofferSubItem:buyClick()
	if self._data.moneyType == Lua_MoneyData.BIND_GOLD then
		if DataCenter.moneyData:getMoney(Lua_MoneyData.GOLD) >= self._data.money
			and DataCenter.moneyData:getMoney(Lua_MoneyData.BIND_GOLD) < self._data.money then -- 礼金不足 元宝满足
			Lua_WindowUtil.openWin("Lua_TipsWindow", WinParam.ACTION_OPEN, {
				owner = self,
				des = LanUtil.getValue(122577),
				type = 1,
				subFun = self.onSureCallback
			});
		else
			self:onSureCallback();
		end
	else
		if DataCenter.moneyData:isMoneyEnough(self._data.moneyType, tonumber(self._data.money), true, true) == false then
			return;
		end
		self:onSureCallback();
	end
end

function Lua_SpecialofferSubItem:onSureCallback()
	DataCenter.OperationalActivitiesData:buyReward(self._data.actIndex, self._data.index, 1);
end

function Lua_SpecialofferSubItem:loadCallFun()
	if self.loadEffect == nil then
		self.loadEffect = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_loadingring", "gui_loadingring", 0, 0);
		self.loadEffect:SetRenderQueue(self.forceBg, 1, 2, false);
	end
	self.loadEffect:setEnable(false);
	self.loadEffect:setEnable(true);
end

function Lua_SpecialofferSubItem:setModelState(val)
	if val then
		if self._data.subType == Lua_PackTypeDefine.FASION then
			self.playerModel:setActive(true);
		else
			if self.modelTexture ~= nil then
				self.modelTexture:setEffectActive(true);
				-- self.modelTexture.uiEffect:setAction(self._data.setAction);
			end
		end

		-- 循环播放
		-- self.modelTexture.uiEffect:setLoop(true);
		-- 交替显隐
		if self._data.setAction == 2 then
			Lua_CommonUtil.addTimer("Lua_SpecialofferSubItem", 2, self, self.effectRoot);
		else
			Lua_CommonUtil.removeTimer(self, self.effectRoot);
		end
	else
		if self._data.subType == Lua_PackTypeDefine.FASION then
			self.playerModel:setActive(false);
		else
			self.modelTexture:setEffectActive(false);
		end
		Lua_CommonUtil.removeTimer(self, self.effectRoot);
	end
end

function Lua_SpecialofferSubItem:effectRoot()
	if self.modelTexture == nil then
		return;
	end
	self.modelTexture.uiEffect:setEnable(false);
	self.modelTexture.uiEffect:setEnable(true);
end

function Lua_SpecialofferSubItem:dispose(p)
	if self.fightNum ~= nil then
		self.fightNum:dispose();
		self.fightNum = nil ;
	end
	if self.modelTexture ~= nil then
		self.modelTexture:dispose();
		self.modelTexture = nil;
	end
	if self.loadEffect ~= nil then
		self.loadEffect:dispose();
		self.loadEffect = nil;
	end
	Lua_CommonUtil.removeTimer(self, self.effectRoot);

	self:superCall("dispose");
end