Lua_SuitSecKillItem = class("Lua_SuitSecKillItem", Lua_ListCell);
function Lua_SuitSecKillItem:ctor(p)
    self:superCall("ctor", p,"SuitSecKillItem_skin");
end
function Lua_SuitSecKillItem:buildShowItem()
	self:superCall("buildShowItem");  
	self.itemImg = Lua_ToolImage.new(self.content);
    self.itemImg:setDepth(5);
    self.itemImg:setCanClick(true);
    self.itemImg:setLocation(-104,0,0)
	self.discountdi:addClickFuntion(self,self.onBuyClick)

	if getLanType() == 1 then
		self.discount.fontSize = 16;
	end
end

function Lua_SuitSecKillItem:setData(data)
	self._data = data;
	local reward  = Lua_ToolVo.new(tonumber(data.id),0,data.bind)
	reward.star = data.star;
    reward.packType = 999;
    self.itemImg.data = reward;
    if data.self_limit ~= 0 then
    	local leftTime = data.self_limit - data.self_amount;
    	if leftTime > 0 then
    		self.itemImg:showNum2(leftTime, data.self_limit, 2);
    	else
    		leftTime = 0;
    		self.itemImg:showNum2(leftTime, data.self_limit, 2);
    	end
    end
    self.moneynum.text = data.money;
    if getLanType() == 1 then
    	self.discount.text = LanUtil.formateStr(LanUtil.getValue(122599),tostring(math.floor((10 - data.discount) * 10)));
    else
    	self.discount.text = LanUtil.formateStr(LanUtil.getValue(122599),tostring(data.discount));
    end
    if data.second_show == 0 then 
    	self.suit:setEnable(false);
    else
    	self.suit:setEnable(true);
    end
    if data.wolrd_limit == 0 then
    	self.surplus:setEnable(false);
    else
    	self.surplus:setEnable(true);
    end

    self.name.text = self.itemImg.data.colorName;
    if data.wolrd_limit ~= 0 then
    	self.surplus.text = LanUtil.formateStr(LanUtil.getValue(122598),tostring(data.wolrd_limit - data.amount));
    else
    	self.surplus.text = "";
    end
end

function Lua_SuitSecKillItem:onBuyClick()

end

function Lua_SuitSecKillItem:onPlayerSoundClick()
	if self._data.self_limit ~= 0 and self._data.wolrd_limit then 
		local maxNum = 999;
		local serverLimit = 999;
		local selfLimit = 999;
		if self._data.wolrd_limit ~= 0 then
			serverLimit = self._data.wolrd_limit - self._data.amount;
		end
		if self._data.self_limit ~= 0 then
			selfLimit = self._data.self_limit - self._data.self_amount;
		end
		maxNum = math.min(maxNum, serverLimit, selfLimit);
		if maxNum <= 0 then
			OperateAlert.show(LanUtil.getValue(121116));
		else
			Lua_WindowUtil.openWin("Lua_SuitBuyTipsWindow",nil,self._data)
		end
	else
		local cmd = ProtoPublic_pb.Proto10105302();
	    cmd.item_index = self._data.index - 1;
	    cmd.amount = 1;
	    sendMsg(10105302, cmd);
	end
end

function Lua_SuitSecKillItem:checkOutBound(showRect)
	if self._data == nil or self._data.effect ~= 1 then
		self.inViewEffect = false;
		return;
	end
	local rect = Lua_Rectangle.new(self.itemX , self.itemY - self.itemImg.item_bg.height/2 , self.itemImg.item_bg.width, self.itemImg.item_bg.height);
	if showRect:containeRect(rect) == true then
		self.inViewEffect = true;
	else
		self.inViewEffect = false;
	end
	self:updateEffectState();
end
function Lua_SuitSecKillItem:updateEffectState()
	if self.inViewEffect == true and self._data.effect == 1 and self.itemImg.data.color >= 3 then
     	if self.itemImg.roundEff == nil then
		    self.itemImg:showRoundEff(true)
			self.itemImg.roundEff:SetRenderQueue(self.itemImg.item_bg, 8, 10,false);
			
		end
		self.itemImg.roundEff:setEnable(true);
	else
		if self.itemImg.roundEff ~= nil then
			self.itemImg.roundEff:setEnable(false);
		end
	end
end