Lua_SuitSecKillPreviewWindow = class("Lua_SuitSecKillPreviewWindow", Lua_Window);
function Lua_SuitSecKillPreviewWindow:ctor()
	self:superCall("ctor");
    self.windowName = "Lua_SuitSecKillPreviewWindow";
    self.skinName = "SuitSecKillPreviewWindow_skin";
end

function Lua_SuitSecKillPreviewWindow:showWin(param)
    self.showData = param;

    self.dragList = Lua_DragList.new(self.content,1, Vector4(0, 0, 625, 355));
    self.dragList:setLocation(23, -34, 0);
    self.dragList:setListCell(Lua_SecKillPreviewitem, 105, 295, 2);
    self.arr = Array();

    for i,v in ipairs(param.next_shop_list) do
        local data = {};
        data.id = v.item_id;
        data.index = i;
            
        if tonumber(v.origin_price.copper) ~= 0 and  tonumber(v.origin_price.copper) ~= nil then
            data.origin_price = tonumber(v.origin_price.copper);  --原价
        end
        if tonumber(v.origin_price.gold) ~= 0 and  tonumber(v.origin_price.gold) ~= nil then
            data.origin_price = tonumber(v.origin_price.gold);  --原价
        end
        if tonumber(v.origin_price.bind_gold) ~= 0 and  tonumber(v.origin_price.bind_gold) ~= nil then
            data.origin_price = tonumber(v.origin_price.bind_gold);  --原价
        end
        if tonumber(v.origin_price.bind_copper) ~= 0 and  tonumber(v.origin_price.bind_copper) ~= nil then
            data.origin_price = tonumber(v.origin_price.bind_copper);  --原价
        end
        

        if tonumber(v.money.copper) ~= 0 and  tonumber(v.money.copper) ~= nil then
            data.money = tonumber(v.money.copper);  --现价
        end
        if tonumber(v.money.gold) ~= 0 and  tonumber(v.money.gold) ~= nil then
            data.money = tonumber(v.money.gold);  --现价
        end
        if tonumber(v.money.bind_gold) ~= 0 and tonumber(v.money.bind_gold) ~= nil then
            data.money = tonumber(v.money.bind_gold);  --现价
        end
        if tonumber(v.money.bind_copper) ~= 0 and  tonumber(v.money.bind_copper) ~= nil then
            data.money = tonumber(v.money.bind_copper);  --现价
        end
        data.wolrd_limit = v.wolrd_limit;   -- 全服限制
        data.self_limit = v.self_limit;  -- 个人限制
        data.amount = v.amount;   -- 全服已购买数量
        data.self_amount = v.self_amount;    -- 自己购买数量
        data.discount = v.discount;   -- 折扣
        data.effect = v.effect;  -- 特效
        data.star = v.star;      -- 星级
        data.second_show = v.second_show;  -- 是否显示秒杀
        data.bind = v.bind;
        self.arr:add(data);
    end

	self.dragList:setLuaArrayData(self.arr, false);
   	
   	
end



Lua_SecKillPreviewitem = class("Lua_SecKillPreviewitem", Lua_ListCell);
function Lua_SecKillPreviewitem:ctor(p)
    self:superCall("ctor", p,"SuitSecKillPreviewItem_skin");
end
function Lua_SecKillPreviewitem:buildShowItem()
    self:superCall("buildShowItem");
    self.itemImg = Lua_ToolImage.new(self.content);
    self.itemImg:setDepth(5);
    -- self.itemImg:setScale(0.85,0.85,0.85)
    self.itemImg:setCanClick(true);
    self.itemImg:setLocation(-105,0,0)
    self.suit:setLocation(87, 30, 0);
    
end

function Lua_SecKillPreviewitem:setData(data)
    self._data = data;
    local reward  = Lua_ToolVo.new(tonumber(data.id),0,data.bind)
    -- reward.index = data.value
    --reward.bind = data.bind;  
    reward.star = data.star;
    reward.packType = 999;
    self.itemImg.data = reward;
    self.moneynum.text = data.money;
    self.discount.text = LanUtil.formateStr(LanUtil.getValue(122599),tostring(data.discount));
    if data.second_show == 0 then 
        self.suit:setEnable(false);
    else
        self.suit:setEnable(true);
    end

    if data.wolrd_limit == 0 then
        self.surplus:setEnable(false);
    else
        self.surplus:setEnable(true);
    end
    self.name.text = self.itemImg.data.colorName;
    self.surplus.text = LanUtil.formateStr(LanUtil.getValue(122598),tostring(data.wolrd_limit));
	
end

function Lua_SecKillPreviewitem:checkOutBound(showRect)
    if self._data == nil or self._data.effect ~= 1 then
        self.inViewEffect = false;
        return;
    end

    local rect = Lua_Rectangle.new(self.itemX, self.itemY - self.itemImg.item_bg.height / 2, self.itemImg.item_bg.width, self.itemImg.item_bg.height);
    self.inViewEffect = showRect:containeRect(rect);
    self:updateEffectState();
end
function Lua_SecKillPreviewitem:updateEffectState()
    if self.inViewEffect == true and self._data.effect == 1 and self.itemImg.data.color >= 3 then
        if self.itemImg.roundEff == nil then
            self.itemImg:showRoundEff(true)
            self.itemImg.roundEff:setSacle(0.9,0.9,0.9);
            self.itemImg.roundEff:SetRenderQueue(self.itemImg.item_bg, 8, 10,false);
            
        end
        self.itemImg.roundEff:setEnable(true);
    else
        if self.itemImg.roundEff ~= nil then
            self.itemImg.roundEff:setEnable(false);
        end
    end
end