-- 合服活动
checkRequire("Lua_OpenCommonActivityPanel"); -- 开宗立派，合服集字
checkRequire("Lua_HelloEveryonePanel"); -- 全民来嗨
checkRequire("Lua_RechargeBagPanel"); -- 累冲好礼
checkRequire("Lua_LandingBagPanel"); -- 登陆有礼
checkRequire("Lua_SuitCloundBuyPanel"); -- 合服云购
checkRequire("Lua_SuitSecKillPanel"); -- 合服秒杀
checkRequire("Lua_BossFirstKillActPanel"); -- BOSS首杀
checkRequire("Lua_BossEveryoneActPanel"); -- 全民BOSS
checkRequire("Lua_CyclicRechargePanel"); -- 循环充值
checkRequire("Lua_CyclicConsumePanel"); -- 循环消费
checkRequire("Lua_CumulativeConsumptionPanel"); -- 累计消费
checkRequire("Lua_TieTheKnotPanel"); -- 喜结良缘
checkRequire("Lua_DiscountStorePanel"); -- 折扣商店
Lua_SuitWindow = class("Lua_SuitWindow", Lua_Window);
function Lua_SuitWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_SuitWindow";
	self.skinName = "GrandCeremonyWindow_skin";
end

function Lua_SuitWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.btnClose:setLocation(455, 213);
	self.title:setAltas("mergeServerActive_atlas", "ui_common_z_hfhd");

	self.panelDic = {};
	self.panelDic[1026] = {index = 1, openId = 1026, eventIds = {11144}, name = LanUtil.getValue(120803), panel = Lua_OpenCommonActivityPanel};
	self.panelDic[1019] = {index = 2, openId = 1019, eventIds = {11145}, name = LanUtil.getValue(120800), panel = Lua_HelloEveryonePanel};
	self.panelDic[1033] = {index = 3, openId = 1033, eventIds = {11147}, name = LanUtil.getValue(120801), panel = Lua_RechargeBagPanel};
	self.panelDic[1037] = {index = 4, openId = 1037, eventIds = {11148}, name = LanUtil.getValue(120802), panel = Lua_LandingBagPanel};
	self.panelDic[1028] = {index = 5, openId = 1028, eventIds = {11146}, name = LanUtil.getValue(120821), panel = Lua_SuitCloundBuyPanel};
	self.panelDic[1013] = {index = 6, openId = 1013, eventIds = {10094}, name = LanUtil.getValue(120854), panel = Lua_OpenCommonActivityPanel};
	self.panelDic[1045] = {index = 7, openId = 1045, eventIds = {12345}, name = LanUtil.getValue(120805), panel = Lua_SuitSecKillPanel};
	self.panelDic[1055] = {index = 8, openId = 1055, clickRemoveEvent = 21008, panel = Lua_BossFirstKillActPanel};
	self.panelDic[1056] = {index = 9, openId = 1056, eventIds = {11219}, clickRemoveEvent = 21009, panel = Lua_BossEveryoneActPanel};
	self.panelDic[1057] = {index = 10, openId = 1057, eventIds = {12220}, clickRemoveEvent = 21010, panel = Lua_CyclicRechargePanel};
	self.panelDic[1058] = {index = 11, openId = 1058, eventIds = {12221}, clickRemoveEvent = 21011, panel = Lua_CyclicConsumePanel};
	self.panelDic[1061] = {index = 12, openId = 1061, eventIds = {22057}, clickRemoveEvent = 21012, panel = Lua_CumulativeConsumptionPanel};
	self.panelDic[1068] = {index = 13, openId = 1068, eventIds = {22063}, clickRemoveEvent = 22062, panel = Lua_TieTheKnotPanel};
	self.panelDic[1075] = {index = 14, openId = 1075, clickRemoveEvent = 22076, panel = Lua_DiscountStorePanel};

	self.dragList = Lua_DragList.new(self.content,2, Vector4(0, 0, 800, 52));
	self.dragList:setListCell(Lua_SuitItem, 52, 152, 999);
	self.dragList:setLocation(-92, 218, 0);

	self:addLuaEvent("UPDATE_ACTIVITIES_DATA", self, self.suitInfo);
	self:addLuaEvent("ON_SUIT_ITEM_CLICK", self, self.btnChildCellClick);
	self:addLuaEvent("SET_ACTIVITIES_BTN_REDDOT", self, self.rSuitBtnRedDot);
	self:addLuaEvent("UPDATE_REDDOT_EVENT", self, self.updateAllPeopleRedDot);
end

function Lua_SuitWindow:showWin(param)
	self.showData = param;
	self.iconId = param.iconId;
	self:suitInfo();
end

function Lua_SuitWindow:suitInfo()
	local actList = DataCenter.OperationalActivitiesData:getActivitiesByIcon(self.iconId);
	local vo;
	self.panelArr = Array();
	for i = 1, actList:getSize() do
		vo = actList[i];
		if vo ~= nil and self.panelDic[vo.first_type] ~= nil then
			self.panelArr:add({
				first_type = vo.first_type,
				act_index = vo.act_index,
				name = vo.title,
				sortIndex = self.panelDic[vo.first_type].index,
				panel = self.panelDic[vo.first_type].panel,
				isRedDot = false,
				clickRemoveEvent = self.panelDic[vo.first_type].clickRemoveEvent
			});
		end
	end
	
	self.panelArr:sort("sortIndex", false);
	for i = 1, self.panelArr:getSize() do
		self.panelArr[i].index = i;
	end
	self:rSuitBtnRedDot();
end

function Lua_SuitWindow:updateAllPeopleRedDot(val)
	if val.evenId == 11219 then
		self:rSetBtnRedDot();
	end
end

function Lua_SuitWindow:rSuitBtnRedDot()
	local isRedDot;
	local btnlen = self.panelArr:getSize()
	for i = 1, btnlen do
		isRedDot = false;
		if DataCenter.OperationalActivitiesData.notify_list:getSize() > 0 then
			local len = #DataCenter.OperationalActivitiesData.notify_list[1];
			for j = 1,len do
				if self.panelArr[i].act_index == DataCenter.OperationalActivitiesData.notify_list[1][j] then
					isRedDot = true;
				end
			end
		end

		if self.panelArr[i].first_type == 1056 then -- 全民BOSS
			if DataCenter.redDotData:getRedDotStateByEventId(11219) == true then
				isRedDot = true;
			end
		end
		if self.panelArr[i].first_type == 1057 then -- 循环充值
			if DataCenter.redDotData:getRedDotStateByEventId(12220) == true then
				isRedDot = true;
			end
		end
		if self.panelArr[i].first_type == 1058 then -- 循环消费
			if DataCenter.redDotData:getRedDotStateByEventId(12221) == true then
				isRedDot = true;
			end
		end
		if self.panelArr[i].first_type == 1061 then -- 累计消费
			if DataCenter.redDotData:getRedDotStateByEventId(22057) == true then
				isRedDot = true;
			end
		end
		if self.panelArr[i].first_type == 1068 then -- 喜结良缘
			isRedDot = DataCenter.redDotData:getRedDotStateByEventId(22063);
		end
		if isRedDot == false then
			self.panelArr[i].isRedDot = false;
		else
			self.panelArr[i].isRedDot = true;
			DataCenter.redDotData:updateRedDotVoState(self.panelArr[i].clickRemoveEvent, false);
		end
	end

	if self.showData == nil then
		self.selectedIndex = 1;
	elseif type(self.showData) == "table" and self.showData.opName ~= nil then
		for i = 1, btnlen do
			if self.showData.opName == self.panelArr[i].name then
				self.selectedIndex = i;
			end
		end
	end
	if self.selectedIndex == nil then
		self.selectedIndex =1;
	end
	self.dragList:setLuaArrayData(self.panelArr, true);
	self.dragList:setSelected(self.selectedIndex);
	self:btnChildCellClick(self.panelArr[self.selectedIndex]);
end

function Lua_SuitWindow:btnChildCellClick(val)
	if self.selectedIndex == val.index and self.oneIS ~= nil then
		return;
	end
	self.oneIS = false;
	self.selectedIndex = val.index;

	if self.curPanel ~= nil then
		self.curPanel:dispose();
		self.curPanel = nil;
	end
	local panelInfo = self.panelArr[val.index];
	self.curPanel = panelInfo.panel.new(self.content);
	self.curPanel.first_type = panelInfo.first_type;

	DataCenter.redDotData:updateRedDotVoState(val.clickRemoveEvent, false);
	DataCenter.OperationalActivitiesData:sGetOperationalActivities(panelInfo.act_index, panelInfo.first_type);
end

function Lua_SuitWindow:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose()
		self.dragList = nil;
	end
	if self.curPanel ~= nil then
		self.curPanel:dispose();
		self.curPanel = nil;
	end

	self:superCall("dispose");
end










Lua_SuitItem = class("Lua_SuitItem", Lua_ListCell);
function Lua_SuitItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_SuitItem:buildShowItem()
	self:superCall("buildShowItem");

	self.btnBg = UICreate.createUIAtlasImage(self.content, "", "", 0, 0, 152, 46);
	self.btnBg:setDepth(0);

	self.btnTxt = UICreate.createLabel(self.content, "", 0, 0, 200, 30, 22);
	self.btnTxt.fontSize = 24;
	self.btnTxt.pivot = UIWidget.Pivot.Center;
	self.btnTxt:setDepth(1);

	self.redDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 98, 24, 0, 0)
	self.redDot.name = "redDot";
	self.redDot:setDepth(5);
end

function Lua_SuitItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.btnTxt.text = data.name;
	self:updateRedDot();
end

function Lua_SuitItem:updateRedDot()
	self.redDot:setEnable(self._data.isRedDot);
end

function Lua_SuitItem:onPlayerSoundClick(go)
	Lua_MsgUtil.callFunc("ON_SUIT_ITEM_CLICK", self._data);
end

function Lua_SuitItem:onSelectionChange(val)
	self:superCall("onSelectionChange", val);

	if val then
		self.btnBg:setAltas("common_atlas_2", "ui_common_btn_y13");
		self.btnBg:setLocation(0, 3);
		self.btnTxt.colorStr = Lua_ColorDefine.transColor("FFFFFF");
		self.btnTxt:setLocation(0, 4);
		self.redDot:setLocation(67, 18, 0);
	else
		self.btnBg:setAltas("common_atlas_2", "ui_common_btn_y12");
		self.btnBg:setLocation(0, -3);
		self.btnTxt.colorStr = Lua_ColorDefine.transColor("8ABAC8");
		self.btnTxt:setLocation(0, -2);
		self.redDot:setLocation(67, 10, 0);
	end
end

function Lua_SuitItem:dispose()
	if self.btnBg ~= nil then
		self.btnBg:dispose();
		self.btnBg = nil;
	end
	if self.btnTxt ~= nil then
		self.btnTxt:dispose();
		self.btnTxt = nil;
	end
	if self.redDot ~= nil then
		self.redDot:dispose();
		self.redDot = nil;
	end
	self._data = nil;
	
	self:superCall("dispose");
end