Lua_SuperBargainItem = class("Lua_SuperBargainItem", Lua_ListCell);
function Lua_SuperBargainItem:ctor(p)
    self:superCall("ctor", p, "SuperBargainItem_skin");
end

function Lua_SuperBargainItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rItem = Lua_ToolImage.new(self.content);
    self.rItem:setDepth(5);
    self.rItem:setLocation(-165, -15.5, 0);
    self.rItem:setScale(0.9, 0.9, 0.9);
    self.rItem:setCanClick(true);

    self.buyBtn:addClickFuntion(self, self.onBuyBtnClick);
end

function Lua_SuperBargainItem:dispose()
	self:superCall("dispose");
end

function Lua_SuperBargainItem:setData(data)
	self.data = data;

	self.rItem.data = data.vo;
	self.rItem:showMaskSp(false);
	self.rItem:showNotYetImg(false);
	if data.show_effect == 1 then
		self.rItem:showRoundEff(true);
		if roundEff ~= nil then
			self.rItem.roundEff:setSacle(0.9,0.9,0.9);
			self.rItem.roundEff:SetRenderQueue(self.rItem.item_bg, 5, 2, true);
		end
	end

	self.name.text = "[7D2C0C]"..data.vo.name.."*"..data.amount.."[-]";
	self.buyTime.text = LanUtil.formateStr(LanUtil.getValue(145802), tostring(data.can_buy_times));
	self.money.text = data.price;
	local moneyType = "money_"..data.cost_type;
	self.moneyIcon:setAltas("icon_atlas_3", moneyType);

	if data.can_buy_times == 0 then
		self.buyBtn:setBtnEnable(false);
	else
		self.buyBtn:setBtnEnable(true);
	end
end

function Lua_SuperBargainItem:checkOutBound(showRect)
	local rect = Lua_Rectangle.new(self.itemX, self.itemY - 40, 25, 50);

	if self.rItem.roundEff ~= nil then
		if showRect:containeRect(rect) == true then
			self.rItem.roundEff:setEnable(true);
		else
			self.rItem.roundEff:setEnable(false);
		end
	end

	if self.data.subType == Lua_PackTypeDefine.STAMP_ITEM then
		if self.rItem.stampEff ~= nil then
			if showRect:containeRect(rect) == true then
				self.rItem.stampEff:setEnable(true);
			else
				self.rItem.stampEff:setEnable(false);
			end
		end
	end
	
	if self.data.subType == Lua_PackTypeDefine.ARMY_EQUIP_ITEM then
		if self.rItem.armyEff ~= nil then
			if showRect:containeRect(rect) == true then
				self.rItem.armyEff:setEnable(true);
			else
				self.rItem.armyEff:setEnable(false);
			end
		end
	end
end

function Lua_SuperBargainItem:onBuyBtnClick()
    local str = "";
    local des = "";
    if self.data.cost_type == Lua_MoneyData.GOLD then
    	str = self:getDes(self.data.cost_type, self.data.price);
		des = LanUtil.formateStr(LanUtil.getValue(145803), str);
    elseif self.data.cost_type == Lua_MoneyData.BIND_GOLD then
    	str = self:getDes(self.data.cost_type, self.data.price);
		des = LanUtil.formateStr(LanUtil.getValue(145804), str);
    end

    local tipData = {};
    tipData.des = des;
    tipData.owner = self;
    tipData.type = 1;
    tipData.subFun = self.onSubFun;
    Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
end

function Lua_SuperBargainItem:onSubFun()
	local isMoneyEnough = false;
	if self.data.cost_type == Lua_MoneyData.COPPER then
		isMoneyEnough = DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.COPPER, self.data.price, true, false);
	elseif self.data.cost_type == Lua_MoneyData.BIND_GOLD or self.data.cost_type == Lua_MoneyData.GOLD then
		isMoneyEnough = DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD_AND_BINDGOLD, self.data.price, true, true);
	end

	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
    local leftNum = bagData:getLeftSize();
    if leftNum < 1 then
        DataCenter.packData:showFullBagTip(Lua_PackData.BAG_PACK);
        return;
    end

    if isMoneyEnough then
		Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sBuyCommodity(0, self.data.index);
	end
end

function Lua_SuperBargainItem:getDes(moneyType, price)
	local str = "";
	if DataCenter.moneyData:getMoney(moneyType) < price then
		str = "["..Lua_ColorDefine.RED_STR.."]"..price.."[-]";
	else
		str = "["..Lua_ColorDefine.GREEN_STR.."]"..price.."[-]";
	end
	return str;
end