-- 聚划算
checkRequire("Lua_SuperBargainItem");
Lua_SuperBargainWindow = class("Lua_SuperBargainWindow", Lua_ActivityBaseWindow);
function Lua_SuperBargainWindow:ctor()
	self:superCall("ctor");

    self.titleAtlas = "superBargain"
    self.titleSprite = "superBargain_title";
    self.windowName = "Lua_SuperBargainWindow";
    self.skinName = "SuperBargainWindow_skin";
end

function Lua_SuperBargainWindow:buildShowItem()
    self:superCall("buildShowItem");
    
    DataCenter.redDotData:updateRedDotVoState(22085, false);
    Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sGetActivityInfo(Lua_OperationalActivitiesData.SUPER_BARGAIN);

    self.rItem = Lua_ToolImage.new(self.content);
    self.rItem:setDepth(5);
    self.rItem:setLocation(-135, -55, 0);
    self.rItem:setScale(1, 1, 1);
    self.rItem:setCanClick(true);

    self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 478, 430));
	self.dragList:setLocation(265, 4, 0);
	self.dragList:setListCell(Lua_SuperBargainItem, 125, 470, 1);

    self.redDot:setEnable(false);
    self.getBtn:addClickFuntion(self, self.onGetBtnClick);
    self.buyBtn:addClickFuntion(self, self.onBuyBtnClick);

    self:addLuaEvent("UPDATE_SUPER_BARGAIN", self, self.updatePanelInfo);
end

function Lua_SuperBargainWindow:dispose()
	if self.rItem ~= nil then
		self.rItem:dispose();
		self.rItem = nil;
	end
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	Lua_CommonUtil.removeTimer(self, self.updateResidueTime);
    self:superCall("dispose");
end

function Lua_SuperBargainWindow:updatePanelInfo()
	local reward_times = DataCenter.superBargainData.reward_times;
	self.tips.text = DataCenter.superBargainData.content;
	self.des.text = LanUtil.getValue(145800);
	self.leftTimes.text = LanUtil.formateStr(LanUtil.getValue(145801), tostring(reward_times));

	if reward_times == 0 then
		self.redDot:setEnable(false);
		self.getBtn:setBtnEnable(false);
	else
		self.redDot:setEnable(true);
		self.getBtn:setBtnEnable(true);
	end

	local reward = DataCenter.superBargainData.reward;
	local vo = Lua_ToolVo.createToolVo(reward.id, reward.amount, reward.bind);
	vo.star = reward.star;
	self.rItem.data = vo;
	self.rItem:showMaskSp(false);
	self.rItem:showNotYetImg(false);
	if reward.show_effect == 1 then
		self.rItem:showRoundEff(true);
		if roundEff ~= nil then
			self.rItem.roundEff:setSacle(0.9,0.9,0.9);
			self.rItem.roundEff:SetRenderQueue(self.rItem.item_bg, 5, 2, true);
		end
	end

	local arr = DataCenter.superBargainData.getCommodityData;
	self.dragList:setLuaArrayData(arr, false);

	self.cost_type = arr[1].cost_type;
	self.moneyIcon:setAltas("icon_atlas_3", "money_"..arr[1].cost_type);
	self.money.text = DataCenter.superBargainData.totalGold + DataCenter.superBargainData.totalBindGold;

	if DataCenter.superBargainData.totalNum == 0 then
		self.buyBtn:setBtnEnable(false);
	else
		self.buyBtn:setBtnEnable(true);
	end

    Lua_CommonUtil.addTimer("SuperBargaine_ResidueTime", 1, self, self.updateResidueTime, nil, -1);
	self:updateResidueTime();
end

function Lua_SuperBargainWindow:updateResidueTime()
	local end_time = tonumber(DataCenter.superBargainData.end_tick) - DataCenter.roleData.serverTime;
	if end_time > 0 then
		self.end_time.text = LanUtil.formateStr(LanUtil.getValue(146012), TimeTransform.getInstance():transSeconds1(end_time, true));
	else
		self.end_time.text = LanUtil.getValue(146011);
		Lua_CommonUtil.removeTimer(self, self.updateResidueTime);
	end
end

function Lua_SuperBargainWindow:onGetBtnClick()
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.3 then
        OperateAlert.show(LanUtil.getValue(121419));
        return;
    end
    self.clickTime = getTime();

    Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sGetActivityRewards(Lua_OperationalActivitiesData.SUPER_BARGAIN);
end

function Lua_SuperBargainWindow:onBuyBtnClick()
	local totalGold = DataCenter.superBargainData.totalGold;
	local totalBindGold = DataCenter.superBargainData.totalBindGold;

    local str = "";
    local des = "";
    if totalGold == 0 then
		self.totalPrice = totalBindGold;
		str = self:getDes(self.cost_type, totalBindGold);
		des = LanUtil.formateStr(LanUtil.getValue(145804), str);
	elseif totalBindGold == 0 then
		self.totalPrice = totalGold;
		str = self:getDes(self.cost_type, totalGold);
		des = LanUtil.formateStr(LanUtil.getValue(145803), str);
	else
		self.totalPrice = totalGold + totalBindGold;
		local str1 = self:getDes(Lua_MoneyData.GOLD, totalGold);
		local str2 = self:getDes(Lua_MoneyData.BIND_GOLD, totalBindGold);
		des = LanUtil.formateStr(LanUtil.getValue(145805), str1, str2);
	end

    local tipData = {};
    tipData.des = des
    tipData.owner = self;
    tipData.type = 1;
    tipData.subFun = self.onSubFun;
    Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
end

function Lua_SuperBargainWindow:onSubFun()
	local isMoneyEnough = false;
	if self.cost_type == Lua_MoneyData.COPPER then
		isMoneyEnough = DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.COPPER, self.totalPrice, true, false);
	elseif self.cost_type == Lua_MoneyData.BIND_GOLD or self.cost_type == Lua_MoneyData.GOLD then
		isMoneyEnough = DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD_AND_BINDGOLD, self.totalPrice, true, true);
	end

	local totalNum = DataCenter.superBargainData.totalNum;
	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
    local leftNum = bagData:getLeftSize();
    if leftNum < totalNum then
        DataCenter.packData:showFullBagTip(Lua_PackData.BAG_PACK);
        return;
    end

    if isMoneyEnough then
		Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sBuyCommodity(1);
	end
end

function Lua_SuperBargainWindow:getDes(moneyType, price)
	local str = "";
	if DataCenter.moneyData:getMoney(moneyType) < price then
		str = "["..Lua_ColorDefine.RED_STR.."]"..price.."[-]";
	else
		str = "["..Lua_ColorDefine.GREEN_STR.."]"..price.."[-]";
	end
	return str;
end