checkRequire("Lua_SuperExchangePanel"); -- 超值兑换
checkRequire("Lua_SuperReturnPanel"); -- 超值返还
Lua_SuperExchangeWindow = class("Lua_SuperExchangeWindow", Lua_ActivityBaseWindow);
function Lua_SuperExchangeWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_SuperExchangeWindow";
	self.titleAtlas = "welfareCeremony_atlas"
	self.titleSprite = "ui_czdh_z01";
end

function Lua_SuperExchangeWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.panelDic = {};
	self.panelDic[1079] = {panel = Lua_SuperExchangePanel, clickRemoveEvent = 22080};
	self.panelDic[1080] = {panel = Lua_SuperReturnPanel, clickRemoveEvent = 22081};

	self.dragList = Lua_DragList.new(self.content,2, Vector4(0, 0, 800, 70));
	self.dragList:setListCell(Lua_SuperExchangeItem, 75, 150, 999);
	self.dragList:setLocation(-65, 218, 0);

	self:addLuaEvent("UPDATE_ACTIVITIES_DATA", self, self.createButtonList);
	self:addLuaEvent("ON_SUPEREXCHANGE_ITEM_CLICK", self, self.updateSuperPanelInfo);
	self:addLuaEvent("SET_ACTIVITIES_BTN_REDDOT", self, self.rSetBtnRedDot);
	DataCenter.OperationalActivitiesData:sGetActivitiesInfo();
end

function Lua_SuperExchangeWindow:createButtonList()
	local actList = DataCenter.OperationalActivitiesData:getActivitiesByIcon(self.iconId);
	local vo;
	self.activitList = Array()
	for i = 1, actList:getSize() do
		vo = actList[i];
		if vo ~= nil then
			self.activitList:add({
				data = vo,
				sort = vo.sort,
				index = nil,
				isRedDot = false,
				panel = self.panelDic[vo.first_type].panel,
				clickRemoveEvent = self.panelDic[vo.first_type].clickRemoveEvent
			});
		end
	end
	self.activitList:sort("sort", true);

	for i = 1, self.activitList:getSize() do
		self.activitList[i].index = i;
	end

	self.selectNum = 1;
	if self.showData == nil then
		self.selectNum = 1;
	elseif type(self.showData) == "table" and self.showData.opName ~= nil then
		for i = 1, self.activitList:getSize() do
			if self.showData.opName == self.activitList[i].data.title then
				self.selectNum = i;
			end
		end
	end

	if self.selectedIndex ~= nil and self.activitList[self.selectedIndex] ~= nil then
		self.selectNum = self.selectedIndex;
	end
	if self.activitList[self.selectNum] == nil then
		return;
	end
	self.dragList:setLuaArrayData(self.activitList, false);
	self.dragList:setSelected(self.selectNum);
	self:updateSuperPanelInfo(self.activitList[self.selectNum], true);
end

function Lua_SuperExchangeWindow:showWin(param)
	self.showData = param;
	self.iconId = param.iconId;
end

function Lua_SuperExchangeWindow:rSetBtnRedDot(isSelect)
	local isRedDot;
	for i = 1, self.activitList:getSize() do
		isRedDot = false;
		if DataCenter.OperationalActivitiesData.notify_list:getSize() > 0 then
			for j = 1, #DataCenter.OperationalActivitiesData.notify_list[1] do
				if self.activitList[i].data.act_index == DataCenter.OperationalActivitiesData.notify_list[1][j] then
					isRedDot = true;
				end
			end
		end

		if self.activitList[i].data.first_type == 1080 then -- 超值返还
			if DataCenter.redDotData:getRedDotStateByEventId(22082) == true then
				isRedDot = true;
			end
		end
		if isRedDot == false then
			self.activitList[i].isRedDot = false;
		else
			self.activitList[i].isRedDot = true;
			DataCenter.redDotData:updateRedDotVoState(self.activitList[i].clickRemoveEvent, false);
		end
	end

	if isSelect == nil or isSelect == true then
		self.dragList:setSelected(self.selectNum);
	end
	self:updateRedDot();
end

function Lua_SuperExchangeWindow:updateSuperPanelInfo(val)
	if self.selectedIndex == val.index then
		return;
	end
	self.selectedIndex = val.index;

	if self.curPanel ~= nil then
		self.curPanel:dispose();
		self.curPanel = nil;
	end
	self.curPanel = val.panel.new(self.content);
	self.curPanel.first_type = val.data.first_type;

	DataCenter.OperationalActivitiesData:sGetOperationalActivities(val.data.act_index,val.data.first_type);
	DataCenter.redDotData:updateRedDotVoState(val.clickRemoveEvent, false);
	self:updateRedDot();
end

-- 刷新红点状态
function Lua_SuperExchangeWindow:updateRedDot()
	if self.dragList ~= nil then
		local arr = self.dragList.showList;
		for i = 1, arr:getSize() do
			arr[i]:updateRedDot();
		end
	end
end

function Lua_SuperExchangeWindow:dispose()
	if self.activitList ~= nil then
		self.activitList:clear()
		self.activitList= nil;
	end
	if self.dragList ~= nil then
		self.dragList:dispose()
		self.dragList = nil;
	end
	if self.curPanel ~= nil then
		self.curPanel:dispose();
		self.curPanel = nil;
	end

	self:superCall("dispose");
end










Lua_SuperExchangeItem = class("Lua_SuperExchangeItem", Lua_ListCell);
function Lua_SuperExchangeItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_SuperExchangeItem:buildShowItem()
	self:superCall("buildShowItem");

	self.btnBg = UICreate.createUIAtlasImage(self.content, "", "", 20, 0, 0, 0);
	self.btnBg:setDepth(8);
	self.btnBg:setScale(0.9, 0.9);

	self.btnTxt = UICreate.createLabel(self.content, "", 20, 0, 200, 30, 24);
	self.btnTxt.pivot = UIWidget.Pivot.Center;
	self.btnTxt:setDepth(15);

	self.redDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 74, 12, 0, 0);
	self.redDot.name = "redDot";
	self.redDot:setDepth(16);
end

function Lua_SuperExchangeItem:setData(data)
	self.data = data;

	self.btnTxt.text = data.data.title;
	self:updateRedDot();
end

function Lua_SuperExchangeItem:updateRedDot()
self.redDot:setEnable(self.data.isRedDot or DataCenter.redDotData:getRedDotStateByEventId(self.data.clickRemoveEvent));
end

function Lua_SuperExchangeItem:onPlayerSoundClick(go)
	Lua_MsgUtil.callFunc("ON_SUPEREXCHANGE_ITEM_CLICK", self.data);
end

function Lua_SuperExchangeItem:onSelectionChange(val)
	self:superCall("onSelectionChange", val);
	if val then
		self.btnBg:setAltas("common_atlas_2", "ui_common_btn_y13");
		self.btnTxt.color = Color.New(1, 1, 1, 1);
		self.btnBg:setLocation(20, 3);
		self.btnTxt:setLocation(20, 4);
		self.redDot:setLocation(91, 26);
	else
		self.btnBg:setAltas("common_atlas_2", "ui_common_btn_y12");
		self.btnTxt.color = Color.New(138 / 255, 186 / 255, 200 / 255, 1);
		self.btnBg:setLocation(20, -1);
		self.btnTxt:setLocation(20, 0);
		self.redDot:setLocation(91, 22);
	end
end

function Lua_SuperExchangeItem:dispose()
	self:superCall("dispose");
end