Lua_YuanBaoDoubleRecordItem = class("Lua_YuanBaoDoubleRecordItem", Lua_DragContainerItem);
function Lua_YuanBaoDoubleRecordItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_YuanBaoDoubleRecordItem:buildShowItem()
	self:superCall("buildShowItem");

	self.label = UICreate.createLabel(self.content, "", 0, 0, 402, 20, 20);
	self.label.overflowMethod = UILabel.Overflow.ResizeHeight;
	self.label.pivot = UIWidget.Pivot.TopLeft;
	self.label.spacingY = 6;
	self.label:setDepth(5);
end

function Lua_YuanBaoDoubleRecordItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local nameStr = "[url=playerClick_" .. data.role_id .. "]" .."[u]".. data.role_name .. "[/u][/url]";
	local costDraw = tostring(data.cost_draw .. Lua_MoneyData:getNameByType(data.cost_type));
	local rewardPercen = tostring(data.reward_percen / 100);
	local rewardDraw = tostring(data.reward_draw .. Lua_MoneyData:getNameByType(data.reward_type));
	self.label.text = LanUtil.formateStr(LanUtil.getValue(143301), nameStr, costDraw, rewardPercen, rewardDraw);
end

function Lua_YuanBaoDoubleRecordItem:getHeight()
	return self.label.height;
end

function Lua_YuanBaoDoubleRecordItem:onPlayerSoundClick()
	self:superCall("onPlayerSoundClick");

	local urlStr = self.label:getUrlByMousePos();
	if urlStr ~= nil then
		local arr = string.split(urlStr, "_");
		if arr[1] == "playerClick" then
			Lua_ChatUtil.playerMenuPopListShow({role_id = tonumber(arr[2])});
		end
	end
end

function Lua_YuanBaoDoubleRecordItem:dispose()
	if self.label ~= nil then
		self.label:dispose();
		self.label = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end