-- 元宝大翻倍
checkRequire("Lua_YuanBaoDoubleRecordItem");
checkRequire("Lua_RotActionItem");
Lua_YuanBaoDoubleWindow = class("Lua_YuanBaoDoubleWindow", Lua_Window);
function Lua_YuanBaoDoubleWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_YuanBaoDoubleWindow";
	self.skinName = "YuanBaoDoubleWindow_skin";
end

function Lua_YuanBaoDoubleWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.leftNumArr = Array();
	self.RightNumArr = Array();

	self.dragContainer = Lua_DragContainer.new(self.content, 1, Vector4(201, -164, 402, 328));
	self.dragContainer:setLocation(75, 42, 0);

	self.pointCircle = Lua_RotActionItem.new(self.pointer);

	self.goBtn:addClickFuntion(self, self.goClick);
	
	DataCenter.redDotData:updateRedDotVoState(22065, false);

	self:addLuaEvent("UPDATE_YUAN_BAO_DOUBLE_RECORDS", self, self.updateRecords);
	self:addLuaEvent("UPDATE_YUAN_BAO_DOUBLE", self, self.updateInfo);
	self:addLuaEvent("UPDATE_YUAN_BAO_DOUBLE_INFORMATION", self, self.drawUpdate);
	self:addLuaEvent("UPDATE_YUAN_BAO_DOUBLE_DRAWRESULT", self, self.updateDrawResult);
	Lua_ProxyManager.getProxy("Lua_YuanBaoDoubleProxy"):sYuanBaoDoubleWinStatus(1);
	Lua_ProxyManager.getProxy("Lua_YuanBaoDoubleProxy"):sOpenYuanBaoDoubleWin();   
end

function Lua_YuanBaoDoubleWindow:drawUpdate()
	self.isDrawing = false;
	self:updateInfo();
end

function Lua_YuanBaoDoubleWindow:updateInfo()
	if self.isDrawing then
		self.goBtnLab.text = LanUtil.formateStr(LanUtil.getValue(143308));
		self.goBtn:setGray(true);
		return;
	end

	local yuanBaoDoubleData = DataCenter.yuanBaoDoubleData;
	self.gold_cost = yuanBaoDoubleData.gold_cost;
	self.end_tick = yuanBaoDoubleData.end_tick;
	self.cost_type = yuanBaoDoubleData.cost_type;
	self.needMoney = yuanBaoDoubleData.need_money;
	self.curMoney = yuanBaoDoubleData.cur_money;

	local timesNum;
	for i = 1, yuanBaoDoubleData.numList:getSize() do
		timesNum = self.leftNumArr[i];
		if timesNum == nil then
			-- 2，4，6，5，1，3
			-- local pos = {{-103, 31}, {-336, -95}, {-336, 167}, {-414, 31}, {-167, 167}, {-167, -95}};
			-- 1，2，3，4，5，6
			local pos = {{-167, 167}, {-103, 31}, {-167, -95}, {-336, -95}, {-414, 31}, {-336, 167}};
			timesNum = Lua_NumberImage.new(self.content);
			timesNum.content.name = "beiNum" .. i;
			timesNum.prefix = "z_";
			timesNum.numWidth = 21;
			timesNum.lastWidth = 30;
			timesNum.pivot = 2;
			timesNum.lastStr = "bei";
			timesNum:setDepth(5);
			timesNum:setLocation(pos[i][1], pos[i][2], 0);
			self.leftNumArr:add(timesNum);
		end
		timesNum.num = yuanBaoDoubleData.numList[i].num;
	end

	for i = 1, yuanBaoDoubleData.bigNumList:getSize() do
		timesNum = self.RightNumArr[i];
		if timesNum == nil then
			local pos = {{148, 235}, {291, 185}};
			timesNum = Lua_NumberImage.new(self.content);
			timesNum.prefix = "p_";
			timesNum.numWidth = 17;
			timesNum.pivot = 2;
			timesNum:setDepth(5);
			timesNum:setLocation(pos[i][1], pos[i][2], 0);
			self.RightNumArr:add(timeNum);
		end
		timesNum.num = yuanBaoDoubleData.bigNumList[i].num;
	end

	local iconStr = "money_" .. self.cost_type;
	if DataCenter.yuanBaoDoubleData.isMax then
		self.needCount:setEnable(false);
		self.moneyIcon:setEnable(false);
		self.moneyCount:setEnable(false);

		self.goBtn:setGray(true);
		self.goBtnLab.text = LanUtil.getValue(143303);
	else
		self.moneyIcon:setAltas("icon_atlas_3", iconStr);
		self.moneyCount.text = self.gold_cost;
		
		self.goBtn:setGray(false);
		self.goBtnLab.text = LanUtil.getValue(143302);
	end

	self.rechargeMoneyIcon:setAltas("icon_atlas_3", iconStr);
	if self.curMoney < self.needMoney then
		self.rechargeTxt.text = LanUtil.formateStr(LanUtil.getValue(143311), "[FF1616]" ..tostring(self.curMoney), tostring(self.needMoney));
	else
		self.rechargeTxt.text = LanUtil.formateStr(LanUtil.getValue(143311), "[00E125]" ..tostring(self.curMoney), tostring(self.needMoney));
	end

	local width = (self.rechargeTxt.width - 178) / 2;
	if self.rechargeTxt.width > 178 then
		-- self.rechargeObj.transform.localPosition = Vector3(220 - width, 125, 0);
		LuaUtil.setObjPos(self.rechargeObj, 220 - width, 125, 0);
	else
		-- self.rechargeObj.transform.localPosition = Vector3(220 + width, 125, 0);
		LuaUtil.setObjPos(self.rechargeObj, 220 + width, 125, 0);
	end

	local leftTime = self.end_tick - tonumber(tostring(GlobalVar.cur_tick));
	self.timeLab.text = LanUtil.formateStr(LanUtil.getValue(143300), TimeTransform.getInstance():transSeconds1(leftTime, true));
	Lua_CommonUtil.addTimer("onActivityTimeDown", 1, self, self.onActivityTimeDown);
end

function Lua_YuanBaoDoubleWindow:goClick()
	if DataCenter.yuanBaoDoubleData.isMax == true then
		OperateAlert.show(LanUtil.getValue(143304));
		return;
	elseif self.isDrawing == true then
		OperateAlert.show(LanUtil.getValue(143309));
		return;
	elseif self.curMoney < self.needMoney then
		OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(143310), tostring(self.needMoney)));
		return;
	end

	if DataCenter.moneyData:getMoney(self.cost_type) < self.gold_cost then
		if self.cost_type == Lua_MoneyData.GOLD then
			Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, des = LanUtil.getValue(122521), type = 1, subFun = self.openChargeWin});
		elseif self.cost_type == Lua_MoneyData.BIND_GOLD then
			Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, des = LanUtil.getValue(124209), type = 1, subFun = self.sendMessage});
		elseif self.cost_type == Lua_MoneyData.COPPER then
			OperateAlert.show(LanUtil.getValue(110816));
		end
		return;
	end
	self:sendMessage();
end

function Lua_YuanBaoDoubleWindow:sendMessage()
	self.isDrawing = true;
	Lua_ProxyManager.getProxy("Lua_YuanBaoDoubleProxy"):sYuanBaoDoubleDraw();
end

function Lua_YuanBaoDoubleWindow:openChargeWin()
	Lua_WindowUtil.openWin("Lua_ChongzhiWindow", WinParam.ACTION_OPEN, 1);
	self:hide();
end

function Lua_YuanBaoDoubleWindow:updateRecords(val)
	if val ~= nil then
		self.dragContainer:removeAllChildren();
		
		local item;
		for k,v in ipairs(val) do
			item = Lua_YuanBaoDoubleRecordItem.new(self.dragContainer.sub);
			self.dragContainer:addSubContainer(item, false);
			self.dragContainer.childrenList[k]:setData(v);
		end
		self.dragContainer:updateChildPos();
	end
end

function Lua_YuanBaoDoubleWindow:onActivityTimeDown()
	local leftTime = self.end_tick - tonumber(tostring(GlobalVar.cur_tick));
	self.timeLab.text = LanUtil.formateStr(LanUtil.getValue(143300), TimeTransform.getInstance():transSeconds1(leftTime, true));
	if leftTime <= 0 then
		Lua_CommonUtil.removeTimer(self, self.onActivityTimeDown);
	end
end

-- 更新旋转
function Lua_YuanBaoDoubleWindow:updateDrawResult(val)
	if val ~= nil then
		self.pointCircle:setParams(-2500, -360 * 2 + (val + 1) * -60 + 30);
		self.pointCircle:start();
	end
end

function Lua_YuanBaoDoubleWindow:onBtnCloseClick(go)
	Lua_ProxyManager.getProxy("Lua_YuanBaoDoubleProxy"):sYuanBaoDoubleWinStatus(0); -- 请求关闭界面
	self:hide();
end

function Lua_YuanBaoDoubleWindow:dispose()
	if self.dragContainer ~= nil then
		self.dragContainer:dispose();
		self.dragContainer = nil;
	end
	if self.pointCircle ~= nil then
		self.pointCircle:dispose();
		self.pointCircle = nil;
	end
	Lua_CommonUtil.removeTimer(self, self.onActivityTimeDown);

	self:superCall("dispose");
end